Dans ce répertoire / In this repository :

* robodoccerf : 
code source au format HTML généré par Robodoc
 / HTML source code generated by Robodoc
 
* doccerf_fr/index.html : 
Documentation en français au format HTML
HTML french documentation

* doccerf_en/index.html : 
Documentation en anglais au format HTML
HTML english documentation

* Cerf_fr.pdf : 
Documentation en français au format PDF
PDF french documentation

* Cerf_en.pdf : 
Documentation en anglais au format PDF
PDF english documentation

  
SUBROUTINE vitson(w,cson)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/vitson  *
!
!    NOM
! vitson(w,cson)
!    DESCRIPTION  
!*
! Calcul de la vitesse du son associee a l etat w 
!
! Calculation of the speed of sound associated with state w 
!*
! 
!    ENTREES / INPUT
! w : objet etat / state object
!
!    SORTIES / OUTPUT
! cson :  vitesse du son / speed of sound
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(state),intent(in)            :: w  !! Variables primitives / Primitive variables
  real(kind=kind(0.d0)),intent(out) :: cson !! vitesse du son / speed of sound
!=========================== DEBUT DU CODE EXECUTABLE ==================

  SELECT CASE (imodel_phy)  

      CASE(2) ! bifluide isotherme
          cson=c_phy
          
      CASE(1)  ! Saint Venant
          IF (w%vprim%v(1) < 0.d0)call print_err('VITSON',' Negative water level')
          cson=dsqrt(gpes_phy*max(w%vprim%v(1),hzero_phy))
          
      CASE DEFAULT
          call print_err('VITSON',' Physical model not defined')
  END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE Vitson
!DOCFIN 

 SUBROUTINE calc_source(calc,lev)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/calc_source  *
!
!    NOM
!   calc_source(calc,lev)
!    DESCRIPTION  
!*
! Calcul des termes sources sur les cellules 
! Calculation of source terms on cells 
!*
! 
!    ENTREES / INPUT
!   calc : objet calcul / Calcul object
!   lev : niveau maximal de raffinement a considerer / maximum level of refinement to be considered
!    SORTIES / OUTPUT
!   calc : objet calcul avec les termes sources mis a jour / Calcul object with updated source terms
!   lev : niveau maximal de raffinement a considerer / maximum level of refinement to be considered
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul),intent(inout) :: calc !! Objet calcul / Calcul object
  integer, intent(inout)     :: lev  !! niveau maximal de raffinement a considerer / maximum level of refinement to be considered
  
  integer                    :: ic
  real(kind=kind(0.d0))      :: vol
  type(vect_nvar)            :: sloc
!=========================== DEBUT DU CODE EXECUTABLE ==================
! calcul des termes sources (physiques et ordre 2 non conservatif)

  DO ic=1,calc%msh%nb_cell
      IF (calc%msh%list_cell(ic)%clevel.le.lev) THEN
          IF (calc%msh%list_cell(ic)%idom.eq.calc%msh%numdom) THEN
              CALL sources(calc%msh%list_cell(ic)%w,sloc,calc%iordre_e)
              vol=calc%msh%list_cell(ic)%vol
              calc%msh%list_cell(ic)%balance%v=calc%msh%list_cell(ic)%balance%v+vol*sloc%v    
          END IF
      END IF

  END DO
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE calc_source
!DOCFIN

 SUBROUTINE gradprim(msh)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/gradprim  *
!
!    NOM
! gradprim(msh)
!    DESCRIPTION  
!*
! Calcul du gradient des variables primitives sur les cellules du maillage msh
! dans le domaine courant.
! attention : les gradients des cellules frontieres ne sont pas calcules
!
! Calculation of the gradient of the primitive variables on the cells of the msh mesh
! in the current domain.
! Warning: the gradients of border cells are not calculated
!*
! 
!    ENTREES / INPUT
!    msh : maillage / mesh
!
!    SORTIES / OUTPUT
!    msh : maillage / mesh
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  use geo, only: display
  IMPLICIT NONE
!.2-----  Declaration
  type(mesh), intent(inout)    :: msh !! Maillage / Mesh
  
  type(state)                  :: w1,w2
  type(vect_nvar),dimension(3) :: vpn
  integer                      :: i,ii,ic1,ic2,idom1,idom2  
!=========================== DEBUT DU CODE EXECUTABLE ==================

  DO i=1,msh%nb_cell
      DO ii=1,3
          msh%list_cell(i)%w%gprim(ii)%v(1:nvar)=0.d0
      END DO
      
!SV: on stocke eta dans la variable z. Retour à la normale a la fin.
      IF(imodel_phy.eq.1) &
      msh%list_cell(i)%w%vprim%v(5)=msh%list_cell(i)%w%vprim%v(1)+msh%list_cell(i)%w%vprim%v(5)
  END DO

  DO i=1,msh%nb_face
      ic1=msh%list_face(i)%ic1
      ic2=msh%list_face(i)%ic2
      
      IF (ic1.le.0) THEN
          write(*,*) 'erreur maillage orientation'
          STOP
      END IF
    
! Numero de domaine à gauche
      idom1=msh%list_cell(ic1)%idom
      IF (idom1.ne.msh%numdom) THEN
          write(*,*) 'erreur maillage domaine'
          STOP
      END IF
         
      IF (ic2.ne.-999) THEN ! ne pas boucler sur les faces fictives
      
          ! numero de domaine à droite
          idom2=0
          IF (ic2.gt.0) idom2=msh%list_cell(ic2)%idom
          IF (idom2.ne.msh%numdom) idom2=0
          
          ! états gauche et droit
          w1=msh%list_cell(ic1)%w
          IF (ic2.gt.0) THEN
              w2=msh%list_cell(ic2)%w
          ELSE
              CALL wext(w1,w2,msh%list_face(i)%vnorm,ic2, &
                   msh%list_face(i)%center%x , &
                   msh%list_face(i)%center%y , &
                   msh%list_face(i)%center%z , &
                   msh%list_cell(ic1)%center%x, &
                   msh%list_cell(ic1)%center%y, &
                   msh%list_cell(ic1)%center%z )
          END IF
          
          ! formule de green pour calculer le gradient au centre
          ! int(Omega,grad f)= int(dOmega, f*normale) = int(dOmega,1/2( f*norm(L) +f*norm(R)))
          ! ce calcul devra être modifié pour des maillages très irréguliers 
          ! ou si on passe a l ordre 2 !!!
          DO ii=1,msh%ndim
              vpn(ii)%v=0.5d0*msh%list_face(i)%vnorm%v(ii)*msh%list_face(i)%surf*&
                  &(w1%vprim%v+w2%vprim%v)
             
              msh%list_cell(ic1)%w%gprim(ii)%v(1:nvar)=msh%list_cell(ic1)%w%gprim(ii)%v(1:nvar)+&
                  &1.d0/msh%list_cell(ic1)%vol*vpn(ii)%v(1:nvar)
             if(imodel_phy.eq.1.and.ngrad_bathy.eq.1)msh%list_cell(i)%w%gprim(ii)%v(5) = msh%list_cell(ic1)%w%gprim(ii)%v(5)+&
                  &1.d0/msh%list_cell(ic1)%vol*vpn(ii)%v(5)
              IF (idom2.ne.0) THEN
                  msh%list_cell(ic2)%w%gprim(ii)%v(1:nvar)=msh%list_cell(ic2)%w%gprim(ii)%v(1:nvar)-&
                     &1.d0/msh%list_cell(ic2)%vol*vpn(ii)%v(1:nvar)
                  if(imodel_phy.eq.1.and.ngrad_bathy.eq.1)msh%list_cell(i)%w%gprim(ii)%v(5) = msh%list_cell(ic2)%w%gprim(ii)%v(5)+&
                       &1.d0/msh%list_cell(ic1)%vol*vpn(ii)%v(5)
              END IF

          END DO
      
      END IF
  
  END DO

 !===========================!=========================== !=========================== !=========================== 
! on calcule le gradient de phi en fonction de grap p et grap rho
!
  DO i=1,msh%nb_cell
!         do ii=1,3
!            if (imodel_phy.eq.3  .OR. imodel_phy.eq.8) then
!            msh%list_cell(i)%w%gprim(ii)%v(10) =-1.D0/((rho0W_phy-rho0A_phy)*cW_phy**2)&
!           *(msh%list_cell(i)%w%gprim(ii)%v(5)-cW_phy**2*msh%list_cell(i)%w%gprim(ii)%v(1))
!            else if (imodel_phy.eq.4) then
!            msh%list_cell(i)%w%gprim(ii)%v(10) =-1.D0/((rho0W_phy-rho0A_phy)*cW_phy**2)&
!           *(msh%list_cell(i)%w%gprim(ii)%v(6)-cW_phy**2*msh%list_cell(i)%w%gprim(ii)%v(1))
!            END IF
!          END DO
!SV : retour aux variables initiales (z=(z+h)-h et idem pour grad_z)
!     on tue les grad_z de Zbottom pour eviter perturber le calcul des limiteurs
!     (mais potentiellement non necessaire!! => certainement a supprimer apres tests!)
      IF (imodel_phy.eq.1)then
         msh%list_cell(i)%w%gprim(:)%v(4)=0.d0
! dans le cas ou le gradient de la bathymetrie est numerique
         if(ngrad_bathy.eq.1)msh%list_cell(i)%w%gprim(:)%v(5)=msh%list_cell(i)%w%gprim(:)%v(5)-& 
                                                              msh%list_cell(i)%w%gprim(:)%v(1)
         msh%list_cell(i)%w%vprim%v(5)=msh%list_cell(i)%w%vprim%v(5)-msh%list_cell(i)%w%vprim%v(1)
      ENDIF
  END DO
!
!===========================   FIN DE LA ROUTINE    ====================
    END SUBROUTINE GRADPRIM
!DOCFIN

 SUBROUTINE fct_cond (vi,vp,fctnum,x,y,z,vn)
!=========================== DOCUMENTATION =============================
!DOCDEBh*    PHY/USER/cond_fct_cond  *
!
!    NOM
! fct_cond(vi,vp,fctnum,x,y,z,vn)
!    DESCRIPTION
!*
! Fonction utilisateur permettant de definir 
! des conditions initiales ou des conditions aux limites
! User function for defining 
! initial conditions or boundary conditions
!*

!
!    ENTREES / INPUT
!   vi    : variables primitives de la cellule appelant / primitive variables of the calling cell
! x,y,z   : coordonees du point ou est calcule la fonction / coordinates of the point where the function is calculated
!  fctnum : numero de la fonction / function number
!   vn    : vecteur normal a la face / vector normal to the face
!
!    SORTIES
!   vp    : variables primitives calculees par la fonction / primitive variables calculated by the function
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ====================
!.1-----  Implicit, Use
   use phy_typ
   IMPLICIT NONE
!.2-----  Declaration
   integer, intent(in)              :: fctnum !! Numero de la fonction / Function number
   real(kind=kind(0.d0)),intent(in) :: x,y,z
!! coordonnees du point ou definir la condition / coordinates of the point at which to define the condition
   type(vect_nvar), intent(in)      :: vi 
!!variables primitives de la cellule appelant / primitive variables of the calling cell
   type(vect_3),intent(in)          :: vn !!vecteur normal a la face / vector normal to the face 
   type(vect_nvar), intent(out)     :: vp
!!variables primitives calculées par la fonction / primitive variables calculated by the function

!=========================== DEBUT DU CODE EXECUTABLE ==================
vp%v(1)=0.d0*x*y*z*vn%v(1)*vn%v(2)*vn%v(3)


   SELECT CASE (fctnum)
!_______________________________________________________________________

!_______________________________________________________________________
! surverse Euler bifluide "JeuckNov2023" : condition aux limites amont
    CASE(3)
      IF(z.gt.3.832311d0) THEN
         vp%v(1)=1.d0     ! rho
         vp%v(2)=0.d0     ! u (flux entrant)
         vp%v(3)=0.d0     ! v
         vp%v(4)=-vi%v(4) ! w
         vp%v(5)=1.e5     ! p (p_hysttq)
      ELSE IF (z.le.3.832311d0) THEN
         vp%v(1)=1000.d0 ! rho
         vp%v(2)=1.805538d0 ! u (flux entrant)
         vp%v(3)=0.d0 ! v
         vp%v(4)=0.d0 ! w
         vp%v(5)=1.e5 + 1000.d0*9.81*(3.832311d0-z)! p (p_hysttq)
      END IF
!_______________________________________________________________________

    CASE DEFAULT
      call print_err('fct_cond', 'User function not defined')

   END SELECT

!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE fct_cond
!DOCFIN

 SUBROUTINE critraf(calc,critere,ib,nb_cell_bloc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/critraf  *
!
!    NOM
! critraf(calc,critere,ib,nb_cell_bloc)
!    DESCRIPTION  
!*
! Determination du critere de raffinement moyen sur un bloc.
! Determining the average refinement criterion on a block.
!*
! 
!    ENTREES / INPUT
!    calc  : objet calcul initial / initial calcul object
!    ib    : numero du bloc / block number
!    nb_cell_bloc : nombre de cellules du bloc / cell number of the block
!
!    SORTIES / OUTPUT
!    critere  : critere de raffinement moyen sur le bloc / average refinement criterion on the block
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul), intent(inout)                       :: calc !! objet calcul / calcul object
  integer, intent(in)                               :: ib  !! numero du bloc / Block number
  integer, intent(in)                               :: nb_cell_bloc !! nombre de cellules du bloc / cell number of the block
  real(kind=kind(0.d0)),dimension(:), intent(inout) :: critere !! Critere moyen sur le bloc / average criterion of the block
  
  real(kind=kind(0.d0))                             :: crit
  integer                                           :: i,ibloc
!=========================== DEBUT DU CODE EXECUTABLE ==================

  ibloc=calc%list_bloc(ib)%numbl
  critere(ibloc)=0.d0

  DO i=1,nb_cell_bloc
    call critphy(calc%msh%list_cell(calc%list_bloc(ib)%first_cell+i)%w,crit)
    critere(ibloc)=critere(ibloc)+ crit* &
                   calc%msh%list_cell(calc%list_bloc(ib)%first_cell+i)%vol

  END DO
  critere(ibloc)=dabs(critere(ibloc))       
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE critraf
!DOCFIN

 SUBROUTINE MESH3D(bl,msh,ib,nb_dom,blv,interdom)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/MESH3D  *
!
!    NOM
! MESH3D(bl,msh,ib,nb_dom,blv,interdom)
!    DESCRIPTION  
!*
!      Maillage regulier d un bloc hexaedrique en 3D
!
!      Regular mesh of a hexahedral block in 3D
!*
! 
!    ENTREES / INPUT
!      bl       : Bloc a mailler et a ajouter au maillage msh / Block to be meshed and added to the msh mesh
!      blv      : Blocs voisins (1 a 6) a modifier / Neighbouring blocks to be modified
!      ib       : Numero du bloc a ajouter / number of the block to be added
!      nb_dom   : nombre de domaines / number of domains                
!      msh      : maillage / mesh
!      interdom : Table de localisation de l interface des domaines / Domain interface location table
! 
!    SORTIES / OUTPUT
!      msh      : maillage / mesh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  use geo, only: psr,volcel,pni
  IMPLICIT NONE
!.2-----  Declaration
      TYPE(bloc), INTENT(in)                        :: bl       
!! Bloc a mailler et a ajouter au maillage msh / Block to be meshed and added to the msh mesh
      TYPE(bloc), INTENT(in)                        :: blv(6)
!! Blocs voisins a modifier / Neighbouring blocks to be modified
      INTEGER, INTENT(in)                           :: ib !! numero du bloc a ajouter / number of the block to be added
      INTEGER, INTENT(in)                           :: nb_dom  !! nombre de domaines / number of domains
      TYPE(mesh), INTENT(inout)                     :: msh !! Maillage / Mesh
      TYPE(list_int), DIMENSION(:), INTENT(inout)   :: interdom
!! Table de localisation de l interface des domaines /Domain interface location table

  real(kind=kind(0.d0))                      :: vv
  integer                                    :: nx,ny,nz,i,j,k,is,ia,idebv,idebf
  integer                                    :: ii,idebc,nui,nue,ipos_send,ipos_recv
  integer                                    :: ie,je,ke,nxv,nyv,nzv
!=========================== DEBUT DU CODE EXECUTABLE ==================
!

       nx=bl%nx*2**(bl%nrb)
       ny=bl%ny*2**(bl%nrb)
       nz=bl%nz*2**(bl%nrb)


! construction de la liste des sommets
       do i=1,nx+1
          do j=1,ny+1
            do k=1,nz+1
              is=i+(nx+1)*(j-1)+(nx+1)*(ny+1)*(k-1)+bl%first_vertex
              msh%list_vertex(is)=pni(bl,i*1.d0,j*1.d0,k*1.d0,0)
            end do
          end do
       end do

! construction de la liste des cellules

       do i=1,nx
          do j=1,ny
            do k=1,nz
               is=i+(j-1)*nx+nx*ny*(k-1)+bl%first_cell
               msh%list_cell(is)%num=is
               msh%list_cell(is)%idom=msh%numdom
               msh%list_cell(is)%center=pni(bl,i*1.d0+0.5d0,j*1.d0+0.5d0,k*1.d0+0.5d0,0)  !!!!!!!!!$$$$$!!!!!!!$$$$$
               msh%list_cell(is)%vol=volcel(bl,i*1.d0,j*1.d0,k*1.d0,0)                    !!!!!!!!!$$$$$!!!!!!!$$$$$
             end do
          end do
       end do
       
ia=bl%first_face
 msh%list_face(:)%nbvertex=4

! construction de la liste des faces interieures paralleles au plan x y
     do k=2,nz
       do i=1,nx
          do j=1,ny
             ia=ia+1 
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(j-1)*nx+(k-2)*nx*ny +bl%first_cell
             msh%list_face(ia)%ic2=i+(j-1)*nx+(k-1)*nx*ny +bl%first_cell                   
         end do
       end do
     end do

! construction de la liste des faces interieures paralleles au plan x z
     do j=2,ny
       do i=1,nx
          do k=1,nz
             ia=ia+1 
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(j-2)*nx+(k-1)*nx*ny +bl%first_cell
             msh%list_face(ia)%ic2=i+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
          end do
       end do
     end do

! construction de la liste des faces interieures paralleles au plan y z
     do i=2,nx
       do j=1,ny
          do k=1,nz
             ia=ia+1 
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i-1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
             msh%list_face(ia)%ic2=i-0+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
          end do
       end do
     end do


idebv=(nx+1)*(ny+1)*(nz+1) +bl%first_vertex
idebf=(nx-1)*ny*nz+nx*(ny-1)*nz+nx*ny*(nz-1) +bl%first_face
idebc=nx*ny*nz +bl%first_cell
!
! Construction de la liste des faces pour x=xmin
! et des cellules du domaine voisin
!===========================================================================================
if(bl%idom.eq.blv(1)%idom.and.ib.lt.bl%cl(1))goto 101
if(blv(1)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=nz
else
   nxv=blv(1)%nx*2**(blv(1)%nrb)
   nyv=blv(1)%ny*2**(blv(1)%nrb)
   nzv=blv(1)%nz*2**(blv(1)%nrb)
endif
if(bl%nrf(1).le.0)then ! Dans le cas ou le bloc voisin est - fin ou identique 
    ii=1
    if(bl%nrf(1).eq.-1)ii=2
    do k=1,nz
       do j=1,ny
           
          ie=nxv
          je=1+int((j-1)/ii)
          ke=1+int((k-1)/ii)
          nue=je+(ke-1)*nyv ! Numerotation exterieure
          nui=j +(k-1)*ny   ! Numerotation interieure au bloc
          ia=idebf+nui
          msh%list_face(ia)%vertex(1)=(1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
          msh%list_face(ia)%vertex(2)=(1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
          msh%list_face(ia)%vertex(3)=(1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
          msh%list_face(ia)%vertex(4)=(1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
          msh%list_face(ia)%ic1=1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
          if(bl%cl(1).le.0)then
             msh%list_face(ia)%ic2=bl%cl(1)
          else 
             if(blv(1)%idom.ne.bl%idom)then
               msh%list_face(ia)%ic2=idebc+nue
               call psr(interdom,nb_dom,bl%idom,blv(1)%idom,ib,bl%cl(1),ipos_send,ipos_recv)
               msh%list_send(blv(1)%idom)%L(nui+ipos_send)=1+(j-1)*nx+(k-1)*nx*ny+ bl%first_cell   
               msh%list_recv(blv(1)%idom)%L(nue+ipos_recv)=idebc+nue    
               msh%list_cell(idebc+nue)%num =idebc+nue
               msh%list_cell(idebc+nue)%idom=blv(1)%idom   
               vv= volcel(blv(1),1.d0*ie,1.d0*je,1.d0*ke,0)
               msh%list_cell(idebc+nue)%vol = vv
               !msh%list_cell(idebc+nue)%h =1.d0/(2.d0*hy*hz*ii*ii/vv+2.d0/hy/ii+2.d0/hz/ii)    
               msh%list_cell(idebc+nue)%center = pni(blv(1),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
             else
               msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(1)%first_cell         !!!!! A VERIFIER PARTOUT
             endif
          endif
       end do
    end do
    idebf=idebf+ny*nz
    if(bl%cl(1).gt.0)then
      if(blv(1)%idom.ne.bl%idom)idebc=idebc+ny*nz/ii/ii
    endif
    
else  ! Dans le cas ou le bloc voisin est + fin 
! creation des noeuds centre des "grosses faces"
    is=idebv
    do j=1,ny
      do k=1,nz
        is=is+1
        msh%list_vertex(is)=pni(bl,1.d0,1.d0*j+0.5d0,1.d0*k+0.5d0,0)
      end do
    end do
! creation des noeuds aux milieux des aretes
    do j=1,ny
      do k=1,nz+1
        is=is+1
        msh%list_vertex(is)=pni(bl,1.d0,1.d0*j+0.5d0,1.d0*k,0)
      end do
    end do
    do k=1,nz
      do j=1,ny+1
        is=is+1
        msh%list_vertex(is)=pni(bl,1.d0,1.d0*j,1.d0*k+0.5d0,0)
      end do
    end do
! creation des faces
    do j=1,ny
      do k=1,nz
        ie=nxv
        je=2*j-1
        ke=2*k-1
        nui=j +(k-1) *ny  ! Numerotation interieure au bloc
        nue=je+(ke-1)*nyv ! Numerotation exterieure
        ia=idebf+nue 
        msh%list_face(ia)%vertex(1)=(1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
        msh%list_face(ia)%vertex(2)=idebv+ny*nz+(j-1)*(nz+1)+k 
        msh%list_face(ia)%vertex(3)=idebv+(j-1)*nz+k 
        msh%list_face(ia)%vertex(4)=idebv+ny*nz+ny*(nz+1)+(k-1)*(ny+1)+j 
        msh%list_face(ia)%ic1=1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
        if(bl%cl(1).le.0)then
          msh%list_face(ia)%ic2=bl%cl(1)
        else
          if(blv(1)%idom.ne.bl%idom)then
             call psr(interdom,nb_dom,bl%idom,blv(1)%idom,ib,bl%cl(1),ipos_send,ipos_recv)
             msh%list_send(blv(1)%idom)%L(nui+ipos_send)    = 1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
             msh%list_recv(blv(1)%idom)%L(nue+ipos_recv)    = idebc+nue     
             msh%list_face(ia)%ic2             = idebc+nue
             msh%list_cell(idebc+nue)%num      = idebc+nue
             msh%list_cell(idebc+nue)%idom     = blv(1)%idom 
             vv= volcel(blv(1),1.d0*ie,1.d0*je,1.d0*ke,0)
             msh%list_cell(idebc+nue)%vol      = vv    
             !msh%list_cell(idebc+nue)%h        = 2.d0/(hy*hz/4./blv(1)%volc+2.d0/hy+2.d0/hz)    
             msh%list_cell(idebc+nue)%center = pni(blv(1),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
          else
             msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(1)%first_cell         !!!!! A VERIFIER PARTOUT
          endif
        endif
             
        ie=nxv
        je=2*j-1+1
        ke=2*k-1
        nue=je+(ke-1)*nyv ! Numerotation exterieure
        ia=idebf+nue 
        msh%list_face(ia)%vertex(1)=idebv+ny*nz+(j-1)*(nz+1)+k
        msh%list_face(ia)%vertex(2)=(1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1)+ bl%first_vertex
        msh%list_face(ia)%vertex(3)=idebv+ny*nz+ny*(nz+1)+(k-1)*(ny+1)+j+1
        msh%list_face(ia)%vertex(4)=idebv+(j-1)*nz+k
        msh%list_face(ia)%ic1=1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
        if(bl%cl(1).le.0)then
          msh%list_face(ia)%ic2=bl%cl(1)
        else
          if(blv(1)%idom.ne.bl%idom)then
             call psr(interdom,nb_dom,bl%idom,blv(1)%idom,ib,bl%cl(1),ipos_send,ipos_recv)
             msh%list_send(blv(1)%idom)%L(nui+ipos_send)    = 1+(j-1)*nx+(k-1)*nx*ny+bl%first_cell
             msh%list_recv(blv(1)%idom)%L(nue+ipos_recv)    = idebc+nue     
             msh%list_face(ia)%ic2             = idebc+nue
             msh%list_cell(idebc+nue)%num      = idebc+nue
             msh%list_cell(idebc+nue)%idom     = blv(1)%idom         
             vv= volcel(blv(1),1.d0*ie,1.d0*je,1.d0*ke,0)
             msh%list_cell(idebc+nue)%vol      = vv    
             msh%list_cell(idebc+nue)%center = pni(blv(1),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
          else
             msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(1)%first_cell         !!!!! A VERIFIER PARTOUT
          endif
        endif
       
        ie=nxv
        je=2*j-1
        ke=2*k-1+1
        nue=je+(ke-1)*nyv ! Numerotation exterieure
        ia=idebf+nue 
        msh%list_face(ia)%vertex(1)=idebv+ny*nz+ny*(nz+1)+(k-1)*(ny+1)+j
        msh%list_face(ia)%vertex(2)=idebv+(j-1)*nz+k
        msh%list_face(ia)%vertex(3)=idebv+ny*nz+(j-1)*(nz+1)+k+1
        msh%list_face(ia)%vertex(4)=(1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
        msh%list_face(ia)%ic1=1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
        msh%list_face(ia)%ic2=bl%cl(1)
        if(bl%cl(1).le.0)then
          msh%list_face(ia)%ic2=bl%cl(1)
        else
          if(blv(1)%idom.ne.bl%idom)then
            call psr(interdom,nb_dom,bl%idom,blv(1)%idom,ib,bl%cl(1),ipos_send,ipos_recv)
            msh%list_send(blv(1)%idom)%L(nui+ipos_send)    = 1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell 
            msh%list_recv(blv(1)%idom)%L(nue+ipos_recv)    = idebc+nue     
            msh%list_face(ia)%ic2             = idebc+nue
            msh%list_cell(idebc+nue)%num      = idebc+nue
            msh%list_cell(idebc+nue)%idom     = blv(1)%idom         
            vv= volcel(blv(1),1.d0*ie,1.d0*je,1.d0*ke,0)
            msh%list_cell(idebc+nue)%vol      = vv    
            msh%list_cell(idebc+nue)%center = pni(blv(1),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
          else
            msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(1)%first_cell         !!!!! A VERIFIER PARTOUT
          endif
        endif
       
        ie=nxv
        je=2*j-1+1
        ke=2*k-1+1
        nue=je+(ke-1)*nyv ! Numerotation exterieure
        ia=idebf+nue 
        msh%list_face(ia)%vertex(1)=idebv+(j-1)*nz+k
        msh%list_face(ia)%vertex(2)=idebv+ny*nz+ny*(nz+1)+(k-1)*(ny+1)+j+1
        msh%list_face(ia)%vertex(3)=(1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
        msh%list_face(ia)%vertex(4)=idebv+ny*nz+(j-1)*(nz+1)+k+1
        msh%list_face(ia)%ic1=1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
        if(bl%cl(1).le.0)then
          msh%list_face(ia)%ic2=bl%cl(1)
        else
          if(blv(1)%idom.ne.bl%idom)then
            call psr(interdom,nb_dom,bl%idom,blv(1)%idom,ib,bl%cl(1),ipos_send,ipos_recv)
            msh%list_send(blv(1)%idom)%L(nui+ipos_send)    = 1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell 
            msh%list_recv(blv(1)%idom)%L(nue+ipos_recv)    = idebc+nue      
            msh%list_face(ia)%ic2             = idebc+nue
            msh%list_cell(idebc+nue)%num      = idebc+nue
            msh%list_cell(idebc+nue)%idom     = blv(1)%idom         
            vv= volcel(blv(1),1.d0*ie,1.d0*je,1.d0*ke,0)
            msh%list_cell(idebc+nue)%vol      = vv    
            msh%list_cell(idebc+nue)%center = pni(blv(1),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
          else
            msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(1)%first_cell         !!!!! A VERIFIER PARTOUT
          endif
        endif
      end do
  end do
  idebf=idebf+ny*nz*4
  idebv=idebv+ny*(nz+1)+(ny+1)*nz+ny*nz
  if(bl%cl(1).gt.0)then
    if(blv(1)%idom.ne.bl%idom)idebc=idebc+ny*nz*4
  endif
endif
101     continue


! Construction de la liste des faces pour x=xmax 
! et des cellules du domaine voisin
!===========================================================================================
if(bl%idom.eq.blv(2)%idom.and.ib.lt.bl%cl(2))goto 102
if(blv(2)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=nz
else
   nxv=blv(2)%nx*2**(blv(2)%nrb)
   nyv=blv(2)%ny*2**(blv(2)%nrb)
   nzv=blv(2)%nz*2**(blv(2)%nrb)
endif

if(bl%nrf(2).le.0)then ! Dans le cas ou le bloc voisin est - fin ou identique 
  ii=1
  if(bl%nrf(2).eq.-1)ii=2
  do k=1,nz
    do j=1,ny
        ie=1
        je=1+int((j-1)/ii)
        ke=1+int((k-1)/ii)
        nue=je+(ke-1)*nyv ! Numerotation exterieure
        nui=j+(k-1)*ny                          ! Numerotation interieure au bloc
        ia=idebf+nui
        msh%list_face(ia)%vertex(1)=(nx+1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
        msh%list_face(ia)%vertex(4)=(nx+1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
        msh%list_face(ia)%vertex(3)=(nx+1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
        msh%list_face(ia)%vertex(2)=(nx+1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
        msh%list_face(ia)%ic1=nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
        if(bl%cl(2).le.0)then
          msh%list_face(ia)%ic2=bl%cl(2)
        else
          if(blv(2)%idom.ne.bl%idom)then
            call psr(interdom,nb_dom,bl%idom,blv(2)%idom,ib,bl%cl(2),ipos_send,ipos_recv)
            msh%list_face(ia)%ic2=idebc+nue
            msh%list_send(blv(2)%idom)%L(nui+ipos_send)=nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
            msh%list_recv(blv(2)%idom)%L(nue+ipos_recv)=idebc+nue
            msh%list_cell(idebc+nue)%num =idebc+nue
            msh%list_cell(idebc+nue)%idom     = blv(2)%idom
            vv= volcel(blv(2),1.d0*ie,1.d0*je,1.d0*ke,0)
            msh%list_cell(idebc+nue)%vol = vv
            msh%list_cell(idebc+nue)%center = pni(blv(2),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
          else
             msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(2)%first_cell         !!!!! A VERIFIER PARTOUT
          endif
        endif
    end do
  end do
  idebf=idebf+ny*nz
  if(bl%cl(2).gt.0)then
      if(blv(2)%idom.ne.bl%idom)idebc=idebc+ny*nz/ii/ii
    endif
else ! Dans le cas ou le bloc voisin est + fin 
! creation des noeuds centre des "grosses faces"
  is=idebv
  do j=1,ny
    do k=1,nz
      is=is+1
      msh%list_vertex(is)=pni(bl,1.d0*(nx+1),1.d0*j+0.5d0,1.d0*k+0.5d0,0)
    end do
  end do
! creation des noeuds aux milieux des aretes
  do j=1,ny
    do k=1,nz+1
      is=is+1
      msh%list_vertex(is)=pni(bl,1.d0*(nx+1),1.d0*j+0.5d0,1.d0*k,0)
    end do
  end do
  do k=1,nz
    do j=1,ny+1
      is=is+1
      msh%list_vertex(is)=pni(bl,1.d0*(nx+1),1.d0*j,1.d0*k+0.5d0,0)
    end do
  end do
! creation des faces
  do j=1,ny
    do k=1,nz
              
      ie=1
      je=2*j-1
      ke=2*k-1
      nui=j +(k-1) *ny  ! Numerotation interieure au bloc
      nue=je+(ke-1)*nyv ! Numerotation exterieure
      ia=idebf+nue 
      msh%list_face(ia)%vertex(1)=(nx+1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
      msh%list_face(ia)%vertex(4)=idebv+ny*nz+(j-1)*(nz+1)+k
      msh%list_face(ia)%vertex(3)=idebv+(j-1)*nz+k
      msh%list_face(ia)%vertex(2)=idebv+ny*nz+ny*(nz+1)+(k-1)*(ny+1)+j
      msh%list_face(ia)%ic1=nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
      if(bl%cl(2).le.0)then
        msh%list_face(ia)%ic2=bl%cl(2)
      else
        if(blv(2)%idom.ne.bl%idom)then
           call psr(interdom,nb_dom,bl%idom,blv(2)%idom,ib,bl%cl(2),ipos_send,ipos_recv)
           msh%list_send(blv(2)%idom)%L(nui+ipos_send)    = nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
           msh%list_recv(blv(2)%idom)%L(nue+ipos_recv)    = idebc+nue     
           msh%list_face(ia)%ic2             = idebc+nue
           msh%list_cell(idebc+nue)%num      = idebc+nue
           msh%list_cell(idebc+nue)%idom     = blv(2)%idom
           vv= volcel(blv(2),1.d0*ie,1.d0*je,1.d0*ke,0)
           msh%list_cell(idebc+nue)%vol = vv
           msh%list_cell(idebc+nue)%center = pni(blv(2),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
        else
           msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(2)%first_cell         !!!!! A VERIFIER PARTOUT
        endif
      endif

      ie=1
      je=2*j-1+1
      ke=2*k-1
      nue=je+(ke-1)*nyv ! Numerotation exterieure
      ia=idebf+nue 
      msh%list_face(ia)%vertex(1)=idebv+ny*nz+(j-1)*(nz+1)+k
      msh%list_face(ia)%vertex(4)=(nx+1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
      msh%list_face(ia)%vertex(3)=idebv+ny*nz+ny*(nz+1)+(k-1)*(ny+1)+j+1
      msh%list_face(ia)%vertex(2)=idebv+(j-1)*nz+k
      msh%list_face(ia)%ic1=nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
      if(bl%cl(2).le.0)then
        msh%list_face(ia)%ic2=bl%cl(2)
      else
        if(blv(2)%idom.ne.bl%idom)then
           call psr(interdom,nb_dom,bl%idom,blv(2)%idom,ib,bl%cl(2),ipos_send,ipos_recv)
           msh%list_send(blv(2)%idom)%L(nui+ipos_send)    = nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
           msh%list_recv(blv(2)%idom)%L(nue+ipos_recv)    = idebc+nue     
           msh%list_face(ia)%ic2             = idebc+nue
           msh%list_cell(idebc+nue)%num      = idebc+nue
           msh%list_cell(idebc+nue)%idom     = blv(2)%idom
           vv= volcel(blv(2),1.d0*ie,1.d0*je,1.d0*ke,0)
           msh%list_cell(idebc+nue)%vol = vv
           msh%list_cell(idebc+nue)%center = pni(blv(2),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
        else
           msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(2)%first_cell         !!!!! A VERIFIER PARTOUT
        endif
      endif

      ie=1
      je=2*j-1
      ke=2*k-1+1
      nue=je+(ke-1)*nyv ! Numerotation exterieure
      ia=idebf+nue 
      msh%list_face(ia)%vertex(1)=idebv+ny*nz+ny*(nz+1)+(k-1)*(ny+1)+j
      msh%list_face(ia)%vertex(4)=idebv+(j-1)*nz+k
      msh%list_face(ia)%vertex(3)=idebv+ny*nz+(j-1)*(nz+1)+k+1
      msh%list_face(ia)%vertex(2)=(nx+1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
      msh%list_face(ia)%ic1=nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
      if(bl%cl(2).le.0)then
        msh%list_face(ia)%ic2=bl%cl(2)
      else
        if(blv(2)%idom.ne.bl%idom)then
           call psr(interdom,nb_dom,bl%idom,blv(2)%idom,ib,bl%cl(2),ipos_send,ipos_recv)
           msh%list_send(blv(2)%idom)%L(nui+ipos_send)    = nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
           msh%list_recv(blv(2)%idom)%L(nue+ipos_recv)    = idebc+nue     
           msh%list_face(ia)%ic2             = idebc+nue
           msh%list_cell(idebc+nue)%num      = idebc+nue
           msh%list_cell(idebc+nue)%idom     = blv(2)%idom
           vv= volcel(blv(2),1.d0*ie,1.d0*je,1.d0*ke,0)
           msh%list_cell(idebc+nue)%vol = vv
           msh%list_cell(idebc+nue)%center = pni(blv(2),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
        else
           msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(2)%first_cell         !!!!! A VERIFIER PARTOUT
        endif
      endif

      ie=1
      je=2*j-1+1
      ke=2*k-1+1
      nue=je+(ke-1)*nyv ! Numerotation exterieure
      ia=idebf+nue 
      msh%list_face(ia)%vertex(1)=idebv+(j-1)*nz+k
      msh%list_face(ia)%vertex(4)=idebv+ny*nz+ny*(nz+1)+(k-1)*(ny+1)+j+1
      msh%list_face(ia)%vertex(3)=(nx+1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
      msh%list_face(ia)%vertex(2)=idebv+ny*nz+(j-1)*(nz+1)+k+1
      msh%list_face(ia)%ic1=nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
      if(bl%cl(2).le.0)then
        msh%list_face(ia)%ic2=bl%cl(2)
      else
        if(blv(2)%idom.ne.bl%idom)then
           call psr(interdom,nb_dom,bl%idom,blv(2)%idom,ib,bl%cl(2),ipos_send,ipos_recv)
           msh%list_send(blv(2)%idom)%L(nui+ipos_send)    = nx+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
           msh%list_recv(blv(2)%idom)%L(nue+ipos_recv)    = idebc+nue     
           msh%list_face(ia)%ic2             = idebc+nue
           msh%list_cell(idebc+nue)%num      = idebc+nue
           msh%list_cell(idebc+nue)%idom     = blv(2)%idom
           vv= volcel(blv(2),1.d0*ie,1.d0*je,1.d0*ke,0)
           msh%list_cell(idebc+nue)%vol = vv
           msh%list_cell(idebc+nue)%center = pni(blv(2),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
        else
           msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(2)%first_cell         !!!!! A VERIFIER PARTOUT
        endif
      endif
    end do
  end do
  idebf=idebf+ny*nz*4
  idebv=idebv+ny*(nz+1)+(ny+1)*nz+ny*nz
  if(bl%cl(2).gt.0)then
    if(blv(2)%idom.ne.bl%idom)idebc=idebc+ny*nz*4
  endif
endif
102 continue


! Construction de la liste des faces pour y=ymin 
! et des cellules du domaine voisin
!===========================================================================================
if(bl%idom.eq.blv(3)%idom.and.ib.lt.bl%cl(3))goto 103
if(blv(3)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=nz
else
   nxv=blv(3)%nx*2**(blv(3)%nrb)
   nyv=blv(3)%ny*2**(blv(3)%nrb)
   nzv=blv(3)%nz*2**(blv(3)%nrb)
endif

if(bl%nrf(3).le.0)then ! Dans le cas ou le bloc voisin est - fin ou identique 

  ii=1
  if(bl%nrf(3).eq.-1)ii=2
  do i=1,nx
    do k=1,nz
       ie=1+int((i-1)/ii)
       je=nyv
       ke=1+int((k-1)/ii)
       nue=ie+(ke-1)*nxv ! Numerotation exterieure
       nui=i+(k-1)*nx                          ! Numerotation interieure au bloc
       ia=idebf+nui                   
       msh%list_face(ia)%vertex(1)=(i+0)+(1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
       msh%list_face(ia)%vertex(4)=(i+1)+(1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
       msh%list_face(ia)%vertex(3)=(i+1)+(1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
       msh%list_face(ia)%vertex(2)=(i+0)+(1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
       msh%list_face(ia)%ic1=i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
       if(bl%cl(3).le.0)then
          msh%list_face(ia)%ic2=bl%cl(3)
       else
          if(blv(3)%idom.ne.bl%idom)then
             call psr(interdom,nb_dom,bl%idom,blv(3)%idom,ib,bl%cl(3),ipos_send,ipos_recv)
             msh%list_face(ia)%ic2=idebc+nue
             msh%list_send(blv(3)%idom)%L(nui+ipos_send)=i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
             msh%list_recv(blv(3)%idom)%L(nue+ipos_recv)=idebc+nue
             msh%list_cell(idebc+nue)%num =idebc+nue
             msh%list_cell(idebc+nue)%idom     = blv(3)%idom        
             vv= volcel(blv(3),1.d0*ie,1.d0*je,1.d0*ke,0)
             msh%list_cell(idebc+nue)%vol = vv
             msh%list_cell(idebc+nue)%center = pni(blv(3),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
          else
             msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(3)%first_cell         
          endif
       endif
    end do
  end do
  idebf=idebf+nz*nx
  if(bl%cl(3).gt.0)then
      if(blv(3)%idom.ne.bl%idom)idebc=idebc+nx*nz/ii/ii
  endif

else ! Dans le cas ou le bloc voisin est + fin 
! creation des noeuds centre des "grosses faces"
          is=idebv
          do i=1,nx
            do k=1,nz
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0,1.d0*k+0.5d0,0)
            end do
          end do
! creation des noeuds aux milieux des aretes
          do i=1,nx
            do k=1,nz+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0,1.d0*k,0)
             end do
          end do
          do k=1,nz
            do i=1,nx+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i,1.d0,1.d0*k+0.5d0,0)
            end do
          end do
! creation des faces
   do i=1,nx
          do k=1,nz
                 ie=2*i-1
                   je=nyv
                   ke=2*k-1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             nui=i+(k-1)*nx         ! Numerotation interieure au bloc
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=(i+0)+(1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=idebv+nx*nz+(i-1)*(nz+1)+k
             msh%list_face(ia)%vertex(3)=idebv+(i-1)*nz+k
             msh%list_face(ia)%vertex(2)=idebv+nx*nz+nx*(nz+1)+(k-1)*(nx+1)+i
             msh%list_face(ia)%ic1=i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
             if(bl%cl(3).le.0)then
               msh%list_face(ia)%ic2=bl%cl(3)
             else
                      if(blv(3)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(3)%idom,ib,bl%cl(3),ipos_send,ipos_recv)
                  msh%list_send(blv(3)%idom)%L(nui+ipos_send)    = i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(3)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(3)%idom
                  vv= volcel(blv(3),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(3),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(3)%first_cell         
                        endif
             endif
                  
                 ie=2*i-1+1
                   je=nyv
                   ke=2*k-1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+nx*nz+(i-1)*(nz+1)+k
             msh%list_face(ia)%vertex(4)=(i+1)+(1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=idebv+nx*nz+nx*(nz+1)+(k-1)*(nx+1)+i+1
             msh%list_face(ia)%vertex(2)=idebv+(i-1)*nz+k
             msh%list_face(ia)%ic1=i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
             if(bl%cl(3).le.0)then
               msh%list_face(ia)%ic2=bl%cl(3)
             else
                      if(blv(3)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(3)%idom,ib,bl%cl(3),ipos_send,ipos_recv)
                  msh%list_send(blv(3)%idom)%L(nui+ipos_send)    = i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(3)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(3)%idom
                  vv= volcel(blv(3),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(3),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(3)%first_cell         
                        endif
             endif
                   
                 ie=2*i-1
                   je=nyv
                   ke=2*k-1+1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+nx*nz+nx*(nz+1)+(k-1)*(nx+1)+i
             msh%list_face(ia)%vertex(4)=idebv+(i-1)*nz+k
             msh%list_face(ia)%vertex(3)=idebv+nx*nz+(i-1)*(nz+1)+k+1
             msh%list_face(ia)%vertex(2)=(i+0)+(1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
             if(bl%cl(3).le.0)then
               msh%list_face(ia)%ic2=bl%cl(3)
             else
                      if(blv(3)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(3)%idom,ib,bl%cl(3),ipos_send,ipos_recv)
                  msh%list_send(blv(3)%idom)%L(nui+ipos_send)    = i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(3)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(3)%idom
                  vv= volcel(blv(3),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(3),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(3)%first_cell         
                        endif
             endif
             
                 ie=2*i-1+1
                   je=nyv
                   ke=2*k-1+1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+(i-1)*nz+k
             msh%list_face(ia)%vertex(4)=idebv+nx*nz+nx*(nz+1)+(k-1)*(nx+1)+i+1
             msh%list_face(ia)%vertex(3)=(i+1)+(1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=idebv+nx*nz+(i-1)*(nz+1)+k+1
             msh%list_face(ia)%ic1=i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
             if(bl%cl(3).le.0)then
               msh%list_face(ia)%ic2=bl%cl(3)
             else
                      if(blv(3)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(3)%idom,ib,bl%cl(3),ipos_send,ipos_recv)
                  msh%list_send(blv(3)%idom)%L(nui+ipos_send)    = i+(1-1)*nx+(k-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(3)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(3)%idom
                  vv= volcel(blv(3),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(3),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(3)%first_cell         
                        endif
             endif
          end do
       end do
       idebf=idebf+nz*nx*4
       idebv=idebv+nz*(nx+1)+(nz+1)*nx+nz*nx
       if(bl%cl(3).gt.0)then
           if(blv(3)%idom.ne.bl%idom)idebc=idebc+nx*nz*4
         endif
endif
103 continue

! Construction de la liste des faces pour y=ymax 
!===========================================================================================
if(bl%idom.eq.blv(4)%idom.and.ib.lt.bl%cl(4))goto 104
if(blv(4)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=nz
else
   nxv=blv(4)%nx*2**(blv(4)%nrb)
   nyv=blv(4)%ny*2**(blv(4)%nrb)
   nzv=blv(4)%nz*2**(blv(4)%nrb)
endif

if(bl%nrf(4).le.0)then ! Dans le cas ou le bloc voisin est - fin ou identique 
       ii=1
       if(bl%nrf(4).eq.-1)ii=2
        do i=1,nx
          do k=1,nz
                     ie=1+int((i-1)/ii)
                   je=1
                   ke=1+int((k-1)/ii)
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             nui=i+(k-1)*nx                          ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(ny+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+1)+(ny+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(ny+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(ny+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
             if(bl%cl(4).le.0)then
               msh%list_face(ia)%ic2=bl%cl(4)
             else
                      if(blv(4)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(4)%idom,ib,bl%cl(4),ipos_send,ipos_recv)
                  msh%list_face(ia)%ic2=idebc+nue
                  msh%list_send(blv(4)%idom)%L(nui+ipos_send)=i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(4)%idom)%L(nue+ipos_recv)=idebc+nue
                  msh%list_cell(idebc+nue)%num =idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(4)%idom        
                  vv= volcel(blv(4),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(4),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(4)%first_cell         
                        endif
             endif
          end do
       end do
       idebf=idebf+nz*nx
       if(bl%cl(4).gt.0)then
           if(blv(4)%idom.ne.bl%idom)idebc=idebc+nx*nz/ii/ii
         endif

     else ! Dans le cas ou le bloc voisin est + fin 
! creation des noeuds centre des "grosses faces"
          is=idebv
          do i=1,nx
            do k=1,nz
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0*(ny+1),1.d0*k+0.5d0,0)
            end do
          end do
! creation des noeuds aux milieux des aretes
          do i=1,nx
            do k=1,nz+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0*(ny+1),1.d0*k,0)
            end do
          end do
          do k=1,nz
            do i=1,nx+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i,1.d0*(ny+1),1.d0*k+0.5d0,0)
            end do
          end do
! creation des faces
   do i=1,nx
          do k=1,nz
                 ie=2*i-1
                   je=1
                   ke=2*k-1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             nui=i+(k-1)*nx         ! Numerotation interieure au bloc
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=(i+0)+(ny+1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=idebv+nx*nz+nx*(nz+1)+(k-1)*(nx+1)+i
             msh%list_face(ia)%vertex(3)=idebv+(i-1)*nz+k
             msh%list_face(ia)%vertex(2)=idebv+nx*nz+(i-1)*(nz+1)+k
             msh%list_face(ia)%ic1=i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
             if(bl%cl(4).le.0)then
               msh%list_face(ia)%ic2=bl%cl(4)
             else
                      if(blv(4)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(4)%idom,ib,bl%cl(4),ipos_send,ipos_recv)
                  msh%list_send(blv(4)%idom)%L(nui+ipos_send)    = i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(4)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(4)%idom
                  vv= volcel(blv(4),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(4),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(4)%first_cell         
                        endif
             endif

                 ie=2*i-1+1
                   je=1
                   ke=2*k-1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+nx*nz+(i-1)*(nz+1)+k
             msh%list_face(ia)%vertex(4)=idebv+(i-1)*nz+k
             msh%list_face(ia)%vertex(3)=idebv+nx*nz+nx*(nz+1)+(k-1)*(nx+1)+i+1
             msh%list_face(ia)%vertex(2)=(i+1)+(ny+1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
             if(bl%cl(4).le.0)then
               msh%list_face(ia)%ic2=bl%cl(4)
             else
                      if(blv(4)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(4)%idom,ib,bl%cl(4),ipos_send,ipos_recv)
                  msh%list_send(blv(4)%idom)%L(nui+ipos_send)    = i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(4)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(4)%idom
                  vv= volcel(blv(4),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(4),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(4)%first_cell         
                        endif
             endif

                 ie=2*i-1
                   je=1
                   ke=2*k-1+1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+nx*nz+nx*(nz+1)+(k-1)*(nx+1)+i
             msh%list_face(ia)%vertex(4)=(i+0)+(ny+1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=idebv+nx*nz+(i-1)*(nz+1)+k+1
             msh%list_face(ia)%vertex(2)=idebv+(i-1)*nz+k
             msh%list_face(ia)%ic1=i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
             if(bl%cl(4).le.0)then
               msh%list_face(ia)%ic2=bl%cl(4)
             else
                      if(blv(4)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(4)%idom,ib,bl%cl(4),ipos_send,ipos_recv)
                  msh%list_send(blv(4)%idom)%L(nui+ipos_send)    = i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(4)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(4)%idom
                  vv= volcel(blv(4),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(4),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(4)%first_cell         
                        endif
             endif

                 ie=2*i-1+1
                   je=1
                   ke=2*k-1+1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             ia=idebf+nue
             msh%list_face(ia)%vertex(1)=idebv+(i-1)*nz+k
             msh%list_face(ia)%vertex(4)=idebv+nx*nz+(i-1)*(nz+1)+k+1
             msh%list_face(ia)%vertex(3)=(i+1)+(ny+1+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=idebv+nx*nz+nx*(nz+1)+(k-1)*(nx+1)+i+1
             msh%list_face(ia)%ic1=i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
             if(bl%cl(4).le.0)then
               msh%list_face(ia)%ic2=bl%cl(4)
             else
                      if(blv(4)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(4)%idom,ib,bl%cl(4),ipos_send,ipos_recv)
                  msh%list_send(blv(4)%idom)%L(nui+ipos_send)    = i+(ny-1)*nx+(k-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(4)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(4)%idom
                  vv= volcel(blv(4),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(4),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(4)%first_cell         
                        endif
             endif
          end do
       end do
       idebf=idebf+nz*nx*4
       idebv=idebv+nz*(nx+1)+(nz+1)*nx+nz*nx
       if(bl%cl(4).gt.0)then
         if(blv(4)%idom.ne.bl%idom)idebc=idebc+nx*nz*4
         endif
endif
104    continue

! Construction de la liste des faces pour z=zmin 
!===========================================================================================

if(bl%idom.eq.blv(5)%idom.and.ib.lt.bl%cl(5))goto 105
if(blv(5)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=nz
else
   nxv=blv(5)%nx*2**(blv(5)%nrb)
   nyv=blv(5)%ny*2**(blv(5)%nrb)
   nzv=blv(5)%nz*2**(blv(5)%nrb)
endif

if(bl%nrf(5).le.0)then ! Dans le cas ou le bloc voisin est - fin ou identique 
       ii=1
       if(bl%nrf(5).eq.-1)ii=2
       do i=1,nx
          do j=1,ny
             ie=1+int((i-1)/ii)
                   je=1+int((j-1)/ii)
                   ke=nzv
             nue=ie+(je-1)*nxv ! Numerotation exterieure
             nui=i+(j-1)*nx    ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(1-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
             if(bl%cl(5).le.0)then
               msh%list_face(ia)%ic2=bl%cl(5)
             else
                      if(blv(5)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(5)%idom,ib,bl%cl(5),ipos_send,ipos_recv)
                  msh%list_face(ia)%ic2=idebc+nue
                  msh%list_send(blv(5)%idom)%L(nui+ipos_send)=i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(5)%idom)%L(nue+ipos_recv)=idebc+nue
                  msh%list_cell(idebc+nue)%num =idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(5)%idom        
                  vv= volcel(blv(5),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(5),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(5)%first_cell         
                        endif
             endif
          end do
       end do
       idebf=idebf+nx*ny
       if(bl%cl(5).gt.0)then
           if(blv(5)%idom.ne.bl%idom)idebc=idebc+nx*ny/ii/ii
         endif

else ! Dans le cas ou le bloc voisin est + fin 
! creation des noeuds centre des "grosses faces"
          is=idebv
          do i=1,nx
            do j=1,ny
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0*j+0.5d0,1.d0,0)
             end do
          end do
! creation des noeuds aux milieux des aretes
          do i=1,nx
            do j=1,ny+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0*j,1.d0,0)
            end do
          end do
          do j=1,ny
            do i=1,nx+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i,1.d0*j+0.5d0,1.d0,0)
            end do
          end do
! creation des faces
   do i=1,nx
          do j=1,ny
             ie=2*i-1
                   je=2*j-1
                   ke=nzv
             nue=ie+(je-1)*nxv ! Numerotation exterieure
             nui=i+(j-1)*nx         ! Numerotation interieure au bloc
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(1+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=idebv+nx*ny+(i-1)*(ny+1)+j
             msh%list_face(ia)%vertex(3)=idebv+(i-1)*ny+j
             msh%list_face(ia)%vertex(4)=idebv+nx*ny+nx*(ny+1)+(j-1)*(nx+1)+i
             msh%list_face(ia)%ic1=i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
             if(bl%cl(5).le.0)then
               msh%list_face(ia)%ic2=bl%cl(5)
             else
                      if(blv(5)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(5)%idom,ib,bl%cl(5),ipos_send,ipos_recv)
                  msh%list_send(blv(5)%idom)%L(nui+ipos_send)    = i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(5)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(5)%idom
                  vv= volcel(blv(5),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(5),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(5)%first_cell         
                        endif
             endif

             ie=2*i-1+1
                   je=2*j-1
                   ke=nzv
             nue=ie+(je-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+nx*ny+(i-1)*(ny+1)+j
             msh%list_face(ia)%vertex(2)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(1+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=idebv+nx*ny+nx*(ny+1)+(j-1)*(nx+1)+i+1
             msh%list_face(ia)%vertex(4)=idebv+(i-1)*ny+j
             msh%list_face(ia)%ic1=i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
             if(bl%cl(5).le.0)then
               msh%list_face(ia)%ic2=bl%cl(5)
             else
                      if(blv(5)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(5)%idom,ib,bl%cl(5),ipos_send,ipos_recv)
                  msh%list_send(blv(5)%idom)%L(nui+ipos_send)    = i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(5)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(5)%idom
                  vv= volcel(blv(5),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(5),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(5)%first_cell         
                        endif
             endif

             ie=2*i-1
                   je=2*j-1+1
                   ke=nzv
             nue=ie+(je-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+nx*ny+nx*(ny+1)+(j-1)*(nx+1)+i
             msh%list_face(ia)%vertex(2)=idebv+(i-1)*ny+j
             msh%list_face(ia)%vertex(3)=idebv+nx*ny+(i-1)*(ny+1)+j+1
             msh%list_face(ia)%vertex(4)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(1+0-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
             if(bl%cl(5).le.0)then
               msh%list_face(ia)%ic2=bl%cl(5)
             else
                      if(blv(5)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(5)%idom,ib,bl%cl(5),ipos_send,ipos_recv)
                  msh%list_send(blv(5)%idom)%L(nui+ipos_send)    = i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(5)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(5)%idom
                  vv= volcel(blv(5),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(5),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(5)%first_cell         
                        endif
             endif

             ie=2*i-1+1
                   je=2*j-1+1
                   ke=nzv
             nue=ie+(je-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+(i-1)*ny+j
             msh%list_face(ia)%vertex(2)=idebv+nx*ny+nx*(ny+1)+(j-1)*(nx+1)+i+1
             msh%list_face(ia)%vertex(3)=(i+1)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(1+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=idebv+nx*ny+(i-1)*(ny+1)+j+1
             msh%list_face(ia)%ic1=i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
             if(bl%cl(5).le.0)then
               msh%list_face(ia)%ic2=bl%cl(5)
             else
                      if(blv(5)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(5)%idom,ib,bl%cl(5),ipos_send,ipos_recv)
                  msh%list_send(blv(5)%idom)%L(nui+ipos_send)    = i+(j-1)*nx+(1-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(5)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(5)%idom
                  vv= volcel(blv(5),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(5),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(5)%first_cell         
                        endif
             endif
          end do
       end do
       idebf=idebf+nx*ny*4
       idebv=idebv+nx*(ny+1)+(nx+1)*ny+nx*ny
       if(bl%cl(5).gt.0)then
           if(blv(5)%idom.ne.bl%idom)idebc=idebc+ny*nx*4
         endif
endif
105     continue

! Construction de la liste des faces pour z=zmax 
!===========================================================================================
if(bl%idom.eq.blv(6)%idom.and.ib.lt.bl%cl(6))goto 106
if(blv(6)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=nz
else
   nxv=blv(6)%nx*2**(blv(6)%nrb)
   nyv=blv(6)%ny*2**(blv(6)%nrb)
   nzv=blv(6)%nz*2**(blv(6)%nrb)
endif

if(bl%nrf(6).le.0)then ! Dans le cas ou le bloc voisin est - fin ou identique 

       ii=1
       if(bl%nrf(6).eq.-1)ii=2
       do i=1,nx
          do j=1,ny
             ie=1+int((i-1)/ii)
                   je=1+int((j-1)/ii)
                   ke=1
             nue=ie+(je-1)*nxv ! Numerotation exterieure
                 nui=i+(j-1)*nx                          ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
             if(bl%cl(6).le.0)then
               msh%list_face(ia)%ic2=bl%cl(6)
             else
                      if(blv(6)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(6)%idom,ib,bl%cl(6),ipos_send,ipos_recv)
                  msh%list_face(ia)%ic2=idebc+nue
                  msh%list_send(blv(6)%idom)%L(nui+ipos_send)=i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(6)%idom)%L(nue+ipos_recv)=idebc+nue
                  msh%list_cell(idebc+nue)%num =idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(6)%idom        
                  vv= volcel(blv(6),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(6),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(6)%first_cell         
                        endif
             endif
          end do
       end do
       idebf=idebf+nx*ny
       if(bl%cl(6).gt.0)then
           if(blv(6)%idom.ne.bl%idom)idebc=idebc+nx*ny/ii/ii
         endif

else ! Dans le cas ou le bloc voisin est + fin 
! creation des noeuds centre des "grosses faces"
          is=idebv
          do i=1,nx
            do j=1,ny
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0*j+0.5d0,1.d0*(nz+1),0)
            end do
          end do
! creation des noeuds aux milieux des aretes
          do i=1,nx
            do j=1,ny+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0*j,1.d0*(nz+1),0)
            end do
          end do
          do j=1,ny
            do i=1,nx+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i,1.d0*j+0.5d0,1.d0*(nz+1),0)
            end do
          end do
! creation des faces
   do i=1,nx
          do j=1,ny
             ie=2*i-1
                   je=2*j-1
                   ke=1
             nue=ie+(je-1)*nxv ! Numerotation exterieure
             nui=i+(j-1)*nx         ! Numerotation interieure au bloc
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=idebv+nx*ny+(i-1)*(ny+1)+j
             msh%list_face(ia)%vertex(3)=idebv+(i-1)*ny+j
             msh%list_face(ia)%vertex(2)=idebv+nx*ny+nx*(ny+1)+(j-1)*(nx+1)+i
             msh%list_face(ia)%ic1=i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
             if(bl%cl(6).le.0)then
               msh%list_face(ia)%ic2=bl%cl(6)
             else
                      if(blv(6)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(6)%idom,ib,bl%cl(6),ipos_send,ipos_recv)
                  msh%list_send(blv(6)%idom)%L(nui+ipos_send)    = i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(6)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(6)%idom
                  vv= volcel(blv(6),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(6),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(6)%first_cell         
                        endif
             endif

             ie=2*i-1+1
                   je=2*j-1
                   ke=1
             nue=ie+(je-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+nx*ny+(i-1)*(ny+1)+j
             msh%list_face(ia)%vertex(4)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=idebv+nx*ny+nx*(ny+1)+(j-1)*(nx+1)+i+1
             msh%list_face(ia)%vertex(2)=idebv+(i-1)*ny+j
             msh%list_face(ia)%ic1=i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
             if(bl%cl(6).le.0)then
               msh%list_face(ia)%ic2=bl%cl(6)
             else
                      if(blv(6)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(6)%idom,ib,bl%cl(6),ipos_send,ipos_recv)
                  msh%list_send(blv(6)%idom)%L(nui+ipos_send)    = i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(6)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(6)%idom
                  vv= volcel(blv(6),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(6),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(6)%first_cell         
                        endif
             endif

             ie=2*i-1
                   je=2*j-1+1
                   ke=1
             nue=ie+(je-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+nx*ny+nx*(ny+1)+(j-1)*(nx+1)+i
             msh%list_face(ia)%vertex(4)=idebv+(i-1)*ny+j
             msh%list_face(ia)%vertex(3)=idebv+nx*ny+(i-1)*(ny+1)+j+1
             msh%list_face(ia)%vertex(2)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
             if(bl%cl(6).le.0)then
               msh%list_face(ia)%ic2=bl%cl(6)
             else
                      if(blv(6)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(6)%idom,ib,bl%cl(6),ipos_send,ipos_recv)
                  msh%list_send(blv(6)%idom)%L(nui+ipos_send)    = i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(6)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(6)%idom
                  vv= volcel(blv(6),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(6),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(6)%first_cell         
                        endif
             endif

             ie=2*i-1+1
                   je=2*j-1+1
                   ke=1
             nue=ie+(je-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+(i-1)*ny+j
             msh%list_face(ia)%vertex(4)=idebv+nx*ny+nx*(ny+1)+(j-1)*(nx+1)+i+1
             msh%list_face(ia)%vertex(3)=(i+1)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=idebv+nx*ny+(i-1)*(ny+1)+j+1
             msh%list_face(ia)%ic1=i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
             if(bl%cl(6).le.0)then
               msh%list_face(ia)%ic2=bl%cl(6)
             else
                      if(blv(6)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(6)%idom,ib,bl%cl(6),ipos_send,ipos_recv)
                  msh%list_send(blv(6)%idom)%L(nui+ipos_send)    = i+(j-1)*nx+(nz-1)*nx*ny +bl%first_cell
                  msh%list_recv(blv(6)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(6)%idom
                  vv= volcel(blv(6),1.d0*ie,1.d0*je,1.d0*ke,0)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(6),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,0)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(6)%first_cell         
                        endif
             endif
          end do
       end do
       idebf=idebf+nx*ny*4
       idebv=idebv+nx*(ny+1)+(nx+1)*ny+nx*ny
       if(bl%cl(6).gt.0)then
           if(blv(6)%idom.ne.bl%idom)idebc=idebc+ny*nx*4
         endif
endif
106    continue
    
!
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE MESH3D
!DOCFIN

 
SUBROUTINE fct_mvsol(v1,v2,v3,o1,o2,o3,num)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/USER/fct_mvsol *
!
!    NOM
! fct_mvsol(v1,v2,v3,o1,o2,o3,num)
!    DESCRIPTION  
!*
! Definition du mouvement impose  a un solide par son vecteur 
! vitesse de translation et son vecteur vitesse angulaire
! Definition of the motion imposed on a solid by its  translational velocity vector
! and angular velocity vector
!*
!
!    ENTREES / INPUT
!    num : numero de la fonction / function number
! on a acces au temps global tc / the global time tc is available
!
!    SORTIES / OUTPUT
!    v : vitesse de translation / translational velocity
!    o : vitesse angulaire / angular velocity
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  real(kind=kind(0.d0)), intent(out) :: v1,v2,v3 !! vitesse de translation / translational velocity
  real(kind=kind(0.d0)), intent(out) :: o1,o2,o3 !! vitesse angulaire / angular velocity
  integer, intent(in)                :: num !! numero de la fonction / Function number
!=========================== DEBUT DU CODE EXECUTABLE ==================
    v1=0.d0    
    v2=0.d0    
    v3=0.d0    
    o1=0.d0    
    o2=0.d0    
    o3=0.d0    

    select case (num)

!  Mouvement du batteur
       case(1)
         v1=-4.d-1*datan(1.d0)*sin(4.d0*datan(1.d0)*tc)

!  Mouvement du batteur
        case(2)
          v1=-0.2d0*4.d0*datan(1.d0)*sin(4.d0*datan(1.d0)*tc)

!  Mouvement du prisme
        case(3)
         if(tc.le.0.087d0)then  !si tps <= à un nmbre à définir
            v2=-0.225d0*9.81d0*tc-0.4d0  !-mg.t+V0 avec m en kg
         else
            v2=0.d0
         endif

!  Erreur
        case default 
         call print_err('FCT_MVSOL',' Solide motion not defined!!')
          stop

    end select
!===============   FIN DE LA ROUTINE    ====================
END SUBROUTINE fct_mvsol
!DOCFIN 

 SUBROUTINE read_mesh(calc,nzone,zone)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_mesh *
!
!    NOM
! read_mesh(calc)
!    DESCRIPTION  
!*
! Lecture du Bloc MESH du fichier de donnees *.inp
! Reading the MESH block from the *.inp data file
!*
! 
!    ENTREES / INPUT
!    calc  objet calcul initial / initial calcul object
!
!    SORTIES / OUTPUT
!    calc  objet calcul mis a jour / updated calcul object
!    nzone  nombre de zone de maillage / number of mesh zones
!    zone   parametres de maillage / mesh parameters
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul), intent(inout)                                     :: calc !! Objet calcul / Calcul object
  integer,allocatable,dimension(:,:), intent(inout)               :: nzone !! parametres de maillage/ mesh parameters
  real(kind=kind(0.d0)),allocatable,dimension(:,:), intent(inout) :: zone !! parametres de maillage/ mesh parameters
  
  character(4)                                                    :: para
  integer                                                         :: i,j,nzra
  real(kind=kind(0.d0))                                           :: arg
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(*,*)
  write(*,*)achar(27)//'[34m================================================'
  write(*,*)'Reading Mesh parameters : block MESH'
  write(*,*)'================================================'//achar(27)//'[0m'
  write(*,*)
  

199 read(33,'(a4,f20.0)',err=200,end=200)para,arg

  SELECT CASE (para)
      CASE('NBDS')
          calc%nbds=idint(arg)
          write(*,*)'MESH-Info  Number of domains                :',calc%nbds
      CASE('MARL')
          calc%nrma=idint(arg)
          write(*,*)'MESH-Info  Maximal refinement level         :',calc%nrma
      CASE('COPA')
          calc%vcde=arg
          write(*,*)'MESH-Info  Mesh coarsening parameter        :',calc%vcde
      CASE('REPA')
          calc%vcra=arg
          write(*,*)'MESH-Info  Mesh refinement parameter        :',calc%vcra
      CASE('FDRA')
          write(*,*)'MESH-Info  Function number                  :',idint(arg)
          allocate(nzone(4,1),zone(6,1))
          nzone(1,1)=-idint(arg)
          zone=0.d0
      CASE('NZRA')
          nzra=idint(arg)
          write(*,*)'MESH-Info  Number of zones to be refined    :',nzra
          allocate(nzone(4,nzra),zone(6,nzra))
          nzone=1
          zone=0.d0
          DO i=1,nzra
              read(33,*)nzone(1,i),(zone(j,i),j=1,6)
              if(nzone(1,i).gt.calc%nrma)then
                calc%nrma=nzone(1,i)
                call print_avert('READ_MESH',' Maximal refinement level has been adjusted')
              endif
          END DO                            
      CASE default
          GOTO 200
  END select
  GOTO 199
200 continue       
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_mesh
!DOCFIN

 SUBROUTINE block2mesh(cb,nzone,zone,nzonei,zonei)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/block2mesh  *
!
!    NOM
! block2mesh(cb,nzone,zone,nzonei,zonei)
!    DESCRIPTION  
!*
! A partir du maillage maitre (les blocs) on construit le maillage de chaque domaine.
! From the master mesh (the blocks) we construct the mesh for each domain.
!*
!
! 
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  use uti, only: inter,init_def_bloc,ini_w,splitdom_Z ! ,bathy_sv1,initsu_sv1
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul)                                      :: cb !! Objet calcul contenant le maillage maitre / Calcul object containing the master mesh
  integer                                           :: nzonei  
!! Parametres de definition des maillages et conditions aux limites / Mesh definition parameters and boundary conditions
  real(kind=kind(0.d0)),allocatable,dimension(:,:)  :: zone,zonei
!! Parametres de definition des maillages et conditions aux limites / Mesh definition parameters and boundary conditions
  integer,allocatable,dimension(:,:)                :: nzone
!! Parametres de definition des maillages et conditions aux limites / Mesh definition parameters and boundary conditions

  type(bloc)                                        :: blv(6),bl_null
  type(calcul)                                      :: calc
  integer                                           :: imac(6),imav(6),imaf(6)
  integer                                           :: idom,nb_dom,nx,ny,nz,i,nb_bloc,ib
  integer                                           :: icb,ibv
  integer                                           :: k,nvi
  integer                                           :: l
  real(kind=kind(0.d0))                             :: hmin,dd,x,y
  type(list_int), allocatable,dimension(:)          :: interdom
  integer, allocatable,dimension(:)                 :: nbl

!=========================== DEBUT DU CODE EXECUTABLE ==================
bl_null%numbl =0 ;bl_null%idom =0 ;bl_null%morton  =0 ;bl_null%nrb =0 ;bl_null%nx =0 ;bl_null%ny =0 ;bl_null%nz  =0 ;
bl_null%volc  =0.d0 ;bl_null%cl(:)  =0 ;bl_null%nrf(:)  =0 ;bl_null%dom(:)  =0 ;bl_null%first_cell =0 ;
bl_null%nb_cell   =0 ;   bl_null%first_face =0 ;bl_null%nb_face    =0 ;  bl_null%first_vertex =0 ;bl_null%nb_vertex  =0 


  write(*,*)
  write(*,*)achar(27)//'[34m================================================'
  write(*,*)'Creation of the domain mesh from the master mesh'
  write(*,*)'================================================'//achar(27)//'[0m'
  write(*,*)
  nb_bloc=cb%nb_bloc
  nb_dom=cb%nbds
  write(*,*)'BLOCK2MESH-INFO Problem dimension :',cb%msh%ndim
! estimation de hmin
    hmin=1.d20
    DO ib=1,nb_bloc
        dd=sqrt((cb%list_bloc(ib)%s(1)%x-cb%list_bloc(ib)%s(2)%x)**2+ &
                (cb%list_bloc(ib)%s(1)%y-cb%list_bloc(ib)%s(2)%y)**2+(cb%list_bloc(ib)%s(1)%z-cb%list_bloc(ib)%s(2)%z)**2)
        if(dd.lt.hmin)hmin=dd
        dd=sqrt((cb%list_bloc(ib)%s(1)%x-cb%list_bloc(ib)%s(4)%x)**2+ &
                (cb%list_bloc(ib)%s(1)%y-cb%list_bloc(ib)%s(4)%y)**2+(cb%list_bloc(ib)%s(1)%z-cb%list_bloc(ib)%s(4)%z)**2)
        if(dd.lt.hmin)hmin=dd
        dd=sqrt((cb%list_bloc(ib)%s(1)%x-cb%list_bloc(ib)%s(5)%x)**2+ &
                (cb%list_bloc(ib)%s(1)%y-cb%list_bloc(ib)%s(5)%y)**2+(cb%list_bloc(ib)%s(1)%z-cb%list_bloc(ib)%s(5)%z)**2)
        if(dd.lt.hmin)hmin=dd
    END DO

!----------------------------------------------------------------------------------
! on definit la discretisation des blocs et l appartenance a un domaine
!
  CALL init_def_bloc(cb,nzone,zone)

!----------------------------------------------------------------------------------
! on verifie la condition sur le niveau de discretisation de 2 blocs voisins
  DO l=1,cb%nrma
    DO ib=1,nb_bloc
        DO i=1,6
            IF (cb%list_bloc(ib)%cl(i).gt.0) THEN
               ibv=cb%list_bloc(ib)%cl(i)
               IF(cb%list_bloc(ib)%nrb.eq.(cb%nrma+1-l).and.cb%list_bloc(ibv)%nrb.lt.(cb%nrma-l)) cb%list_bloc(ibv)%nrb=(cb%nrma-l)
            END IF
        END DO
    END DO
  END DO
!----------------------------------------------------------------------------------
! on decompose en sous-domaines par code de Morton

  write( *,1011)nb_bloc,nb_dom
1011 format('Aggregation of ',i6,' blocks into',i3,' sub-domains')

  CALL splitdom_Z(cb%list_bloc,nb_bloc,nb_dom, cb%msh%ndim) 

! liste des voisins: -1/ le voisin est + grossier
!                     0/ le voisin est identique
!                     1/ le voisin est + fin
  DO ib=1,nb_bloc
      cb%list_bloc(ib)%nrf=0
      DO i=1,6
          ibv=cb%list_bloc(ib)%cl(i)
          IF(ibv.lt.-100000)ibv=-ibv-100000
          IF (ibv.gt.0) THEN
              IF (cb%list_bloc(ibv)%nrb.gt.cb%list_bloc(ib)%nrb) cb%list_bloc(ib)%nrf(i)=1
              IF (cb%list_bloc(ibv)%nrb.lt.cb%list_bloc(ib)%nrb) cb%list_bloc(ib)%nrf(i)=-1
          END IF
      END DO
  END DO
!
!-------  Determination de la taille des tableaux du bloc
  DO ib=1,nb_bloc
      cb%list_bloc(ib)%dom=0
      DO i=1,6
          ibv=cb%list_bloc(ib)%cl(i)
          IF(ibv.lt.-100000)ibv=-ibv-100000
          IF (ibv.gt.0) cb%list_bloc(ib)%dom(i)=cb%list_bloc(ibv)%idom
      END DO
      imac=1
      imav=1
      imaf=1
      DO i=1,6 ! ima: indice de maillage de l interface entre 2 blocs voisins
          ibv=cb%list_bloc(ib)%cl(i)
          IF(ibv.lt.-100000)ibv=-ibv-100000
          IF (cb%list_bloc(ib)%idom.eq.cb%list_bloc(ib)%dom(i).and.ib.lt.ibv) imaf(i)=0
          IF (cb%list_bloc(ib)%idom.eq.cb%list_bloc(ib)%dom(i).and.ib.lt.ibv) imav(i)=0
          IF (cb%list_bloc(ib)%idom.eq.cb%list_bloc(ib)%dom(i).or.ibv.le.0)   imac(i)=0
      END DO

      SELECT CASE (cb%msh%ndim)
        CASE (1) ! Cas 1D
          nx=cb%list_bloc(ib)%nx*2**(cb%list_bloc(ib)%nrb)
          ny=1
          nz=1
          cb%list_bloc(ib)%nb_cell   = nx+imac(1)+imac(2)
          cb%list_bloc(ib)%nb_vertex = (nx+1)*(ny+1)*2 
          cb%list_bloc(ib)%nb_face   = (nx-1)+nx*2*2 + imaf(1)+imaf(2) 

         CASE (2) ! Cas 2D
          nx=cb%list_bloc(ib)%nx*2**(cb%list_bloc(ib)%nrb)
          ny=cb%list_bloc(ib)%ny*2**(cb%list_bloc(ib)%nrb)
          nz=1

          cb%list_bloc(ib)%nb_cell   = nx*ny + int(ny*2.**cb%list_bloc(ib)%nrf(1)*imac(1)) &
                                   + int(ny*2.**cb%list_bloc(ib)%nrf(2)*imac(2)) &
                                   + int(nx*2.**cb%list_bloc(ib)%nrf(3)*imac(3)) &
                                   + int(nx*2.**cb%list_bloc(ib)%nrf(4)*imac(4))
          cb%list_bloc(ib)%nb_vertex = (nx+1)*(ny+1)*2 &
                                   + cb%list_bloc(ib)%nrf(1)*(cb%list_bloc(ib)%nrf(1)+1)*ny*imav(1) &
                                   + cb%list_bloc(ib)%nrf(2)*(cb%list_bloc(ib)%nrf(2)+1)*ny*imav(2) &
                                   + cb%list_bloc(ib)%nrf(3)*(cb%list_bloc(ib)%nrf(3)+1)*nx*imav(3) &
                                   + cb%list_bloc(ib)%nrf(4)*(cb%list_bloc(ib)%nrf(4)+1)*nx*imav(4)
          cb%list_bloc(ib)%nb_face   = (nx-1)*ny+nx*(ny-1)+nx*ny*2 &
                                   + ny*imaf(1)+ny*imaf(2)+nx*imaf(3)+nx*imaf(4)  &
                                   + cb%list_bloc(ib)%nrf(1)*(cb%list_bloc(ib)%nrf(1)+1)*ny/2*imaf(1) &
                                   + cb%list_bloc(ib)%nrf(2)*(cb%list_bloc(ib)%nrf(2)+1)*ny/2*imaf(2) &
                                   + cb%list_bloc(ib)%nrf(3)*(cb%list_bloc(ib)%nrf(3)+1)*nx/2*imaf(3) &
                                   + cb%list_bloc(ib)%nrf(4)*(cb%list_bloc(ib)%nrf(4)+1)*nx/2*imaf(4)        
         CASE (3) ! Cas 3D
          nx=cb%list_bloc(ib)%nx*2**(cb%list_bloc(ib)%nrb)
          ny=cb%list_bloc(ib)%ny*2**(cb%list_bloc(ib)%nrb)
          nz=cb%list_bloc(ib)%nz*2**(cb%list_bloc(ib)%nrb)
          cb%list_bloc(ib)%nb_cell   = nx*ny*nz &
                                   + int(ny*nz*4.**cb%list_bloc(ib)%nrf(1)*imac(1)) &
                                   + int(ny*nz*4.**cb%list_bloc(ib)%nrf(2)*imac(2)) &
                                   + int(nx*nz*4.**cb%list_bloc(ib)%nrf(3)*imac(3)) &
                                   + int(nx*nz*4.**cb%list_bloc(ib)%nrf(4)*imac(4)) &
                                   + int(nx*ny*4.**cb%list_bloc(ib)%nrf(5)*imac(5)) &
                                   + int(nx*ny*4.**cb%list_bloc(ib)%nrf(6)*imac(6)) 
          cb%list_bloc(ib)%nb_vertex = (nx+1)*(ny+1)*(nz+1) &
                                   + cb%list_bloc(ib)%nrf(1)*(cb%list_bloc(ib)%nrf(1)+1)/2*(3*ny*nz+ny+nz)*imav(1) &
                                   + cb%list_bloc(ib)%nrf(2)*(cb%list_bloc(ib)%nrf(2)+1)/2*(3*ny*nz+ny+nz)*imav(2) &
                                   + cb%list_bloc(ib)%nrf(3)*(cb%list_bloc(ib)%nrf(3)+1)/2*(3*nx*nz+nx+nz)*imav(3) &
                                   + cb%list_bloc(ib)%nrf(4)*(cb%list_bloc(ib)%nrf(4)+1)/2*(3*nx*nz+nx+nz)*imav(4) &
                                   + cb%list_bloc(ib)%nrf(5)*(cb%list_bloc(ib)%nrf(5)+1)/2*(3*nx*ny+nx+ny)*imav(5) &
                                   + cb%list_bloc(ib)%nrf(6)*(cb%list_bloc(ib)%nrf(6)+1)/2*(3*nx*ny+nx+ny)*imav(6) 
          cb%list_bloc(ib)%nb_face   = (nx-1)*ny*nz+nx*(ny-1)*nz+nx*ny*(nz-1) &
                                   + ny*nz*imaf(1)+ny*nz*imaf(2)+nx*nz*imaf(3)+nx*nz*imaf(4) &
                                   + nx*ny*imaf(5)+nx*ny*imaf(6) &
                                   + cb%list_bloc(ib)%nrf(1)*(cb%list_bloc(ib)%nrf(1)+1)/2*3*ny*nz*imaf(1) &
                                   + cb%list_bloc(ib)%nrf(2)*(cb%list_bloc(ib)%nrf(2)+1)/2*3*ny*nz*imaf(2) &
                                   + cb%list_bloc(ib)%nrf(3)*(cb%list_bloc(ib)%nrf(3)+1)/2*3*nx*nz*imaf(3) &
                                   + cb%list_bloc(ib)%nrf(4)*(cb%list_bloc(ib)%nrf(4)+1)/2*3*nx*nz*imaf(4) &  
                                   + cb%list_bloc(ib)%nrf(5)*(cb%list_bloc(ib)%nrf(5)+1)/2*3*nx*ny*imaf(5) &  
                                   + cb%list_bloc(ib)%nrf(6)*(cb%list_bloc(ib)%nrf(6)+1)/2*3*nx*ny*imaf(6)   
                                                      
      END SELECT
      !call display(cb%list_bloc(ib)) !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  END DO

! Creation de la liste des interfaces 
  allocate(interdom(int(nb_dom*(nb_dom-1)/2)))
  allocate(nbl(int(nb_dom*(nb_dom-1)/2)))
  CALL inter(cb%list_bloc,nb_bloc,nb_dom,interdom,nbl,cb%msh%ndim)
  
! Determination de petit
  petit=1.d-3
  DO ib=1,nb_bloc
      IF (hmin/(cb%list_bloc(ib)%nx*2**cb%list_bloc(ib)%nrb).lt.petit) &
          petit=hmin/(cb%list_bloc(ib)%nx*2**cb%list_bloc(ib)%nrb)
      IF (hmin/(cb%list_bloc(ib)%ny*2**cb%list_bloc(ib)%nrb).lt.petit.and.cb%msh%ndim.ne.1) &
          petit=hmin/(cb%list_bloc(ib)%ny*2**cb%list_bloc(ib)%nrb)
      IF (hmin/(cb%list_bloc(ib)%nz*2**cb%list_bloc(ib)%nrb).lt.petit.and.cb%msh%ndim.eq.3) &
          petit=hmin/(cb%list_bloc(ib)%nz*2**cb%list_bloc(ib)%nrb)
  END DO
  petit=petit*1.d-5
  write( *,1212)petit
 1212  format('Small dimension',e13.5)

 !----------- Cas particulier de Saint Venant -----
! On stocke eventuellement la bathy sur chaque bloc
if(imodel_phy.eq.1.and.ibathy.eq.2)then
open(14,file=fich_bathy,status='old')
   do ib=1,nb_bloc
       do i=1,4
          read(14,*)x,y,cb%list_bloc(ib)%vb(i), cb%list_bloc(ib)%vb(i+4)
       enddo
   enddo
   close(14)
endif


!-----------------------------------------------------------------------
! Boucle sur les domaines pour creer calc
!-----------------------------------------------------------------------
  DO idom=1,nb_dom
! Initialisations
      calc%msh%ndim  =cb%msh%ndim
      calc%msh%nb_dom=nb_dom
      nullify(calc%msh%list_vertex)
      nullify(calc%msh%list_face)
      nullify(calc%msh%list_cell)
      nullify(calc%msh%list_send)
      nullify(calc%msh%list_recv)
      CALL empty_mesh(calc%msh,calc%msh%nb_dom,idom)
      IF (associated(calc%list_bloc)) THEN
          deallocate(calc%list_bloc)
          nullify(calc%list_bloc)
      END IF
      nullify(calc%list_bloc)
     
! Determination de la taille des tableaux du domaine
      calc%msh%nb_cell   = 0
      calc%msh%nb_vertex = 0
      calc%msh%nb_face   = 0
      calc%nb_bloc       = 0
         
      DO ib=1,nb_bloc
          IF (cb%list_bloc(ib)%idom.eq.idom) THEN
              calc%nb_bloc=calc%nb_bloc+1
              cb%list_bloc(ib)%first_cell   = calc%msh%nb_cell
              calc%msh%nb_cell    = calc%msh%nb_cell + cb%list_bloc(ib)%nb_cell
              cb%list_bloc(ib)%first_face   = calc%msh%nb_face
              calc%msh%nb_face    = calc%msh%nb_face + cb%list_bloc(ib)%nb_face
              cb%list_bloc(ib)%first_vertex = calc%msh%nb_vertex
              calc%msh%nb_vertex  = calc%msh%nb_vertex + cb%list_bloc(ib)%nb_vertex
          END IF
      END DO
  
      allocate(calc%list_bloc(calc%nb_bloc))
      allocate(calc%msh%list_cell(calc%msh%nb_cell))
      allocate(calc%msh%list_vertex(calc%msh%nb_vertex))
      allocate(calc%msh%list_face(calc%msh%nb_face))
      allocate(calc%msh%list_send(calc%msh%nb_dom))
      allocate(calc%msh%list_recv(calc%msh%nb_dom))
  
      DO i=1,idom-1
          k=idom-i+(i-1)*(2*nb_dom-i)/2 
          IF (nbl(k).ne.0) allocate(calc%msh%list_recv(i)%L(interdom(k)%L(4*nbl(k)-1)))
          IF (nbl(k).ne.0) allocate(calc%msh%list_send(i)%L(interdom(k)%L(4*nbl(k)-0)))
      END DO
      nullify(calc%msh%list_send(idom)%L)
      nullify(calc%msh%list_recv(idom)%L)
      DO i=idom+1,nb_dom
          k=i-idom+(idom-1)*(2*nb_dom-idom)/2
          IF (nbl(k).ne.0) allocate(calc%msh%list_recv(i)%L(interdom(k)%L(4*nbl(k)-0)))
          IF (nbl(k).ne.0) allocate(calc%msh%list_send(i)%L(interdom(k)%L(4*nbl(k)-1)))
      END DO
      CALL initialise(calc%msh)
       
! Maillage des blocs du domaine
      icb=0
      DO ib=1,nb_bloc
          IF (cb%list_bloc(ib)%idom.eq.idom) THEN
              icb=icb+1
              calc%list_bloc(icb)=cb%list_bloc(ib)
              DO i=1,6
                  blv(i)=bl_null
                  ibv=cb%list_bloc(ib)%cl(i)
                  if(ibv.lt.-100000)ibv=-ibv-100000
                  IF (ibv.gt.0) blv(i)=cb%list_bloc(ibv)
              END DO

              SELECT CASE (cb%msh%ndim)
                 CASE (1)
                   CALL mesh1d(cb%list_bloc(ib),calc%msh,ib,nb_dom,blv,interdom)

                 CASE (2)
                   CALL mesh2d(cb%list_bloc(ib),calc%msh,ib,nb_dom,blv,interdom)

                 CASE (3)
                   CALL mesh3d(cb%list_bloc(ib),calc%msh,ib,nb_dom,blv,interdom)

            END SELECT
          END IF
      END DO ! Fin boucle sur les blocs

      CALL init_mesh(calc%msh)

! On elimine les sommets surabondants
      nvi=calc%msh%nb_vertex
      CALL trivertex(calc%msh)
      write( *,1111) idom,nvi-calc%msh%nb_vertex,nvi,calc%msh%nb_vertex
1111  format('Domain',i3,' elimination of ',i7,' vertexes out of',i7,', i.e.',i7,' vertexes.')
      write( *,2222) idom,calc%msh%nb_vertex
      write( *,3333) idom,calc%msh%nb_face
      write( *,4444) idom,calc%msh%nb_cell
2222  format('Domain',i3,' Number of vertexes :',i7)
3333  format('Domain',i3,' Number of faces    :',i7)
4444  format('Domain',i3,' Number of cells    :',i7)
        
! Recuperation des données de cb
      calc%tmin           = cb%tmin
      calc%tmax           = cb%tmax
      calc%dt             = cb%dt
      calc%pdtp           = cb%pdtp
      calc%cfl            = cb%cfl
      calc%vmax           = cb%vmax
      calc%isauv          = cb%isauv
      calc%istart         = cb%istart
      calc%ipas           = cb%ipas
      calc%iordre_e       = cb%iordre_e
      calc%iordre_t       = cb%iordre_t
      calc%imeth_int_temps= cb%imeth_int_temps
      calc%point_sondes   = cb%point_sondes
      calc%nb_sondes      = cb%nb_sondes
      calc%num_point_min  = cb%num_point_min
      calc%ityp_flux      = cb%ityp_flux
      calc%ilimiteur      = cb%ilimiteur
      calc%nbds           = cb%nbds
      calc%nrma           = cb%nrma
      calc%vcde           = cb%vcde
      calc%vcra           = cb%vcra
      if(cb%nb_sol.ne.0)call copy_sol(cb,calc)
      
! Initialisation sur tout le domaine
  
      calc%msh%numdom=idom
      call ini_w(calc,nzonei,zonei)
       !call display(calc%msh)  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      CALL save_calc(calc)
      CALL empty_mesh(calc%msh,0,0)  ! liberation de la memoire

  END DO ! Fin boucle sur les domaines

  !deallocate(bl)

!===========================   FIN DE LA ROUTINE    ====================

END SUBROUTINE block2mesh
!DOCFIN 

  MODULE msh
!=========================== DOCUMENTATION ============================= 
!DOCDEBm*    UTI/msh  *
!
!    NOM
! msh
!    DESCRIPTION
!*
! Ensemble de routines necessaires au maillage
! Set of routines required for meshing
!*
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo
  IMPLICIT NONE
!=========================== DEBUT DU CODE EXECUTABLE ==================

!----- Debut type ------------------------------------------------------
 TYPE vertex
    real(kind=kind(0.d0))      :: x, y, z
    integer(kind=16) :: morton ! code morton du vertex
    integer  :: num    ! numero du vertex
 END TYPE vertex
!----- Fin type --------------------------------------------------------
!----- Debut type ------------------------------------------------------
 TYPE mface
    integer(kind=16), dimension(4)  :: mv       ! codes morton des 2/3/4 vertex composant la face
    integer(kind=16)                :: morton   ! code morton de la face
    integer                         :: num      ! numero de la face
    integer                         :: qe1,qe2  ! codes quadtree/Octree des deux elements voisins si qe2 <= 0 ---> condition aux limites
    integer                         :: be1,be2  ! numero de bloc des deux elements voisins si be2 <= 0 ---> condition aux limites
    integer                         :: nr1,nr2  ! niveau de raffinement des deux elements voisins 
    integer         , dimension(2)  :: fac_loc  ! numeros locaux des deux elements connectes
    real(kind=kind(0.d0)), dimension(3)      :: vn       ! normale 
 END TYPE mface
!----- Fin type --------------------------------------------------------
!----- Debut type ------------------------------------------------------
 TYPE chaine_MF
    type(mface)              :: f
    type(chaine_MF), pointer :: prec,suiv
 END TYPE chaine_MF
!----- Fin type --------------------------------------------------------

!----- Debut type ------------------------------------------------------
 TYPE noe
    type(point)       :: coord  ! Barycentre
    integer(kind=16) :: morton ! Code morton du noeud
    integer(kind=16)  :: num    ! Numero du noeud
 END TYPE noe
!----- Fin type --------------------------------------------------------



 CONTAINS

! Routines necessaires a read_gmsh
 subroutine ini_mface(f)
     type(mface)   :: f
     f%mv=0       
     f%morton=0   
     f%num   =0   
     f%qe1=0 ; f%qe2=0  
     f%be1=0 ; f%be2=0  
     f%nr1=0 ; f%nr2=0  
     f%fac_loc=0  
 end subroutine ini_mface
!-------------------------------------------------------
   subroutine range_mface(f,lcf,ier)
    implicit none
    Type(chaine_MF), Pointer        :: lcf
    Type(mface)                     :: f
    integer                         :: ier
    logical                         :: droite
    Type(chaine_MF), Pointer        :: chloc,temp

    ! interdit de rentrer dans cette routine si la chaine pointe sur null
    droite=.false.
    if (f%morton>lcf%f%morton) droite=.true.
    do while (associated(lcf))
          temp=>lcf
          if (f%morton>lcf%f%morton) then
             if (droite) then
                lcf=>lcf%suiv
             else
                call insertdroite_MF(f,lcf,ier)
                return
             end if
          else
             if (f%morton==lcf%f%morton) then
                ier=1
!---- on actualise la face qui existe deja
                if(lcf%f%be1.le.0)then
                  lcf%f%qe1=f%qe1
                  lcf%f%be1=f%be1
                  lcf%f%nr1=f%nr1
                  lcf%f%mv =f%mv
                  lcf%f%vn =f%vn
                  lcf%f%fac_loc(1) =f%fac_loc(1)
                else
                  lcf%f%qe2=lcf%f%qe1
                  lcf%f%be2=lcf%f%be1
                  lcf%f%nr2=lcf%f%nr1
                  lcf%f%fac_loc(2) =lcf%f%fac_loc(1)
                  lcf%f%qe1=f%qe1
                  lcf%f%be1=f%be1
                  lcf%f%nr1=f%nr1
                  lcf%f%mv =f%mv
                  lcf%f%vn =f%vn
                  lcf%f%fac_loc(1) =f%fac_loc(1)
                endif
!----
                return
             else
                if (droite) then
                   call insertgauche_MF(f,lcf,ier)
                   return
                else
                   lcf=>lcf%prec
                end if
             end if
          end if
       end do
!cas du bout de liste droite ou gauche
       allocate(chloc)
       chloc%f=f
       if (droite) then
!ajout a droite de temp
          chloc%prec=>temp
          nullify(chloc%suiv)
          temp%suiv=>chloc
       else
!ajout a gauche  de temp
          chloc%suiv=>temp
          nullify(chloc%prec)
          temp%prec=>chloc
       end if
       lcf=>chloc!temp
       ier=0
       return
  end subroutine range_mface
!-------------------------------------------------------

 subroutine mortonface(f,lnf,nn,ndim)
  use geo_typ
  use zorder
  implicit none
  integer        :: nn,ndim,i,mortonx,mortony,mortonz
  type(mface)             :: f
  type(noe), dimension(8) :: lnf
  real(kind=kind(0.d0))   :: x,y,z
  integer(kind=16)       :: nmorton

  x= 0.d0 ; y= 0.d0 ; z= 0.d0
  do i=1,nn
    f%mv(i)=lnf(i)%morton
    x=x+lnf(i)%coord%x
    y=y+lnf(i)%coord%y
    z=z+lnf(i)%coord%z
  enddo
  x=x/nn ; y=y/nn ;z=z/nn
  mortonx=coord_real2int(x,x_min_morton,petit_morton)
  mortony=coord_real2int(y,y_min_morton,petit_morton)
  if (ndim == 2) then
    call zordercurve2d(mortonx,mortony,nmorton)
  else
    mortonz=coord_real2int(z,z_min_morton,petit_morton)
    call zordercurve3d(mortonx,mortony,mortonz,nmorton)
  endif
  f%morton=nmorton
  select case (nn)
      case(2) ! L2
        f%vn(1) = -(lnf(2)%coord%y-lnf(1)%coord%y)
        f%vn(2) =  (lnf(2)%coord%x-lnf(1)%coord%x)
        f%vn(3) = 0.d0
      case(3) ! T3
        f%vn(1) = ((lnf(2)%coord%y-lnf(1)%coord%y)*(lnf(3)%coord%z-lnf(1)%coord%z)-&
        (lnf(2)%coord%z-lnf(1)%coord%z)*(lnf(3)%coord%y-lnf(1)%coord%y))*0.5d0
        f%vn(2) = ((lnf(2)%coord%z-lnf(1)%coord%z)*(lnf(3)%coord%x-lnf(1)%coord%x)-&
        (lnf(2)%coord%x-lnf(1)%coord%x)*(lnf(3)%coord%z-lnf(1)%coord%z))*0.5d0
        f%vn(3) = ((lnf(2)%coord%x-lnf(1)%coord%x)*(lnf(3)%coord%y-lnf(1)%coord%y)-&
        (lnf(2)%coord%y-lnf(1)%coord%y)*(lnf(3)%coord%x-lnf(1)%coord%x))*0.5d0
      case(4) ! Q4
        f%vn(1) = ((lnf(2)%coord%y-lnf(1)%coord%y)*(lnf(4)%coord%z-lnf(1)%coord%z)-&
        (lnf(2)%coord%z-lnf(1)%coord%z)*(lnf(4)%coord%y-lnf(1)%coord%y))
        f%vn(2) = ((lnf(2)%coord%z-lnf(1)%coord%z)*(lnf(4)%coord%x-lnf(1)%coord%x)-&
        (lnf(2)%coord%x-lnf(1)%coord%x)*(lnf(4)%coord%z-lnf(1)%coord%z))
        f%vn(3) = ((lnf(2)%coord%x-lnf(1)%coord%x)*(lnf(4)%coord%y-lnf(1)%coord%y)-&
        (lnf(2)%coord%y-lnf(1)%coord%y)*(lnf(4)%coord%x-lnf(1)%coord%x))
 end select

 end subroutine mortonface
!-------------------------------------------------------
 subroutine permnoe(ln,n)
  use geo_typ
  type(noe), dimension(8)  :: ln,temp
  integer(kind=16)        :: imin
  integer                  :: i,j,n
  imin=huge(imin)
  temp=ln
  j = 1
  do i=1,n
      if (ln(i)%morton <= imin) then
          imin=ln(i)%morton
          j=i
      endif
  enddo  
  ln(:)%coord%x= 0.d0 ;   ln(:)%coord%y= 0.d0 ;   ln(:)%coord%z= 0.d0
  ln(:)%morton= 0
  ln(:)%num   = 0
  
  do i=1,n
    if (j+i-1 <= n) then
      ln(i)=temp(j+i-1)
    else
      ln(i)=temp(j+i-n-1)
    endif
  enddo
 end subroutine permnoe

!-------------------------------------------------------
 subroutine perm4(array,n)
  integer(kind=16), dimension(4) :: array,temp
  integer(kind=16)               :: imin
  integer                         :: i,j,n
  imin=huge(imin)
  temp=array
  if (n==2)return
  do i=1,n
      if (array(i) <= imin) then
          imin=array(i)
          j=i
      endif
  enddo  
  array= 0
  do i=1,n
    if (j+i-1 <= n) then
      array(i)=temp(j+i-1)
    else
      array(i)=temp(j+i-n-1)
    endif
  enddo
 end subroutine perm4
!-------------------------------------------------------

 subroutine noe2bloc(ln,b,ns,ndim,nmorton)
  use geo_typ
  use zorder
  implicit none
  integer        :: ns,ndim,i,mortonx,mortony,mortonz
  type(bloc)              :: b
  type(noe), dimension(8) :: ln
  real(kind=kind(0.d0))   :: x,y,z
  integer(kind=16)       :: nmorton
      x=0.d0 ; y=0.d0 ;z=0.d0

    do i=1,ns
        b%s(i)%x=ln(i)%coord%x
        b%s(i)%y=ln(i)%coord%y
        b%s(i)%z=ln(i)%coord%z
        x=x+ln(i)%coord%x
        y=y+ln(i)%coord%y
        z=y+ln(i)%coord%z
    enddo
    x=x/ns ; y=y/ns ;z=z/ns
    mortonx=coord_real2int(x,x_min_morton,petit_morton)
    mortony=coord_real2int(y,y_min_morton,petit_morton)
    if (ndim == 2) then
      call zordercurve2d(mortonx,mortony,nmorton)
    else
      mortonz=coord_real2int(z,z_min_morton,petit_morton)
      call zordercurve3d(mortonx,mortony,mortonz,nmorton)
    endif
    !b%morton  = nmorton
  end subroutine noe2bloc
!-------------------------------------------------------
 subroutine insertdroite_MF(f,lcf,ier)
    implicit none
    integer                 :: ier
    Type(chaine_MF), Pointer     :: lcf
    Type(mface)                  :: f
    Type(chaine_MF), Pointer     :: temp, locch

!cas du bout de liste droite ou gauche
      temp=>lcf%suiv
       allocate (locch)
       locch%f=f
       locch%suiv=>temp
       temp%prec=>locch
       locch%prec=>lcf
       lcf%suiv=>locch
!modif
       lcf=>locch
       ier=0
       return
  end subroutine insertdroite_MF
!-------------------------------------------------------
 subroutine insertgauche_MF(f,lcf,ier)
    implicit none
    integer                 :: ier
    Type(chaine_MF), Pointer     :: lcf
    Type(mface)                  :: f
    Type(chaine_MF), Pointer     :: temp, locch
!cas du bout de liste droite ou gauche
    temp=>lcf%prec
       allocate (locch)
       locch%f=f
       locch%suiv=>lcf
       lcf%prec=>locch
       locch%prec=>temp
       temp%suiv=>locch
!modif
       lcf=>locch
       ier=0
       return
  end subroutine insertgauche_MF
!===========================   FIN DU MODULE   =========================
 END MODULE msh
!DOCFIN 

 SUBROUTINE save_1D(calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/save_1D  *
!
!    NOM
! save_1D(calc)
!
!    DESCRIPTION
!*
! Posttraitement dans le cas ou le maillage est 1D
! Post-processing if the mesh is 1D
!*
! 
!    ENTREES / INPUT
!  calc: objet de type calcul / object of type calcul
!
!    SORTIES / OUTPUT
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul), intent(inout)         :: calc !! Objet calcul / Calcul object
  
  real(kind=kind(0.d0))               :: r,u,p,psiL,psiR,psi,xi,alf,err1,err2,volt
  character*7                         :: fsol
  character*10                        :: cn
  integer                             :: i,ic,id,iu,ios
  character(len=256)                  :: iomsg
!=========================== DEBUT DU CODE EXECUTABLE ==================
!-------  Initialisations
  cn='0123456789'
  ic=int(calc%msh%numdom/100.)
  id=int((calc%msh%numdom-ic*100.)/10.)
  iu=calc%msh%numdom-id*10-ic*100
  
  IF (calc%msh%numdom.gt.999) call print_err('SAVE_1D','Domain index > 999 is not supported')
  fsol(5:5)=cn(ic+1:ic+1)
  fsol(6:6)=cn(id+1:id+1)
  fsol(7:7)=cn(iu+1:iu+1)

! ouverture des fichiers
  SELECT CASE (imodel_phy)
      
    CASE(2) 
      fsol(1:4)='n_r_'  ! densite
      OPEN(41,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='n_u_'  ! vitesse
      OPEN(42,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='n_p_'  ! pression
      OPEN(43,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='n_e_'  ! production numerique d entropie
      OPEN(49,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='n_c_'  ! fonction couleur
      OPEN(44,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='e_r_'
      OPEN(51,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='e_u_'
      OPEN(52,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='e_p_'
      OPEN(53,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='e_e_'
      open(54,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
     
    CASE(1) 
      fsol(1:4)='n_h_'  ! hauteur d eau
      OPEN(41,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='n_u_'  ! vitesse
      OPEN(42,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='n_e_'  ! production numerique d entropie
      OPEN(49,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='e_h_'
      OPEN(51,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      fsol(1:4)='e_u_'
      OPEN(52,file=fsol,iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      open(53,file='cerf_1d.dat',iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('SAVE_1D','Cannot open cerf_1d.dat : '//trim(iomsg))
      write(53,*,iostat=ios,iomsg=iomsg)'TITLE="Solution Numerique CERF"'
      if (ios /= 0) call print_err('SAVE_1D','Error writing cerf_1d header: '//trim(iomsg))
      write(53,*,iostat=ios,iomsg=iomsg)' VARIABLES="X","h","U","zb","eta"'
      if (ios /= 0) call print_err('SAVE_1D','Error writing cerf_1d variables: '//trim(iomsg))
      write(53,111,iostat=ios,iomsg=iomsg)calc%msh%nb_cell
      if (ios /= 0) call print_err('SAVE_1D','Error writing cerf_1d zone: '//trim(iomsg))
111     format('ZONE T="", I=',i9,' F=POINT')
      
    CASE default
      call print_err('SAVE_1D','Physical model not defined')
      
    END SELECT
    
    
  ! remplissage des fichiers de resultats num
  err1=0.d0
  err2=0.d0
  volt=0.d0  
  if (calc%tmax == 0.d0) call print_err('SAVE_1D','tmax is zero, xi cannot be computed')
  DO i=1,calc%msh%nb_cell
    xi=calc%msh%list_cell(i)%center%x/calc%tmax
    CALL bal2prim(calc%msh%list_cell(i)%w)
    volt=volt+calc%msh%list_cell(i)%vol
    
    SELECT CASE (imodel_phy)
      
      CASE(2) 
        write(41,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%w%vprim%v(1)! densite
        if (ios /= 0) call print_err('SAVE_1D','Error writing n_r_: '//trim(iomsg))
        write(42,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%w%vprim%v(2)! vitesse
        if (ios /= 0) call print_err('SAVE_1D','Error writing n_u_: '//trim(iomsg))
        write(43,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%w%vprim%v(5)! pression
        if (ios /= 0) call print_err('SAVE_1D','Error writing n_p_: '//trim(iomsg))
        write(49,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%w%vprim%v(6)
        if (ios /= 0) call print_err('SAVE_1D','Error writing n_e_: '//trim(iomsg))
        write(44,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%w%vbal%v(5)
        if (ios /= 0) call print_err('SAVE_1D','Error writing n_c_: '//trim(iomsg))
        psiL=phy_state(1)%vbal%v(5)
        psiR=phy_state(2)%vbal%v(5)
        CALL riemisot(phy_state(1)%vprim%v(1),phy_state(1)%vprim%v(2),psiL,psiL, &
        phy_state(2)%vprim%v(1),phy_state(2)%vprim%v(2),psiR,psiR,xi,r,u,p,psi,alf)
                
        write(51,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,r
        if (ios /= 0) call print_err('SAVE_1D','Error writing e_r_: '//trim(iomsg))
        write(52,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,u
        if (ios /= 0) call print_err('SAVE_1D','Error writing e_u_: '//trim(iomsg))
        write(53,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,p
        if (ios /= 0) call print_err('SAVE_1D','Error writing e_p_: '//trim(iomsg))
        write(54,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,psi
        if (ios /= 0) call print_err('SAVE_1D','Error writing e_e_: '//trim(iomsg))
            
      CASE(1) 
        write(41,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%w%vprim%v(1)+&
                                           calc%msh%list_cell(i)%w%vprim%v(5)! hauteur d eau
        if (ios /= 0) call print_err('SAVE_1D','Error writing n_h_: '//trim(iomsg))
        write(42,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%w%vprim%v(2)! vitesse
        if (ios /= 0) call print_err('SAVE_1D','Error writing n_u_: '//trim(iomsg))
        write(49,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%w%vprim%v(4)! production entropie
        if (ios /= 0) call print_err('SAVE_1D','Error writing n_e_: '//trim(iomsg))
        CALL svriemann(phy_state(1)%vprim%v(1),phy_state(1)%vprim%v(2),&
                       phy_state(2)%vprim%v(1),phy_state(2)%vprim%v(2),xi,r,u)
        write(51,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,r
        if (ios /= 0) call print_err('SAVE_1D','Error writing e_h_: '//trim(iomsg))
        write(52,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,u
        if (ios /= 0) call print_err('SAVE_1D','Error writing e_u_: '//trim(iomsg))
        write(53,*,iostat=ios,iomsg=iomsg) calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%w%vprim%v(1),&
                                           calc%msh%list_cell(i)%w%vprim%v(2), &
                                           calc%msh%list_cell(i)%w%vprim%v(5), &
                                           calc%msh%list_cell(i)%w%vprim%v(1)+calc%msh%list_cell(i)%w%vprim%v(5)
        if (ios /= 0) call print_err('SAVE_1D','Error writing cerf_1d.dat row: '//trim(iomsg))

      CASE default
         call print_err('SAVE_1D','Physical model not defined')
      
      END SELECT
      err1=err1+calc%msh%list_cell(i)%vol*(calc%msh%list_cell(i)%w%vprim%v(1)-r)**2
      err2=err2+calc%msh%list_cell(i)%vol*(calc%msh%list_cell(i)%w%vprim%v(2)-u)**2

  END DO
  if (volt <= 0.d0) call print_err('SAVE_1D','Total cell volume is zero, cannot compute L2 errors')
  err1=sqrt(err1/volt)
  err2=sqrt(err2/volt)

! Fermeture des fichiers
  SELECT CASE (imodel_phy)
      
    CASE(2) 
    write( *,1331)err1
    write( *,1332)err2
1331 format('Density L2 error  :',e13.5)
1332 format('Velocity L2 error :',e13.5)
      close(41)
      close(42)
      close(43)
      close(49)
      close(44)
      close(51)
      close(52)
      close(53)
      close(54)
      
    CASE(1) 
    write( *,1001)err1
    write( *,1002)err2
1001 format('Water level L2 error  :',e13.5)
1002 format('Velocity L2 error     :',e13.5)
      close(41)
      close(42)
      close(49)
      close(51)
      close(52)
      close(53)
      
    CASE default
      call print_err('SAVE_1D','Unexpected physical model case')
      
    END SELECT



!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE SAVE_1D
!DOCFIN 

 SUBROUTINE pointaffiche(p)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/pointaffiche  *
!
!    NOM
! pointaffiche(p)
!
!    DESCRIPTION 
!*
! Affichage d un objet point 
!
! Displaying a point object 
!*
!    ENTREES / INPUT
!    p : objet de type point / point object
!
!    SORTIES / OUTPUT
!    p : objet de type point / point object
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(point) ,intent(in) :: p !! Point
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(*,'(3e15.8)') p%x,p%y,p%z
!===========================   FIN DE LA ROUTINE    ====================
 END SUBROUTINE POINTAFFICHE
!DOCFIN

 SUBROUTINE faceaffiche(e)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/faceaffiche  *
!
!    NOM
! faceaffiche(e)
!
!    DESCRIPTION 
!*
! Affichage d un objet face 
!
! Displaying a face object 
!* 
!    ENTREES / INPUT
!    e : objet de type face / face object
!
!    SORTIES / OUTPUT
!    e : objet de type face / face object
!  
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(face) ,intent(in) :: e !! Face
  integer ii
!=========================== DEBUT DU CODE EXECUTABLE ==================
! Initialisations

  write(*,1001) e%surf
  write(*,1003) e%vnorm%v(1),e%vnorm%v(2),e%vnorm%v(3)
  write(*,1002) e%center%x,e%center%y,e%center%z
  write(*,1004) e%ic1,e%ic2
  write(*,1005) (e%vertex(ii),ii=1,e%nbvertex)
1001  format('Face area          : ',e13.5)
1002  format('Face center        : ',3e13.5)
1003  format('Normal vector      : ',3e13.5)
1004  format('Adjacent cells     : ',2i7)
1005  format('Vertexes           : ',10i7)
!
!===========================   FIN DE LA ROUTINE    ====================
 END SUBROUTINE faceAFFICHE
!DOCFIN

 SUBROUTINE cellaffiche(c)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/cellaffiche  *
!
!    NOM
! cellaffiche(c)
!     
!    DESCRIPTION 
!*
! Affichage d un objet cellule 
!
! Displaying a cell object 
!*!  
!    ENTREES / INPUT
!    c : objet de type cellule / cell object
!
!    SORTIES / OUTPUT
!    c : objet de type cellule / cell object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  use geo, only: display
  IMPLICIT NONE
!.2-----  Declaration
  type(cell) ,intent(in) :: c !! Cellule / Cell
!=========================== DEBUT DU CODE EXECUTABLE ==================
! Initialisations
  write(*,1010) c%num,c%numloc
  write(*,1011) c%idom,c%vol,c%center%x,c%center%y,c%center%z,c%h
1010  format(' **** Cell',2i10,' *******')
1011  format(' Belonging to the domain',i4,' of volume',e13.5,' of center',3e13.5,' of radius',e13.5)
  write(*,'(10e13.5)')c%balance%v
    call display(c%w)
!===========================   FIN DE LA ROUTINE    ====================
  END SUBROUTINE CELLAFFICHE
!DOCFIN

 SUBROUTINE mshaffiche(m)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/meshaffiche  *
!
!    NOM
! meshaffiche(m)
!     
!    DESCRIPTION 
!*
! Affichage d un objet maillage 
!
! Displaying a mesh object 
!*!  
!    ENTREES / INPUT
!    m : objet de type maillage / mesh object
!
!    SORTIES / OUTPUT
!    m : objet de type maillage / mesh object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  use geo, only: display
  IMPLICIT NONE
!.2-----  Declaration
  type(mesh) ,intent(in) :: m !!Maillage / Mesh
  integer                :: i
!=========================== DEBUT DU CODE EXECUTABLE ==================
! Initialisations
  write(*,*) 
  write(*,*) '====================================='
  write(*,*) 'DOMAIN NUMBER      : ',m%numdom
  write(*,*) 'Number of domains  : ',m%nb_dom
  write(*,*) 'Number of cells    : ',m%nb_cell
  write(*,*) 'Number of faces    : ',m%nb_face
  write(*,*) 'Number of vertexes : ',m%nb_vertex        
  write(*,*) 'exchange list'
  IF (associated(m%list_send)) THEN
      DO i=1,m%nb_dom
          write(*,*) 'domain:',i
          write(*,*) 'cells to send (global number):'
          IF (associated(m%list_send(i)%L)) THEN
              write(*,*) m%list_cell(m%list_send(i)%L)%num
              write(*,*)
          ELSE
              write(*,*) 'empty list'
          END IF
      END DO
  ELSE
      write(*,*) 'table not build'
  END IF
  
  IF (associated(m%list_recv)) THEN
      DO i=1,m%nb_dom
          write(*,*) 'domain:',i
          write(*,*) 'cells to recieve (global number):'
          IF (associated(m%list_recv(i)%L)) THEN
              write(*,*) m%list_cell(m%list_recv(i)%L)%num
              write(*,*)
          ELSE
              write(*,*) 'empty list'                  
          END IF
      END DO
  ELSE
     write(*,*) 'table not build'
  END IF
  
  write(*,*)
  write(*,*) 'List of vertexes'
  DO i=1,m%nb_vertex
      call display(m%list_vertex(i))
  END DO
      write(*,*)
      write(*,*) 'List of faces'
  DO i=1,m%nb_face
      write(*,*) 'Face number:',i
      CALL display(m%list_face(i))
      write(*,*)
  END DO
      write(*,*)
      write(*,*) 'List of Cells'
  DO i=1,m%nb_cell
      CALL display(m%list_cell(i))
      write(*,*)
  END DO
!===========================   FIN DE LA ROUTINE    ====================
 END SUBROUTINE MSHAFFICHE
!DOCFIN 

 SUBROUTINE list_i_affiche(L)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/list_i_affiche  *
!
!    NOM
! list_i_affiche(L)
!
!    DESCRIPTION 
!*
! Affichage d un objet liste d entier 
!
! Displaying a integer list object 
!*
!
!    ENTREES / INPUT
!    l : objet de type liste d entier / integer list object
!
!    SORTIES / OUTPUT
!    l : objet de type liste d entier / integer list object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(list_int),intent(in) :: L !! Liste d entiers / Integer list
!=========================== DEBUT DU CODE EXECUTABLE ==================
  IF (associated(L%L)) THEN
      write(*,'(12i6)') L%L
  ELSE
      write(*,*) 'empty list'
  END IF
!===========================   FIN DE LA ROUTINE    ====================
 END SUBROUTINE list_i_affiche
!DOCFIN 

 SUBROUTINE blocaffiche(b)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/blocaffiche  *
!
!    NOM
! blocaffiche(b)
!
!    DESCRIPTION 
!*
! Affichage d un objet bloc 
!
! Displaying a block object 
!*
! 
!    ENTREES / INPUT
!    b : objet de type bloc / block
!
!    SORTIES / OUTPUT
!    b : objet de type bloc / block
!
!    l : objet de type liste d entier / integer list object!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(bloc),intent(in) :: b ! Bloc / Block
  integer i
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(*,*)'Bloc', b%numbl, ' du domaine', b%idom 
  write(*,*) 'nx,ny,nz,nrb',b%nx,b%ny,b%nz,b%nrb
  DO i=1,8
      write(*,'(3e12.5)') b%s(i)%x,b%s(i)%y,b%s(i)%z
  END DO
  write(*,*)'volume',b%volc
  write(*,*)' Adjacent blocks'
  write(*,'(6i7)') b%cl
  write(*,*)' Refinement level of the adjacent blocks'
  write(*,'(6i7)') b%nrf
  write(*,*)' Domain number of the adjacent blocks'
  write(*,'(6i7)') b%dom
  write(*,*)' first cell/face/vertex, number of cell/face/vertex'
  write(*,'(6i7)') b%first_cell, b%nb_cell, b%first_face, b%nb_face, b%first_vertex, b%nb_vertex
!===========================   FIN DE LA ROUTINE    ====================
 END SUBROUTINE blocaffiche
!DOCFIN

SUBROUTINE solideaffiche(s)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/solideaffiche  *
!
!    NOM
! solideaffiche(s)
!
!    DESCRIPTION 
!*
! Affichage d un objet solide 
! Displaying a solide object 
!*
! 
!    ENTREES / INPUT
!    s : objet de type solide / solide object
!
!    SORTIES / OUTPUT
!    s : objet de type solide / solide object
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(solide),intent(in) :: s !! solide
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(*,*)'Solide', s%id, ' *********************************************'
  write(*,*)'bounding box                  :',s%xmin_s,s%xmax_s,s%ymin_s,s%ymax_s,s%zmin_s,s%zmax_s
  write(*,*)'density                       :',s%rho
  write(*,*)' center of gravity            :',s%xg
  write(*,*)' rotation                     :', s%theta
  write(*,*)'Number of internal cells      :',s%nb_cell 
!  write(*,'(10i9)')s%list_cells
  write(*,*)'Number of vertexes            :',s%nb_vert
  write(*,'(3e13.5)')s%list_vertex
  write(*,*)'Numbers of faces              :',s%nb_face
  write(*,'(3i9)')s%list_facette
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE solideaffiche
!DOCFIN

 SUBROUTINE waffiche(w)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/waffiche  *
!
!    NOM
! waffiche(w)
!
!    DESCRIPTION  
!*
! Affichage des variables d etat 
!
! Displaying state variables 
!*
! 
!    ENTREES / INPUT
! w    : objet de type "state" / object of type "state"
!
!    SORTIES / OUTPUT
! w    : objet de type "state" / object of type "state"
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(state),intent(in) :: w !! variable d etat / State variables
  integer                :: i
!=========================== DEBUT DU CODE EXECUTABLE ==================
!
  write(*,'(10e12.5)')(w%vprim%v(i),i=1,nvar)
  write(*,'(10e12.5)')(w%vbal%v(i),i=1,nvar)
  write(*,'(10e12.5)')(w%gprim(1)%v(i),i=1,nvar)
  write(*,'(10e12.5)')(w%gprim(2)%v(i),i=1,nvar)
  write(*,'(10e12.5)')(w%gprim(3)%v(i),i=1,nvar)
  write(*,'(10e12.5)')w%enti,w%entf,w%pe,w%chi
!===========================   FIN DE LA ROUTINE    ====================
 END SUBROUTINE waffiche
!DOCFIN

 SUBROUTINE  fct_iniw(x,y,z,vprim,ifct)
!=========================== DOCUMENTATION =============================
!DOCDEBh*    PHY/USER/fct_iniw  *
!
!    NOM
! fct_iniw(x,y,z,vprim,ifct)
!    DESCRIPTION
!*
! Initialisation des variables primitives d une cellule par une fonction utilisateur
!
! Initialisation of primitive variables in a cell by a user function
!*
! 
!    ENTREES / INPUT
!    x,y,z : coordonnees / coordinates
!    ifct  : numero de la fonction definissant les variables primitives 
!          / number of the function defining the primitive variables
!    
!    SORTIES / OUTPUT
!    vprim     : variables primitives / primitive variables
! modele bifluide : densite,vitesse suivant x,y,z, pression
! / two-fluid model: density, velocity along x,y,z, pressure
! modele St-Venant: hauteur d eau,vitesse suivant x,y
! /St-Venant model: water height, velocity along x,y
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ====================
!.1-----  Implicit, Use
   use phy_typ
   IMPLICIT NONE
!.2-----  Declaration
   real(kind=kind(0.d0)), intent(in)    :: x,y,z !!coordonnees / coordinates
   type(vect_nvar) , intent(out)        :: vprim !!variables primitives / Primitive variables
   integer                              :: ifct !!numero de la fonction / Function number

   real(kind=kind(0.d0))                :: r,u,v,w,p
   real(kind=kind(0.d0))                :: h,zb
!=========================== DEBUT DU CODE EXECUTABLE ==================
r=0.d0;u=0.d0;v=0.d0;w=0.d0;p=0.d0*x*y*z
h=0.d0;zb=0.d0
vprim%v=0.d0

   SELECT CASE (ifct)

! ====== Bump   -------------------------------------
    CASE(1)
      !vprim%v(1)=0.66d0
      vprim%v(1)=0.33d0
      IF(x.gt.8.D0 .and. x.lt.12.d0)then
         zb=0.2d0-0.05d0*(x-10.d0)**2
         !vprim%v(1)=0.66d0-zb
         vprim%v(1)=0.33d0-zb
      ENDIF
! ====== Drop of water   -------------------------------------
    CASE(2)
      vprim%v(1)=1.d0
      vprim%v(5)=1.d5
      IF(y.le.0.007)then
        vprim%v(1)=1000.d0
        vprim%v(5)=1.d5+1000.d0*9.81d0*(0.007d0-y)
      ENDIF
      if(((x-0.045d0)**2+(y-0.1546d0)**2).le.0.00155d0**2)then
        vprim%v(1)=1000.d0
      endif
 ! ====== Drop of water 3D ------------------------------------
    CASE(3)
      vprim%v(1)=1.d0
      vprim%v(5)=1.d5
      IF(z.le.0.007)then
        vprim%v(1)=1000.d0
        vprim%v(5)=1.d5+1000.d0*9.81d0*(0.007d0-z)
      ENDIF
      if((x**2+y**2+(z-0.1546d0)**2).le.0.00155d0**2)then
        vprim%v(1)=1000.d0
      endif
     
    CASE DEFAULT
      call print_err('fct_iniw', 'No user function defined')

   END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE fct_iniw
!DOCFIN

 SUBROUTINE friction(calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/friction  *
!
!    NOM
!   friction(calc,lev)
!    DESCRIPTION  
!*
! Calcul de la penalisation de la vitesse par la friction 
! Calculation of speed penalty due to friction 
!* 
! 
!    ENTREES / INPUT
!   calc : objet calcul / Calcul object
!    SORTIES / OUTPUT
!   calc : objet calcul modifie / Modified calcul object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul),intent(inout) :: calc !! Objet calcul / Calcul object

  integer                    :: ic
  real(kind=kind(0.d0))      :: alpha, beta, Uold, cf, h
!=========================== DEBUT DU CODE EXECUTABLE ==================
! calcul des termes sources par splitting
      select case (ifrict)
        case (0)
          return
        case (1,2)
        case default
           call print_err('FRICTION','Friction model not defined ')
      end select

! Terme source de frottements par la loi de Mannning pour Saint-Venant
      DO ic=1,calc%msh%nb_cell
          IF (calc%msh%list_cell(ic)%idom.ne.calc%msh%numdom) CYCLE   
              
              Uold  = dsqrt(calc%msh%list_cell(ic)%w%vprim%v(2)**2 + &
                      calc%msh%list_cell(ic)%w%vprim%v(3)**2)
              h     = calc%msh%list_cell(ic)%w%vprim%v(1)
              cf    = calc%msh%list_cell(ic)%w%vprim%v(6)
              alpha = 1.d0    
              beta  = 0.d0   
              if (h.lt.hzero_phy) cycle
              select case (ifrict)
                case (1)
                   beta=cf/(h**(4.d0/3.d0))*gpes_phy*calc%dt*Uold
                case (2)
                   beta=cf/h*gpes_phy*calc%dt*Uold
               end select
               alpha=2.d0/(1.d0+sqrt(1.d0+4.d0*beta))
              calc%msh%list_cell(ic)%w%vprim%v(2) = alpha*calc%msh%list_cell(ic)%w%vprim%v(2)
              calc%msh%list_cell(ic)%w%vprim%v(3) = alpha*calc%msh%list_cell(ic)%w%vprim%v(3)                     
              
              CALL prim2bal(calc%msh%list_cell(ic)%w)
                                  
      END DO
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE friction
!DOCFIN

 SUBROUTINE SAVE_CALC (calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/save_calc  *
!
!    NOM
! SAVE_CALC  (calc)
!    DESCRIPTION  
!*
! Sauvegarde binaire du domaine en cours
! Binary backup of the current domain
!*
! 
! !
!    ENTREES / INPUT
! calc : objet calcul / calculation object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
#ifdef _MPI
  include 'mpif.h'
#endif
!.2-----  Declaration
  type(calcul),intent(in) :: calc!! Objet calcul / Calcul object
  
  character               :: fsol*11,cn*10
  integer                 :: i,ic,id,iu,jc,jd,ju,is,ios
  character(len=256)      :: iomsg
!=========================== DEBUT DU CODE EXECUTABLE ==================
  cn='0123456789'
  ic=int(calc%msh%numdom/100.)
  id=int((calc%msh%numdom-ic*100.)/10.)
  iu=calc%msh%numdom-id*10-ic*100
  jc=int(calc%ipas/100.)
  jd=int((calc%ipas-jc*100.)/10.)
  ju=calc%ipas-jd*10-jc*100
  
  IF (calc%msh%numdom.gt.999)then
     call print_err('SAVE_CALC','Domain index > 999 is not supported')
     stop
  end if
  
  fsol( 1: 7)='cerfbin' 
  fsol( 8: 8)='_'
  fsol( 9: 9)=cn(ic+1:ic+1)
  fsol(10:10)=cn(id+1:id+1)
  fsol(11:11)=cn(iu+1:iu+1)
    
  open(11,file=fsol,form='unformatted',iostat=ios,iomsg=iomsg)
  if (ios /= 0) call print_err('SAVE_CALC','Cannot open '//trim(fsol)//' : '//trim(iomsg))
  rewind(11)

  write(11,iostat=ios,iomsg=iomsg) calc%nb_bloc,calc%nbds
  if (ios /= 0) call print_err('SAVE_CALC','Error writing header (nb_bloc,nbds): '//trim(iomsg))


! Ecriture des parametres numeriques
  write(11,iostat=ios,iomsg=iomsg) nvar
  if (ios /= 0) call print_err('SAVE_CALC','Error writing nvar: '//trim(iomsg))
  write(11,iostat=ios,iomsg=iomsg) calc%tmax,2*calc%tmax-calc%tmin,   calc%cfl 
  if (ios /= 0) call print_err('SAVE_CALC','Error writing time/cfl: '//trim(iomsg))
  write(11,iostat=ios,iomsg=iomsg) calc%isauv,    calc%istart, calc%ipas, &
            calc%ityp_flux ,calc%iordre_t,calc%iordre_e,calc%imeth_int_temps, calc%ilimiteur
  if (ios /= 0) call print_err('SAVE_CALC','Error writing numerics: '//trim(iomsg))
  write(11,iostat=ios,iomsg=iomsg) calc%msh%numdom, calc%msh%nb_cell, &
            calc%msh%nb_face,calc%msh%nb_dom,calc%msh%nb_vertex,calc%msh%ndim, &
            calc%msh%nb_level_face,calc%msh%nb_level_cell
  if (ios /= 0) call print_err('SAVE_CALC','Error writing mesh dimensions: '//trim(iomsg))
  write(11,iostat=ios,iomsg=iomsg) calc%msh%small, calc%msh%big
  if (ios /= 0) call print_err('SAVE_CALC','Error writing mesh scales: '//trim(iomsg))
  write(11,iostat=ios,iomsg=iomsg) calc%pdtp,calc%nb_sondes ,calc%point_sondes, calc%num_point_min
  if (ios /= 0) call print_err('SAVE_CALC','Error writing probes: '//trim(iomsg))

! ecriture des parametres physiques
  write(11,iostat=ios,iomsg=iomsg) gpes_phy,imodel_phy,pes_xyz
  if (ios /= 0) call print_err('SAVE_CALC','Error writing physical params #1: '//trim(iomsg))

!diphasique
  write(11,iostat=ios,iomsg=iomsg) rho0A_phy,c_phy, rho0W_phy, p0_phy, sharp_phy
  if (ios /= 0) call print_err('SAVE_CALC','Error writing physical params #2: '//trim(iomsg))
!SV
  write(11,iostat=ios,iomsg=iomsg) hzero_phy,ibathy,num_bathy,ngrad_bathy,ifrict
  if (ios /= 0) call print_err('SAVE_CALC','Error writing physical params #3: '//trim(iomsg))
  write(11,iostat=ios,iomsg=iomsg) fich_bathy
  if (ios /= 0) call print_err('SAVE_CALC','Error writing bathy filename: '//trim(iomsg))


! Ecriture des sommets, des faces, des cellules
  if(calc%msh%nb_vertex.ne.0) then
      write(11,iostat=ios,iomsg=iomsg) calc%msh%list_vertex
      if (ios /= 0) call print_err('SAVE_CALC','Error writing vertices: '//trim(iomsg))
  end if
  if(calc%msh%nb_face.ne.0) then
      write(11,iostat=ios,iomsg=iomsg) calc%msh%list_face
      if (ios /= 0) call print_err('SAVE_CALC','Error writing faces: '//trim(iomsg))
  end if
  if(calc%msh%nb_cell.ne.0) then
      write(11,iostat=ios,iomsg=iomsg) calc%msh%list_cell
      if (ios /= 0) call print_err('SAVE_CALC','Error writing cells: '//trim(iomsg))
  end if

! ecriture des conditions aux limites imposees
  write(11,iostat=ios,iomsg=iomsg) phy_state
  if (ios /= 0) call print_err('SAVE_CALC','Error writing boundary states: '//trim(iomsg))
  
! ecriture des blocs
  write(11,iostat=ios,iomsg=iomsg) calc%nrma
  if (ios /= 0) call print_err('SAVE_CALC','Error writing nrma: '//trim(iomsg))
  write(11,iostat=ios,iomsg=iomsg) calc%vcde,calc%vcra
  if (ios /= 0) call print_err('SAVE_CALC','Error writing vcde/vcra: '//trim(iomsg))
  IF (calc%nb_bloc.ne.0) then
      write(11,iostat=ios,iomsg=iomsg) calc%list_bloc
      if (ios /= 0) call print_err('SAVE_CALC','Error writing block list: '//trim(iomsg))
  end if
      
  write(11,iostat=ios,iomsg=iomsg) calc%nb_sol      ! Nombre de solides <5
  if (ios /= 0) call print_err('SAVE_CALC','Error writing number of solids: '//trim(iomsg))
! ecriture des solides
  !IF (calc%nb_sol .NE. 0 .AND. iu.NE.0) THEN
  IF (calc%nb_sol .NE. 0 ) THEN
      DO i=1,calc%nb_sol 
          !Identifiant du solide, Nbre de sommets, facettes, Nbre de cellules
          write(11,iostat=ios,iomsg=iomsg) calc%list_sol(i)%id, calc%list_sol(i)%imv, &
          calc%list_sol(i)%nb_vert,calc%list_sol(i)%nb_face, calc%list_sol(i)%nb_cell
          if (ios /= 0) call print_err('SAVE_CALC','Error writing solid header: '//trim(iomsg))
          ! Bounding Box du solide et rho
          write(11,iostat=ios,iomsg=iomsg) calc%list_sol(i)%xmin_s,calc%list_sol(i)%xmax_s,&
                    calc%list_sol(i)%ymin_s,calc%list_sol(i)%ymax_s,&
                    calc%list_sol(i)%zmin_s,calc%list_sol(i)%zmax_s,calc%list_sol(i)%rho
          if (ios /= 0) call print_err('SAVE_CALC','Error writing solid bounds/rho: '//trim(iomsg))
          ! Postion du centre de gravite du solide, angle de rotation par rapport au referentiel global
          write(11,iostat=ios,iomsg=iomsg) calc%list_sol(i)%xg,calc%list_sol(i)%theta
          if (ios /= 0) call print_err('SAVE_CALC','Error writing solid state: '//trim(iomsg))
          ! Liste des facettes constituant l enveloppe du solide
          write(11,iostat=ios,iomsg=iomsg) calc%list_sol(i)%list_facette
          if (ios /= 0) call print_err('SAVE_CALC','Error writing solid facets: '//trim(iomsg))
          ! Liste des vertex sur l enveloppe du solide
          write(11,iostat=ios,iomsg=iomsg) calc%list_sol(i)%list_vertex
          if (ios /= 0) call print_err('SAVE_CALC','Error writing solid vertices: '//trim(iomsg))
          ! Nbre de cellules contenues dans le solide
          !IF (calc%list_sol(i)%nb_cell.ne.0) write(11) calc%list_sol(i)%list_cells
          write(16,1000) calc%msh%numdom,calc%list_sol(i)%id, calc%list_sol(i)%nb_vert,&
                        calc%list_sol(i)%nb_face,calc%list_sol(i)%nb_cell
1000     format(' Domaine:',i7,/, &
                ' Solide :',i7,/,&
                ' nb vert:',i7,/,&
                ' nb face:',i7,/,&
                ' nb cell:',i7,/) 
      END DO
  END IF

! Ecriture de la liste des cellules a echanger/recevoir
  DO i=1,calc%msh%nb_dom
      is=0
      IF (associated(calc%msh%list_send(i)%L)) THEN
         is=size(calc%msh%list_send(i)%L)
      END IF
        write(11,iostat=ios,iomsg=iomsg) is
        if (ios /= 0) call print_err('SAVE_CALC','Error writing send size: '//trim(iomsg))
        IF (is.ne.0) then
          write(11,iostat=ios,iomsg=iomsg) calc%msh%list_send(i)%L
          if (ios /= 0) call print_err('SAVE_CALC','Error writing send list: '//trim(iomsg))
        end if
  END DO
  
  DO i=1,calc%msh%nb_dom
      is=0
      IF (associated(calc%msh%list_recv(i)%L)) THEN
          is=size(calc%msh%list_recv(i)%L)
      END IF
        write(11,iostat=ios,iomsg=iomsg) is
        if (ios /= 0) call print_err('SAVE_CALC','Error writing recv size: '//trim(iomsg))
        IF (is.ne.0) then
          write(11,iostat=ios,iomsg=iomsg) calc%msh%list_recv(i)%L
          if (ios /= 0) call print_err('SAVE_CALC','Error writing recv list: '//trim(iomsg))
        end if
  END DO
 
  close(11)

!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE SAVE_CALC
!DOCFIN

  MODULE zorder
!=========================== DOCUMENTATION ============================= 
!DOCDEBm*    UTI/zorder  *
!
!    NOM
! zorder
!    DESCRIPTION  
!*
! Ensemble de routines necessaires aux codes de Morton
!
! Set of routines required for Morton codes
!*
! Interfaces:
! Subroutine
!  ->zordercurve3D
!  ->convertDecBin
!  ->convetrBinDec
!  ->mixBinXBinYBinZ
! Function
!  ->GETSIZE
!  ->COORD_REAL2INT
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  implicit none

!=========================== DEBUT DU CODE EXECUTABLE ==================

  contains
  
 SUBROUTINE zordercurve3d(nx,ny,nz,nt)
!=========================== DOCUMENTATION ============================= 
!
! zordercurve3d(nx,ny,nz,nt)
!      
! A partir des coordonnees, calculer le numero (id)
! associe a celle-ci a l aide du code de Morton
! 
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  IMPLICIT NONE                                                        ;

!.2-----  Declaration
  INTEGER                          :: sizex,sizey,sizez,smax,sizet  ! SIZEX : Number of bits of the binary number associated at NX ; smax = max (sizex,y,z)
  INTEGER, INTENT(IN)              :: nx   ,ny   ,nz                ! NX    : Integer associated at the coordinate x (not in the routine)
  INTEGER(kind=16), INTENT(OUT)    :: nt                            ! NT    : Integer associated at the Morton s number
  LOGICAL,DIMENSION(:),ALLOCATABLE :: Tx   ,Ty   ,Tz   ,     Tt     ! TX    : Table (= binary number) associated at the integer NX
!=========================== DEBUT DU CODE EXECUTABLE ==================

! ************************************
! *** INITIALISATION DES VARIABLES ***
! ************************************

  ! ***** Trouver le nombre de fois que l on divise par 2, le nb x *****
  sizex = getsize(nx)
  sizey = getsize(ny)
  sizez = getsize(nz)
  
  ! **** Trouver le plus grand entre sizex et sizey ********************
  smax = max(sizex,sizey,sizez)
  ! **** Calculer la taille du tableau Tz  *****************************
  sizet = 3*smax
! ********************************
! *** ALLOCATION DES VARIABLES ***
! ********************************
  
  allocate(Tx(smax),Ty(smax),Tz(smax),Tt(sizet))

! ***************************
! *** FONCTION PRINCIPALE ***
! ***************************

! ##################################
! ### Passer de Entier à Binaire ###
! ##################################
  
  call convertDecBin(nx,Tx,smax,sizex)
  call convertDecBin(ny,Ty,smax,sizey)
  call convertDecBin(nz,Tz,smax,sizez)

! ######################################################
! ### Mixer les 2 binaires suivant le code de Morton ###
! ######################################################
  call mixBinXBinYBinZ(Tx,Ty,Tz,smax, Tt)

! ##################################
! ### Passer de Binaire à Entier ###
! ##################################
  call convertBinDec(Tt,sizet,nt)


! ***********************************
! *** DESALLOCATION DES VARIABLES ***
! ***********************************
  deallocate(Tx,Ty,Tz,Tt)

 end subroutine zordercurve3d

 SUBROUTINE zordercurve2d(nx,ny,nt)
!=========================== DOCUMENTATION ============================= 
!
! zordercurve3d(nx,ny,nt)
!      
! A partir des coordonnees, calculer le numero (id)
! associe a celle-ci a l aide du code de Morton
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  implicit none

!.2-----  Declaration
  INTEGER                          :: sizex,sizey,smax,sizet ! SIZEX : Number of bits of the binary number associated at NX ; smax = max (sizex,y)
  INTEGER, INTENT(IN)              :: nx,   ny               ! NX    : Integer associated at the coordinate x (not in the routine)
  INTEGER(kind=16), INTENT(OUT)    :: nt                     ! NT    : Integer associated at the Morton s number
  LOGICAL,DIMENSION(:),ALLOCATABLE :: Tx, Ty, Tt             ! TX    : Table (= binary number) associated at the integer NX
!=========================== DEBUT DU CODE EXECUTABLE ==================

! *** INITIALISATION DES VARIABLES ***
  sizex = getsize(nx)
  sizey = getsize(ny)
  smax = max(sizex,sizey)
  sizet = 2*smax
  
  allocate(Tx(smax),Ty(smax),Tt(sizet))

! ### Passer de Entier à Binaire ###
  call convertDecBin(nx,Tx,smax,sizex)
  call convertDecBin(ny,Ty,smax,sizey)
! ### Mixer les 2 binaires suivant le code de Morton ###
  call mixBinXBinY(Tx,Ty,smax, Tt)

! ### Passer de Binaire à Entier ###
  call convertBinDec(Tt,sizet,nt)

  deallocate(Tx,Ty,Tt)

 END SUBROUTINE zordercurve2d   
! *****************
! *** FONCTIONS ***
! *****************
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 FUNCTION GETSIZE(N) ! What will be the size of the binary number associated at N ?
  INTEGER, INTENT(IN) :: N ! input
  INTEGER             :: NTEST ! var
  integer::getsize
  GETSIZE = 0     
  NTEST   = 0

  DO WHILE( NTEST< N )
     NTEST   = NTEST + 2**GETSIZE
     GETSIZE = GETSIZE+1
  ENDDO
  IF( N==0 ) GETSIZE = 1 

 END FUNCTION GETSIZE
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! *******************
! *** SUBROUTINES ***
! *******************

! ****************************
! *** Convertir en Binaire ***
! ****************************
 SUBROUTINE convertDecBin(x,Tx,smax,sizex)
  IMPLICIT NONE                                                        ;
     integer::i
     integer::smax,sizex,x,xcopie
     logical,dimension(smax)::Tx
     logical::r
     xcopie = x
     Tx(:) = .false.
     r = (mod(2,2)==1)

  i = smax
    DO WHILE( i>=(smax-sizex+1))
       Tx(i) = (mod(xcopie,2) == 1)
       xcopie = (xcopie- mod(xcopie,2) ) /2
      i = i - 1 
    ENDDO 
    
  end subroutine convertDecBin
  
! ****************************
! *** Convertir en Decimal ***
! ****************************
   subroutine convertBinDec(Tz,sizez,numDec)
     implicit none
     integer::i,sizez
     integer(kind=16) :: numDec

     logical,dimension(sizez)::Tz
     numDec = 0
     numdec=0
     do i=1,sizez
       if(Tz(i))then
         numDec = numDec + (int(2,16))**(sizez - i)
       endif
      enddo
!===========================   FIN DE LA ROUTINE    ====================  
   end subroutine convertBinDec

! *******************************
! *** Mixer selon code Morton ***
! *******************************
  SUBROUTINE mixBinXBinYBinZ(Tx,Ty,Tz,smax,Tt)
    IMPLICIT NONE                                                     
    INTEGER, INTENT(IN)                             :: smax           
    LOGICAL, DIMENSION(:), ALLOCATABLE, INTENT(IN)  :: Tx, Ty, Tz     
    LOGICAL, DIMENSION(:), ALLOCATABLE, INTENT(OUT) :: Tt             

    INTEGER              :: I, J, K                                   ! loop
    I = 1  
    J = 0      
    K = 0                                

  !                                        CHECK IF TX, TY, TZ, TT ALLOCATED
  IF( .NOT.ALLOCATED(TX) ) THEN
     WRITE(*,*) "ERROR   01 (mixBinXBinYBinZ) : TX NOT ALLOCATED "    
     STOP  
  ENDIF
  IF( .NOT.ALLOCATED(TY) ) THEN
     WRITE(*,*) "ERROR   02 (mixBinXBinYBinZ) : TY NOT ALLOCATED "    
     STOP  
  ENDIF
  IF( .NOT.ALLOCATED(TZ) ) THEN
     WRITE(*,*) "ERROR   03 (mixBinXBinYBinZ) : TZ NOT ALLOCATED "    
     STOP 
  ENDIF
  IF( .NOT.ALLOCATED(TT) ) ALLOCATE(TT(1:(3*SMAX)))                           


  !-----------------------------------------
  !--- Boucle pour remplir le tableau Tx ---
  !-----------------------------------------
 !                                                                COMPUTE TT

  DO WHILE( ( (I+J+K)<=(3*SMAX) ).AND.( I<=SMAX ).AND.( J<=SMAX ).AND.( K<=SMAX) )    ! Car J et K debutent a 0
     IF( MOD( (I+J+K),3 )==0 )THEN
        TT( I+J+K ) = TX( I )                                              
        !write(*,*) 'Tt(',i+j+k,') = ',TT(I+J+K)
        I = I + 1                                                          
     ELSE IF( MOD( (I+J+K),3 )==2 )THEN
        TT( I+J+K ) = TY( J+1 )                                                ! CAR ON A DEBUTE A J = 0
        !write(*,*) 'Tt(',i+j+k,') = ',TT(I+J+K)
        J = J + 1                                                          
     ELSE 
        TT( I+J+K ) = TZ( K+1 )                                            
        !write(*,*) 'Tt(',i+j+k,') = ',TT(I+J+K)
        K = K + 1                                                          
     ENDIF
  END DO
  !write(*,*)'numero en binaire : ',TT

  end subroutine mixBinXBinYBinZ
! *******************************
! *** Mixer selon code Morton en 2D***
! *******************************
 SUBROUTINE mixBinXBinY(Tx,Ty,smax,Tt)
    implicit none                                                     
    INTEGER, INTENT(IN)                             :: smax           
    LOGICAL, DIMENSION(:), ALLOCATABLE, INTENT(IN)  :: Tx, Ty
    LOGICAL, DIMENSION(:), ALLOCATABLE, INTENT(OUT) :: Tt             

    INTEGER              :: I, J, K                                   ! loop
    I = 1  
    J = 0      
    K = 0                                

  !                                        CHECK IF TX, TY, TZ, TT ALLOCATED
  IF( .NOT.ALLOCATED(TX) ) THEN
     WRITE(*,*) "ERROR   01 (mixBinXBinY) : TX NOT ALLOCATED "    
     STOP  
  ENDIF
  IF( .NOT.ALLOCATED(TY) ) THEN
     WRITE(*,*) "ERROR   02 (mixBinXBinY) : TY NOT ALLOCATED "    
     STOP  
  ENDIF
  IF( .NOT.ALLOCATED(TT) ) ALLOCATE(TT(1:(2*SMAX)))                           

 !     COMPUTE TT

  DO WHILE( ( (I+J)<=(2*SMAX) ).AND.( I<=SMAX ).AND.( J<=SMAX ) )    ! Car J debute a 0
     IF( MOD( (I+J),2 )==0 )THEN
        TT( I+J ) = TX( I )                                              
        I = I + 1                                                          
     ELSE
        TT( I+J ) = TY( J+1 )                                                ! CAR ON A DEBUTE A J = 0
        J = J + 1                                                          
     ENDIF
  END DO

 END SUBROUTINE mixBinXBinY

 FUNCTION COORD_REAL2INT(X, XMIN, DC) 
  INTEGER::COORD_REAL2INT                                                 
  REAL(KIND = KIND(0.d0)), INTENT(IN) :: X, XMIN, DC                       ! DC = dimension caracteristique
  REAL(KIND=KIND(0.d0)), PARAMETER     :: RAF=10.0                         ! parametre de raffinage

  COORD_REAL2INT = 0                                                      

  IF(DC == 0)THEN
    WRITE(*,*) "ERROR 01 (COORD_REAL2INT) : DeltaX = 0"       
    STOP 
  ENDIF
  COORD_REAL2INT = NINT((X-XMIN)*RAF/DC)                                       ! 1/10 Dim caract : Vol/surf

 END FUNCTION COORD_REAL2INT

 subroutine parcoursR3(ch)
 use geo_typ
    implicit none
    Type(chaineR3), Pointer      :: ch
    Type(chaineR3), Pointer      :: dblech
    type (chaineR2), Pointer     :: ch2
    type (chaineR1), Pointer     :: ch1
    integer :: num


    
   num=0
    dblech=>ch
    do while (associated(dblech%prec))
       dblech=>dblech%prec
    end do
    do while (associated(dblech))
       ch2=>dblech%cr2
       do while (associated(ch2%prec))
          ch2=>ch2%prec
       end do
       do while(associated(ch2))
          ch1=>ch2%cr1
          do while (associated(ch1%prec))
             ch1=>ch1%prec
          end do
          do while(associated(ch1))
             ch1%num=num
             num=num+1             
             ch1=>ch1%suiv
          end do
          ch2=>ch2%suiv
       end do
       dblech=>dblech%suiv
    end do
 end subroutine parcoursR3
!

!================================================================================================================
 subroutine donne_num(x,y,z,R3,num,interieur)
    use geo_typ
    implicit none
    Type(chaineR3), Pointer   :: R3
    real*8, intent(in)        :: x,y,z
    integer, intent(inout)    :: num,interieur
    logical                   :: droite
    Type(chaineR3), Pointer   :: temp
    
    ! interdit de rentrer dans cette routine si la chaine pointe sur null
    droite=.false.
    if (x>=R3%x-petit) droite=.true.
    do while (associated(R3))
          temp=>R3
          if (x>R3%x+petit) then
             if (droite) then
                R3=>R3%suiv
             else
                R3=>temp
                return
             end if
          else
             if (abs(x-R3%x)<petit) then 
 !               print*,'avant R2'
                call donne_numR2(y,z,R3%cr2,num,interieur)

                return
             else
                if (droite) then 
                   R3=>temp
                    return
                else
                   R3=>R3%prec
                end if
             end if
          end if
       end do
       R3=>temp
       return
     end subroutine donne_num
!-----------------------------------------------
!-----------------------------------------------
 subroutine donne_numR2(y,z,R2,t,in)
      use geo_typ
    implicit none
 
 Type(chaineR2), Pointer     :: R2
 real*8, intent(in)          :: y,z
 integer, intent(inout)      :: t,in
 logical                     :: droite
 Type(chaineR2), Pointer     :: temp
   
    ! interdit de rentrer dans cette routine si la chaine pointe sur null
    droite=.false.
    if (y>=R2%y-petit) droite=.true.
    do while (associated(R2))
          temp=>R2
          if (y>R2%y+petit) then
             if (droite) then
                R2=>R2%suiv
             else
                R2=>temp
                return
             end if
          else
             if (abs(y-R2%y)<petit) then 
                call donne_numR1(z,R2%cr1,t,in)
                return
             else
                if (droite) then 
                   R2=>temp
                   return
                else
                   R2=>R2%prec
                end if
             end if
          end if
       end do
       R2=>temp
       return
     end subroutine donne_numR2
!--------------------------
!-----------------------------------------------
 subroutine donne_numR1(z,R1,t,in)
use geo_typ
 implicit none
 Type(chaineR1), Pointer   :: R1
 real*8, intent(in)        :: z
 integer, intent(inout)    :: t,in
 logical                   :: droite
 Type(chaineR1), Pointer   :: temp
    
    ! inrterdit de rentrer dans cette routine si la chaine pointe sur null
    droite=.false.
    if (z>=R1%z-petit) droite=.true.
    do while (associated(R1))
          temp=>R1
          if (z>R1%z+petit) then
             if (droite) then
                R1=>R1%suiv
             else
                R1=>temp
                return
             end if
          else
             if (abs(z-R1%z)<petit) then 
                t=R1%num
                in=R1%interieur
                return
             else
                if (droite) then 
                   R1=>temp
                   return
                else
                   R1=>R1%prec
                end if
             end if
          end if
       end do
       R1=>temp
!print*,'probleme'
       return
  end subroutine donne_numR1
!---------------------------
 subroutine rangeR3(x,y,z,R3,t)
   use geo_typ
   implicit none
   Type(chaineR3), Pointer     :: R3
   real*8, intent(in)          :: x,y,z
   integer, intent(inout)      :: t
   logical                     :: droite
   Type(chaineR3), Pointer     :: chloc,temp
   Type(chaineR2), Pointer     :: locR2 
   Type(chaineR1), Pointer     :: locR1

    ! inrterdit de rentrer dans cette routine si la chaine pointe sur null
    droite=.false.
    if (x>=R3%x-petit) droite=.true.
    do while (associated(R3))
          temp=>R3
          if (x>R3%x+petit) then
             if (droite) then
                R3=>R3%suiv
             else
                t=t+1
                call insertdroitex(x,y,z,R3)
                R3%cr2%cr1%num=t
                return
             end if
          else
             if (abs(x-R3%x).le.petit) then 
                call rangeR2(y,z,R3%cr2,t)
                return
             else
                if (droite) then 
                   t=t+1
                   call insertgauchex(x,y,z,R3)
                R3%cr2%cr1%num=t
                   return
                else
                   R3=>R3%prec
                end if
             end if
          end if
       end do
!cas du bout de liste droite ou gauche
       allocate (locR1)
       locR1%z=z
       Nullify(locR1%suiv) ; Nullify(locR1%prec)
       allocate (locR2)
       t=t+1
       locR1%num=t
       locR2%y=y
       locR2%cr1=>locR1
       nullify(locR2%suiv)
       nullify(locR2%prec)
       allocate(chloc)
       chloc%x=x
       chloc%cr2=>locR2
       if (droite) then
!ajout à droite de temp
          chloc%prec=>temp
          nullify(chloc%suiv)
          temp%suiv=>chloc
       else
!ajout à gauche  de temp
          chloc%suiv=>temp
          nullify(chloc%prec)
          temp%prec=>chloc
       end if
!!!modif
          R3=>chloc
!       R3=>temp
!       print*,'dans range',R3%x
       return
  end subroutine rangeR3
!-----------------------------------------------
 subroutine rangeR2(y,z,R2,t)
   use geo_typ
   !use geo, only: insertdroitey, rangeR1, insertgauchey
   implicit none
 
   Type(chaineR2), Pointer  :: R2
   real*8, intent(in)       :: y,z
   integer, intent(inout)   :: t
   logical                  :: droite
   Type(chaineR2), Pointer  :: chloc,temp
   Type(chaineR1), Pointer  :: locR1

   
    ! interdit de rentrer dans cette routine si la chaine pointe sur null
    droite=.false.
    if (y>=R2%y-petit) droite=.true.
    do while (associated(R2))
          temp=>R2
          if (y>R2%y+petit) then
             if (droite) then
                R2=>R2%suiv
             else
                t=t+1
                call insertdroitey(y,z,R2)
                R2%cr1%num=t
                return
             end if
          else
             if (abs(y-R2%y).le.petit) then 
                call rangeR1(z,R2%cr1,t)
                return
             else
                if (droite) then 
                   t=t+1
                   call insertgauchey(y,z,R2)
                   R2%cr1%num=t
                   return
                else
                   R2=>R2%prec
                end if
             end if
          end if
       end do
!cas du bout de liste droite ou gauche
       allocate (locR1)
       locR1%z=z
       Nullify(locR1%suiv) ; Nullify(locR1%prec)
       t=t+1
       locR1%num=t
       allocate(chloc)
       chloc%y=y 
       chloc%cr1=>locR1
       if (droite) then
!ajout à droite de temp
          chloc%prec=>temp
          nullify(chloc%suiv)
          temp%suiv=>chloc
       else
!ajout à gauche  de temp
          chloc%suiv=>temp
          nullify(chloc%prec)
          temp%prec=>chloc
       end if
!modif
       R2=>chloc!temp
       return
  end subroutine rangeR2

!-----------------------------------------------
 subroutine rangeR1(z,R1,t)
    use geo_typ
    !use geo, only: insertdroitez, insertgauchez
    implicit none
    Type(chaineR1), Pointer     :: R1
    real*8, intent(in)          :: z
    integer, intent(inout)      :: t
    logical                     :: droite
    Type(chaineR1), Pointer     :: chloc,temp
    
    ! interdit de rentrer dans cette routine si la chaine pointe sur null
    droite=.false.
    if (z>=R1%z-petit) droite=.true.
    do while (associated(R1))
          temp=>R1
          if (z>R1%z+petit) then
             if (droite) then
                R1=>R1%suiv
             else
                t=t+1
                call insertdroitez(z,R1)
                R1%num=t
                return
             end if
          else
             if (abs(z-R1%z).le.petit) then 
                return
             else
                if (droite) then 
                   t=t+1
                   call insertgauchez(z,R1)
                   R1%num=t
                   return
                else
                   R1=>R1%prec
                end if
             end if
          end if
       end do
!cas du bout de liste droite ou gauche
       t=t+1
       allocate(chloc)
       chloc%z=z 
       chloc%num=t
       if (droite) then
!ajout à droite de temp
          chloc%prec=>temp
          nullify(chloc%suiv)
          temp%suiv=>chloc
       else
!ajout à gauche  de temp
          chloc%suiv=>temp
          nullify(chloc%prec)
          temp%prec=>chloc
       end if
       R1=>chloc!temp
       return
  end subroutine rangeR1
!-----------------------------------------------

 subroutine insertgauchex(x,y,z,ch)
    use geo_typ
    implicit none
    real*8, intent(in)                   :: x,y,z
    Type(chaineR3), Pointer               :: ch
!
    Type(chaineR3), Pointer             :: temp, locch
    type(chaineR2), Pointer            :: locR2
    type(chaineR1), Pointer            :: locR1
    !
!cas du bout de liste droite ou gauche
    temp=>ch%prec
       allocate (locch)
       locch%x=x
       allocate (locR2)
       locR2%y=y
       nullify(locR2%suiv)
       nullify(locR2%prec)
       allocate (locR1)
       locR1%z=z
       nullify(locR1%suiv)
       nullify(locR1%prec)
       locR2%cr1=>locR1
       locch%cr2=>locR2
       locch%suiv=>ch
       ch%prec=>locch
       locch%prec=>temp
       temp%suiv=>locch
!modif
       ch=>locch
       return
  end subroutine insertgauchex
!-----------------------------------------------

 subroutine insertdroitex(x,y,z,ch)
    use geo_typ
    implicit none
    real*8, intent(in)                   :: x,y,z
    Type(chaineR3), Pointer               :: ch
!
    Type(chaineR3), Pointer             :: temp, locch
    type(chaineR2), Pointer            :: locR2
    type(chaineR1), Pointer            :: locR1
    ! 
    !
    !
!cas du bout de liste droite ou gauche
    temp=>ch%suiv
       allocate (locch)
       locch%x=x
       allocate (locR2)
       locR2%y=y
       nullify(locR2%suiv)
       nullify(locR2%prec)
       allocate (locR1)
       locR1%z=z
       nullify(locR1%suiv)
       nullify(locR1%prec)
       locR2%cr1=>locR1
       locch%cr2=>locR2
       locch%suiv=>temp
       temp%prec=>locch
       locch%prec=>ch
       ch%suiv=>locch
!modif
       ch=>locch
       return
  end subroutine insertdroitex

!-----------------------------------------------
 subroutine insertgauchey(y,z,ch)
    use geo_typ
    implicit none
    real*8, intent(in)                   :: y,z
    Type(chaineR2), Pointer               :: ch
!
    Type(chaineR2), Pointer             :: temp, locch
    type(chaineR1), Pointer            :: locR1
    ! 
    !
    !
!cas du bout de liste droite ou gauche
    temp=>ch%prec
       allocate (locch)
       locch%y=y
       allocate (locR1)
       locR1%z=z
       nullify(locR1%suiv)
       nullify(locR1%prec)
       locch%cr1=>locR1
       locch%suiv=>ch
       ch%prec=>locch
       locch%prec=>temp
       temp%suiv=>locch
!modif
       ch=>locch
       return
  end subroutine insertgauchey
!-----------------------------------------------

 subroutine insertdroitey(y,z,ch)
    use geo_typ
    implicit none
    real*8, intent(in)                   :: y,z
    Type(chaineR2), Pointer               :: ch
!
    Type(chaineR2), Pointer             :: temp, locch
    type(chaineR1), Pointer            :: locR1
    ! 
    !
    !
!cas du bout de liste droite ou gauche
    temp=>ch%suiv
       allocate (locch)
       locch%y=y
       allocate (locR1)
       locR1%z=z
       nullify(locR1%suiv)
       nullify(locR1%prec)
       locch%cr1=>locR1
       locch%suiv=>temp
       temp%prec=>locch
       locch%prec=>ch
       ch%suiv=>locch
!modif
       ch=>locch
       return
  end subroutine insertdroitey

!-----------------------------------------------
!-----------------------------------------------
 subroutine insertgauchez(z,ch)
    use geo_typ
    implicit none
    real*8, intent(in)                   :: z
    Type(chaineR1), Pointer               :: ch
!
    Type(chaineR1), Pointer             :: temp, locch
    ! 
    !
    !
!cas du bout de liste droite ou gauche
    temp=>ch%prec
       allocate (locch)
       locch%z=z
       locch%suiv=>ch
       ch%prec=>locch
       locch%prec=>temp
       temp%suiv=>locch
!modif
       ch=>locch
       return
  end subroutine insertgauchez
!-----------------------------------------------

 subroutine insertdroitez(z,ch)
    use geo_typ
    implicit none
    real*8, intent(in)                   :: z
    Type(chaineR1), Pointer               :: ch
!
    Type(chaineR1), Pointer             :: temp, locch
    ! 
    !
    !
!cas du bout de liste droite ou gauche
      temp=>ch%suiv
       allocate (locch)
       locch%z=z
       locch%suiv=>temp
       temp%prec=>locch
       locch%prec=>ch
       ch%suiv=>locch
!modif
       ch=>locch
       return
  end subroutine insertdroitez

!===========================   FIN DU MODULE   =========================
  END MODULE zorder
!DOCFIN 

 SUBROUTINE critphy(w,c)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/critphy  *
!
!    NOM
! critphy(w,c)
!
!    DESCRIPTION 
!*
! Calcul du critere de raffinement sur la cellule
! Calculation of the cell refinement criterion
!*
! 
!    ENTREES / INPUT
! w    : objet de type "state" contenant les variables conservatives et primitives
!       / State object containing the conservative and primitive variables
!
!    SORTIES / OUTPUT
! w    : objet de type "state" contenant les variables conservatives et primitives
!       / State object containing the conservative and primitive variables
! c    : critere de raffinement / refinement criterion
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(state),intent(inout)          :: w !! objet de type "state" / State object
  real(kind=kind(0.d0)), intent(out) :: c !! critere / criterion
!=========================== DEBUT DU CODE EXECUTABLE ==================

! initialisations communes
  c=0.d0

  SELECT CASE (imodel_phy)

      CASE (2) ! bifluide isotherme
          c=dabs(w%vprim%v(6))

     CASE (1) ! SaintVenant
          c=dabs(w%vprim%v(4))

  END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE critphy
!DOCFIN

 SUBROUTINE sharp(calc,pm)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/sharp  *
!
!    NOM
!   sharp(calc,t,pm)
!    DESCRIPTION  
!*
! Raidissement de l interface dans la cas d'un ecoulement bi-fluide par penalisation
!
! Stiffening of the interface in the case of two-fluid flow by penalisation
!*
! 
!    ENTREES / INPUT
!   calc : objet calcul / calculation object
!   pm   : plus grand accroissement au cours du pas de temps
!          d une des variables / largest increase over the time step in one of the variables
!    SORTIES / OUTPUT
!   calc : objet calcul / calculation object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
    use num_typ
    use num ,only:  
    IMPLICIT NONE
#ifdef _MPI
     include 'mpif.h'
#endif
!.2-----  Declaration
 type(calcul),intent(inout) :: calc !! Objet calcul / Calcul object
 real(kind=kind(0.d0))      :: pm
 !! plus grand accroissement au cours du pas de temps d une des variables / largest increase over the time step in one of the variables
 
 integer                    :: i,ierr
 real(kind=kind(0.d0))      :: vol_dom,vol_tot,cn,cd,cn_tot,cd_tot,c,dtmin,dt_glob,dt,r,psi
 real(kind=kind(0.d0))      :: ss,smax,uu,vv,ww,smax_glob,eps,pm_glob

!=========================== DEBUT DU CODE EXECUTABLE ==================
 !write(*,*) 'Compression...', sharp_phy
if(imodel_phy.ne.2)then
  call print_avert('SHARP', ' No sharpening for this physical model')
return
endif
!do k=1,4
      dt=1.d20
        dt_glob=0.d0
      dtmin=1.d20
      vol_tot=0.d0
      vol_dom=0.d0
      c=0.5d0
      cn=0.d0
      cd=0.d0
        smax=0.d0
        eps=0.d-3
      do i=1,calc%msh%nb_cell
       if (calc%msh%list_cell(i)%idom.eq.calc%msh%numdom) then
        psi=calc%msh%list_cell(i)%w%vbal%v(5)
        if(psi.le.eps)psi=0.d0
        if(psi.ge.1.d0-eps)psi=1.d0
        !r=calc%msh%list_cell(i)%w%vprim%v(1)
        !if((r-rho0A_phy).le.0.d0)r=rho0A_phy
        !if(r.ge.rho0W_phy)r=rho0W_phy
        cd=cd+(1.d0-psi)**2*psi**2*calc%msh%list_cell(i)%vol
        cn=cn+(1.d0-psi)**2*psi**3*calc%msh%list_cell(i)%vol
        vol_dom=vol_dom+calc%msh%list_cell(i)%vol
       endif
      end do
#ifdef _MPI
      Call MPI_ALLREDUCE(cn,cn_tot,1,MPI_DOUBLE_PRECISION, MPI_SUM,MPI_COMM_WORLD,ierr)
      Call MPI_ALLREDUCE(cd,cd_tot,1,MPI_DOUBLE_PRECISION, MPI_SUM,MPI_COMM_WORLD,ierr)
      Call MPI_ALLREDUCE(vol_dom,vol_tot,1,MPI_DOUBLE_PRECISION, MPI_SUM,MPI_COMM_WORLD,ierr)
#endif
       if(cd_tot.ne.0.d0)c=cn_tot/cd_tot
         !write(*,*)calc%msh%numdom,cn,cd,vol_dom,pm
         !if(calc%msh%numdom==1)write(*,*)'#########  C=',c !,cn_tot,cd_tot
       if(c.gt.1.d0)c=1.d0
       if(c.lt.0.d0)c=0.d0

     do i=1,calc%msh%nb_cell
       if (calc%msh%list_cell(i)%idom.eq.calc%msh%numdom) then
        psi=calc%msh%list_cell(i)%w%vbal%v(5)
        if(psi.le.eps)psi=0.d0
        if(psi.ge.1.d0-eps)psi=1.d0
        r=calc%msh%list_cell(i)%w%vprim%v(1)
        if((r-rho0A_phy).le.0.d0)r=rho0A_phy
        if(r.ge.rho0W_phy)r=rho0W_phy
        ss=-(1.d0-psi)**2*psi**2*(c-psi) !!!!!!!!!!!!!!!!!!!!!!!
        if(dabs(ss).le.1.d-10)ss=0.d0
        dt=0.d0
        if(ss.gt. 1.d-10)dt=min((1.d0-psi)/ss,(r-rho0A_phy)/ss/(rho0W_phy-rho0A_phy))
        if(ss.lt.-1.d-10)dt=min(-psi/ss,(r-rho0W_phy)/ss/(rho0W_phy-rho0A_phy))
        !if(ss.gt. 1.d-10)dt=(1.d0-psi)/ss
        !if(ss.lt.-1.d-10)dt=-psi/ss
        if(dt.le.dtmin.and.dt.ne.0.d0)dtmin=dt
            if(dabs(ss).gt.smax)smax=dabs(ss)
       endif
      end do
         !write(*,*)calc%msh%numdom,dtmin
      if(dtmin.eq.1.d20)dtmin=0.d0
        dt=0.9d0*dtmin !/vol_tot  

#ifdef _MPI
      Call MPI_ALLREDUCE(dt,dt_glob,1,MPI_DOUBLE_PRECISION, MPI_MIN,MPI_COMM_WORLD,ierr)
      Call MPI_ALLREDUCE(smax,smax_glob,1,MPI_DOUBLE_PRECISION, MPI_MAX,MPI_COMM_WORLD,ierr)
      Call MPI_ALLREDUCE(pm,pm_glob,1,MPI_DOUBLE_PRECISION, MPI_MAX,MPI_COMM_WORLD,ierr)
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
if(smax_glob.ne.0.d0)dt_glob=sharp_phy*pm_glob/smax_glob
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

         !if(calc%msh%numdom==1.and.dt_glob.ne.0.d0)write(*,*)'######### dt et C',dt_glob,c,smax_glob*dt_glob
if(dt_glob.lt.0.d0)stop
if(dt_glob.eq.0.d0)return


     do i=1,calc%msh%nb_cell
       if (calc%msh%list_cell(i)%idom.eq.calc%msh%numdom) then
            psi=calc%msh%list_cell(i)%w%vbal%v(5)
            if(psi.le.eps)psi=0.d0
            if(psi.ge.1.d0-eps)psi=1.d0
            ss=-(1.d0-psi)**2*psi**2*(c-psi)
            r=calc%msh%list_cell(i)%w%vprim%v(1)
            if((r-rho0A_phy).le.0.d0)r=rho0A_phy
            if(r.ge.rho0W_phy)r=rho0W_phy
            uu=calc%msh%list_cell(i)%w%vbal%v(2)/calc%msh%list_cell(i)%w%vbal%v(1)
            vv=calc%msh%list_cell(i)%w%vbal%v(3)/calc%msh%list_cell(i)%w%vbal%v(1)
            ww=calc%msh%list_cell(i)%w%vbal%v(4)/calc%msh%list_cell(i)%w%vbal%v(1)
            calc%msh%list_cell(i)%w%vbal%v(1)=calc%msh%list_cell(i)%w%vbal%v(1) & 
          - dt_glob * (rho0W_phy-rho0A_phy)*ss
            calc%msh%list_cell(i)%w%vbal%v(2)=calc%msh%list_cell(i)%w%vbal%v(2) & 
          - dt_glob * (rho0W_phy-rho0A_phy)*ss*uu
            calc%msh%list_cell(i)%w%vbal%v(3)=calc%msh%list_cell(i)%w%vbal%v(3) & 
          - dt_glob * (rho0W_phy-rho0A_phy)*ss*vv
            calc%msh%list_cell(i)%w%vbal%v(4)=calc%msh%list_cell(i)%w%vbal%v(4) & 
          - dt_glob * (rho0W_phy-rho0A_phy)*ss*ww
            calc%msh%list_cell(i)%w%vbal%v(5)=calc%msh%list_cell(i)%w%vbal%v(5) & 
          + dt_glob * ss
            call bal2prim(calc%msh%list_cell(i)%w)
       endif
      end do


!enddo


!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE sharp
!DOCFIN 

 SUBROUTINE bal2prim(w)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/Bal2Prim  *
!
!    NOM
! bal2prim(w)
!
!    DESCRIPTION 
!*
! Calcul des variables primitives a partir des variables conservatives 
! Calculating primitive variables from conservative variables 
!*
! 
!    ENTREES / INPUT
! w    : objet de type "state" contenant les variables conservatives et primitives
!      / object of type "state" containing conservative and primitive variables
!
!    SORTIES / OUTPUT
! w    : objet de type "state" contenant les variables conservatives et primitives
!      / object of type "state" containing conservative and primitive variables
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(state),intent(inout) :: w !! Variables d etat / State variables
  real(kind=kind(0.d0))     :: r,u1,u2,p,phi,r0,h
!=========================== DEBUT DU CODE EXECUTABLE ==================
!-------  Initialisations communes

  SELECT CASE (imodel_phy)
 
  CASE (2) ! bifluide isotherme non conservatif
        r=w%vbal%v(1)
        phi=w%vbal%v(5)
        r0=phi*rho0A_phy+(1.d0-phi)*rho0W_phy
        p=p0_phy+c_phy**2*(r-r0)

        w%vprim%v(1)=r
        w%vprim%v(2)=w%vbal%v(2)/r
        w%vprim%v(3)=w%vbal%v(3)/r
        w%vprim%v(4)=w%vbal%v(4)/r
        w%vprim%v(5)=p

!----------------------------------------------------
  CASE (1) ! SaintVenant
      h=w%vbal%v(1)
      if (h <= hzero_phy) then      
        h=0.d0
        u1=0.d0
        u2=0.d0
      else
        u1=w%vbal%v(2)/h
        u2=w%vbal%v(3)/h
      endif
      w%vprim%v(1)=h
      w%vprim%v(2)=u1
      w%vprim%v(3)=u2
      
  CASE DEFAULT 
       call print_err('BAL2PRIM','Physical model not defined')

 !----------------------------------------------------
  END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE bal2prim
!DOCFIN

 SUBROUTINE empty_sol(list_sol)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/PRE/empty_sol  *
!
!    NOM
! empty_sol(list_sol)
!    DESCRIPTION 
!*
! Vide la liste des solides
! Empty the list of solids
!*
! 
!
!    ENTREES / INPUT
!    list_sol : liste de solides / List of solides
!
!    SORTIES / OUTPUT
!    list_sol : liste de solides / List of solides
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(solide), dimension(10), intent(inout) :: list_sol !! liste des solides / List of solides
  integer :: i
!=========================== DEBUT DU CODE EXECUTABLE ==================


  DO i=1,nb_sol_max
!     IF (allocated(list_sol(i)%list_cells)) deallocate(list_sol(i)%list_cells)
     IF (allocated(list_sol(i)%list_vertex)) deallocate(list_sol(i)%list_vertex)
     IF (allocated(list_sol(i)%list_facette)) deallocate(list_sol(i)%list_facette)
  END DO
!===========================   FIN DE LA ROUTINE    ====================

END SUBROUTINE empty_sol
!DOCFIN

 
MODULE uti 
!=========================== DOCUMENTATION ============================= 
!DOCDEBm*    UTI/uti  *
!
!    NOM
!    uti
!    DESCRIPTION  
!*
! Interface des routines du Module UTIlitaires
! Interface of routines from UTIlitary Module 
!*!     
!
!    SOURCE 
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, use 
  use  num
  IMPLICIT NONE
!=========================== DEBUT DU CODE EXECUTABLE ==================
 


!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE amr2tec(bl,critere,nbdom)
        use  num_typ
        type(bloc),dimension(:), intent(in)            :: bl
        real(kind=kind(0.d0)), dimension(:),intent(in) :: critere
        integer, intent(in)                            :: nbdom
      END SUBROUTINE amr2tec
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE block2mesh(cb,nzone,zone,nzonei,zonei)
        use  num
        type(calcul)  :: cb 
        integer       :: nzonei
        real(kind=kind(0.d0)),allocatable,dimension(:,:)  :: zone,zonei
        integer,allocatable,dimension(:,:)  :: nzone
      END SUBROUTINE block2mesh
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE calc_bathy(calc)
        USE num
        type(calcul),intent(inout) :: calc
      END SUBROUTINE calc_bathy
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
    interface
       SUBROUTINE copy_sol(cin,cout)
         use  num_typ
         type(calcul),intent(inout) :: cin,cout
       END SUBROUTINE copy_sol
    end interface
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE critraf(calc,critere,ib,nb_cell_bloc)
        use  num_typ
        integer, intent(in)             :: ib ,nb_cell_bloc
        type(calcul), intent(in)        :: calc 
        real(kind=kind(0.d0)), dimension(:),intent(inout)   :: critere
      END SUBROUTINE critraf
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------------------------------
  INTERFACE
       SUBROUTINE empty_sol(list_sol)
         use  geo_typ
         type(solide), dimension(5), intent(inout) :: list_sol
       END SUBROUTINE empty_sol
  END INTERFACE
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------
  INTERFACE
    SUBROUTINE  fct_mesh(x,y,z,ifct,nrb)
        use  num
        real(kind=kind(0.d0)), intent(in)                :: x,y,z
        integer, intent(in)                              :: ifct
        integer, intent(out)                             :: nrb
    END SUBROUTINE fct_mesh
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
INTERFACE
  SUBROUTINE ini_w(calc,nzonei,zonei)
    use  num
    TYPE(calcul)                                      :: calc
    INTEGER                                           :: nzonei
    REAL(kind=kind(0.d0)),allocatable,dimension(:,:)  :: zonei
  END SUBROUTINE ini_w
END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
INTERFACE
  SUBROUTINE init_def_bloc(cb,nzone,zone)
    use  num
    IMPLICIT NONE
    TYPE(calcul)                                      :: cb
    real(kind=kind(0.d0)),allocatable,dimension(:,:)  :: zone
    integer,allocatable,dimension(:,:)                :: nzone
  END SUBROUTINE init_def_bloc
END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE inter (bl,nb_bloc,nb_dom,interdom,nbl,ndim)
        use  num_typ
        integer, intent(in)     ::   nb_bloc,nb_dom,ndim
        type(bloc),dimension(:),intent(inout)  ::   bl
        type(list_int),dimension(:) :: interdom
        integer,dimension(:),intent(inout) :: nbl
      END SUBROUTINE inter
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
     SUBROUTINE mame2bloc(xmin,xmax,ymin,ymax,zmin,zmax,nx,ny,nz,lst_bloc,ndim)
         use  num
         use  zorder
         implicit none
         real(kind=kind(0.d0)), intent(inout)             :: xmin,xmax,ymin,ymax,zmin,zmax
         integer, intent(in)                              :: nx,ny,nz,ndim
         type(bloc), pointer, dimension(:), intent(inout) :: lst_bloc
    END SUBROUTINE mame2bloc
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE proddl(w,bli,blo,co,idi)
        use  num_typ
        type(bloc), intent(in)          :: bli,blo 
        type(list_vec), intent(inout)   :: w 
        integer,intent(in)              :: idi
        type(calcul), intent(inout)     :: co 
      END SUBROUTINE proddl
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
    SUBROUTINE read_bath(icode,iarg)
        use  num
        integer, intent(inout)                           :: icode,iarg
    END SUBROUTINE read_bath
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
       SUBROUTINE read_cond(lst_bloc,icode,iarg,nb_bloc)
          use  num
          type(bloc), pointer, dimension(:), intent(inout) :: lst_bloc
          integer, intent(inout)                           :: icode, nb_bloc, iarg
       END SUBROUTINE read_cond
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------------------------------
  INTERFACE
       SUBROUTINE read_gmsh(fichmsh,calc)
          use  num
          type(calcul), intent(inout) :: calc
          character(*), intent(in)    :: fichmsh ! Nom du maillage
       END SUBROUTINE read_gmsh
  END INTERFACE
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE read_init(icode,iarg,zonei,nzonei)
        use  num
        integer, intent(inout)       :: icode,iarg ,nzonei
        real(kind=kind(0.d0)),allocatable,dimension(:,:) :: zonei
      END SUBROUTINE read_init
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE read_mame(calc,icode,iarg)
        use  num
        type(calcul), intent(inout)         :: calc 
        integer, intent(in)                 :: icode,iarg
      END SUBROUTINE read_mame
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE read_mesh(calc,nzone,zone)
        use  num
        type(calcul), intent(inout)                       :: calc 
        integer,allocatable,dimension(:,:), intent(inout) :: nzone
        real(kind=kind(0.d0)),allocatable,dimension(:,:), intent(inout)  :: zone
      END SUBROUTINE read_mesh
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE read_nume(calc)
        use  num
        type(calcul), intent(inout)  :: calc 
      END SUBROUTINE read_nume
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE read_obst(calc,iarg)
        use  num
        type(calcul), intent(inout)  :: calc 
        integer, intent(inout)       :: iarg 
      END SUBROUTINE read_obst
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE read_obj(isol,sol,file)
          use  geo
          integer, intent(in)          :: isol
          type(solide), intent(inout)  :: sol
          CHARACTER*20, intent(in)     :: file
      END SUBROUTINE read_obj
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE read_phys()
        use  num
      END SUBROUTINE read_phys
  END INTERFACE
!----- Fin Interface ---------------------------

!----- Debut Interface -------------------------
    interface
        SUBROUTINE save_obj (calc)
            use  num_typ
            type(calcul),intent(in) :: calc
        END SUBROUTINE save_obj  
    end interface
!----- Fin Interface ---------------------------

!----- Debut Interface ------------------------- ! 
  INTERFACE
      SUBROUTINE splitdom_Z (bl,nb_bloc,nbdv,ndim)
        use  num_typ
        integer, intent(in)     ::   nb_bloc,nbdv,ndim
        type(bloc),dimension(:),intent(inout)  ::   bl
      END SUBROUTINE splitdom_Z      
  END INTERFACE
!----- Fin Interface --------------------------- ! 



!===========================   FIN DU MODULE   =========================
END MODULE UTI
!DOCFIN

 SUBROUTINE  fct_bathy(x,y,z,zb,zbx,zby,cf)
!=========================== DOCUMENTATION =============================
!DOCDEBh*    PHY/USER/fct_bathy  *
!
!    NOM
! fct_bathy(x,y,z,zb,zbx,zby,cf)
!
!    DESCRIPTION
!*
! Initialisation du coefficient de friction, de la bathymetrie et eventuellement son gradient par une fonction utilisateur.
! Initialise the friction coefficient, the bathymetry and possibly its gradient using a user function.
!*
! on connait egalement le temps courant tc / the current time tc is also known
!
!    ENTREES / INPUT
!    x,y,z      : coordonnees du point ou effectuer le calcul 
!                / coordinates of the point where to perform the calculation
!    num_bathy  : numero de la fonction definissant la bathymetrie (variable globale)
!               / number of the function defining the bathymetry (global variable)
!    
!    SORTIES / OUTPUT
!    zb      : bathymetrie au point considere /bathymetry at the point under consideration
!    zbx,zby : gradient de la bathymetrie au point considere / gradient of bathymetry at the point under consideration
!    cf      : coefficient de friction / coefficient of friction
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ====================
!.1-----  Implicit, Use
   use phy_typ
   IMPLICIT NONE
!.2-----  Declaration
   real(kind=kind(0.d0)), intent(in)                :: x,y,z !! Coordonnees / Coordinates
   real(kind=kind(0.d0)), intent(out)               :: zb      
!! bathymetrie au point considere /bathymetry at the point under consideration
   real(kind=kind(0.d0)), intent(out)               :: zbx,zby
!! gradient de la bathymetrie au point considere / gradient of bathymetry at the point under consideration
   real(kind=kind(0.d0)), intent(out)               :: cf      
!! coefficient de friction / coefficient of friction

   real(kind=kind(0.d0))  :: h,hp,xi
   integer ::i,n

!=========================== DEBUT DU CODE EXECUTABLE ==================

  zb  = 0.d0*x*y*z
  zbx = 0.d0
  zby = 0.d0
  cf  = 0.d0
  
   SELECT CASE (num_bathy)

!------ Cas test "Bump" de Swashes
    CASE (1)
      IF(x.gt.8.D0 .and. x.lt.12.d0)then
          zb  = 0.2d0-0.05d0*(x-10.d0)**2
          zbx = -0.1d0*(x-10.d0)
      endif

!------ Cas test "McDonald" de Swashes
    CASE (2)
      n=int((1000.d0-x)*10.d0)
      zb=0.d0
      do i=1,n
          xi=1000.d0-(i*1.d0-0.5d0)/10.d0
          h=(4.d0/9.81d0)**(1.d0/3.d0)*(1.d0+0.5d0*exp(-16.d0*(xi*1.d-3-0.5d0)**2))
          hp=-(4.d0/9.81d0)**(1.d0/3.d0)*2.d0/125.d0*(xi*1.d-3-0.5d0)*exp(-16.d0*(xi*1.d-3-0.5d0)**2)
          cf=0.033d0**2
          zbx=(1.d0-4.d0/(9.81d0*h**3))*hp+4*cf/h**(10.d0/3.d0)
          zb=zb+zbx/10.d0
      enddo
      
!------ Cas "Montfaucon"
    CASE (3)
      if(x.le.2.d0)then
        zb = 6.2d0
        zbx= 0.d0
        cf = 0.d0
      endif
      if(x.gt.2.d0.and.x.le.16.d0)then
        zb =6.2d0-0.25d0*(x-2.d0)
        zbx=-0.25d0
        cf = 1.8d-4
      endif
      if(x.gt.16.d0.and.x.le.22.d0)then
        zb = 2.7d0
        zbx= 0.d0
        cf = 3.3d-4
      endif
      if(x.gt.22.d0)then
        zb =2.7d0-0.36666667d0*(x-22.d0)
        zbx=-0.25d0
        cf = 4.d-4
      endif
      

    CASE DEFAULT
      call print_err('fct_bathy', 'No user function defined')

   END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE fct_bathy
!DOCFIN

 SUBROUTINE read_obst(calc,icode)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_obst *
!
!    NOM
! read_obst(calc,icode)
!    DESCRIPTION  
!*
! Lecture du Bloc OBST du fichier de donnees *.inp
! Reading the OBST block from the *.inp data file
!*
! 
!    ENTREES / INPUT
!    calc   : objet calcul initial / initial calculation object
!    icode  : nombre de solides / number of solids
!
!    SORTIES / OUTPUT
!    calc  objet calcul / calculation object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  use uti, only : read_obj
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul), intent(inout)  :: calc !! Objet calcul / Calcul object
  integer, intent(inout)       :: icode !! Code
  character*20                 :: file
  integer                      :: i
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(*,*)
  write(*,*)achar(27)//'[34m================================================'
  write(*,*)'Reading obstacle parameters: block OBST'
  write(*,*)'================================================'//achar(27)//'[0m'
  write(*,*)

     
  calc%nb_sol = icode
  write(*,*) 'Number of obstacles  :', calc%nb_sol
  IF (calc%nb_sol.NE.0) THEN
      DO i=1,calc%nb_sol
          calc%list_sol(i)%xg%v    = 0.d0
          calc%list_sol(i)%theta%v = 0.d0
          read(33,*) file, calc%list_sol(i)%rho,calc%list_sol(i)%imv
          write(*,*) file, calc%list_sol(i)%rho,calc%list_sol(i)%imv
          CALL read_obj(i,calc%list_sol(i),file)
      END DO
  END IF      
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_obst
!DOCFIN

 SUBROUTINE sources(w,s,iordre)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/sources(w,s,iordre,dt)  *
!
!    NOM
! source
!    DESCRIPTION 
!*
! Calcul des termes source du modele physique 
! Calculation of the physics model source terms 
!*
! 
!    ENTREES / INPUT
!    w :  état / state
!    iordre: ordre du schema en espace / order of the scheme in space
!
!    SORTIES / OUTPUT
!    s : un vecteur de taille nvar avec le terme source / a vector of size nvar with the source term
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(state), intent(inout)                :: w !! Variables d etat / State variables
  type(vect_nvar),intent(out)               :: s  
!!un vecteur de taille nvar avec le terme source / a vector of size nvar with the source term
  integer,intent(in)                        :: iordre !!ordre du schema en espace / order of the scheme in space
  
  real(kind=kind(0.d0))                     :: gxphi,gyphi,gzphi
!=========================== DEBUT DU CODE EXECUTABLE ==================
! Initialisations
  s%v=0.d0

  SELECT CASE (imodel_phy)

      !----------------------------------------------------
      CASE (2) ! bifluide isotherme   
          if(pes_xyz.ne.0)s%v(pes_xyz+1)=gpes_phy*w%vprim%v(1)
 
          IF (iordre.eq.2) then
                gxphi=(w%gprim(1)%v(5)/c_phy/c_phy-w%gprim(1)%v(1))/(rho0W_phy-rho0A_phy)
                gyphi=(w%gprim(2)%v(5)/c_phy/c_phy-w%gprim(2)%v(1))/(rho0W_phy-rho0A_phy)
                gzphi=(w%gprim(3)%v(5)/c_phy/c_phy-w%gprim(3)%v(1))/(rho0W_phy-rho0A_phy)
                 
                s%v(5)=w%vprim%v(2)*gxphi+w%vprim%v(3)*gyphi+w%vprim%v(4)*gzphi
          END IF
      !----------------------------------------------------

      !---------------------------------------------------
      CASE (1) ! Saint Venant
          IF(iordre.eq.2)THEN
              s%v(2)=gpes_phy*w%vprim%v(1)*w%gprim(1)%v(5)
              s%v(3)=gpes_phy*w%vprim%v(1)*w%gprim(2)%v(5)
          ENDIF

      !---------------------------------------------------
       CASE DEFAULT
          call print_err('SOURCES',' Physical model not defined')

  END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE sources
!DOCFIN

 SUBROUTINE fluxnum(wL,wR,vn,flux,itypflux)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/fluxnum  *
!
!    NOM
! fluxnum(wL,wR,vn,flux,itypflux)
!    DESCRIPTION 
!*
! Calcul du flux numerique 
! Calculating the numerical flux 
!*
! cas 0: Rusanov
! cas 1 : Godunov
! Cas 2 : Flux centre
! Cas 3 : VF-Roe 
! 
! 
!    ENTREES / INPUT
! wL   : objet de type "state" Etat de la partie gauche / left state
! wR   : objet de type "state" Etat de la partie droite / right state
! vn   : objet de type "vect_3", normale à la face / normal vector to the face
! itypflux   : type de flux / type of flux
!
!    SORTIES / OUTPUT
! flux : objet de type "vect_nvar", flux numerique / numerical flux
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  use phy ,only:  riemisot, svriemann !compflux, vpmax, vitson, energie, prim2bal, riemann_vfroe,phy_typflux
  IMPLICIT NONE
!.2-----  Declaration
  integer                     :: itypflux !! type de flux / type of flux
  type(state), intent(in)     :: wL , wR  !! Etat gauche et droit / left and right state 
  type(vect_3),intent(in)     :: vn  !! Vecteur normal a la face / Normal vector to the face
  type(vect_nvar),intent(out) :: flux !! Flux
  
  real(kind=kind(0.d0))       :: unL,unR,rL,rR,pL,pR
  real(kind=kind(0.d0))       :: hL,hR,h,zL,zR,hL_reco,hR_reco
  real(kind=kind(0.d0))       :: psi,psiR,psiL,r,un,p,xi,alf
  type(vect_3)                :: uL,uR,u
!=========================== DEBUT DU CODE EXECUTABLE ==================
!-------  Initialisations
  flux%v=0.d0
  u%v=0.d0
  uL%v=0.d0
  uR%v=0.d0

  SELECT CASE (itypflux)
  !---------------------------------------------------
      !~CASE (0) ! flux de HLL ou Rusanov
      !~    CALL compflux(wL,vn,fluxL)
      !~    CALL compflux(wR,vn,fluxR)
      !~    SELECT CASE (imodel_phy)
      !~        CASE DEFAULT
      !~            vv=vn%v(1)**2+vn%v(2)**2+vn%v(3)**2-1.d0
      !~            IF (dabs(vv).gt.1.d-10) THEN
      !~               write(*,*) vv
      !~               STOP
      !~            END IF
      !~            vp=0.d0    ! pour plus tard: maillage mobile...
      !~            uL%v(1)=wL%vprim%v(2)
      !~            uL%v(2)=wL%vprim%v(3)
      !~            uL%v(3)=wL%vprim%v(4)
      !~            CALL vitson(wL,cL)
      !~            unL=uL%v(1)*vn%v(1)+uL%v(2)*vn%v(2)+uL%v(3)*vn%v(3)
      !~            uR%v(1)=wR%vprim%v(2)
      !~            uR%v(2)=wR%vprim%v(3)
      !~            uR%v(3)=wR%vprim%v(4)
      !~            CALL vitson(wR,cR)
      !~            unR=uR%v(1)*vn%v(1)+uR%v(2)*vn%v(2)+uR%v(3)*vn%v(3)
      !~            smin=unL-vp-cL
      !~            IF (smin.gt.unR-vp-cR) smin=unR-vp-cR
      !~            smax=unL-vp+cL
      !~            IF (smax.lt.unR-vp+cR) smax=unR-vp+cR
      !~            vmax=dabs(smin)
      !~            IF (vmax.lt.dabs(smax)) vmax=dabs(smax)
      !~    END SELECT
      !~    ! pour rusanov, décommenter ces lignes : indispensable pour le bifluide !!!!!
      !~    smax=vmax
      !~    smin=-vmax
      !~    IF (smin.ge.0.d0) THEN
      !~       flux%v=fluxL%v
      !~    ELSE IF (smax.le.0.d0) THEN
      !~       flux%v=fluxR%v
      !~    ELSE
      !~       flux%v=(smax*fluxL%v-smin*fluxR%v+smin*smax*(wR%vbal%v-wL%vbal%v))/(smax-smin)
      !~    END IF
  !---------------------------------------------------
      CASE (1) ! flux de godunov
          
          ! calculs communs
          xi=0.d0

          SELECT CASE (imodel_phy)
!---------------------------------------------------  
             CASE (2) ! bifluide isotherme non conservatif
              rL=wL%vprim%v(1)
              uL%v(1)=wL%vprim%v(2)
              uL%v(2)=wL%vprim%v(3)
              uL%v(3)=wL%vprim%v(4)
              pL=wL%vprim%v(5)
              unL=uL%v(1)*vn%v(1)+uL%v(2)*vn%v(2)+uL%v(3)*vn%v(3)

              rR=wR%vprim%v(1)
              uR%v(1)=wR%vprim%v(2)
              uR%v(2)=wR%vprim%v(3)
              uR%v(3)=wR%vprim%v(4)
              pR=wR%vprim%v(5)
              unR=uR%v(1)*vn%v(1)+uR%v(2)*vn%v(2)+uR%v(3)*vn%v(3)
                psiL=wL%vbal%v(5)
                psiR=wR%vbal%v(5)
                !if(wL%chi.eq.0.d0.and.wR%chi.ne.0.d0)then
                !  psiR=psiL
                !  rR  =rL
                !endif
                !if(wR%chi.eq.0.d0.and.wL%chi.ne.0.d0)then
                !  psiL=psiR
                !  rL  =rR
                !endif
                 CALL riemisot(rL,unL,psiL,psiL,rR,unR,psiR,psiR,xi,r,un,p,psi,alf)
                 u%v=un*vn%v
                 IF (un.gt.0.d0) THEN
                    u%v=u%v+uL%v-unL*vn%v
                 ELSE
                    u%v=u%v+uR%v-unR*vn%v
                 END IF
                 flux%v(:)=0.d0
                 flux%v(1)=r*un
                 flux%v(2)=r*u%v(1)*un+p*vn%v(1)
                 flux%v(3)=r*u%v(2)*un+p*vn%v(2)
                 flux%v(4)=r*u%v(3)*un+p*vn%v(3)
                 flux%v(6)=(r*un*un/2+r*(1.d0+log(r))*c_phy*c_phy)*un  ! flux d entropie
                 vi_phy = un   ! stockage de la vitesse du contact pour le schema nc
                 flux%v(5)=0.d0   

!---------------------------------------------------
             CASE (1) ! SaintVenant
                 hL=wL%vprim%v(1)
                 uL%v(1)=wL%vprim%v(2)
                 uL%v(2)=wL%vprim%v(3)
                 unL=uL%v(1)*vn%v(1)+uL%v(2)*vn%v(2)
                 zL=wL%vprim%v(5)
        
                 hR=wR%vprim%v(1)
                 uR%v(1)=wR%vprim%v(2)
                 uR%v(2)=wR%vprim%v(3)
                 unR=uR%v(1)*vn%v(1)+uR%v(2)*vn%v(2)
                 zR=wR%vprim%v(5)

!Reconstruction Hydrostatique
                 IF(hL.LE.hzero_phy)hL=0.d0
                 IF(hR.LE.hzero_phy)hR=0.d0
                 hL_reco=max(0.d0,hL+zL-max(zL,zR))
                 hR_reco=max(0.d0,hR+zR-max(zL,zR))
!secu!
                 IF(hL_reco.LE.hzero_phy)THEN
                   hL_reco=0.d0
                   unL=0.d0
                 ENDIF
                 IF(hR_reco.LE.hzero_phy)THEN
                   hR_reco=0.d0
                   unR=0.d0
                 ENDIF

                 xi=0.d0
                 call svriemann(hL_reco,unL,hR_reco,unR,xi,h,un)
!secu!
                 if(h.LE.hzero_phy)then
                  h=0.d0
                  un=0.d0
                 endif

!projection u_riemann sur normale a la face
                 u%v=un*vn%v
!what is it? : construction du vecteur vitesse etoile a partir de la solution 
!scalaire du probleme de riemann et des normales aux faces
                 if (un.gt.0.d0) then
                  u%v(1)=u%v(1)+uL%v(1)-unL*vn%v(1)
                  u%v(2)=u%v(2)+uL%v(2)-unL*vn%v(2)
                 else
                  u%v(1)=u%v(1)+uR%v(1)-unR*vn%v(1)
                  u%v(2)=u%v(2)+uR%v(2)-unR*vn%v(2)
                 end if

                 flux%v(:)=0.d0
                 flux%v(1)=h*un
                 flux%v(2)=h*u%v(1)*un+gpes_phy*vn%v(1)/2*h*h !+ g*vn%v(1)/2.d0*(hL**2-hL_reco**2) voir fluxnoncons
                 flux%v(3)=h*u%v(2)*un+gpes_phy*vn%v(2)/2*h*h !+ g*vn%v(2)/2.d0*(hL**2-hL_reco**2)voir fluxnoncons
                 flux%v(4)=un*(5.d-1*h*(u%v(1)**2+u%v(2)**2)+gpes_phy*h**2+gpes_phy*h*max(zL,zR)) ! flux d entropie
!---------------------------------------------------
             CASE DEFAULT 
                 call print_err('FLUXNUM','Godunov is not implemented for this model')

          END SELECT

!-------------------------------------------------------------------
      !~CASE (2) ! flux centré (instable sauf si integration en temps de rk4)
      !~    wstar%vprim%v=0.5d0*(wL%vprim%v+wR%vprim%v)
      !~    rL=wL%vprim%v(1)
      !~    rR=wR%vprim%v(1)
      !~    IF (rL.lt.rR) THEN
      !~       temp=rL
      !~       rL=rR
      !~       rR=temp
      !~    END IF
      !~    co=rR/rL
      !~    pe=6.
      !~    pm=pe-1.d0
      !~    IF (rR.ne.rL) wstar%vprim%v(1) = (co+1.D0)*rL/2.D0
      !~    CALL prim2bal(wstar)
      !~    CALL compflux(wstar,vn,flux)
      !~    visnu=0.d0
      !~    flux%v=flux%v-visnu*(wR%vbal%v-wL%vbal%v)

!-------------------------------------------------------------------
      !~CASE (3) ! schéma vfroe
      !~    CALL riemann_vfroe(wL,wR,vn,0.d0,wstar)
      !~    CALL compflux(wstar,vn,flux)
  END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE fluxnum
!DOCFIN

 SUBROUTINE dtloc (calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/dtloc  *
!
!    NOM
! dtloc (calc)
!    DESCRIPTION  
!*
! Calcul du pas de temps local a  un domaine
!
! Calculating the local time step for a domain
!*
! 
!    ENTREES / INPUT
!  calc : objet calcul / calcul object
!    SORTIES / OUTPUT
!  calc : objet calcul / calcul object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul), intent(inout) :: calc !! Objet calcul / Calcul object
  
  integer                     :: i
  real(kind=kind(0.d0))       :: vloc,dt_loc
!=========================== DEBUT DU CODE EXECUTABLE ==================

! On determine la vitesse d onde maximale sur toutes les cellules du calcul
  calc%vmax=0.d0
  calc%dt=1.d20
  DO i=1,calc%msh%nb_cell
      IF (calc%msh%numdom.eq.calc%msh%list_cell(i)%idom) THEN
          CALL velcfl(calc%msh%list_cell(i)%w,vloc,calc%msh%list_cell(i)%h)
          IF (vloc.gt.calc%vmax)calc%vmax=vloc
          dt_loc=calc%msh%list_cell(i)%h*calc%cfl/vloc     
          IF (dt_loc.lt.calc%dt)calc%dt=dt_loc
      END IF
  END DO
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE DTLOC
!DOCFIN

 
subroutine svriemann(hg,ug,hd,ud,xi,h,u)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/svriemann  *
!
!    NOM
! svriemann(hg,ug,hd,ud,xi,h,u)
!    DESCRIPTION  
!*
! Resolution du probleme de Riemann pour Saint Venant
! Solving the Riemann problem for Saint Venant
!*
! 
!    ENTREES / INPUT
!  hg  : hauteur d'eau gauche / water level left
!  ug  : vitesse gauche / velocity left
!  hd  : hauteur d'eau droit / water level right
!  ud  : vitesse droit / velocity right
!  xi  : x/t
!
!    SORTIES / OUTPUT
!  h   : hauteur d'eau interface / water level at the interface
!  u   : vitesse interface / interface velocity
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  implicit none
!.2-----  Declaration
  real(kind=kind(0.d0)),intent(in)  ::  hg !! hauteur d eau gauche / water level left 
  real(kind=kind(0.d0)),intent(in)  ::  hd !! vitesse gauche / velocity left 
  real(kind=kind(0.d0)),intent(in)  ::  ug !! hauteur d eau droit / water level right 
  real(kind=kind(0.d0)),intent(in)  ::  ud !! vitesse droit / velocity right 
  real(kind=kind(0.d0)),intent(in)  ::  xi !! x/t
  real(kind=kind(0.d0)),intent(out) ::  h  !! hauteur d eau a l interface / water level at the interface 
  real(kind=kind(0.d0)),intent(out) ::  u  !! vitesse a l interface / interface velocity 

  real(kind=kind(0.d0))            :: g,eps
  integer,parameter                :: maxiter=100
  real(kind=kind(0.d0))            :: cg,cd,cstar,ustar,hstar,dh,res
  real(kind=kind(0.d0))            :: xlambda1m,xlambda1p,xlambda2m,xlambda2p
  integer                          :: config,iter
!=========================== DEBUT DU CODE EXECUTABLE ==================

eps=hzero_phy
g=gpes_phy

! test type configuration
IF ((ud-ug) .GE. (2.d0*dsqrt(g)*(dsqrt(hg)+dsqrt(hd)))) THEN
! dry zone centrale
  config = 1
ELSEIF (hg .LE. eps .and. hd .GT. eps) THEN
! dry zone gauche
  config = 2
ELSEIF (hd .LE. eps .and. hg .GT. eps) THEN
! dry zone droite
  config = 3
ELSEIF (hg .LE. eps .and. hd .LE. eps) THEN
!dry zone a droite et a gauche
  config = 4
ELSE
! pas de dry zone
  config = 0
ENDIF



select case(config)

! pas de dry zone
  case(0)
!
!-------  Initialisations
!
    hstar=.5*(hg+hd)
    
! newton-raphson pour calculer h*
      iter=0
      res=1.d0
      dh=1.d0
      do while((dabs(dh).gt.eps).or.(dabs(res).gt.eps))
           iter=iter+1
          ! calcul du residu (on veut que res=0)
           res= ud-ug+(hstar-hd)*zsv(hstar,hd)+(hstar-hg)*zsv(hstar,hg)
          ! calcul de l accroissement
           dh=zsv(hstar,hd) +(hstar-hd)*dzsv(hstar,hd) &
            + zsv(hstar,hg) +(hstar-hg)*dzsv(hstar,hg) 
           dh=-res/dh
          ! mise a jour
           hstar=hstar+dh
          ! test d arret
           if (iter.ge.maxiter) then
           stop 'Newton iteration max atteinte!'
           endif
      enddo
  
! calcul de u*
      ustar=ud+(hstar-hd)*zsv(hstar,hd)
  
! celerite du "son" a gauche droite et milieu
      cg=dsqrt(g*hg)
      cd=dsqrt(g*hd)
      cstar=dsqrt(g*hstar)
  
! calcul de lambda(i,plus) et lambda(i,moins)
   ! onde 1
      if (hstar.gt.hg) then
           !     choc
           xlambda1m=(hg*ug-hstar*ustar)/(hg-hstar)
           xlambda1p=xlambda1m
      else
           !     detente
           xlambda1m=ug-cg
           xlambda1p=ustar-cstar
      endif
   ! onde 2
      if (hstar.gt.hd) then
           !     choc
           xlambda2m=(hd*ud-hstar*ustar)/(hd-hstar)
           xlambda2p=xlambda2m
      else
           !     detente
           xlambda2p=ud+cd
           xlambda2m=ustar+cstar
      endif
  
  ! h_interface et u_interface
      if (xi .lt. xlambda1m) then
           ! etat gauche
           h=hg
           u=ug
      elseif ((xi .ge. xlambda1m).and.(xi .lt. xlambda1p)) then
           !     1-detente
           h=(2.d0*cg+ug-xi)**2/(9.d0*g)
           u=(2.d0*(cg+xi)+ug)/3.d0 
      elseif ((xi .ge. xlambda1p).and.(xi .lt. xlambda2m)) then
           !     etat milieu
           h=hstar
           u=ustar
      elseif ((xi .ge. xlambda2m).and.(xi .lt. xlambda2p)) then
           !     2-detente
           h=(2.d0*cd-ud+xi)**2/(9.d0*g) 
           u=(-2.d0*cd+2.d0*xi+ud)/3.d0  
      elseif (xi .ge. xlambda2p) then
           ! etat droit
           h=hd
           u=ud
      endif
      
      
    ! dry zone centrale    
  case(1)
  ! etat milieu
      hstar=0.d0
      ustar=0.d0
  ! celerite du "son" a gauche droite et milieu
      cg=dsqrt(g*hg)
      cd=dsqrt(g*hd)
      cstar=0.d0
  ! calcul de lambda(i,plus) et lambda(i,moins)
      ! onde 1
          xlambda1m=ug-cg
          xlambda1p=ug+2.d0*cg
      ! onde 2
          xlambda2m=ud-2.d0*cd
          xlambda2p=ud+cd
  ! h_interface et u_interface
      if (xi .lt. xlambda1m) then
           ! etat gauche
           h=hg
           u=ug
      elseif ((xi .ge. xlambda1m).and.(xi .lt. xlambda1p)) then
           !     1-detente
           h=(2.d0*cg+ug-xi)**2/(9.d0*g);
           u=(2.d0*cg+ug+2*xi)/3.d0
      elseif ((xi .ge. xlambda1p).and.(xi .lt. xlambda2m)) then
           !     etat milieu
           h=hstar
           u=ustar
      elseif ((xi .ge. xlambda2m).and.(xi .lt. xlambda2p)) then
           !     2-detente
           h=(2.d0*cd-ud+xi)**2/(9.d0*g);
           u=(-2.d0*cd+ud+2*xi)/3.d0
      elseif (0.d0 .ge. xlambda2p) then
           ! etat droit
           h=hd
           u=ud
      endif
    
    
    ! dry zone gauche
  case(2)
       cd=dsqrt(g*hd)
   ! calcul de lambda(i,plus) et lambda(i,moins)
       ! onde 2
           xlambda2m=ud-2.d0*cd
           xlambda2p=ud+cd
   ! h_interface et u_interface
       if (xi .lt. xlambda2m) then
            !     etat milieu
            h=0.d0
            u=0.d0
       elseif ((xi .ge. xlambda2m).and.(xi .lt. xlambda2p)) then
            !     2-detente
            h=(2.d0*cd-ud+xi)**2/(9.d0*g);
            u=(-2.d0*cd+ud+2*xi)/3.d0
       elseif (xi .ge. xlambda2p) then
            ! etat droit
            h=hd
            u=ud
       endif            
       
       
    ! dry zone droite
  case(3)
      cg=dsqrt(g*hg)
  ! calcul de lambda(i,plus) et lambda(i,moins)
      ! onde 1
      xlambda1m=ug-cg
      xlambda1p=ug+2*cg
  ! h_interface et u_interface
      if (xi .lt. xlambda1m) then
           ! etat gauche
           h=hg
           u=ug
      elseif ((xi .ge. xlambda1m).and.(xi .lt. xlambda1p)) then
           !     1-detente
           h=(2*cg+ug-xi)**2/(9.d0*g);
           u=(2*cg+ug+2*xi)/3.d0
      elseif (xi .ge. xlambda1p) then
           !     etat milieu
           h=0.d0
           u=0.d0
      endif


    ! dry zone a droite et a gauche
  case(4)
       h=0.d0
       u=0.d0

    
end select
            
return
!
!===========================   FIN DE LA ROUTINE    ====================
contains
    function zsv(h1,h2)
      implicit none
      real(kind=kind(0.d0))     :: gg,h1,h2,zsv,zsol
    
      gg=9.81d0
      zsol=0.d0
    
      if (h1.gt.h2) then
         zsol=dsqrt(gg/2.d0)*dsqrt((h1+h2)/(h1*h2))
      else
         zsol=2.d0*dsqrt(gg)/(dsqrt(h1)+dsqrt(h2))
      endif
    
      zsv=zsol
    end function zsv

    function dzsv(h1,h2)
      implicit none
      real(kind=kind(0.d0)) :: gg,h1,h2,dzsv,dzsol
    
      gg=9.81d0
      dzsol=0.d0
    
      if (h1.gt.h2) then
         dzsol= dsqrt(2.d0)*dsqrt(gg)/4.d0*sqrt(h1*h2/(h1+h2))* &
              (1.d0/(h1*h2)-(h1+h2)/(h1**2*h2))
      else
         dzsol=-dsqrt(gg)/(dsqrt(h1)+dsqrt(h2))**2/dsqrt(h1)
      endif
    
      dzsv=dzsol
    end function dzsv
end subroutine svriemann
!DOCFIN           

 SUBROUTINE inter (bl,nb_bloc,nb_dom,interdom,nbl,ndim)
!=========================== DOCUMENTATION =============================
!DOCDEBh*    UTI/PRE/interface  *
!
!    NOM
!  inter (bl,nb_bloc,nb_dom,interdom,nbl,ndim)
!    DESCRIPTION  
!*
! Creation de la liste des blocs de chaque cote de l interface entre les domaines
! pour chaque couple de domaine Di, Dj  i<j
! cree en position j-i+(i-1)*(2nb_dom-i)/2 
! une liste de 4 entiers:
! - numero du bloc du domaine Di
! - numero du bloc du domaine Dj
! - position cumule de la liste send pour les 2 blocs
! - position cumule de la liste recv 
!
! Creation of the list of blocks on each side of the interface between domains
! for each pair of domains Di, Dj i<j
! create at position j-i+(i-1)*(2nb_dom-i)/2 
! a list of 4 integers:
! - domain Di block number
! - number of the block in the Dj domain
! - cumulative position of the send list for the 2 blocks
! - cumulative position of the recv list 
!*
! 
!    ENTREES / INPUT
! bl      : liste des blocs a repartir / list of blocks to be distributed
! nb_bloc : nombre de blocs / number of blocks
! nb_dom  : nombre de domaines / number of domains
! ndim    : dimension du maillage 1/1D, 2/2D , 3/3D  / mesh dimension 1/1D, 2/2D, 3/3D
! 
!    SORTIES / OUTPUT
! interdom      : liste des blocs de chaque cote de l interface entre les domaines 
!               / List of blocks on each side of the interface between domains
! nbl           : nombre d interface de bloc par frontiere de domaine / number of block interfaces per domain border
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DECLARATIONS ==============================
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  integer, intent(in)                        :: nb_bloc  !! Nombre de blocs / Number of block
  integer, intent(in)                        :: nb_dom   !! Nombre de domaine / Number of domains
  integer, intent(in)                        :: ndim     !! Dimension du probleme / Problem dimension
  type(bloc),dimension(:),intent(inout)      :: bl       !! Liste des blocs a repartir / list of blocks to be distributed
  integer,dimension(:),intent(inout)         :: nbl      
!! Nombre d interface de bloc par frontiere de domaine / number of block interfaces per domain border
  type(list_int),dimension(:), intent(inout) :: interdom 
!! Liste des blocs de chaque cote de l interface entre les domaines / List of blocks on each side of the interface between domains
  
  integer                                    ::   i,j,k,ib,iv,ibj
  integer                                    ::   nxi=0,nyi=0,nzi=0,nxj=0,nyj=0,nzj=0
!====================== START OF THE EXECUTABLE CODE  ==================

  nbl=0
!----- Determination du nombre d interface pour chaque couple Di, Dj
  DO ib=1,nb_bloc
      i=bl(ib)%idom
      DO iv=1,6
          j=bl(ib)%dom(iv)
          IF (i.lt.j) THEN
              k=j-i+(i-1)*(2*nb_dom-i)/2 
              nbl(k)=nbl(k)+1
          END IF
      END DO
  END DO

!-----  allocation de la liste des interfaces
  DO i=1,nb_dom-1
      DO j=i+1,nb_dom
          k=j-i+(i-1)*(2*nb_dom-i)/2 
          IF (nbl(k).ne.0) THEN
              allocate(interdom(k)%L(nbl(k)*4))
              interdom(k)%L=0
          END IF
      END DO
  END DO
!-----  Remplissage de la liste des interfaces   !!!!!!!!!!! A VERIFIER EN 3D
  nbl=0
  DO ib=1,nb_bloc
      i=bl(ib)%idom
      SELECT CASE (ndim)
        CASE (1) ! Cas 1D
          nxi=bl(ib)%nx*2**(bl(ib)%nrb)
          nyi=1
          nzi=1
        CASE (2) ! Cas 2D
          nxi=bl(ib)%nx*2**(bl(ib)%nrb)
          nyi=bl(ib)%ny*2**(bl(ib)%nrb)
          nzi=1
        CASE (3) ! Cas 3D
          nxi=bl(ib)%nx*2**(bl(ib)%nrb)
          nyi=bl(ib)%ny*2**(bl(ib)%nrb)
          nzi=bl(ib)%nz*2**(bl(ib)%nrb)
      END SELECT 

      DO iv=1,6
          j=bl(ib)%dom(iv)
          IF (i.lt.j) THEN
              k=j-i+(i-1)*(2*nb_dom-i)/2 
              interdom(k)%L(nbl(k)*4+1)=ib    ! numero du bloc appartenant au domaine Di
              ibj=bl(ib)%cl(iv)               ! numero du bloc appartenant au domaine Dj
              if(ibj.lt.-100000)ibj=-ibj-100000
              interdom(k)%L(nbl(k)*4+2)=ibj 
              SELECT CASE (ndim)
                CASE (1) ! Cas 1D
                  nxj=bl(ibj)%nx*2**(bl(ibj)%nrb)
                  nyj=1
                  nzj=1
                CASE (2) ! Cas 2D
                  nxj=bl(ibj)%nx*2**(bl(ibj)%nrb)
                  nyj=bl(ibj)%ny*2**(bl(ibj)%nrb)
                  nzj=1
                CASE (3) ! Cas 3D
                  nxj=bl(ibj)%nx*2**(bl(ibj)%nrb)
                  nyj=bl(ibj)%ny*2**(bl(ibj)%nrb)
                  nzj=bl(ibj)%nz*2**(bl(ibj)%nrb)
              END SELECT 

              IF (iv.eq.1.or.iv.eq.2) THEN
                interdom(k)%L(nbl(k)*4+3)= nyi*nzi ! Position dans la list_send
                interdom(k)%L(nbl(k)*4+4)= nyj*nzj ! Position dans la list_recv
              END IF
              IF (iv.eq.3.or.iv.eq.4) THEN
                interdom(k)%L(nbl(k)*4+3)= nxi*nzi ! Position dans la list_send
                interdom(k)%L(nbl(k)*4+4)= nxj*nzj ! Position dans la list_recv
              END IF
              IF (ndim.eq.3) THEN
                  IF (iv.eq.5.or.iv.eq.6) THEN
                      interdom(k)%L(nbl(k)*4+3)= nxi*nyi ! Position dans la list_send
                      interdom(k)%L(nbl(k)*4+4)= nxj*nyj ! Position dans la list_recv
                  END IF
              END IF
              IF (nbl(k).ne.0)interdom(k)%L(nbl(k)*4+3)=interdom(k)%L(nbl(k)*4+3)+interdom(k)%L((nbl(k)-1)*4+3) !cumul!!
              IF (nbl(k).ne.0)interdom(k)%L(nbl(k)*4+4)=interdom(k)%L(nbl(k)*4+4)+interdom(k)%L((nbl(k)-1)*4+4) !cumul!! 
              nbl(k)=nbl(k)+1
          END IF
      END DO
  END DO
!===========================   END OF THE SUBROUTINE    ====================
END SUBROUTINE inter
!DOCFIN

 SUBROUTINE u_penalisation(calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/u_penalisation *
!
!    NOM
! u_penalisation(calc)
!
!    DESCRIPTION  
!*
!  Penalisation par methode de projection de la vitesse dans le solide afin de correspondre a un champ de vitesse solide rigide.
!  Calcul des differents termes de l equation de la vitesse penalisee, calcul du centre de gravite, matrice 
!  d inertie puis deplacement des marqueurs solides et mise a jour de l indicatrice.
!
!  Penalisation using the method of projecting the velocity into the solid to correspond to a velocity field rigid solid.
!  Calculate the various terms in the equation of penalized velocity, calculate the centre of gravity, the inertia matrix,
!  then move the solid markers and update the indicator.
!*
! 
!    ENTREES / INPUT
! calc : objet calcul / calcul object
!    SORTIES / OUTPUT
! calc : objet calcul / calcul object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  use num, only: raycasting
  IMPLICIT NONE
#ifdef _MPI
  include 'mpif.h'
#endif
!.2-----  Declaration
  type(calcul), intent(inout)          :: calc !! Objet calcul / Calcul object
  
  integer                              :: i=0,ierr=0,isol=0,ic1,ic2
  real(kind=kind(0.d0))                :: r1=0.d0,r2=0.d0,r3=0.d0,chi_ini,rv
  real(kind=kind(0.d0))                :: i11=0.d0,i22=0.d0,i33=0.d0,i12=0.d0,i13=0.d0,i23=0.d0
  real(kind=kind(0.d0))                :: det=0.d0
  real(kind=kind(0.d0)), dimension(3,nb_sol_max)  :: omega
  real(kind=kind(0.d0)), dimension(17,nb_sol_max) :: vl,vg  
  real(kind=kind(0.d0)), dimension(:),allocatable :: rf  
!=========================== DEBUT DU CODE EXECUTABLE ==================
! vecteur de travail local au domaine ou global somme sur les domaines pour chaque solide
! vl(i,isol) ou vg(i,isol) : 
! i= 1,2,3 :translation moyenne suivant x,y,z
! i= 4,5,6 :centre de gravite
! i= 7     :volume du solide
! i= 8     :volume * densite du solide
! i= 9-14  :matrice d inertie du solide j11,j22,j33,j12,j13,j23
! i= 15-17 : moment de densite*vitesse 
omega(:,:)=0.d0
vl(:,:)=0.d0
vg(:,:)=0.d0
  
!---- A la frontiere du solide rho_A ou rho_W ??
    allocate(rf(calc%msh%nb_cell))
    rf=0.5d0*(rho0w_phy+rho0a_phy)
    DO i=1,calc%msh%nb_face
      ic1=calc%msh%list_face(i)%ic1
      ic2=calc%msh%list_face(i)%ic2
      if(ic2.gt.0)then
        if(calc%msh%list_cell(ic1)%w%chi.gt.0.d0.and.calc%msh%list_cell(ic2)%w%chi.eq.0.d0)then
          if(calc%msh%list_cell(ic2)%w%vprim%v(1).gt.(rho0A_phy+rho0A_phy)*0.51d0)then
            rf(ic1)=rho0W_phy
          else
            rf(ic1)=rho0A_phy
          endif
        endif
        if(calc%msh%list_cell(ic2)%w%chi.gt.0.d0.and.calc%msh%list_cell(ic1)%w%chi.eq.0.d0)then
          if(calc%msh%list_cell(ic1)%w%vprim%v(1).gt.(rho0A_phy+rho0A_phy)*0.5d0)then
            rf(ic2)=rho0W_phy
          else
            rf(ic2)=rho0A_phy
          endif
        endif
      endif
    ENDDO

! Calcul des paramètres de penalisation

    DO i=1,calc%msh%nb_cell
      DO isol=1,calc%nb_sol ! Boucle sur les solides
        IF (calc%msh%list_cell(i)%idom .EQ. calc%msh%numdom .AND. int(calc%msh%list_cell(i)%w%chi) .EQ.calc%list_sol(isol)%id)THEN
        ! Translation moyenne suivant x,y,z      
          vl(1,isol)=vl(1,isol)+calc%msh%list_cell(i)%w%vprim%v(1)*calc%msh%list_cell(i)%w%vprim%v(2)* calc%msh%list_cell(i)%vol 
          vl(2,isol)=vl(2,isol)+calc%msh%list_cell(i)%w%vprim%v(1)*calc%msh%list_cell(i)%w%vprim%v(3)* calc%msh%list_cell(i)%vol 
          vl(3,isol)=vl(3,isol)+calc%msh%list_cell(i)%w%vprim%v(1)*calc%msh%list_cell(i)%w%vprim%v(4)* calc%msh%list_cell(i)%vol 
        ! Centre de gravité en x,y,z
          vl(4,isol)=vl(4,isol)+calc%msh%list_cell(i)%center%x*calc%msh%list_cell(i)%w%vprim%v(1)*calc%msh%list_cell(i)%vol 
          vl(5,isol)=vl(5,isol)+calc%msh%list_cell(i)%center%y*calc%msh%list_cell(i)%w%vprim%v(1)*calc%msh%list_cell(i)%vol 
          vl(6,isol)=vl(6,isol)+calc%msh%list_cell(i)%center%z*calc%msh%list_cell(i)%w%vprim%v(1)*calc%msh%list_cell(i)%vol 
      
          vl(7,isol)=vl(7,isol) + calc%msh%list_cell(i)%vol
          vl(8,isol)=vl(8,isol) + calc%msh%list_cell(i)%w%vprim%v(1) * calc%msh%list_cell(i)%vol
        END IF
      ENDDO
    END DO
 
!----Synchronisation avec les autres processus
    DO isol=1,calc%nb_sol 
#ifdef _MPI
      DO i=1,8
        CALL MPI_ALLREDUCE(vl(i,isol),vg(i,isol),1,MPI_DOUBLE_PRECISION, MPI_SUM,MPI_COMM_WORLD,ierr)
      END DO
#endif
    ! Position du centre de gravité
      calc%list_sol(isol)%xg%v(1) = vg(4,isol) / vg(8,isol) 
      calc%list_sol(isol)%xg%v(2) = vg(5,isol) / vg(8,isol) 
      calc%list_sol(isol)%xg%v(3) = vg(6,isol) / vg(8,isol) 
    ! Vitesse de translation moyenne
      vg(1,isol) = vg(1,isol) / vg(8,isol) 
      vg(2,isol) = vg(2,isol) / vg(8,isol) 
      vg(3,isol) = vg(3,isol) / vg(8,isol) 
    
     !if(calc%msh%numdom.eq.1)write(12,'(9e13.5)')tc,calc%list_sol(isol)%xg%v,vg(1,isol),vg(2,isol),vg(3,isol),vg(7,isol),vg(8,isol)
    ENDDO 
    
    
! Calcul de la matrice d inertie du solide j 
    DO i=1,calc%msh%nb_cell
      DO isol=1,calc%nb_sol 
        IF (calc%msh%list_cell(i)%idom .EQ. calc%msh%numdom .AND. int(calc%msh%list_cell(i)%w%chi) .EQ.calc%list_sol(isol)%id &
        .AND. calc%list_sol(isol)%imv .EQ. 0) THEN
          r1=calc%msh%list_cell(i)%center%x-calc%list_sol(isol)%xg%v(1)
          r2=calc%msh%list_cell(i)%center%y-calc%list_sol(isol)%xg%v(2)
          r3=calc%msh%list_cell(i)%center%z-calc%list_sol(isol)%xg%v(3)
          IF (abs(r3)<1.d-10) r3=0.d0
          
        ! Calcul de la matrice d inertie en G centre de gravite de l assemblage j
          rv=calc%msh%list_cell(i)%w%vprim%v(1)*calc%msh%list_cell(i)%vol
          vl( 9,isol) = vl( 9,isol) + rv * (r2**2 + r3**2)
          vl(10,isol) = vl(10,isol) + rv * (r1**2 + r3**2)
          vl(11,isol) = vl(11,isol) + rv * (r1**2 + r2**2)
          vl(12,isol) = vl(12,isol) - rv * r1 * r2
          vl(13,isol) = vl(13,isol) - rv * r1 * r3
          vl(14,isol) = vl(14,isol) - rv * r2 * r3
        
        !----Calcul de int(GM ^ rho u)
          vl(15,isol) = vl(15,isol) + rv * &
                (- calc%msh%list_cell(i)%w%vprim%v(3)* r3  + calc%msh%list_cell(i)%w%vprim%v(4)* r2 )
        
          vl(16,isol) = vl(16,isol) + rv * &
                (+ calc%msh%list_cell(i)%w%vprim%v(2)* r3 - calc%msh%list_cell(i)%w%vprim%v(4)* r1 )
        
          vl(17,isol) = vl(17,isol) + rv * &
                (- calc%msh%list_cell(i)%w%vprim%v(2)* r2 + calc%msh%list_cell(i)%w%vprim%v(3)* r1 )
        END IF
       ENDDO
    END DO
    
    DO isol=1,calc%nb_sol 
      IF (calc%list_sol(isol)%imv .EQ. 0)THEN
  !----Synchronisation avec les autres processus
#ifdef _MPI
        DO i=9,17
          CALL MPI_ALLREDUCE(vl(i,isol),vg(i,isol),1,MPI_DOUBLE_PRECISION, MPI_SUM,MPI_COMM_WORLD,ierr)
        END DO
#endif   
! Déterminant de J
        det = vg( 9,isol)*vg(10,isol)*vg(11,isol) + 2.d0*vg(12,isol)*vg(13,isol)*vg(14,isol) &
            - vg(10,isol)*vg(13,isol)*vg(13,isol) -      vg( 9,isol)*vg(14,isol)*vg(14,isol) &
            - vg(11,isol)*vg(12,isol)*vg(12,isol)
    
        if(det.eq.0.d0)then
        call print_err('U_PENALISATION', 'Null determinant!!')
            stop
        endif
! Co-matrice de J
        i11 = ( vg(10,isol)*vg(11,isol)-vg(14,isol)*vg(14,isol))/det
        i12 = (-vg(12,isol)*vg(11,isol)+vg(14,isol)*vg(13,isol))/det
        i13 = ( vg(12,isol)*vg(14,isol)-vg(10,isol)*vg(13,isol))/det
        i22 = ( vg( 9,isol)*vg(11,isol)-vg(13,isol)*vg(13,isol))/det
        i23 = (-vg( 9,isol)*vg(14,isol)+vg(12,isol)*vg(13,isol))/det
        i33 = ( vg( 9,isol)*vg(10,isol)-vg(12,isol)*vg(12,isol))/det
    
!----Vecteur vitesse instantanée de rotation
        omega(1,isol) = i11 * vg(15,isol) + i12 * vg(16,isol) + i13 * vg(17,isol) ! Vitesse angulaire autour de x
        omega(2,isol) = i12 * vg(15,isol) + i22 * vg(16,isol) + i23 * vg(17,isol) ! Vitesse angulaire autour de y
        omega(3,isol) = i13 * vg(15,isol) + i23 * vg(16,isol) + i33 * vg(17,isol) ! Vitesse angulaire autour de z
      ENDIF
      if(calc%list_sol(isol)%imv.eq.-1)then
        vg(1,isol)    = 0.d0 
        vg(2,isol)    = 0.d0 
        vg(3,isol)    = 0.d0 
        omega(1,isol) = 0.d0
        omega(2,isol) = 0.d0
        omega(3,isol) = 0.d0
      endif
      if(calc%list_sol(isol)%imv.gt.0)then
        call fct_mvsol(vg(1,isol),vg(2,isol),vg(3,isol),omega(1,isol),omega(2,isol),omega(3,isol),calc%list_sol(isol)%imv)
      endif  
 ENDDO




    
! Pénalisation en vitesse
    DO i=1,calc%msh%nb_cell
      DO isol=1,calc%nb_sol 
        IF (calc%msh%list_cell(i)%idom .EQ. calc%msh%numdom .AND. int(calc%msh%list_cell(i)%w%chi) .EQ.calc%list_sol(isol)%id) THEN   
          r1=calc%msh%list_cell(i)%center%x-calc%list_sol(isol)%xg%v(1)
          r2=calc%msh%list_cell(i)%center%y-calc%list_sol(isol)%xg%v(2)
          r3=calc%msh%list_cell(i)%center%z-calc%list_sol(isol)%xg%v(3)
        
          calc%msh%list_cell(i)%w%vprim%v(1)=  calc%list_sol(isol)%rho  
          calc%msh%list_cell(i)%w%vprim%v(2) = vg(1,isol) + omega(2,isol)*r3 - omega(3,isol)*r2 
          calc%msh%list_cell(i)%w%vprim%v(3) = vg(2,isol) + omega(3,isol)*r1 - omega(1,isol)*r3 
          calc%msh%list_cell(i)%w%vprim%v(4) = vg(3,isol) + omega(1,isol)*r2 - omega(2,isol)*r1 
          CALL prim2bal(calc%msh%list_cell(i)%w)
        END IF
      ENDDO
    END DO
    
    DO isol=1,calc%nb_sol 
    
! Nouvelle position des marqueurs
      DO i=1,calc%list_sol(isol)%nb_vert
        calc%list_sol(isol)%list_vertex(i)%x = calc%list_sol(isol)%list_vertex(i)%x + &
        (vg(1,isol) - omega(3,isol)*(calc%list_sol(isol)%list_vertex(i)%y-calc%list_sol(isol)%xg%v(2))) * calc%dt ! x
        calc%list_sol(isol)%list_vertex(i)%y = calc%list_sol(isol)%list_vertex(i)%y + &
        (vg(2,isol) + omega(3,isol)*(calc%list_sol(isol)%list_vertex(i)%x-calc%list_sol(isol)%xg%v(1))) * calc%dt ! y
        calc%list_sol(isol)%list_vertex(i)%z = calc%list_sol(isol)%list_vertex(i)%z + &
        (vg(3,isol) + omega(1,isol)*(calc%list_sol(isol)%list_vertex(i)%y-&
        calc%list_sol(isol)%xg%v(2))-omega(2,isol)*(calc%list_sol(isol)%list_vertex(i)%x-calc%list_sol(isol)%xg%v(1))) * calc%dt ! z
      END DO

! Update de la bounding box
      calc%list_sol(isol)%xmin_s = minval(calc%list_sol(isol)%list_vertex(:)%x)
      calc%list_sol(isol)%xmax_s = maxval(calc%list_sol(isol)%list_vertex(:)%x)
      calc%list_sol(isol)%ymin_s = minval(calc%list_sol(isol)%list_vertex(:)%y)
      calc%list_sol(isol)%ymax_s = maxval(calc%list_sol(isol)%list_vertex(:)%y)
      calc%list_sol(isol)%zmin_s = minval(calc%list_sol(isol)%list_vertex(:)%z)
      calc%list_sol(isol)%zmax_s = maxval(calc%list_sol(isol)%list_vertex(:)%z)
      calc%list_sol(isol)%xmin_s = calc%list_sol(isol)%xmin_s-0.02d0*dabs(calc%list_sol(isol)%xmin_s)
      calc%list_sol(isol)%xmax_s = calc%list_sol(isol)%xmax_s+0.02d0*dabs(calc%list_sol(isol)%xmax_s)
      calc%list_sol(isol)%ymin_s = calc%list_sol(isol)%ymin_s-0.02d0*dabs(calc%list_sol(isol)%ymin_s)
      calc%list_sol(isol)%ymax_s = calc%list_sol(isol)%ymax_s+0.02d0*dabs(calc%list_sol(isol)%ymax_s)
      calc%list_sol(isol)%zmin_s = calc%list_sol(isol)%zmin_s-0.02d0*dabs(calc%list_sol(isol)%zmin_s)
      calc%list_sol(isol)%zmax_s = calc%list_sol(isol)%zmax_s+0.02d0*dabs(calc%list_sol(isol)%zmax_s)

    ENDDO
      
! Calcul de la nouvelle distribution de la fonction indicatrice du solide
!calc%msh%list_cell(calc%list_sol(isol)%list_cells)%w%chi=0 
    calc%list_sol(:)%nb_cell=0
    !rf=rho0A_phy  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    DO i=1,calc%msh%nb_cell
      chi_ini=calc%msh%list_cell(i)%w%chi
      DO isol=1,calc%nb_sol 

        if(calc%msh%list_cell(i)%w%chi.eq.calc%list_sol(isol)%id*1.d0)calc%msh%list_cell(i)%w%chi=0.d0
        !IF (calc%msh%list_cell(i)%idom .EQ. calc%msh%numdom .AND. &!
        IF ( &
            calc%msh%list_cell(i)%center%x<calc%list_sol(isol)%xmax_s .AND. &
            calc%msh%list_cell(i)%center%x>calc%list_sol(isol)%xmin_s .AND. &
            calc%msh%list_cell(i)%center%y<calc%list_sol(isol)%ymax_s .AND. &
            calc%msh%list_cell(i)%center%y>calc%list_sol(isol)%ymin_s .AND. &
            calc%msh%list_cell(i)%center%z<calc%list_sol(isol)%zmax_s .AND. &
            calc%msh%list_cell(i)%center%z>calc%list_sol(isol)%zmin_s) THEN 
! Faire le raycasting que dans la bounding box (grosse optimisation)
              CALL raycasting(calc%list_sol(isol),calc%msh%list_cell(i)%center%x,&
              calc%msh%list_cell(i)%center%y,calc%msh%list_cell(i)%center%z, &
              calc%msh%list_cell(i)%w%chi)
! Compte le nombre de cellules dans le solide j
              IF (calc%msh%list_cell(i)%w%chi .EQ. calc%list_sol(isol)%id) calc%list_sol(isol)%nb_cell=calc%list_sol(isol)%nb_cell+1 
        END IF
      ENDDO
!---  Fresh cell
      !~if(chi_ini.ne.0.d0.and.calc%msh%list_cell(i)%w%chi.eq.0.d0)then
      !~  calc%msh%list_cell(i)%w%vprim%v(1)=rf(i)
      !~  call prim2bal(calc%msh%list_cell(i)%w)
      !~  !if(rf(i).eq.0.d0)then
      !~  !write(*,'(i5,5e13.5)')i,calc%msh%list_cell(i)%center%x,calc%msh%list_cell(i)%center%y,&
      !~  !calc%msh%list_cell(i)%w%vprim%v(1),calc%msh%list_cell(i)%w%vbal%v(5)
      !~     !stop
      !~     !endif
      !~        !calc%msh%list_cell(i)%w%vprim%v(4)=rf(i)
      !~        !if(i==520)call display(calc%msh%list_cell(i))
      !~        !if(i== 88)call display(calc%msh%list_cell(i))
      !~endif

    END DO

    deallocate(rf)
  
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE u_penalisation
!DOCFIN

  MODULE num_typ
!=========================== DOCUMENTATION ============================= 
!DOCDEBm*    NUM/num_typ  *
!
!    NOM
! num_typ
!    DESCRIPTION  
!*
! Descrition des types de structures NUMerique
!
! Description of NUMeric structure types
!*
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo
  IMPLICIT NONE
!=========================== DEBUT DU CODE EXECUTABLE ==================
!----- Debut Type ---------------------------------------------------------
  TYPE calcul
      real(kind=kind(0.d0))            :: tmin,tmax         ! borne en temps du calcul / time bounds of the calculation
      real(kind=kind(0.d0))            :: dt                ! pas de temps courant / current time step
      real(kind=kind(0.d0))            :: pdtp              ! pas de temps precedent / previous time step
      real(kind=kind(0.d0))            :: cfl               ! cfl 
      real(kind=kind(0.d0))            :: vmax              ! vitesse d onde maximale observee sur le calcul / maximum wave speed observed in the calculation
      integer                          :: isauv, istart     ! type de sauvegarde, indicateur de reprise / type of saving, restart indicator
      integer                          :: ipas              ! numero du pas de temps courant / current time step number
      integer                          :: iordre_t          ! ordre de la methode en temps / order of the time method
      integer                          :: iordre_e          ! ordre de la methode en espace / order of the space method
      integer                          :: imeth_int_temps   ! methode  integration en temps 1/rk 2/adams / method of time integration 1/rk 2/adams
      type(point),dimension(1:20)      :: point_sondes      ! points ou mettre une sonde /  points where to put a probe
      integer                          :: nb_sondes         ! nombre de sondes / number of probes
      integer,dimension(1:10)          :: num_point_min
      type(mesh)                       :: msh               ! maillage / mesh
      integer                          :: ityp_flux =0      ! type du flux numerique : =0 --> rusanov    =1 --> godunov
      integer                          :: ilimiteur=0       ! type de limiteur  0: barth , 1: cartesien          
      integer                          :: nb_bloc=0         ! Nombre de blocs du domaine / number of blocks in the domain
      integer                          :: nbds=1            ! Nombre de domaines souhaites / number of desired domains
      integer                          :: nrma=0            ! Niveau de rafinement maximal / maximum refinement level
      integer                          :: sera=0            ! 
      real(kind=kind(0.d0))            :: vcde=0.002d0      ! Valeur du critere de deraffinement / Value of the derefinement criterion
      real(kind=kind(0.d0))            :: vcra=0.02d0       ! Valeur du critere de raffinement / Value of the refinement criterion
      type(bloc),pointer,dimension(:)  :: list_bloc => null()   !  liste des blocs / list of blocks
      integer                          :: nb_sol = 0            ! Nombre de solides <nb_sol_max / Number of solids <nb_sol_max
      type(solide), dimension(nb_sol_max) :: list_sol           ! Liste de solides / List of solids
  END TYPE calcul
!----- Fin Type ----------------------------------------------------------
!===========================   FIN DU MODULE   =========================
  END MODULE num_typ
!DOCFIN

 SUBROUTINE rk2(calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/rk2  *
!
!    NOM
!   rk2(calc)
!    DESCRIPTION  
!*
! Integration en temps, par la methode de Runge-Kutta d ordre 1 ou 2 des bilans des flux.
!
! Integration in time, by the Runge-Kutta method of order 1 or 2 of flux balances.
!*
! 
!    ENTREES / INPUT
!   calc : objet calcul / calculation object
!    SORTIES / OUTPUT
!   calc : objet calcul mis a jour / updated calculation object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  use num ,only:  dtloc, synchro_mpi, u_penalisation,display,calc_flux, calc_source,synchro_w,sharp
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul),intent(inout) :: calc !! Objet calcul / Calcul object
  
  integer                    :: i,nitmax
  real(kind=kind(0.d0))      :: pm,e,vol
  integer                    :: lev,ic1,ic2

!=========================== DEBUT DU CODE EXECUTABLE ==================

! level: niveau de raffinement a considerer. Ici lev=grand.
  lev=1000
  
! Temps courant  
  tc=calc%tmin
  
! Nbre de pas de temps max  
  nitmax=100000

! Boucle en temps
  DO WHILE (tc.lt.calc%tmax)

! Determination du pas de temps du calcul
      CALL dtloc(calc)

! Ajustement du pas de temps si necessaire  au dernier pas de temps
      IF (tc+calc%dt.gt.calc%tmax) calc%dt=calc%tmax-tc
 
! Synchronisation du pas de temps et des cellules aux frontieres du domaine
      CALL synchro_mpi(calc)

! Calcul des gradients si necessaire
      IF (calc%iordre_e.eq.2) then
          CALL gradprim(calc%msh)
          SELECT CASE (calc%ilimiteur)
              CASE (0)   ! barth
                  CALL gradlim(calc%msh)
              CASE (1)   ! cartesien
                  CALL gradlimxy(calc%msh)
          END SELECT
          CALL synchro_w(calc)  
      END IF
  
! Calcul de l entropie a l instant t 
      DO i=1,calc%msh%nb_cell
          CALL entropie(calc%msh%list_cell(i)%w,calc%msh%list_cell(i)%w%enti)
      END DO

!------- Initialisation du stockage des flux et sources
      DO i=1,calc%msh%nb_cell
          calc%msh%list_cell(i)%balance%v=0.d0
      END DO

!------- Calcul des flux aux faces (et eventuellement stockage)
      CALL calc_flux(calc,lev)

!------- Calcul des termes source (et eventuellement stockage)
      CALL calc_source(calc,lev)

      tc=tc+calc%dt
      calc%ipas=calc%ipas+1
          
      IF (calc%msh%numdom.eq.1) write( *,1000) calc%ipas,tc,calc%dt,calc%vmax 
1000  format(' Ipas: ',i7,' T=',e12.5,' dt=',e12.5,' vmax=',e12.5)

! Mise a jour des variables conservatives
      pm=0.d0     
      DO i=1,calc%msh%nb_cell
          vol=calc%msh%list_cell(i)%vol
          calc%msh%list_cell(i)%w%vbal%v=calc%msh%list_cell(i)%w%vbal%v   & 
          - calc%dt/calc%iordre_t/vol * calc%msh%list_cell(i)%balance%v   ! point milieu
          CALL bal2prim(calc%msh%list_cell(i)%w)
          IF (dabs(calc%dt/vol * calc%msh%list_cell(i)%balance%v(5)).gt.pm& !!!!!! PEUT-ON LE METTRE AILLEURS ?
           .and. (imodel_phy.eq.2)) pm=dabs(calc%dt/vol * calc%msh%list_cell(i)%balance%v(5))
      END DO

if(imodel_phy.eq.1)then
    calc%dt=calc%dt/calc%iordre_t
    call friction(calc)
    calc%dt=calc%dt*calc%iordre_t
endif

! Correction par le point milieu ou heun si ordre 2 en temps
      IF (calc%iordre_t.eq.2) THEN
          IF (calc%iordre_e.eq.2) THEN
              CALL synchro_w(calc)
              CALL gradprim(calc%msh)  
              SELECT CASE(calc%ilimiteur)
                  CASE(0)   ! barth
                      CALL gradlim(calc%msh)
                  CASE(1)   ! cartesien
                      CALL gradlimxy(calc%msh)
              END SELECT
              CALL synchro_w(calc)  
          END IF

! On revient en arriere d un demi pas de temps (en variables conservatives)
          DO i=1,calc%msh%nb_cell
              calc%msh%list_cell(i)%balance%v=-0.5d0*calc%msh%list_cell(i)%balance%v 
              IF (ive_phy.ne.0) calc%msh%list_cell(i)%balance%v(ive_phy)=0.d0 
          END DO
              
!------- Calcul des flux aux faces (et eventuellement stockage)
          CALL calc_flux(calc,lev)
  
!------- Calcul des termes source (et eventuellement stockage)
          CALL calc_source(calc,lev)
   
          pm=0.d0     
          DO i=1,calc%msh%nb_cell
              vol=calc%msh%list_cell(i)%vol
              calc%msh%list_cell(i)%w%vbal%v=calc%msh%list_cell(i)%w%vbal%v & 
              - calc%dt/vol * calc%msh%list_cell(i)%balance%v
              CALL bal2prim(calc%msh%list_cell(i)%w)
              IF (dabs(calc%dt/vol * calc%msh%list_cell(i)%balance%v(5)).gt.pm&
              .and. imodel_phy.eq.2) pm=dabs(calc%dt/vol *&
              calc%msh%list_cell(i)%balance%v(5))
          END DO
        if(imodel_phy.eq.1)then
            calc%dt=calc%dt/calc%iordre_t
            call friction(calc)
            calc%dt=calc%dt*calc%iordre_t
        endif
      END IF

!------- Calcul de l entropie a l instant t+dt 
      DO i=1,calc%msh%nb_cell
          CALL entropie(calc%msh%list_cell(i)%w,e)
          calc%msh%list_cell(i)%w%entf=e
          IF (ive_phy.ne.0) THEN
              calc%msh%list_cell(i)%w%pe=(e-calc%msh%list_cell(i)%w%enti)/calc%dt +&
                                         calc%msh%list_cell(i)%balance%v(ive_phy)/calc%msh%list_cell(i)%vol
              calc%msh%list_cell(i)%w%vprim%v(ive_phy)=calc%msh%list_cell(i)%w%pe
          END IF
      END DO
! dans le cas de saint venant determination de la shoreline et calcul de la friction
if(imodel_phy.eq.1)then
      DO i=1,calc%msh%nb_cell
          calc%msh%list_cell(i)%w%chi=0.d0
      END DO
      DO i=1,calc%msh%nb_face
          ic1=calc%msh%list_face(i)%ic1
          ic2=calc%msh%list_face(i)%ic2
          if(ic2.gt.0)then
              if(calc%msh%list_cell(ic1)%w%vprim%v(1).gt.hzero_phy.and.&
                 calc%msh%list_cell(ic2)%w%vprim%v(1).lt.hzero_phy)calc%msh%list_cell(ic1)%w%chi=1.d0
              if(calc%msh%list_cell(ic1)%w%vprim%v(1).lt.hzero_phy.and.&
                 calc%msh%list_cell(ic2)%w%vprim%v(1).gt.hzero_phy)calc%msh%list_cell(ic2)%w%chi=1.d0
               if(calc%msh%list_cell(ic1)%w%vprim%v(1).gt.hzero_phy.and.&
                 calc%msh%list_cell(ic2)%w%vprim%v(1).lt.hzero_phy)calc%msh%list_cell(ic2)%w%chi=1.d0
              if(calc%msh%list_cell(ic1)%w%vprim%v(1).lt.hzero_phy.and.&
                 calc%msh%list_cell(ic2)%w%vprim%v(1).gt.hzero_phy)calc%msh%list_cell(ic1)%w%chi=1.d0
         endif
      END DO
      !call friction(calc)
 endif

! Compression de l interface
      IF (imodel_phy.eq.2.and.sharp_phy.ne.0.d0) CALL sharp(calc,pm)

! Penalisation si obstacle
      IF (calc%nb_sol .NE. 0) CALL u_penalisation(calc)
! Verification conservation
      !call  info_cons(calc)

  END DO
  !if(calc%msh%numdom.eq.1.and.calc%nb_sol .NE. 0)write(13,'(7e13.5)')tc,calc%list_sol(1)%xg%v
  CALL synchro_w(calc)
  !call display(calc%msh)

!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE RK2
!DOCFIN

 SUBROUTINE read_mame(calc,icode,iarg)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_mame *
!
!    NOM
! read_mame(calc,icode,iarg)
!    DESCRIPTION  
!*
! Lecture du Bloc MAME du fichier de donnees *.inp
! Reading the MAME block from the *.inp data file
!*
! 
!    ENTREES / INPUT
!    calc        : objet calcul / calculation object
!    icode,iarg  : 1,0/ tube a choc / shock tube
!                  1,1/ rectangle 2D / rectangle 2D
!                  1,2/ cube 3D / cube 3D
!                  2,*/ Maillage au format gmsh / Mesh in gmsh format
!
!    SORTIES / OUTPUT
!    calc%msh    : maillage / mesh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  use uti, only: mame2bloc,read_gmsh
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul), intent(inout)        :: calc !! Objet calcul / Calcul object
  integer, intent(in)                :: icode,iarg !! Code, argument
  
  integer                            :: nx,ny,nz
  real(kind=kind(0.d0))              :: xmin,xmax,ymin,ymax,zmin,zmax
  character(20)                      :: fichmsh
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(*,*)
  write(*,*)achar(27)//'[34m================================================'
  write(*,*)'Reading Master mesh parameters: block MAME'
  write(*,*)'================================================'//achar(27)//'[0m'
  write(*,*)
  
nx=1;ny=1;nz=1

  SELECT CASE (icode)
      CASE (1) ! Creation d un maillage par CERF

          SELECT CASE (iarg)
              CASE (0)
                  write(*,*) 'Master Mesh creation: 1D case'
                  read(33,*) xmin,xmax
                  read(33,*)nx
                  calc%msh%ndim=1
                  ymin=-(xmax-xmin)*0.5d0/nx
                  ymax= (xmax-xmin)*0.5d0/nx
                  zmin=-(xmax-xmin)*0.5d0/nx
                  zmax= (xmax-xmin)*0.5d0/nx

              CASE (1)
                  write(*,*) 'Master Mesh creation: 2D case'
                  read(33,*) xmin,xmax,ymin,ymax
                  read(33,*)nx,ny
                  calc%msh%ndim=2
                  zmin=-min((xmax-xmin)*0.5d0/nx,(ymax-ymin)*0.5d0/ny)
                  zmax= min((xmax-xmin)*0.5d0/nx,(ymax-ymin)*0.5d0/ny)
            
              CASE (2)
                  write(*,*) 'Master Mesh creation: 3D case'
                  read(33,*) xmin,xmax,ymin,ymax,zmin,zmax
                  calc%msh%ndim=3
                  read(33,*)nx,ny,nz
          END SELECT
          calc%nb_bloc=nx*ny*nz
          allocate(calc%list_bloc(calc%nb_bloc))
          call mame2bloc(xmin,xmax,ymin,ymax,zmin,zmax,nx,ny,nz,calc%list_bloc,calc%msh%ndim)
!-----------------------------------------------------
      CASE (2) ! Lecture  du maillage sur fichier au format gmsh V2.2
          write(*,*)'MAME-Info reading GMSH mesh '
          read(33,'(a)')fichmsh
          write(*,*)
          write( *,1000)fichmsh
1000 format(' MAME-Info Reading the GMSH file: ',a20)
          calc%msh%ndim=iarg
          CALL read_gmsh  (fichmsh,calc) !----- Lecture du maillage maitre complet
          calc%msh%nb_dom=1

      CASE DEFAULT
         call print_err('READ_MAME', 'Master Mesh definition unforeseen case')

  END SELECT



!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_mame
!DOCFIN

 SUBROUTINE empty_mesh(msh,nbd,numd)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/empty_mesh  *
!
!    NOM
! empty_mesh(msh,nbd,numd)
!
!    DESCRIPTION 
!*
! Vide un maillage et desalloue les pointeurs
! alloue les listes d echange connaissant le nombre de domaines nbd
! recommande avant l utilisation et le numero du domaine numd
!
! Empties a mesh and deallocates pointers, allocates exchange lists knowing the number of nbd domains.
! Recommended before use and domain number numd
!*
! 
!    ENTREES / INPUT
!    msh : maillage / mesh
!    nbd : nombre de domaines / domain number
!    numd : numero du domaine a traiter / number of the domain to be traited
!
!    SORTIES / OUTPUT
!    msh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(mesh), intent(inout) :: msh  !! Maillage / Mesh
  integer,intent(in)        :: nbd  !! Nombre de domaines / Domain number
  integer,intent(in)        :: numd !! Numero du domaine a traiter / Number of the domain to be traited
  
  integer                   :: i
!=========================== DEBUT DU CODE EXECUTABLE ==================
  IF (associated(msh%list_vertex)) THEN
      deallocate(msh%list_vertex)
      nullify(msh%list_vertex)
  END IF
  IF (associated(msh%list_cell)) THEN
      deallocate(msh%list_cell)
      nullify(msh%list_cell)
  END IF
  IF (associated(msh%list_face)) THEN
      deallocate(msh%list_face)
      nullify(msh%list_face)
  END IF

  IF (associated(msh%list_send)) THEN
      DO i=1,msh%nb_dom
          IF (associated(msh%list_send(i)%L)) THEN
              deallocate(msh%list_send(i)%L)
              nullify(msh%list_send(i)%L)
          END IF
      END DO
     deallocate(msh%list_send)
     nullify(msh%list_send)
  END IF

  IF (associated(msh%list_recv)) then
      DO i=1,msh%nb_dom
          IF (associated(msh%list_recv(i)%L)) THEN
              deallocate(msh%list_recv(i)%L)
              nullify(msh%list_recv(i)%L)
          END IF
      END DO
     deallocate(msh%list_recv)
     nullify(msh%list_recv)
  END IF

! Fin des liberations

  msh%numdom=numd
  msh%nb_dom=nbd

  IF (nbd.ne.0) THEN    ! reallocation si le nbre de dom different de 0
      msh%nb_cell=0
      msh%nb_vertex=0
      msh%nb_face=0
      allocate(msh%list_send(nbd))
      DO i=1,msh%nb_dom
          nullify(msh%list_send(i)%L)
      END DO
      allocate(msh%list_recv(nbd))
      DO i=1,msh%nb_dom
          nullify(msh%list_recv(i)%L)
      END DO
  END IF

!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE EMPTY_MESH
!DOCFIN

 SUBROUTINE read_cond(lst_bloc,icode,iarg,nb_bloc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_cond *
!
!    NOM
! read_cond(calc,icode,iarg,nb_bloc)
!    DESCRIPTION  
!*
! Lecture du Bloc COND du fichier de donnees .inp
! Reading the COND block of the .inp data file
!*
! 
!    ENTREES / INPUT
!    lst_bloc    : liste des blocs / list of blocks
!    icode  : 0/ tube a choc / shock tube
!             1/ Cas 2D / 2D case
!             2/ Cas 3D / 3D case
!             3/ condition par zones (gmsh) / condition by zones (gmsh)
!    iarg    : nombre de zones pour le cas 3 / number of zones for case 3
!    nb_bloc : nombre de blocs / number of blocks

!    SORTIES / OUTPUT
!    msh    : maillage / mesh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  type(bloc), pointer, dimension(:), intent(inout) :: lst_bloc !! Liste des blocs / Block list
  integer, intent(inout)                           :: icode, iarg !! Code, argument
  integer, intent(inout)                           :: nb_bloc !! nombre de blocs / number of blocks
  
  integer                                   :: i,nzon,nbf,fctnum,icl,kkk,k
  integer                                   :: ityp,iz,izone
  real(kind=kind(0.d0)), dimension(nvarmax) :: val
!=========================== DEBUT DU CODE EXECUTABLE ==================
!-------  Initialisations
  nzon=0
  write(*,*)
  write(*,*)achar(27)//'[34m================================================'
  write(*,*)'Reading boundary condition: block COND'
  write(*,*)'================================================'//achar(27)//'[0m'
  write(*,*)
         
  SELECT CASE (icode)
!=====================================================================
! Conditions pour le tube a choc
!=====================================================================
      CASE (0)
          write(*,*)'COND-Info Boundary condition for shock tube already defined'
          DO i=1,nb_bloc
              if(lst_bloc(i)%cl(1).eq.-111) lst_bloc(i)%cl(1)=-101
              if(lst_bloc(i)%cl(2).eq.-222) lst_bloc(i)%cl(2)=-102
          END DO

!=====================================================================
! Conditions communes pour la marche et le cube
!=====================================================================
      CASE (1,2)
          IF (icode.eq.1) then
             write(*,*)'COND-Info 2D Conditions definition'
             kkk=4
           endif
          IF (icode.eq.2) then
              write(*,*)'COND-Info 3D Conditions definition'
              kkk=6
          endif

          ! condition en xmin, xmax, ymin, ymax (zmin, zmax)
          do k=1,kkk
              phy_state(k)%vprim%v=0.d0
              phy_state(k)%vbal%v =0.d0
              phy_state(k)%gprim(1)%v =0.d0
              phy_state(k)%gprim(2)%v =0.d0
              phy_state(k)%gprim(3)%v =0.d0
              val =0.d0
              read(33,*)ityp
              SELECT CASE (ityp)
                  CASE (0)
                      icl= 0
                  CASE (1)
                      icl=-1
                  CASE (2)
                      icl=-100-k
                      read(33,*)(val(i),i=1,nvar)
                      phy_state(k)%vprim%v=val
                      CALL Prim2Bal(phy_state(k))
                  CASE (3)
                      read(33,*)fctnum
                      icl=-(10000+fctnum)
                  !~CASE (6)
                  !~    icl=-2001 !condition de type periodique
                  CASE (4)
                      icl=-200-k
                      read(33,*)(val(i),i=1,nvar)
                      phy_state(k)%vbal%v=val
                      CALL bal2prim(phy_state(k))
                  CASE (999)
                      icl=-999
                  CASE DEFAULT
                  call print_err('READ_COND','unknown kind of boundary condition')
              END SELECT
            
              nbf=0
              DO i=1,nb_bloc
                  if(lst_bloc(i)%cl(k).eq.-111*k) then
                      lst_bloc(i)%cl(k)=icl
                      nbf=nbf+1
                  endif
              END DO
              if(k.eq.1)write( *,1011)icl,nbf
              if(k.eq.2)write( *,1012)icl,nbf
              if(k.eq.3)write( *,1013)icl,nbf
              if(k.eq.4)write( *,1014)icl,nbf
              if(k.eq.5)write( *,1015)icl,nbf
              if(k.eq.6)write( *,1016)icl,nbf
          enddo
1011 format(' COND-Info Condition',i8,' is affected to ',I8,' faces at Xmin')
1012 format(' COND-Info Condition',i8,' is affected to ',I8,' faces at Xmax')
1013 format(' COND-Info Condition',i8,' is affected to ',I8,' faces at Ymin')
1014 format(' COND-Info Condition',i8,' is affected to ',I8,' faces at Ymax')
1015 format(' COND-Info Condition',i8,' is affected to ',I8,' faces at Zmin')
1016 format(' COND-Info Condition',i8,' is affected to ',I8,' faces at Zmax')
         
         
!=====================================================================
! Conditions definis par zone au format GMSH
!=====================================================================
      CASE (3)
          write(*,*)'COND-Info Conditions defined using GMSH'
          DO iz=1,iarg
              nbf=0
              read(33,*)izone,ityp  !numero de zone, type de condition aux limites
              SELECT CASE (ityp)
                  CASE (0)
                      icl= 0
                  CASE (1)
                      icl=-1
                  CASE (2)
                      nzon=nzon+1
                      icl=-100-nzon
                      read(33,*)(val(i),i=1,nvar)
                      phy_state(nzon)%vprim%v=val
                      CALL Prim2Bal(phy_state(nzon))
                  CASE (3)
                      read(33,*)fctnum
                      icl=-(10000+fctnum)
                  CASE (4)
                      nzon=nzon+1
                      icl=-200-nzon
                      read(33,*)(val(i),i=1,nvar)
                      phy_state(nzon)%vbal%v=val
                      CALL bal2prim(phy_state(nzon))
                  CASE (999)
                      icl=-999
                  CASE DEFAULT
                     call print_err('READ_COND','unknown kind of boundary condition')
                     STOP
              END SELECT
              
              nbf=0
              DO i=1,nb_bloc
                do k=1,6
                  if(lst_bloc(i)%cl(k).eq.-izone) then
                      lst_bloc(i)%cl(k)=icl
                      nbf=nbf+1
                  endif
                enddo
              END DO

              write( *,1021)izone,icl,nbf
1021 format(' COND-Info Zone',i2,' affectation of the condition',i8,' to ',I8,' faces')
          END DO
      CASE DEFAULT
         call print_err('READ_COND','unknown code')

  END SELECT       
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_cond
!DOCFIN

 SUBROUTINE copy_sol(cin,cout)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/copy_sol  *
!
!    NOM
!   copy_sol(cin,cout)  
!    DESCRIPTION  
!*
! Copie des objets solides  
!
! Copy solid objects  
!*
! 
! 
!    ENTREES / INPUT
!   cin : objet calcul initial / initial calcul object
!
!    SORTIES / OUTPUT
!   cout : objet calcul copie / copied calcul object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul),intent(inout) :: cin,cout !! Objets calcul en entree, sortie / calcul object input and output
  integer                    :: i
!=========================== DEBUT DU CODE EXECUTABLE ==================
! calcul des termes sources (physiques et ordre 2 non conservatif)
      cout%nb_sol = cin%nb_sol
      call empty_sol(cout%list_sol)

      do i=1,cin%nb_sol
        cout%list_sol(i)%id     =cin%list_sol(i)%id
        cout%list_sol(i)%imv    =cin%list_sol(i)%imv
        cout%list_sol(i)%nb_vert=cin%list_sol(i)%nb_vert
        cout%list_sol(i)%nb_face=cin%list_sol(i)%nb_face
        cout%list_sol(i)%xmin_s =cin%list_sol(i)%xmin_s
        cout%list_sol(i)%xmax_s =cin%list_sol(i)%xmax_s
        cout%list_sol(i)%ymin_s =cin%list_sol(i)%ymin_s
        cout%list_sol(i)%ymax_s =cin%list_sol(i)%ymax_s
        cout%list_sol(i)%zmin_s =cin%list_sol(i)%zmin_s
        cout%list_sol(i)%zmax_s =cin%list_sol(i)%zmax_s
        cout%list_sol(i)%rho    =cin%list_sol(i)%rho
        cout%list_sol(i)%xg     =cin%list_sol(i)%xg
        cout%list_sol(i)%theta  =cin%list_sol(i)%theta
        allocate(cout%list_sol(i)%list_facette(cin%list_sol(i)%nb_face))
        cout%list_sol(i)%list_facette  =cin%list_sol(i)%list_facette
        allocate(cout%list_sol(i)%list_vertex(cin%list_sol(i)%nb_vert))
        cout%list_sol(i)%list_vertex  =cin%list_sol(i)%list_vertex
        cout%list_sol(i)%nb_cell= 0

!      integer, dimension(:), allocatable        :: list_cells
     enddo  
  
  
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE copy_sol
!DOCFIN

  MODULE geo
!=========================== DOCUMENTATION ============================= 
!DOCDEBm*    GEO/geo  *
!
!    NOM
! geo
!    DESCRIPTION  
!*
! Interface des routines du Module GEOmetrique
!
! Interface of routines from GEOmetric Module 
!*
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
!=========================== DEBUT DU CODE EXECUTABLE ==================

!----- Debut Interface -------------------------------------------------
 interface display
     subroutine pointaffiche(p)
      use geo_typ
        type(point),intent(in) :: p 
      end subroutine pointaffiche
     subroutine faceaffiche(e)
      use geo_typ
        type(face),intent(in)  :: e 
      end subroutine faceaffiche
     subroutine cellaffiche(c)
      use geo_typ
        type(cell),intent(in)  :: c 
      end subroutine cellaffiche
     subroutine mshaffiche(msh)
      use geo_typ
        type(mesh),intent(in) :: msh 
      end subroutine mshaffiche
      subroutine list_i_affiche(L)
        use geo_typ
        type(list_int),intent(in) :: L
      end subroutine list_i_affiche
      subroutine blocaffiche(b)
        use geo_typ
        type(bloc),intent(in) :: b
      end subroutine blocaffiche
      
      subroutine solideaffiche(s)
        use geo_typ
        type(solide),intent(in) :: s
      end subroutine solideaffiche
      
      subroutine waffiche(w)
        use phy_typ
        type(state),intent(in) :: w 
      end subroutine waffiche
 end interface display
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
  INTERFACE
       SUBROUTINE empty_mesh(msh,nbd,numd)
         use geo_typ
         type(mesh), intent(inout) :: msh
         integer,intent(in)        :: nbd,numd
       END SUBROUTINE empty_mesh
  END INTERFACE
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
 interface
     subroutine gradprim(msh)
       use geo_typ
       type(mesh), intent(inout) :: msh 
     end subroutine gradprim
 end interface
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
 interface
   subroutine gradlim(msh)
     use geo_typ
     type(mesh), intent(inout) :: msh 
   end subroutine gradlim
 end interface
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
 interface
   subroutine gradlimxy(msh)
     use geo_typ
     type(mesh), intent(inout) :: msh 
   end subroutine gradlimxy
 end interface
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
 interface
      SUBROUTINE MESH1D  (bl,msh,ib,nb_dom,blv,interdom)
      use geo_typ
       type(bloc),intent(in)            :: bl, blv(6)
       integer,intent(in)               :: ib,nb_dom     
       type(mesh), intent(inout)        :: msh 
        type(list_int),dimension(:), intent(inout) :: interdom
         end subroutine mesh1d
 end interface
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
 interface
      SUBROUTINE MESH2D  (bl,msh,ib,nb_dom,blv,interdom)
      use geo_typ
       type(bloc),intent(in)            :: bl, blv(6)
       integer,intent(in)               :: ib,nb_dom     
       type(mesh), intent(inout)        :: msh 
        type(list_int),dimension(:), intent(inout) :: interdom
         end subroutine mesh2d
 end interface
!----- Fin Interface ---------------------------------------------------
!~
!----- Debut Interface -------------------------------------------------
 interface
      SUBROUTINE MESH3D  (bl,msh,ib,nb_dom,blv,interdom)
      use geo_typ
       type(bloc),intent(in)            :: bl, blv(6)
       integer,intent(in)               :: ib,nb_dom     
       type(mesh), intent(inout)        :: msh 
        type(list_int),dimension(:), intent(inout) :: interdom
         end subroutine mesh3d
 end interface
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
 interface 
 FUNCTION pni(bl,vi,vj,vk,i2d)
  use geo_typ
  IMPLICIT NONE
  integer,intent(in) :: i2d
  type(point) :: pni
  type(bloc),intent(in) :: bl
  real(kind=kind(0.d0)),intent(in)  :: vi,vj,vk
 END FUNCTION pni
 end interface
!----- Fin Interface ---------------------------------------------------
 
!----- Debut Interface -------------------------------------------------
 interface
      SUBROUTINE psr(interdom,nb_dom,idomI,idomJ,ibI,ibJ,ipos_send,ipos_recv)
      use geo_typ
        integer, intent(in)     ::   nb_dom,idomI,idomJ,ibI,ibJ
        integer, intent(out)    ::   ipos_send,ipos_recv
          type(list_int),dimension(:), intent(in):: interdom
      END SUBROUTINE psr
 end interface
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
 interface 
    subroutine triangle(x1,y1,z1,x2,y2,z2,x3,y3,z3,xn,yn,zn,surf,xm,ym,zm)
            real(kind=kind(0.d0))   :: x1,y1,z1,x2,y2,z2,x3,y3,z3,xn,yn,zn,surf,xm,ym,zm
    end subroutine triangle
 end interface
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
 interface 
  real*8 FUNCTION volbloc(bl)
  use geo_typ
  type(bloc),intent(in) :: bl
 END FUNCTION volbloc
 end interface
!----- Fin Interface ---------------------------------------------------

!----- Debut Interface -------------------------------------------------
 interface 
    real*8 FUNCTION volcel(bl,vi,vj,vk,i2d)
      use geo_typ
      integer,intent(in) :: i2d
      type(bloc),intent(in) :: bl
      real(kind=kind(0.d0)),intent(in)  :: vi,vj,vk
    END FUNCTION volcel
 end interface
!----- Fin Interface ---------------------------------------------------
!===========================   FIN DU MODULE   =========================
  END MODULE geo

!DOCFIN

 SUBROUTINE gradlim(msh)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/gradlim.f90  *
!
!    NOM
! gradlim(msh)
!    DESCRIPTION  
!*
! Limite le gradient des variables primitives par la methode de Barth
! Suppose donc que le gradient a deja ete calcule (appel a gradprim)
! Attention: le gradient des cellules frontiere n est pas limite
! Il faut donc un appel a MPI pour mettre a jours TOUS les limiteurs
!
! Limits the gradient of primitive variables using Barth s method
! Therefore assumes that the gradient has already been calculated (call gradprim)
! Warning: the gradient of border cells is not limited
! A call to MPI is therefore required to update ALL the limiters
!*
!
!    ENTREES / INPUT
!    msh : maillage / mesh
!
!    SORTIES / OUTPUT
!    msh : maillage / mesh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(mesh), intent(inout)                        :: msh  !! Maillage / Mesh
  
  real(kind=kind(0.d0)),dimension(:,:,:),allocatable :: dlim ! tableau des limiteurs de pente dans chaque cellule
  integer                                          :: i,iv,ic1,ic2,idom1,idom2,idom,ii,j
  real(kind=kind(0.d0)),dimension(nvarmax)         :: odg
  real(kind=kind(0.d0))                            :: g,r,dlim2
  type(vect_3)                                     :: vcf
  type(state)                                      :: w1
  type(state)                                      :: w2

!=========================== DEBUT DU CODE EXECUTABLE ==================

  allocate(dlim(3,nvar,msh%nb_cell)) ! valeur min, valeur max, limiteur

  do i=1, msh%nb_cell
    do j=1, nvar
       dlim(1,j,i)=1.d20  !valeur min sur la cellule i de la variable j
       dlim(2,j,i)=-1.d20 !valeur max sur la cellule i de la variable j
       dlim(3,j,i)=1.d0   !limiteur  de la variable j de la cellule i
    enddo
  enddo

! vecteur des ordres de grandeur (permet d avoir un limiteur adimensionne)
  DO iv=1,nvar
     odg(iv)=1.d0
  END DO
  odg(5)=1.d5
!-------------------------------------------------------------------------
! Determination du min et du max entourant une cellule
!-------------------------------------------------------------------------
! boucle sur les faces du maillage
  DO i=1,msh%nb_face
    ic1=msh%list_face(i)%ic1
    ic2=msh%list_face(i)%ic2
    w1=msh%list_cell(ic1)%w
    IF (ic2.gt.0) THEN
        w2=msh%list_cell(ic2)%w
    ELSE
        CALL wext(w1,w2,msh%list_face(i)%vnorm,ic2, &
                  msh%list_face(i)%center%x, msh%list_face(i)%center%y, msh%list_face(i)%center%z, &
                  msh%list_cell(ic1)%center%x, msh%list_cell(ic1)%center%y, msh%list_cell(ic1)%center%z )
    END IF
    DO iv=1,nvar
      if(w2%vprim%v(iv).lt.dlim(1,iv,ic1))dlim(1,iv,ic1)=w2%vprim%v(iv)
      if(w2%vprim%v(iv).gt.dlim(2,iv,ic1))dlim(2,iv,ic1)=w2%vprim%v(iv)         
      IF (ic2.gt.0)then
        if(w1%vprim%v(iv).lt.dlim(1,iv,ic2))dlim(1,iv,ic2)=w1%vprim%v(iv)
        if(w1%vprim%v(iv).gt.dlim(2,iv,ic2))dlim(2,iv,ic2)=w1%vprim%v(iv)
      endif         
    END DO
  END DO
  DO i=1,msh%nb_cell
    w1=msh%list_cell(i)%w
    DO iv=1,nvar
      if(w1%vprim%v(iv).lt.dlim(1,iv,i))dlim(1,iv,i)=w1%vprim%v(iv)
      if(w1%vprim%v(iv).gt.dlim(2,iv,i))dlim(2,iv,i)=w1%vprim%v(iv)         
    END DO
  END DO

!-------------------------------------------------------------------------
! calcul du limiteur de pente de Barth-Jespersen
!-------------------------------------------------------------------------
! boucle sur les faces du maillage
  DO i=1,msh%nb_face
      
      ! reperage des voisins
      ic1=msh%list_face(i)%ic1
      ic2=msh%list_face(i)%ic2
      
      w1=msh%list_cell(ic1)%w
      IF (ic2.gt.0) THEN
          w2=msh%list_cell(ic2)%w
      ELSE
          CALL wext(w1,w2,msh%list_face(i)%vnorm,ic2, &
                    msh%list_face(i)%center%x , msh%list_face(i)%center%y , msh%list_face(i)%center%z , &
                    msh%list_cell(ic1)%center%x, msh%list_cell(ic1)%center%y, msh%list_cell(ic1)%center%z )
      END IF

      ! numero de domaine à gauche
      idom1=msh%list_cell(ic1)%idom
      IF (idom1.ne.msh%numdom) THEN
          write(*,*) 'erreur maillage domaine'
          STOP
      END IF
      
      IF (ic2.ne.-999) THEN ! ne pas boucler sur les faces fictives
         
         ! numero de domaine à droite
         idom2=0
         IF (ic2.gt.0) idom2=msh%list_cell(ic2)%idom
         IF (idom2.ne.msh%numdom) idom2=0
             
         ! limitation cellule de gauche
         
         ! determination du vecteur centre de la cellule - centre de la face
         vcf%v(1)=msh%list_face(i)%center%x-msh%list_cell(ic1)%center%x
         vcf%v(2)=msh%list_face(i)%center%y-msh%list_cell(ic1)%center%y
         vcf%v(3)=msh%list_face(i)%center%z-msh%list_cell(ic1)%center%z
         
         DO iv=1,nvar
         
             dlim2=1.d0
             g=w1%gprim(1)%v(iv)*vcf%v(1)+&
               w1%gprim(2)%v(iv)*vcf%v(2)+&
               w1%gprim(3)%v(iv)*vcf%v(3)
 !          if (dabs(g/odg(iv)).gt.1.d-6) then
             r=0.d0
             IF (g.ne.0.d0) THEN   ! moins compliqué et plus stable
                 if(g.gt.0.d0)r=(dlim(2,iv,ic1)-w1%vprim%v(iv))/g
                 if(g.lt.0.d0)r=(dlim(1,iv,ic1)-w1%vprim%v(iv))/g
                 IF (r.lt.0.d0) THEN
                     dlim2=0.d0
                     !write(*,*)'r negatif',ic1,r
                 ELSE IF (r.gt.1.d0) THEN
                     dlim2=1.d0
                     !write(*,*)'r sup a 1',ic1,r
                 ELSE
                     dlim2=r
                 END IF
             ELSE
                 dlim2=1.d0
             END IF
         
             IF (dlim(3,iv,ic1).gt.dlim2) dlim(3,iv,ic1)=dlim2
         END DO
         
         ! limitation cellule de droite
         
         IF (idom2.ne.0) THEN
         
             ! détermination du vecteur centre de la cellule - centre de la face
             vcf%v(1)=msh%list_face(i)%center%x-msh%list_cell(ic2)%center%x
             vcf%v(2)=msh%list_face(i)%center%y-msh%list_cell(ic2)%center%y
             vcf%v(3)=msh%list_face(i)%center%z-msh%list_cell(ic2)%center%z
             
             DO iv=1,nvar
               
                 dlim2=1.d0
               
                 g=w2%gprim(1)%v(iv)*vcf%v(1)+&
                 & w2%gprim(2)%v(iv)*vcf%v(2)+&
                 & w2%gprim(3)%v(iv)*vcf%v(3)
                 r=0.d0            
                 IF (g.ne.0.d0) THEN   ! moins compliqué et plus stable
 !                   if (dabs(g/odg(iv)).gt.1.d-6) then   ! si trop limité
                 if(g.ge.0.d0)r=(dlim(2,iv,ic2)-w2%vprim%v(iv))/g
                 if(g.lt.0.d0)r=(dlim(1,iv,ic2)-w2%vprim%v(iv))/g
                     IF (r.lt.0.d0) THEN
                         dlim2=0.d0
                         !write(*,*)'r negatif',ic2,r
                     ELSE IF (r.gt.1.d0) THEN
                         dlim2=1.d0
                         !write(*,*)'r sup a 1',ic2,r
                     ELSE
                         dlim2=r
                     END IF
                 ELSE
                  dlim2=1.d0
                 END IF
               
                 IF (dlim(3,iv,ic2).gt.dlim2) dlim(3,iv,ic2)=dlim2
               
             END DO
         END IF
      END IF
  END DO


! Mise a jour du gradient dans les cellules
  DO i=1,msh%nb_cell
      idom=msh%list_cell(i)%idom
      IF (idom.eq.msh%numdom) THEN
          DO iv=1,nvar
              DO ii=1,msh%ndim
                  msh%list_cell(i)%w%gprim(ii)%v(iv)=0.9d0*dlim(3,iv,i)*msh%list_cell(i)%w%gprim(ii)%v(iv) ! précaution en plus...
                  if(msh%list_cell(i)%w%chi.ne.0.d0)msh%list_cell(i)%w%gprim(ii)%v(iv)=0.d0
              END DO
          END DO
      END IF
  END DO
            
  deallocate(dlim)
  
  
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE GRADLIM
!DOCFIN

 SUBROUTINE Wext(win,wout,vn,ityp,x,y,z,xm,ym,zm)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/Wext  *
!
!    NOM
! wext(win,wout,vn,ityp)
!    DESCRIPTION  
!*
! Determination des conditions aux limites
! Determining boundary conditions
!*
! 
!    ENTREES / INPUT
! win  : objet de type "state" contenant les variables de la cellule courante 
!      / state object containing the variables of the current cell
! vn   : objet de type "vect_3", normale a la face / normal to the face
! ityp : Type de condition aux limites / Type of boundary condition
!        0 -> On recopie / We copy
!       -1 -> Condition miroir / Mirror condition
! x,y,z : centre de la facette ou la condition est calculee / center of the facet where the condition is calculated
! xm,ym,zm : centre de la cellule de win. / center of the cell of win
!
!    SORTIES / OUTPUT
! wout : objet de type "state" contenant la condition aux limites
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  use phy ,only: prim2bal, fct_cond,phy_state,bal2prim
  IMPLICIT NONE
!.2-----  Declaration
  integer,intent(in)                        :: ityp     !! Type de condition aux limites / Type of boundary condition
  type(state),intent(in)                    :: win      !! objet de type "state" de la cellule courante / state object of the current cell
  type(vect_3),intent(in)                   :: vn       !! normale a la face / normal to the face
  type(state),intent(out)                   :: wout     !! objet de type "state" sur la cellule fictive / state object on the fictitious cell
  real(kind=kind(0.d0)),optional,intent(in) :: x,y,z    !! position du point sur la frontiere / position of point on boundary
  real(kind=kind(0.d0)),optional,intent(in) :: xm,ym,zm !! centre de la cellule courante / centre of current cell 
  
  real(kind=kind(0.d0))                     :: qn,q
  integer                                   :: fctnum,i
  !=========================== DEBUT DU CODE EXECUTABLE ==================

wout%vprim%v=0.d0
wout%vbal%v=0.d0
wout%gprim(1)%v=0.d0
wout%gprim(2)%v=0.d0
wout%gprim(3)%v=0.d0

  SELECT CASE (ityp)
      CASE(0) !  recopie simple
          wout=win

      CASE (-1) ! condition de non-penetration
          wout%vprim=win%vprim
          qn=win%vprim%v(2)*vn%v(1)+win%vprim%v(3)*vn%v(2)+win%vprim%v(4)*vn%v(3)
          wout%vprim%v(2)=win%vprim%v(2)-2.d0*qn*vn%v(1)
          wout%vprim%v(3)=win%vprim%v(3)-2.d0*qn*vn%v(2)
          wout%vprim%v(4)=win%vprim%v(4)-2.d0*qn*vn%v(3)            
          wout%vprim%v(5)=win%vprim%v(5)-2.d0*win%vprim%v(1)*gpes_phy*(y-ym)
          if(imodel_phy.eq.1)then
              wout%vprim%v(4)=0.d0*xm*zm*ym       
              wout%vprim%v(5)=win%vprim%v(5)
          endif
          CALL prim2bal(wout)

      CASE (-2) ! condition d adherence
          wout%vprim=win%vprim
          wout%vprim%v(2)=0.d0
          wout%vprim%v(3)=0.d0
          wout%vprim%v(4)= 0.d0           
          CALL prim2bal(wout)  

        
! conditions imposees: on cherche l etat impose dans le vecteur phy_state

      CASE (-101)
          wout=phy_state(1)  
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(1)%vprim%v(i).ge.1.d20) wout%vprim%v(i)= win%vprim%v(i)
          END DO
          if(imodel_phy.eq.1)wout%vprim%v(5)=win%vprim%v(5)
          CALL prim2bal(wout)

      CASE (-102)
          wout=phy_state(2) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(2)%vprim%v(i).ge.1.d20) wout%vprim%v(i)= win%vprim%v(i)
          END DO
          if(imodel_phy.eq.1)wout%vprim%v(5)=win%vprim%v(5)
          CALL prim2bal(wout)

      CASE (-103)
          wout=phy_state(3) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(3)%vprim%v(i).ge.1.d20) wout%vprim%v(i)= win%vprim%v(i)
          END DO
          if(imodel_phy.eq.1)wout%vprim%v(5)=win%vprim%v(5)
          CALL prim2bal(wout)

      CASE (-104)
          wout=phy_state(4) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(4)%vprim%v(i).ge.1.d20) wout%vprim%v(i)= win%vprim%v(i)
          END DO
          if(imodel_phy.eq.1)wout%vprim%v(5)=win%vprim%v(5)
          CALL prim2bal(wout)

      CASE (-105)
          wout=phy_state(5) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(5)%vprim%v(i).ge.1.d20) wout%vprim%v(i)= win%vprim%v(i)
          END DO
          CALL prim2bal(wout)
      
      CASE (-106)
          wout=phy_state(6) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(6)%vprim%v(i).ge.1.d20) wout%vprim%v(i)= win%vprim%v(i)
          END DO
          CALL prim2bal(wout)
      
      CASE (-107)
          wout=phy_state(7) 
      
      CASE (-108)
          wout=phy_state(8) 
      
      CASE (-109)
          wout=phy_state(9) 
      
      CASE (-110)
          wout=phy_state(10) 
          
      CASE (-201)
          wout=phy_state(1)  
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(1)%vbal%v(i).ge.1.d20) wout%vbal%v(i)= win%vbal%v(i)
          END DO
          if(imodel_phy.eq.1)wout%vprim%v(5)=win%vprim%v(5)
          q=sqrt(phy_state(1)%vbal%v(2)**2+phy_state(1)%vbal%v(3)**2)
         if(imodel_phy.eq.1.and.win%vbal%v(1).le.hzero_phy.and.q.gt.1.d-6) then
           wout%vbal%v(1)=(q**2/gpes_phy)**(1.d0/3.d0)
         endif
          CALL bal2prim(wout)

      CASE (-202)
          wout=phy_state(2) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(2)%vbal%v(i).ge.1.d20) wout%vbal%v(i)= win%vbal%v(i)
          END DO
          if(imodel_phy.eq.1)wout%vprim%v(5)=win%vprim%v(5)
          CALL bal2prim(wout)

      CASE (-203)
          wout=phy_state(3) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(3)%vbal%v(i).ge.1.d20) wout%vbal%v(i)= win%vbal%v(i)
          END DO
          if(imodel_phy.eq.1)wout%vprim%v(5)=win%vprim%v(5)
          CALL bal2prim(wout)

      CASE (-204)
          wout=phy_state(4) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(4)%vbal%v(i).ge.1.d20) wout%vbal%v(i)= win%vbal%v(i)
          END DO
          if(imodel_phy.eq.1)wout%vprim%v(5)=win%vprim%v(5)
          CALL bal2prim(wout)

      CASE (-205)
          wout=phy_state(5) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(5)%vbal%v(i).ge.1.d20) wout%vbal%v(i)= win%vbal%v(i)
          END DO
          CALL bal2prim(wout)
      
      CASE (-206)
          wout=phy_state(6) 
          !on laisse libre les ddls dont phy_state est > 1.d20
          DO i=1,nvar
              IF (phy_state(6)%vbal%v(i).ge.1.d20) wout%vbal%v(i)= win%vbal%v(i)
          END DO
          CALL bal2prim(wout)
      


      CASE (-999) ! frontiere artificielle pour le passage du 3D au 2D, on fait comme un miroir            
          wout%vprim=win%vprim
          qn=win%vprim%v(2)*vn%v(1)+win%vprim%v(3)*vn%v(2)+win%vprim%v(4)*vn%v(3)
          wout%vprim%v(2)=win%vprim%v(2)-2.d0*qn*vn%v(1)
          wout%vprim%v(3)=win%vprim%v(3)-2.d0*qn*vn%v(2)
          wout%vprim%v(4)=win%vprim%v(4)-2.d0*qn*vn%v(3)            
          CALL prim2bal(wout)

      CASE (-998) ! frontiere artificielle pour le passage du 3D au AXIsymetrique, on fait tourner la quantite de mouvement             
          wout=win
          wout%vprim%v(2)=win%vprim%v(2)*(vn%v(3)**2-vn%v(1)**2)
          wout%vprim%v(4)=-2.d0*win%vprim%v(2)*vn%v(3)*vn%v(1)           
          CALL prim2bal(wout)

      CASE (-20000:-10000) ! Cas ou la condition aux limites est definie par une fonction utilisateur
          wout=win
          fctnum=-10000-ityp
          CALL fct_cond(win%vprim,wout%vprim,fctnum,x,y,z,vn)
          CALL prim2bal(wout)
           
      CASE DEFAULT
          write(*,*)ityp 
          call print_err('WEXT','Kind of boundary condition not defined')
        
  END SELECT


!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE Wext
!DOCFIN

 SUBROUTINE raycasting(sol,x,y,z,chi)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/raycasting *
!
!    NOM
! raycasting(sol,x,y,z,chi)
!
!    DESCRIPTION  
!*
!  Algorithme de raycasting permettant de determiner si la cellule courante est dans le "solide" ou non.
!  Raycasting algorithm to determine whether the current cell is in the ‘solid’ or not.
!*
! 
!    ENTREES / INPUT
!    sol   : solide / solid
!    x,y,z : coordonnees du point a tester / coordinates of the point to be tested
!
!    SORTIES / OUTPUT
!    chi   : indicatrice de presence (0: non, 1: oui) / presence indicator (0: no, 1: yes)
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
!.2-----  Declaration
  real(kind=kind(0.d0)), intent(in)  :: x,y,z 
!! coordonnees du centre de la cellule a tester / coordinates of the centre of the cell to be tested
  type(solide), intent(inout)        :: sol !! Objet solide / Solid object
  real(kind=kind(0.d0)), intent(out) :: chi !! Indicatrice de presence (0: non, 1: oui) / Presence indicator (0: no, 1: yes)
  
  integer                            :: k,ind
  real(kind=kind(0.d0))              :: xn
  
  type(point)                        :: ori,v0,v1,v2
  integer                            :: cpt,intersect
  type(vect_3)                       :: dir
!=========================== DEBUT DU CODE EXECUTABLE ==================

  ind=0

  !~!  
  !~!  ! 3D : voir "Fast, minimum storage Ray/Triangle intersection" (1997) - Moller et Trumbore
  !~!  
    ori%x=x ! Origine du rayon
    ori%y=y ! Origine du rayon
    ori%z=z ! Origine du rayon
    dir%v(1)=sol%xg%v(1) - x                ! Vecteur directeur du rayon  
    dir%v(2)=sol%xg%v(2) - y
    dir%v(3)=sol%xg%v(3) - z
    dir%v(1)=1.d0                ! Vecteur directeur du rayon  
    dir%v(2)=0.d0
    dir%v(3)=0.d0
    xn=dsqrt(dir%v(1)**2+dir%v(2)**2+dir%v(3)**2)
    cpt = 0
    if (xn.ne.0.d0)dir%v=dir%v/xn
        !call display(ori)
        !write(*,*)dir,sol%xg

    DO k=1,sol%nb_face ! Boucle sur les faces/triangles
        
        ! Construction des points du triangle
        v0=sol%list_vertex(sol%list_facette(k)%vertex(1))
        v1=sol%list_vertex(sol%list_facette(k)%vertex(2))
        v2=sol%list_vertex(sol%list_facette(k)%vertex(3))
       
        ! Compteur d intersection
        cpt = cpt + intersect(V0,V1,V2,ori,dir)
        !write(*,*)intersect(V0,V1,V2,ori,dir)
        !call display(v0)
        !call display(v1)
        !call display(v2)
    END DO

    ind=0
    IF (mod(cpt,2).EQ.1) ind=1 ! Si le nombre d intersection est impair, alors la maille est dans le polygone.
  
  IF (ind.NE.0) chi=sol%id*1.d0
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE raycasting
!DOCFIN
!================================================================================================================
  
  

FUNCTION signe(det) ! Determine le signe d un reel
  integer :: signe
  real(kind=kind(0.d0)) :: det
  
  if (det>0) signe = 1
  if (det==0) signe = 0
  if (det<0) signe = -1
    
END FUNCTION

FUNCTION determinant2D(x1,y1,x2,y2) ! Calcul un déterminant 2x2
  real(kind=kind(0.d0)) :: determinant2D,x1,y1,x2,y2
  
  determinant2D = x1*y2 - x2*y1
    
END FUNCTION

FUNCTION SUB(P1,P2) ! Construit un vecteur à partir de 2 points en 3D
  use geo_typ
  type(point) :: P1,P2
  type(vect_3) :: SUB
  
  SUB%v(1)=P1%x-P2%x
  SUB%v(2)=P1%y-P2%y
  SUB%v(3)=P1%z-P2%z
END FUNCTION SUB

FUNCTION CROSS(V1,V2) ! Effectue le produit vectoriel entre 2 vecteurs 3D
  use geo_typ
  type(vect_3) :: CROSS,V1,V2
  
  CROSS%v(1)= V1%v(2)*V2%v(3)-V1%v(3)*V2%v(2)
  CROSS%v(2)= V1%v(3)*V2%v(1)-V1%v(1)*V2%v(3)
  CROSS%v(3)= V1%v(1)*V2%v(2)-V1%v(2)*V2%v(1)
     
END FUNCTION CROSS

FUNCTION DOT(V1,V2) ! Effectue le produit scalaire entre 2 vecteurs 3D
  use geo_typ
  type(vect_3) :: V1,V2 
  real(kind=kind(0.d0)) :: DOT
  
  DOT = V1%v(1)*V2%v(1)+V1%v(2)*V2%v(2)+V1%v(3)*V2%v(3)  
   
END FUNCTION DOT


FUNCTION intersect(V0,V1,V2,ori,dir) ! Determine s il existe une intersection entre un rayon et un triangle (voir "Fast, minimum storage Ray/Triangle intersection" (1997) - Moller et Trumbore)

  use geo_typ, only : point, vect_3
  type(point) :: V0,V1,V2,ori
  type(vect_3) :: E1,E2,dir,SUB,CROSS,P,T,Q
  real(kind=kind(0.d0)), parameter:: eps=1.d-10
  real(kind=kind(0.d0)) :: DOT,det,inv_det,u,v,tray
  integer :: intersect
  
  intersect = 0
  E1 = SUB(V1,V0)
  E2 = SUB(V2,V0)
  P = CROSS(dir,E2)
  det = DOT(E1,P)
  
  IF (abs(det) < eps) return ! Si le determinant est nul, le rayon et le triangle sont dans le meme plan et ne s intersectent donc pas => on s arrete
  
  inv_det=1.d0/det 
  T = SUB(ori,V0)  
  u = DOT(T,P)*inv_det
  
  IF (u<0.d0 .OR. u>1.d0) return ! La coordonnée barycentrique doit 0 < u < 1 sinon on est en dehors du triangle et on s arrete 
  
  Q=CROSS(T,E1)
  v=DOT(dir,Q)*inv_det
  IF (v<0.d0 .OR. (u+v)>1.d0) return ! La coordonnee barycentrique doit 0 < v < 1 et 0 < u + v < 1 sinon on est en dehors du triangle et on s arrete 
  
  tray = DOT(E2,Q)*inv_det
  IF (tray<0) return ! Il y a intersection que si t > 0 sinon on s arrete
  
  intersect = 1 ! Si aucune des conditions précedentes n a ete remplie alors le rayon a bien intersecte le triangle

END FUNCTION intersect
!================================================================================================================

 SUBROUTINE mesh1d (bl,msh,ib,nb_dom,blv,interdom) 
! =============================== DOCUMENTATION =======================
! DOCDEBh*      GEO/mesh1d *                                           
!                                                                      
! NOM :                                                                
!      mesh1d (bl,msh,ib,nb_dom,blv,interdom)                          
!                                                                      
! DESCRIPTION:                                                         
!*
!      Maillage regulier d un bloc hexaedrique en 1D
!
!      Regular mesh of a hexahedral block in 1D
!*                                                   
!                                                                      
!    ENTREES / INPUT
!      bl       : Bloc a mailler et a ajouter au maillage msh / Block to be meshed and added to the msh mesh
!      blv      : Blocs voisins (1 a 6) a modifier / Neighbouring blocks to be modified
!      ib       : Numero du bloc a ajouter / number of the block to be added
!      nb_dom   : nombre de domaines / number of domains                
!      msh      : maillage / mesh
!      interdom : Table de localisation de l interface des domaines / Domain interface location table
! 
!    SORTIES / OUTPUT
!      msh      : maillage / mesh
!                                
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
! =====================================================================

! ================================== DEBUT DES DECLARATIONS =================================== ! 
!.1 --- Implicit, Use 
      use geo_typ
      use geo, ONLY: psr,pni,volcel,display
      IMPLICIT NONE
!.2---- Declaration 
      TYPE(bloc), INTENT(in)                        :: bl       
!! Bloc a mailler et a ajouter au maillage msh / Block to be meshed and added to the msh mesh
      TYPE(bloc), INTENT(in)                        :: blv(6)
!! Blocs voisins a modifier / Neighbouring blocks to be modified
      INTEGER, INTENT(in)                           :: ib !! numero du bloc a ajouter / number of the block to be added
      INTEGER, INTENT(in)                           :: nb_dom  !! nombre de domaines / number of domains
      TYPE(mesh), INTENT(inout)                     :: msh !! Maillage / Mesh
      TYPE(list_int), DIMENSION(:), INTENT(inout)   :: interdom
!! Table de localisation de l interface des domaines /Domain interface location table

      REAL(KIND=KIND(0.0d0))                        :: vv
      INTEGER                                       :: nx, ny, nz, i, j, k, is, ia, idebv, idebf
      INTEGER                                       :: ii, idebc, nui, nue, ipos_send, ipos_recv
      INTEGER                                       :: ie,je,ke,nxv,nyv,nzv

! ================================= DEBUT DU CODE EXECUTABLE ================================= !
!
!CALL display (bl)

      nx = bl%nx*2**(bl%nrb)
      ny = 1
      nz = 1

! Construction de la liste des sommets 
      DO i=1,nx+1 
         DO j=1,ny+1
            DO k=1,nz+1
               is = i + (j-1)*(nx+1) + (k-1)*(nx+1)*2 + bl%first_vertex
               msh%list_vertex(is) = pni(bl,i*1.0d0,j*1.0d0,k*1.0d0,-1)
            ENDDO
         ENDDO
      ENDDO      

! Construction de la liste des cellules 

         DO i=1,nx
            is = i +bl%first_cell
            msh%list_cell(is)%num  = is
            msh%list_cell(is)%idom = bl%idom
            msh%list_cell(is)%center=pni(bl,i*1.d0+0.5d0,1.d0+0.5d0,1.d0+0.5d0,-1)  !!!!!!!!!$$$$$!!!!!!!$$$$$
            msh%list_cell(is)%vol=volcel(bl,i*1.d0,1.d0,1.d0,-1)                    !!!!!!!!!$$$$$!!!!!!!$$$$$
         ENDDO

      msh%list_face(:)%nbvertex = 4

ia = bl%first_face     
! Construction de la liste des faces interieures paralleles au plan y z 

!      IF(nx.NE.1)THEN
         DO i=2,nx
            ia = ia+1
            msh%list_face(ia)%vertex(1)= (i+0)+(1+0-1)*(nx+1) + (nx+1)*(1+1)*(1+0-1) + bl%first_vertex
            msh%list_face(ia)%vertex(2)= (i+0)+(1+0-1)*(nx+1) + (nx+1)*(1+1)*(1+1-1) + bl%first_vertex
            msh%list_face(ia)%vertex(3)= (i+0)+(1+1-1)*(nx+1) + (nx+1)*(1+1)*(1+1-1) + bl%first_vertex
            msh%list_face(ia)%vertex(4)= (i+0)+(1+1-1)*(nx+1) + (nx+1)*(1+1)*(1+0-1) + bl%first_vertex
            msh%list_face(ia)%ic1      = (i-1)+bl%first_cell
            msh%list_face(ia)%ic2      = (i-0)+bl%first_cell
         ENDDO
!      ENDIF   

idebv = (nx+1)*2*2 + bl%first_vertex
idebf = nx-1 + bl%first_face
idebc = nx   + bl%first_cell

! Construction de la liste des faces pour x=xmin
! et des cellules du domaine voisin
! =============================================================================================

IF(bl%idom.eq.blv(1)%idom.AND.ib.LT.bl%cl(1)) GOTO 101

IF(blv(1)%idom.EQ.0) THEN
   nxv=nx
   nyv=1
   nzv=1
ELSE
   nxv=blv(1)%nx*2**(blv(1)%nrb)
   nyv=1
   nzv=1
ENDIF
            ie=nxv
            je=1
            ke=1
            nue=je                  ! Numerotation exterieure
            nui=1                   ! Numerotation interieure au bloc 
            ia=idebf+nui
            msh%list_face(ia)%vertex(1)=(1+0)+(1+0-1)*(nx+1) + bl%first_vertex
            msh%list_face(ia)%vertex(2)=(1+0)+(1+1-1)*(nx+1) + bl%first_vertex
            msh%list_face(ia)%vertex(3)=(1+0)+(1+1-1)*(nx+1) + 2*(nx+1) + bl%first_vertex
            msh%list_face(ia)%vertex(4)=(1+0)+(1+0-1)*(nx+1) + 2*(nx+1) + bl%first_vertex
            msh%list_face(ia)%ic1= 1 +bl%first_cell            
            IF(bl%cl(1).LE.0) THEN
               msh%list_face(ia)%ic2=bl%cl(1)
            ELSE
               IF(blv(1)%idom.NE.bl%idom) THEN
                  msh%list_face(ia)%ic2=idebc+nue
                  CALL psr(interdom,nb_dom,bl%idom,blv(1)%idom,ib,bl%cl(1),ipos_send,ipos_recv)
                  msh%list_send(blv(1)%idom)%L(nui+ipos_send) = 1 + bl%first_cell
                  msh%list_recv(blv(1)%idom)%L(nue+ipos_recv) = idebc+nue
                  msh%list_face(ia)%ic2               = idebc+nue
                  msh%list_cell(idebc+nue)%num    = idebc+nue
                  msh%list_cell(idebc+nue)%idom   =blv(1)%idom
                  vv=volcel(blv(1),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol    = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(1),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.0*ke+0.5d0,-1)
               ELSE
                  msh%list_face(ia)%ic2 = ie + blv(1)%first_cell      !!!!! A VERIFIER PARTOUT
               ENDIF
            ENDIF
        idebf=idebf+1
!        idebv=idebv+2
        IF(bl%cl(1).GT.0)THEN
        IF(blv(1)%idom.NE.bl%idom)      idebc=idebc+1
      ENDIF

101 CONTINUE         

!
! Construction de la liste des faces pour x=xmax 
! et des cellules du domaine voisin
!===========================================================================================

IF(bl%idom.eq.blv(2)%idom.AND.ib.LT.bl%cl(2)) GOTO 102

IF(blv(2)%idom.EQ.0) THEN
   nxv=nx
   nyv=1
   nzv=1
ELSE
   nxv=blv(2)%nx*2**(blv(2)%nrb)
   nyv=1
   nzv=1
ENDIF
            ie=1
            je=1
            ke=1
            nue=je                  ! Numérotation exterieure
            nui=1                   ! Numérotation interieure au bloc 
            ia=idebf+nui
            msh%list_face(ia)%vertex(1)=(nx+1+0)+(1+0-1)*(nx+1) + bl%first_vertex
            msh%list_face(ia)%vertex(4)=(nx+1+0)+(1+1-1)*(nx+1) + bl%first_vertex
            msh%list_face(ia)%vertex(3)=(nx+1+0)+(1+1-1)*(nx+1) + 2*(nx+1) + bl%first_vertex
            msh%list_face(ia)%vertex(2)=(nx+1+0)+(1+0-1)*(nx+1) + 2*(nx+1) + bl%first_vertex
            msh%list_face(ia)%ic1= nx +bl%first_cell            
            IF(bl%cl(2).LE.0) THEN
               msh%list_face(ia)%ic2=bl%cl(2)
            ELSE
               IF(blv(2)%idom.NE.bl%idom) THEN
                  msh%list_face(ia)%ic2=idebc+nue
                    CALL psr(interdom,nb_dom,bl%idom,blv(2)%idom,ib,bl%cl(2),ipos_send,ipos_recv)
                  msh%list_send(blv(2)%idom)%L(nui+ipos_send) = nx + bl%first_cell
                  msh%list_recv(blv(2)%idom)%L(nue+ipos_recv) = idebc+nue
                  msh%list_cell(idebc+nue)%num        = idebc+nue
                  msh%list_cell(idebc+nue)%idom       =blv(2)%idom
                  vv=volcel(blv(2),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol    = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(2),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.0*ke+0.5d0,-1)
               ELSE
                  msh%list_face(ia)%ic2 = ie + blv(2)%first_cell      !!!!! A VERIFIER PARTOUT
               ENDIF
            ENDIF

      idebf=idebf+1
!      idebv=idebv+2  
      IF(bl%cl(2).GT.0)THEN
         IF(blv(2)%idom.NE.bl%idom)      idebc=idebc+1
      ENDIF


102 CONTINUE      

! Construction de la liste des faces pour y=ymin 
! et des cellules du domaine voisin
!===========================================================================================
      DO i=1,nx
           nue=1                    ! Numerotation exterieure
           nui=i                    ! Numerotation interieure au bloc
         ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(1+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+1)+(1+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(2+1-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+0)+(2+1-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+bl%first_cell
             msh%list_face(ia)%ic2=bl%cl(3)
        ENDDO
       
             idebf=idebf+nx

! Construction de la liste des faces pour y=ymax
! et des cellules du domaine voisin
!===========================================================================================
      DO i=1,nx
           nue=i            ! Numerotation exterieure
           nui=i            ! Numerotation interieure au bloc
           ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(1+0-1)*(nx+1) + (nx+1)*(0+1)*(2-1)+bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+1)+(1+0-1)*(nx+1) + (nx+1)*(0+1)*(2-1)+bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(2+1-1)*(nx+1) + (nx+1)*(0+1)*(2-1)+bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(2+1-1)*(nx+1) + (nx+1)*(0+1)*(2-1)+bl%first_vertex
             msh%list_face(ia)%ic1=i+bl%first_cell
             msh%list_face(ia)%ic2=bl%cl(4)
        ENDDO
       
        idebf=idebf+nx

! Construction de la liste des faces pour z=zmin 
!==========================================================================================
       ii=1
       DO i=1,nx
             nue=1+int((i-1)/ii)                 ! Numerotation exterieure
             nui=i                               ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(1+0-1)*(nx+1) + (nx+1)*(1+1)*(1-1)+bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+1)+(1+0-1)*(nx+1) + (nx+1)*(1+1)*(1-1)+bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(1+1-1)*(nx+1) + (nx+1)*(1+1)*(1-1)+bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(1+1-1)*(nx+1) + (nx+1)*(1+1)*(1-1)+bl%first_vertex
             msh%list_face(ia)%ic1=i+bl%first_cell
             msh%list_face(ia)%ic2=bl%cl(5)
       ENDDO
       idebf=idebf+nx

! Construction de la liste des faces pour z=zmax 
!===========================================================================================
       DO i=1,nx
             nue=i       ! Numerotation exterieure
             nui=i       ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(1+0-1)*(nx+1) + (nx+1)*(1+1)*(2-1)+bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+1)+(1+0-1)*(nx+1) + (nx+1)*(1+1)*(2-1)+bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(1+1-1)*(nx+1) + (nx+1)*(1+1)*(2-1)+bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+0)+(1+1-1)*(nx+1) + (nx+1)*(1+1)*(2-1)+bl%first_vertex
             msh%list_face(ia)%ic1=i+bl%first_cell
             msh%list_face(ia)%ic2=bl%cl(6)
       ENDDO
       idebf=idebf+nx

RETURN 
!
!===========================   FIN DE LA ROUTINE    =====================================

END SUBROUTINE mesh1d
!DOCFIN

 SUBROUTINE synchro_mpi(calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/synchro_mpi  *
!
!    NOM
! synchro_mpi(calc)
!    DESCRIPTION 
!*
! Envoie des donnees entre domaines et calcul du pas de temps global 
! Sending data between domains and calculating the global time step 
!*
! 
!    ENTREES / INPUT
! calc : objet calcul / calcul object
!    SORTIES / OUTPUT
! calc : objet calcul / calcul object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
#ifdef _MPI
  include 'mpif.h'
#endif
!.2-----  Declaration
  type(calcul), intent(inout)          :: calc !! Objet calcul / Calcul object
  
  real(kind=kind(0.d0))                :: dt_glob,vmax_glob,xb_level_cell_glob
  integer                              :: ierr,isize,nbs,nbr,jj,kc,ii
#ifdef _MPI
  integer, dimension(MPI_STATUS_SIZE)  :: istat
#endif

! tableau des donnees a  echanger dimensionne au max des cellules a  envoyer ou recevoir
! conserve entre chaque appel a synchro_mpi
!  type(vect_nvar),dimension(:),save,allocatable :: buffer_send,buffer_recv  ! version non visqueuse
  type(state),dimension(:),save,allocatable :: buffer_send,buffer_recv       ! version visqueuse (passage des gradients)
!=========================== DEBUT DU CODE EXECUTABLE ==================

! Si buffer n est pas reserve, recherche de sa taille et allocation
  isize=0
  IF (.not.allocated(buffer_send)) THEN
      DO ii=1,calc%msh%nb_dom
          IF (associated(calc%msh%list_send(ii)%L))isize=max(isize,size(calc%msh%list_send(ii)%L))
          IF (associated(calc%msh%list_recv(ii)%L))isize=max(isize,size(calc%msh%list_recv(ii)%L))
      END DO
      allocate(buffer_send(isize))
      allocate(buffer_recv(isize))
  END IF

#ifdef _MPI
  CALL MPI_ALLREDUCE(calc%dt,dt_glob,1,MPI_DOUBLE_PRECISION, MPI_MIN,MPI_COMM_WORLD,ierr)
  CALL MPI_ALLREDUCE(calc%vmax,vmax_glob,1,MPI_DOUBLE_PRECISION,MPI_MAX,MPI_COMM_WORLD,ierr)
  CALL MPI_ALLREDUCE(calc%msh%nb_level_cell*1.d0,xb_level_cell_glob,1,MPI_DOUBLE_PRECISION,MPI_MAX,MPI_COMM_WORLD,ierr)
  calc%dt                = dt_glob
  calc%vmax              = vmax_glob
  calc%msh%nb_level_cell = int(xb_level_cell_glob)
#endif
  
! Echange des donnees entre les sous-domaines
  DO ii=1,calc%msh%nb_dom
        
! Remplissage de buffer_send
      IF (associated(calc%msh%list_send(ii)%L)) THEN
          DO jj=1,size(calc%msh%list_send(ii)%L)
              kc=calc%msh%list_send(ii)%L(jj)
              buffer_send(jj)=calc%msh%list_cell(kc)%w        
          END DO
           
          nbs=size(calc%msh%list_send(ii)%L)
          nbr=size(calc%msh%list_recv(ii)%L)

#ifdef _MPI
          CALL MPI_SENDRECV(buffer_send,(5*nvarmax+4)*nbs,           &
               MPI_DOUBLE_PRECISION,ii-1,calc%ipas,         &
               buffer_recv,(5*nvarmax+4)*nbr,                        &
               MPI_DOUBLE_PRECISION,ii-1,calc%ipas,         &
               MPI_COMM_WORLD,istat,ierr)                 
#endif           
        
! Distribution de buffer_recv dans les celllules

          DO jj=1,size(calc%msh%list_recv(ii)%L)
             kc=calc%msh%list_recv(ii)%L(jj)
             calc%msh%list_cell(kc)%w=buffer_recv(jj)  ! version visqueuse
          END DO
           
      END IF
         
  END DO

  deallocate(buffer_send)
  deallocate(buffer_recv)

!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE synchro_mpi
!DOCFIN

 SUBROUTINE read_nume(calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_nume *
!
!    NOM
! read_nume(calc)
!    DESCRIPTION  
!*
! Lecture du Bloc NUME du fichier de donnees *.inp
! Reading the NUME block from the *.inp data file
!*
! 
!    ENTREES / INPUT
!    calc  objet calcul initial / initial calcul object
!
!    SORTIES / OUTPUT
!    calc  objet calcul / calcul object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul), intent(inout)  :: calc !! Objet calcul / Calcul object
  
  character(4)                 :: para
  integer                      :: isondes
  real(kind=kind(0.d0))        :: x,y,z,arg,t
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(*,*)
  write(*,*)achar(27)//'[34m================================================'
  write(*,*)'Reading numerical parameters: block NUME'
  write(*,*)'================================================'//achar(27)//'[0m'
  write(*,*)


  calc%cfl = 0.9d0
  calc%ityp_flux=1
  calc%isauv=1
  calc%iordre_t=1
  calc%iordre_e=1
  calc%imeth_int_temps=1
  calc%ilimiteur=0
  calc%ipas=0
  calc%nb_sondes=0
499 read(33,'(a4,f20.0)',err=500,end=500)para,arg

  SELECT CASE (para)
      CASE('TINT')
          calc%tmax=arg
          write(*,*)'NUME-Info  Time interval                    :',calc%tmax
      CASE('CCFL')
          calc%cfl=arg
          write(*,*)'NUME-Info  New cfl  value                   :',calc%cfl
   !~   CASE('FLUX')
   !~       calc%ityp_flux=idint(arg)
   !~       write(*,*)'NUME-Info  New kind of numerical flux       :',calc%ityp_flux
      CASE('TDOR')
          calc%iordre_t=idint(arg)
          write(*,*)'NUME-Info  Time discretization order        :',calc%iordre_t
      CASE('SDOR')
          calc%iordre_e=idint(arg)
          write(*,*)'NUME-Info  Space discretization order       :',calc%iordre_e
      CASE('TIME')
          calc%imeth_int_temps=idint(arg)
          write(*,*)'NUME-Info  Time integration method          :',calc%imeth_int_temps
      CASE('LIMI')
          calc%ilimiteur=idint(arg)
          write(*,*)'NUME-Info  kind of limiter                  :',calc%ilimiteur
      CASE('SAVE')
          calc%isauv=idint(arg)
          write(*,*)'NUME-Info  kind of backup                   :',calc%isauv
      CASE('NPRO')
          calc%nb_sondes=int(arg)
          IF (calc%nb_sondes.ne.0) THEN
              write(*,*)'SOND-Info  number of probe              :',calc%nb_sondes
              DO isondes=1,calc%nb_sondes
                  read(33,*)x,y,z
                  calc%point_sondes(isondes)%x=x
                  calc%point_sondes(isondes)%y=y
                  calc%point_sondes(isondes)%z=z
                  write( *,1011)isondes,calc%point_sondes(isondes)
1011 format('SOND-Info  Probe coordinates number',i4,':', 3e13.5)
              END DO
          END IF

      CASE default
          GOTO 500
  END SELECT
  GOTO 499
500 continue
  t=calc%tmax
  calc%tmax=calc%tmin
  calc%tmin=-t       
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_nume
!DOCFIN

 SUBROUTINE init_calc(calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/init_cal  *
!
!    NOM
!   init_calc(calc)
!    DESCRIPTION  
!*
! Initialisation d un calcul: initialisation MPI, recuperation du nombre de domaines,
! du numero du domaine courant. Lecture des donnees du calcul.
!
! Initialisation of a calculation: MPI initialisation, recovery of the number of domains,
! the number of the current domain. Reading calculation data.
!*
!
!    ENTREES / INPUT
!   calc : Objet calcul / Calcul object
!    SORTIES / OUTPUT
!   calc : Objet calcul / Calcul object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  use num ,only: get_calc
  IMPLICIT NONE
  
#ifdef _MPI
  include 'mpif.h'
#endif
!.2-----  Declaration
  type(calcul),intent(inout) :: calc !! Objet calcul / Calcul object
  
  integer                    :: ierr
!=========================== DEBUT DU CODE EXECUTABLE ==================

  CALL empty_mesh(calc%msh,0,0)

#ifdef _MPI
  CALL MPI_INIT(ierr)
  CALL MPI_COMM_RANK( MPI_COMM_WORLD, calc%msh%numdom, ierr )
#else
  calc%msh%numdom=0
#endif

#ifdef _MPI
  CALL MPI_COMM_SIZE( MPI_COMM_WORLD, calc%msh%nb_dom,ierr )
#else
  calc%msh%nb_dom=1
#endif

  calc%msh%numdom=1+calc%msh%numdom
  CALL empty_mesh(calc%msh,calc%msh%nb_dom,calc%msh%numdom)
  CALL get_calc(calc)
   

!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE INIT_CALC
!DOCFIN

 SUBROUTINE MESH2D  (bl,msh,ib,nb_dom,blv,interdom)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/MESH2D  *
!
!    NOM
! mesh2d(bl,msh,ib,nb_dom,blv,interdom)
!    DESCRIPTION  
!*
!      Maillage regulier d un bloc hexaedrique en 2D
!
!      Regular mesh of a hexahedral block in 2D
!*
! 
!  
!    ENTREES / INPUT
!      bl       : Bloc a mailler et a ajouter au maillage msh / Block to be meshed and added to the msh mesh
!      blv      : Blocs voisins (1 a 6) a modifier / Neighbouring blocks to be modified
!      ib       : Numero du bloc a ajouter / number of the block to be added
!      nb_dom   : nombre de domaines / number of domains                
!      msh      : maillage / mesh
!      interdom : Table de localisation de l interface des domaines / Domain interface location table
! 
!    SORTIES / OUTPUT
!      msh      : maillage / mesh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
      use geo_typ
      use geo, only: psr,pni,volcel
      IMPLICIT NONE
!.2-----  Declaration
      TYPE(bloc), INTENT(in)                        :: bl       
!! Bloc a mailler et a ajouter au maillage msh / Block to be meshed and added to the msh mesh
      TYPE(bloc), INTENT(in)                        :: blv(6)
!! Blocs voisins a modifier / Neighbouring blocks to be modified
      INTEGER, INTENT(in)                           :: ib !! numero du bloc a ajouter / number of the block to be added
      INTEGER, INTENT(in)                           :: nb_dom  !! nombre de domaines / number of domains
      TYPE(mesh), INTENT(inout)                     :: msh !! Maillage / Mesh
      TYPE(list_int), DIMENSION(:), INTENT(inout)   :: interdom
!! Table de localisation de l interface des domaines /Domain interface location table

       real(kind=kind(0.d0))                        :: vv
       integer                                      :: nx,ny,nz,i,j,k,is,ia,idebv,idebf,blcl1
       integer                                      :: ii,idebc,nui,nue,ipos_send,ipos_recv
       integer                                      :: ie,je,ke,nxv,nyv,nzv
!=========================== DEBUT DU CODE EXECUTABLE ==================
!
       nx=bl%nx*2**(bl%nrb)
       ny=bl%ny*2**(bl%nrb)
       nz=1

! construction de la liste des sommets
       do i=1,nx+1
          do j=1,ny+1
            do k=1,nz+1
              is=i+(nx+1)*(j-1)+(nx+1)*(ny+1)*(k-1)+bl%first_vertex
              msh%list_vertex(is)=pni(bl,i*1.d0,j*1.d0,k*1.d0,1)
            end do
          end do
       end do

! construction de la liste des cellules

       do i=1,nx
          do j=1,ny
            do k=1,nz
               is=i+(j-1)*nx+nx*ny*(k-1)+bl%first_cell
               msh%list_cell(is)%num = is
               msh%list_cell(is)%idom= bl%idom
               msh%list_cell(is)%center=pni(bl,i*1.d0+0.5d0,j*1.d0+0.5d0,k*1.d0+0.5d0,1)  !!!!!!!!!$$$$$!!!!!!!$$$$$
               msh%list_cell(is)%vol=volcel(bl,i*1.d0,j*1.d0,k*1.d0,1)                    !!!!!!!!!$$$$$!!!!!!!$$$$$
             end do
          end do
       end do
       
     msh%list_face(:)%nbvertex=4

ia=bl%first_face

! construction de la liste des faces interieures paralleles au plan x z
     do j=2,ny
       do i=1,nx
          do k=1,nz
             ia=ia+1 
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(j-2)*nx+(k-1)*nx*ny +bl%first_cell
             msh%list_face(ia)%ic2=i+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
          end do
       end do
     end do

! construction de la liste des faces interieures paralleles au plan y z
     do i=2,nx
       do j=1,ny
          do k=1,nz
             ia=ia+1 
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+1-1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(k+0-1) +bl%first_vertex
             msh%list_face(ia)%ic1=i-1+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
             msh%list_face(ia)%ic2=i-0+(j-1)*nx+(k-1)*nx*ny +bl%first_cell
          end do
       end do
     end do


idebv=(nx+1)*(ny+1)*2 +bl%first_vertex
idebf=(nx-1)*ny+nx*(ny-1) +bl%first_face
idebc=nx*ny +bl%first_cell

! Construction de la liste des faces pour x=xmin
! et des cellules du domaine voisin
!===========================================================================================

if(bl%idom.eq.blv(1)%idom.and.ib.lt.bl%cl(1))goto 101
blcl1=bl%cl(1)
if(blcl1.lt.-100000)blcl1=-blcl1-100000
if(blv(1)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=1
else
   nxv=blv(1)%nx*2**(blv(1)%nrb)
   nyv=blv(1)%ny*2**(blv(1)%nrb)
   nzv=1
endif
if(bl%nrf(1).le.0)then ! Dans le cas ou le bloc voisin est + grossier ou identique 
       ii=1
       if(bl%nrf(1).eq.-1)ii=2
          do j=1,ny
             ie=nxv
             je=1+int((j-1)/ii)
             ke=1
             nue=je+(ke-1)*nyv ! Numerotation exterieure
             nui=j             ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(1+0)+(j+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(1+0)+(j+1-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%ic1=1+(j-1)*nx +bl%first_cell
             if(blcl1.le.0)then
               msh%list_face(ia)%ic2=blcl1
             else
                if(blv(1)%idom.ne.bl%idom)then
                  msh%list_face(ia)%ic2=idebc+nue
                  call psr(interdom,nb_dom,bl%idom,blv(1)%idom,ib,blcl1,ipos_send,ipos_recv)
                  msh%list_send(blv(1)%idom)%L(nui+ipos_send)=1+(j-1)*nx +bl%first_cell 
                  msh%list_recv(blv(1)%idom)%L(nue+ipos_recv)=idebc+nue
                  msh%list_cell(idebc+nue)%num =idebc+nue
                  msh%list_cell(idebc+nue)%idom=blv(1)%idom
                          
                  vv= volcel(blv(1),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(1),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(1)%first_cell         !!!!! A VERIFIER PARTOUT
                endif
             endif
          end do

       idebf=idebf+ny
       if(blcl1.gt.0)then
           if(blv(1)%idom.ne.bl%idom)idebc=idebc+ny/ii 
       endif
         
       
else  ! Dans le cas ou le bloc voisin est + fin 
          is=idebv
 ! creation des noeuds aux milieux des aretes
          do j=1,ny
            do k=1,nz+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0,1.d0*j+0.5d0,1.d0*k,1)
            end do
          end do
! creation des faces    
   do j=1,ny
             ie=nxv
             je=2*j-1
             ke=1
             nue=je+(ke-1)*nyv ! Numerotation exterieure
             nui=j         ! Numerotation interieure au bloc
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=(1+0)+(j+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=idebv+2*j 
             msh%list_face(ia)%vertex(2)=idebv+2*j-1
             msh%list_face(ia)%ic1=1+(j-1)*nx +bl%first_cell
             if(blcl1.le.0)then
               msh%list_face(ia)%ic2=blcl1
             else
                if(blv(1)%idom.ne.bl%idom)then
                  call psr(interdom,nb_dom,bl%idom,blv(1)%idom,ib,blcl1,ipos_send,ipos_recv)
                  msh%list_send(blv(1)%idom)%L(nui+ipos_send)    = 1+(j-1)*nx +bl%first_cell  
                  msh%list_recv(blv(1)%idom)%L(nue+ipos_recv)    = idebc+nue      
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(1)%idom 
                  vv= volcel(blv(1),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol      = vv    
                  msh%list_cell(idebc+nue)%center = pni(blv(1),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                else
                   msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(1)%first_cell         
                endif
             endif
             
                 ie=nxv
                   je=2*j
                   ke=1
             nue=je+(ke-1)*nyv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+2*j-1
             msh%list_face(ia)%vertex(4)=idebv+2*j
             msh%list_face(ia)%vertex(3)=(1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(1+0)+(j+1-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%ic1=1+(j-1)*nx +bl%first_cell
             if(blcl1.le.0)then
               msh%list_face(ia)%ic2=blcl1
             else
                if(blv(1)%idom.ne.bl%idom)then
                  call psr(interdom,nb_dom,bl%idom,blv(1)%idom,ib,blcl1,ipos_send,ipos_recv)
                  msh%list_send(blv(1)%idom)%L(nui+ipos_send)    = 1+(j-1)*nx +bl%first_cell 
                  msh%list_recv(blv(1)%idom)%L(nue+ipos_recv)    = idebc+nue      
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(1)%idom         
                  vv= volcel(blv(1),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol      = vv    
                  msh%list_cell(idebc+nue)%center = pni(blv(1),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(1)%first_cell         
                endif
             endif
             
        end do
       idebf=idebf+ny*2
       idebv=idebv+2*ny
       if(blcl1.gt.0)then
           if(blv(1)%idom.ne.bl%idom)idebc=idebc+ny*2  
       endif
endif

101 continue
!
! Construction de la liste des faces pour x=xmax 
! et des cellules du domaine voisin
!===========================================================================================
if(bl%idom.eq.blv(2)%idom.and.ib.lt.bl%cl(2))goto 102
if(blv(2)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=1
else
   nxv=blv(2)%nx*2**(blv(2)%nrb)
   nyv=blv(2)%ny*2**(blv(2)%nrb)
   nzv=1
endif
if(bl%nrf(2).le.0)then ! Dans le cas ou le bloc voisin est - fin ou identique 
       ii=1
       if(bl%nrf(2).eq.-1)ii=2
          do j=1,ny
                     ie=1
                   je=1+int((j-1)/ii)
                   ke=1
             nue=je+(ke-1)*nyv ! Numerotation exterieure
             nui=j                    ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(nx+1+0)+(j+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(nx+1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)+bl%first_vertex
             msh%list_face(ia)%vertex(3)=(nx+1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)+bl%first_vertex
             msh%list_face(ia)%vertex(4)=(nx+1+0)+(j+1-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%ic1=nx+(j-1)*nx +bl%first_cell
             if(bl%cl(2).le.0)then
               msh%list_face(ia)%ic2=bl%cl(2)
             else
                      if(blv(2)%idom.ne.bl%idom)then
                  msh%list_face(ia)%ic2=idebc+nue
                          call psr(interdom,nb_dom,bl%idom,blv(2)%idom,ib,bl%cl(2),ipos_send,ipos_recv)
                  msh%list_send(blv(2)%idom)%L(nui+ipos_send)=nx+(j-1)*nx +bl%first_cell
                  msh%list_recv(blv(2)%idom)%L(nue+ipos_recv)=idebc+nue
                  msh%list_cell(idebc+nue)%num = idebc+nue
                  msh%list_cell(idebc+nue)%idom= blv(2)%idom
                  vv= volcel(blv(2),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(2),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(2)%first_cell         
                        endif
             endif
          end do

       idebf=idebf+ny
       if(bl%cl(2).gt.0)then
           if(blv(2)%idom.ne.bl%idom)idebc=idebc+ny/ii
         endif
         
else ! Dans le cas ou le bloc voisin est + fin 
          is=idebv
! creation des noeuds aux milieux des aretes
          do j=1,ny
            do k=1,nz+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*(nx+1),1.d0*j+0.5d0,1.d0*k,1)
            end do
          end do

! creation des faces
   do j=1,ny
                 ie=1
                   je=2*j-1
                   ke=1
             nue=je+(ke-1)*nyv ! Numerotation exterieure
             nui=j         ! Numerotation interieure au bloc
             nue=2*j-1     ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=(nx+1+0)+(j+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(nx+1+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=idebv+2*j
             msh%list_face(ia)%vertex(4)=idebv+2*j-1
             msh%list_face(ia)%ic1=nx+(j-1)*nx +bl%first_cell
             if(bl%cl(2).le.0)then
               msh%list_face(ia)%ic2=bl%cl(2)
             else
                      if(blv(2)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(2)%idom,ib,bl%cl(2),ipos_send,ipos_recv)
                  msh%list_send(blv(2)%idom)%L(nui+ipos_send)    = nx+(j-1)*nx +bl%first_cell
                  msh%list_recv(blv(2)%idom)%L(nue+ipos_recv)    = idebc+nue     
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(2)%idom
                  vv= volcel(blv(2),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(2),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(2)%first_cell         
                        endif
             endif

             ie=1
                   je=2*j-1+1
                   ke=1
             nue=je+(ke-1)*nyv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+2*j-1
             msh%list_face(ia)%vertex(2)=idebv+2*j
             msh%list_face(ia)%vertex(3)=(nx+1+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(nx+1+0)+(j+1-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%ic1=nx+(j-1)*nx +bl%first_cell
             if(bl%cl(2).le.0)then
               msh%list_face(ia)%ic2=bl%cl(2)
             else
                      if(blv(2)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(2)%idom,ib,bl%cl(2),ipos_send,ipos_recv)
                  msh%list_send(blv(2)%idom)%L(nui+ipos_send)    = nx+(j-1)*nx +bl%first_cell
                  msh%list_recv(blv(2)%idom)%L(nue+ipos_recv)    = idebc+nue     
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(2)%idom
                  vv= volcel(blv(2),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(2),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(2)%first_cell      
                        endif
             endif
       end do
         
       idebf=idebf+ny*2
       idebv=idebv+2*ny
       if(bl%cl(2).gt.0)then
           if(blv(2)%idom.ne.bl%idom)idebc=idebc+ny*2
         endif
endif
102 continue

! Construction de la liste des faces pour y=ymin 
! et des cellules du domaine voisin
!===========================================================================================
if(bl%idom.eq.blv(3)%idom.and.ib.lt.bl%cl(3))goto 103
if(blv(3)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=1
else
   nxv=blv(3)%nx*2**(blv(3)%nrb)
   nyv=blv(3)%ny*2**(blv(3)%nrb)
   nzv=1
endif
if(bl%nrf(3).le.0)then ! Dans le cas ou le bloc voisin est - fin ou identique 
       ii=1
       if(bl%nrf(3).eq.-1)ii=2
       do i=1,nx
                     ie=1+int((i-1)/ii)
                   je=nyv
                   ke=1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             nui=i             ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(1+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+0)+(1+0-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(1+0-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+1)+(1+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(1-1)*nx +bl%first_cell
             if(bl%cl(3).le.0)then
               msh%list_face(ia)%ic2=bl%cl(3)
             else
                      if(blv(3)%idom.ne.bl%idom)then
                  msh%list_face(ia)%ic2=idebc+nue
                          call psr(interdom,nb_dom,bl%idom,blv(3)%idom,ib,bl%cl(3),ipos_send,ipos_recv)
                  msh%list_send(blv(3)%idom)%L(nui+ipos_send)=i+(1-1)*nx +bl%first_cell
                  msh%list_recv(blv(3)%idom)%L(nue+ipos_recv)=idebc+nue
                  msh%list_cell(idebc+nue)%num =idebc+nue
                  msh%list_cell(idebc+nue)%idom=blv(3)%idom        
                  vv= volcel(blv(3),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(3),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(3)%first_cell         
                        endif
             endif
       end do
       idebf=idebf+nx
       if(bl%cl(3).gt.0)then
           if(blv(3)%idom.ne.bl%idom)idebc=idebc+nx/ii
         endif

else ! Dans le cas ou le bloc voisin est + fin 
          is=idebv
! creation des noeuds aux milieux des aretes
          do i=1,nx
            do k=1,nz+1
              is=is+1
               msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0,1.d0*k,1)
            end do
          end do
! creation des faces
   do i=1,nx
                 ie=2*i-1
                   je=nyv
                   ke=1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             nui=i      ! Numerotation interieure au bloc
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=(i+0)+(1+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+0)+(1+0-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=idebv+2*i
             msh%list_face(ia)%vertex(4)=idebv+2*i-1
             msh%list_face(ia)%ic1=i+(1-1)*nx +bl%first_cell
             if(bl%cl(3).le.0)then
               msh%list_face(ia)%ic2=bl%cl(3)
             else
                      if(blv(3)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(3)%idom,ib,bl%cl(3),ipos_send,ipos_recv)
                  msh%list_send(blv(3)%idom)%L(nui+ipos_send)    = i+(1-1)*nx+bl%first_cell
                  msh%list_recv(blv(3)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(3)%idom
                  vv= volcel(blv(3),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(3),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(3)%first_cell         
                        endif
             endif

                 ie=2*i-1+1
                   je=nyv
                   ke=1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+2*i-1
             msh%list_face(ia)%vertex(2)=idebv+2*i
             msh%list_face(ia)%vertex(3)=(i+1)+(1+0-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+1)+(1+0-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(1-1)*nx +bl%first_cell
             if(bl%cl(3).le.0)then
               msh%list_face(ia)%ic2=bl%cl(3)
             else
                      if(blv(3)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(3)%idom,ib,bl%cl(3),ipos_send,ipos_recv)
                  msh%list_send(blv(3)%idom)%L(nui+ipos_send)    = i+(1-1)*nx+bl%first_cell
                  msh%list_recv(blv(3)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(3)%idom
                 vv= volcel(blv(3),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(3),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(3)%first_cell         
                        endif
             endif
       end do
         
       idebf=idebf+nx*2
       idebv=idebv+nx*2
       if(bl%cl(3).gt.0)then
           if(blv(3)%idom.ne.bl%idom)idebc=idebc+nx*2
         endif
endif

103  continue

!
! Construction de la liste des faces pour y=ymax 
!===========================================================================================
if(bl%idom.eq.blv(4)%idom.and.ib.lt.bl%cl(4))goto 104
if(blv(4)%idom.eq.0)then
   nxv=nx
   nyv=ny
   nzv=1
else
   nxv=blv(4)%nx*2**(blv(4)%nrb)
   nyv=blv(4)%ny*2**(blv(4)%nrb)
   nzv=1
endif
if(bl%nrf(4).le.0)then ! Dans le cas ou le bloc voisin est - fin ou identique 
       ii=1
       if(bl%nrf(4).eq.-1)ii=2
        do i=1,nx
                     ie=1+int((i-1)/ii)
                   je=1
                   ke=1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             nui=i               ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(ny+1-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+1)+(ny+1-1)*(nx+1) +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(ny+1-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(ny+1-1)*(nx+1) + (nx+1)*(ny+1) +bl%first_vertex
             msh%list_face(ia)%ic1=i+(ny-1)*nx +bl%first_cell
             if(bl%cl(4).le.0)then
               msh%list_face(ia)%ic2=bl%cl(4)
             else
                      if(blv(4)%idom.ne.bl%idom)then
                  msh%list_face(ia)%ic2=idebc+nue
                          call psr(interdom,nb_dom,bl%idom,blv(4)%idom,ib,bl%cl(4),ipos_send,ipos_recv)
                  msh%list_send(blv(4)%idom)%L(nui+ipos_send)=i+(ny-1)*nx +bl%first_cell
                  msh%list_recv(blv(4)%idom)%L(nue+ipos_recv)=idebc+nue
                  msh%list_cell(idebc+nue)%num =idebc+nue
                  msh%list_cell(idebc+nue)%idom=blv(4)%idom        
                 vv= volcel(blv(4),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(4),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(4)%first_cell         
                        endif
             endif
       end do
       idebf=idebf+nx
       if(bl%cl(4).gt.0)then
           if(blv(4)%idom.ne.bl%idom)idebc=idebc+nx/ii
         endif

     else ! Dans le cas ou le bloc voisin est + fin 
          is=idebv
! creation des noeuds aux milieux des aretes
          do i=1,nx
            do k=1,nz+1
              is=is+1
              msh%list_vertex(is)=pni(bl,1.d0*i+0.5d0,1.d0*(ny+1),1.d0*k,1)
            end do
          end do
! creation des faces
   do i=1,nx
                 ie=2*i-1
                   je=1
                   ke=1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             nui=i         ! Numerotation interieure au bloc
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=(i+0)+(ny+1+0-1)*(nx+1)  +bl%first_vertex
             msh%list_face(ia)%vertex(2)=idebv+2*i-1
             msh%list_face(ia)%vertex(3)=idebv+2*i
             msh%list_face(ia)%vertex(4)=(i+0)+(ny+1-1)*(nx+1) + (nx+1)*(ny+1)  +bl%first_vertex
             msh%list_face(ia)%ic1=i+(ny-1)*nx +bl%first_cell
             if(bl%cl(4).le.0)then
               msh%list_face(ia)%ic2=bl%cl(4)
             else
                      if(blv(4)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(4)%idom,ib,bl%cl(4),ipos_send,ipos_recv)
                  msh%list_send(blv(4)%idom)%L(nui+ipos_send)    = i+(ny-1)*nx +bl%first_cell
                  msh%list_recv(blv(4)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(4)%idom
                  vv= volcel(blv(4),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(4),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(4)%first_cell         
                        endif
             endif

                 ie=2*i-1+1
                   je=1
                   ke=1
             nue=ie+(ke-1)*nxv ! Numerotation exterieure
             ia=idebf+nue 
             msh%list_face(ia)%vertex(1)=idebv+2*i-1
             msh%list_face(ia)%vertex(2)=(i+1)+(ny+1+0-1)*(nx+1)  +bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(ny+1-1)*(nx+1) + (nx+1)*(ny+1)  +bl%first_vertex
             msh%list_face(ia)%vertex(4)=idebv+2*i
             msh%list_face(ia)%ic1=i+(ny-1)*nx +bl%first_cell
             if(bl%cl(4).le.0)then
               msh%list_face(ia)%ic2=bl%cl(4)
             else
                      if(blv(4)%idom.ne.bl%idom)then
                          call psr(interdom,nb_dom,bl%idom,blv(4)%idom,ib,bl%cl(4),ipos_send,ipos_recv)
                  msh%list_send(blv(4)%idom)%L(nui+ipos_send)    = i+(ny-1)*nx +bl%first_cell
                  msh%list_recv(blv(4)%idom)%L(nue+ipos_recv)    = idebc+nue
                  msh%list_face(ia)%ic2             = idebc+nue
                  msh%list_cell(idebc+nue)%num      = idebc+nue
                  msh%list_cell(idebc+nue)%idom     = blv(4)%idom
                   vv= volcel(blv(4),1.d0*ie,1.d0*je,1.d0*ke,1)
                  msh%list_cell(idebc+nue)%vol = vv
                  msh%list_cell(idebc+nue)%center = pni(blv(4),1.d0*ie+0.5d0,1.d0*je+0.5d0,1.d0*ke+0.5d0,1)
                        else
                  msh%list_face(ia)%ic2=ie+(je-1)*nxv+(ke-1)*nxv*nyv+blv(4)%first_cell         
                        endif
             endif
       end do
         
       idebf=idebf+nx*2
       idebv=idebv+2*nx
       if(bl%cl(4).gt.0)then
           if(blv(4)%idom.ne.bl%idom)idebc=idebc+nx*nz*2
         endif
endif

104 continue

! Construction de la liste des faces pour z=zmin 
!===========================================================================================
       ii=1
       do i=1,nx
          do j=1,ny
             nue=1+int((i-1)/ii)+int((j-1)/ii)*nx/ii ! Numerotation exterieure
             nui=i+(j-1)*nx                          ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(1-1)+bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(1-1)+bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(1-1)+bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(1-1)+bl%first_vertex
             msh%list_face(ia)%ic1=i+(j-1)*nx+(1-1)*nx*ny+bl%first_cell
             msh%list_face(ia)%ic2=bl%cl(5)
          end do
       end do
       idebf=idebf+nx*ny

! Construction de la liste des faces pour z=zmax 
!===========================================================================================
       do i=1,nx
          do j=1,ny
             nue=i+(j-1)*nx! Numerotation exterieure
             nui=i+(j-1)*nx                          ! Numerotation interieure au bloc
             ia=idebf+nui
             msh%list_face(ia)%vertex(1)=(i+0)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1)+bl%first_vertex
             msh%list_face(ia)%vertex(4)=(i+1)+(j+0-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1)+bl%first_vertex
             msh%list_face(ia)%vertex(3)=(i+1)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1)+bl%first_vertex
             msh%list_face(ia)%vertex(2)=(i+0)+(j+1-1)*(nx+1) + (nx+1)*(ny+1)*(nz+1-1)+bl%first_vertex
             msh%list_face(ia)%ic1=i+(j-1)*nx+(nz-1)*nx*ny+bl%first_cell
             msh%list_face(ia)%ic2=bl%cl(6)
          end do
       end do
       idebf=idebf+nx*ny


return
!
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE MESH2D
!DOCFIN

 
MODULE num 
!=========================== DOCUMENTATION ============================= 
!DOCDEBm*    NUM/num  *
!
!    NOM
!    num
!
!    DESCRIPTION  
!*
! Interface des routines du Module NUMerique
! Interface of routines from NUMeric Module 
!*
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
!=========================== DEBUT DU CODE EXECUTABLE ==================
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE calc_flux(calc,lev)
        use num_typ
        type(calcul), intent(inout) :: calc
        integer, intent(inout)      :: lev
      END SUBROUTINE calc_flux
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE calc_source(calc,lev)
      use num_typ
        type(calcul), intent(inout) :: calc
        integer, intent(inout)     :: lev
      END SUBROUTINE calc_source
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE dtloc(calc)
      use num_typ
        type(calcul), intent(inout) :: calc
      END SUBROUTINE dtloc
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE friction(calc)
        use num_typ
        type(calcul), intent(inout) :: calc
      END SUBROUTINE friction
  END INTERFACE
  !----- Fin Interface --------------------------  
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE get_calc(calc)
        use num_typ
        type(calcul), intent(inout) :: calc
      END SUBROUTINE get_calc
  END INTERFACE
  !----- Fin Interface --------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE init_calc(calc)
        use num_typ
        type(calcul), intent(inout) :: calc
      END SUBROUTINE init_calc
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE raycasting(sol,x,y,z,chi)
        use num_typ
        real(kind=kind(0.d0)), intent(in) :: x,y,z
        type(solide), intent(inout) :: sol
        real(kind=kind(0.d0)), intent(out) :: chi
      END SUBROUTINE raycasting
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE rk2(calc)
        use num_typ
        type(calcul), intent(inout) :: calc
      END SUBROUTINE rk2
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE save_1D(calc)
        use num_typ
        type(calcul), intent(inout) :: calc
      END SUBROUTINE save_1D
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE save_calc(calc)
        use num_typ
        type(calcul), intent(inout) :: calc
      END SUBROUTINE save_calc
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE sharp(calc,pm)
        use num_typ
        type(calcul), intent(inout) :: calc
        real(kind=kind(0.d0)),intent(inout) :: pm
      END SUBROUTINE sharp
  END INTERFACE
  !----- Fin Interface ---------------------------
     
  !----- Debut Interface -------------------------
  INTERFACE
       SUBROUTINE synchro_mpi(calc)
         use num_typ
         type(calcul), intent(inout) :: calc
       END SUBROUTINE synchro_mpi
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
      SUBROUTINE synchro_w(calc)
        use num_typ
        type(calcul), intent(inout) :: calc
      END SUBROUTINE synchro_w
  END INTERFACE
  !----- Fin Interface ---------------------------
  
  !----- Debut Interface -------------------------
  INTERFACE
       SUBROUTINE u_penalisation(calc)
            use num_typ
            type(calcul), intent(inout) :: calc
       END SUBROUTINE u_penalisation
  END INTERFACE
  !----- Fin Interface --------------------------

END MODULE NUM
!DOCFIN

program CERF
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/CERF  *
!
!    NOM
! CERF
!    DESCRIPTION  
!*
! CERF: Computation, ERosion and Flow
! Parallel Finite volume code using adaptive mesh refinement technique
! IMATH from university of Toulon
! INSTITUT DE MATHEMATIQUE DE TOULON
!*
!>    AUTEUR 
!> Frederic GOLAY
!  
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
   use num
#ifdef _MPI
  use ptim
#endif  
  
implicit none

#ifdef _MPI
    include 'mpif.h'
#endif

!.2-----  Declaration
  type(calcul) :: calc !! Objet calcul 
  integer ierr,id,iu

!=========================== DEBUT DU CODE EXECUTABLE ==================





! Initialisation 
!------------------------------------------------------
  call print_info('CERF', ' Initialisation')
  call init_calc(calc)
# ifdef _MPI
  CALL PTIM_start(LABEL="Parallel work")  
# endif
IF(calc%msh%numdom.eq.1)then
    write(*,*)achar(27)//'[34m**********************************************************'
    write(*,*) fdate()
    write(*,*)'CERF : Computation, ERosion and Flow '
    write(*,*)'**********************************************************' //achar(27)//'[0m'
endif

! Calcul
!------------------------------------------------------
  
  call print_info('CERF', ' Calcul')
  
   select case (calc%imeth_int_temps) 
   case(1) ! rk2
      IF(calc%msh%numdom.eq.1)call print_info('CERF','Integration temporelle: RUNGE-KUTTA')
     call rk2(calc)
     
     case default
       call print_err('CERF',' Time integration not defined')
    !~else if (calc%imeth_int_temps.eq.2) then
    !~   write(*,*), 'Integration temporelle: ADAMS BASHFORT '
    !~   call adams(calc)  
    !~else if (calc%imeth_int_temps.eq.3) then
    !~   write(*,*), 'Integration temporelle: ADAMS BASHFORT pas de temps local'
    !~   call adams(calc)  
    end select


#ifdef _MPI
  CALL PTIM_stop(LABEL="Parallel work")  
# endif

! Sauvegardes
!------------------------------------------------------

  id=idint(calc%isauv/10.d0)
  iu=idint(calc%isauv-id*10.d0)
  
  if(id.ne.0)call save_1D(calc)  
  if(iu.ne.0)call save_calc(calc)
  
! Fin
!------------------------------------------------------

IF(calc%msh%numdom.eq.1)then
    write(*,*)achar(27)//'[34m**********************************************************'
    write(*,*) fdate()
    write(*,*)'CERF End of computation '
    write(*,*)'**********************************************************' //achar(27)//'[0m'
endif


  call empty_mesh(calc%msh,0,0)  ! liberation de la mémoire
# ifdef _MPI
  call MPI_FINALIZE(ierr)
# endif
!===========================   FIN DU PROGRAMME    ====================
end program CERF
!DOCFIN

 SUBROUTINE initialise(m)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/initialise  *
!
!    NOM
! initialise(m)
!
!    DESCRIPTION  
!*
! Initialisation d un objet maillage
!
! Initialising a mesh object
!*
!
!    ENTREES / INPUT
!    m : maillage / mesh
!
!    SORTIES / OUTPUT
!    m : maillage initialise / initialised mesh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration     
  type(mesh) :: m !! Maillage / Mesh
  integer    :: i
!=========================== DEBUT DU CODE EXECUTABLE ==================
  DO i=1,m%nb_vertex
      m%list_vertex%x=0.d0
      m%list_vertex%y=0.d0
      m%list_vertex%z=0.d0
  END DO
  
  DO i=1,m%nb_face
      m%list_face(i)%surf=0.d0
      m%list_face(i)%vnorm%v=0.d0
      m%list_face(i)%center%x=0.d0
      m%list_face(i)%center%y=0.d0
      m%list_face(i)%center%z=0.d0
      m%list_face(i)%ic1=0
      m%list_face(i)%ic2=0
      m%list_face(i)%vertex=0
  END DO
  
  DO i=1,m%nb_cell
      m%list_cell(i)%num=0
      m%list_cell(i)%vol=0.d0
      m%list_cell(i)%center%x=0.d0
      m%list_cell(i)%center%y=0.d0
      m%list_cell(i)%center%z=0.d0
      m%list_cell(i)%h=0.d0
  END DO
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE initialise
!DOCFIN

 SUBROUTINE prim2bal(w)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/prim2bal  *
!
!    NOM
! prim2bal(w)
!    DESCRIPTION 
!*
! Calcul des variables conservatives a partir des variables primitives 
! Calculating conservative variables from primitive variables 
!*
! 
!    ENTREES / INPUT
! w    : objet de type "state" contenant les variables conservatives et primitives
!      / object of type "state" containing the conservative and primitive variables
!
!    SORTIES / OUTPUT
! w    : objet de type "state" contenant les variables conservatives et primitives
!      / object of type "state" containing the conservative and primitive variables
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(state),intent(inout) :: w !! Variables d etat / State variables
  real(kind=kind(0.d0))     :: r,u1,u2,u3,p,phi,h
!=========================== DEBUT DU CODE EXECUTABLE ==================

  SELECT CASE (imodel_phy)

!----------------------------------------------------
      CASE (2) ! bifluide isotherme
          r = w%vprim%v(1)  
          u1= w%vprim%v(2)
          u2= w%vprim%v(3)
          u3= w%vprim%v(4)
          p = w%vprim%v(5)
          phi=((p-p0_phy)/c_phy**2+rho0W_phy-r)/(rho0W_phy-rho0A_phy)

          IF (phi.gt.1.d0) phi=1.d0
          IF (phi.lt.0.d0) phi=0.d0

          w%vbal%v(1)=r
          w%vbal%v(2)=r*u1
          w%vbal%v(3)=r*u2
          w%vbal%v(4)=r*u3
          w%vbal%v(5)=phi

!----------------------------------------------------
      CASE (1) ! Saint Venant
          h=w%vprim%v(1)
          u1=w%vprim%v(2)
          u2=w%vprim%v(3)
          w%vbal%v(1)=h
          w%vbal%v(2)=h*u1
          w%vbal%v(3)=h*u2

  END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE prim2bal
!DOCFIN

 SUBROUTINE entropie(w,e)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/entropie  *
!
!    NOM
! entropie(w,e)
!    DESCRIPTION 
!*
! Calcul de l entropie sur la cellule
!
! Calculating entropy on the cell
!*
! 
!    ENTREES / INPUT
! w    : objet de type "state" contenant les variables conservatives et primitives
!      / object of type "state" containing the conservative and primitive variables
!
!    SORTIES / OUTPUT
! e    : entropie / entropy
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(state),intent(inout)          :: w !! Variables primitives / Primitive variables
  real(kind=kind(0.d0)), intent(out) :: e !! Entropie / Entropy
  
  real(kind=kind(0.d0))              :: r,u1,u2,u3,p,h,zb
!=========================== DEBUT DU CODE EXECUTABLE ==================

  e=0.d0

  SELECT CASE (imodel_phy)
!---------------------------------------------------
      CASE (2) ! bifluide isotherme
          r =w%vprim%v(1)
          u1=w%vprim%v(2)
          u2=w%vprim%v(3)
          u3=w%vprim%v(4)
          p =w%vprim%v(5)
          ive_phy=6
          w%vprim%v(ive_phy) = 0.5d0*(u1*u1+u2*u2+u3*u3)*r+ r*log(r)*c_phy*c_phy&
                     +c_phy*c_phy*(r-rho0W_phy) - p +p0_phy
          e=w%vprim%v(ive_phy)

     CASE (1) ! SaintVenant
          ive_phy=4
          h = w%vprim%v(1)
          u1= w%vprim%v(2)
          u2= w%vprim%v(3)
          zb= w%vprim%v(5)
          w%vprim%v(ive_phy) = 0.5d0*(u1*u1+u2*u2)*h+ 0.5d0*gpes_phy*h*h+ gpes_phy*h*zb
          e=w%vprim%v(ive_phy)
!----------------------------------------------------

  END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE entropie
!DOCFIN

 SUBROUTINE read_obj(isol,sol,file)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_obj *
!
!    NOM
! read_obj(isol,sol,file)
!    DESCRIPTION  
!*
!  Lecture d un fichier de description de maillage au format OBJ.
!  La connectivite entre les elements du maillage est stockee dans conn_edge (2D) et conn_face (3D)
!  Les coordonnéees des noeuds du maillage sont stockees dans x,y et z
!  Sur le format OBJ ==> https://fr.wikipedia.org/wiki/Objet_3D_%28format_de_fichier%29
!
!  Reading a mesh description file in OBJ format.
!  Connectivity between mesh elements is stored in conn_edge (2D) and conn_face (3D).
!  Mesh node coordinates are stored in x,y and z
!  In OBJ format ==> https://fr.wikipedia.org/wiki/Objet_3D_%28format_de_fichier%29
!*
!
! 
!    ENTREES / INPUT
!    isol   : numero du solide / solid number
!    sol    : solide / solid
!    file   : fichier de definition du solide au format OBJ / file defining the solid in OBJ format
!
!    SORTIES / OUTPUT
!    sol    : solide / solid
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo
  IMPLICIT NONE
!.2-----  Declaration
  integer, intent(in)         :: isol !! numero du solide / Solid number
  type(solide), intent(inout) :: sol !! Solide / Solid
  CHARACTER*20, intent(in)    :: file !! Nom du fichier definissant le solide / Name of the file defining the solid
  
  CHARACTER(len=2)            :: c
  integer                     :: i,j
  integer                     :: i1,i2,i3
  real(kind=kind(0.d0))       :: x,y,z
!=========================== DEBUT DU CODE EXECUTABLE ==================

  write(*,*) 'OBST-INFO == Reading the mesh defining the obstacle ',isol,'file ', file
  
  ! Initialisations
  sol%nb_vert=0
  sol%nb_face=0
  sol%xmin_s = 1.d20
  sol%xmax_s =-1.d20
  sol%ymin_s = 1.d20
  sol%ymax_s =-1.d20
  sol%zmin_s = 1.d20
  sol%zmax_s =-1.d20
  
  i=0
  j=0
  
  ! Lecture du fichier OBJ
  OPEN(UNIT=10,FILE=file,STATUS='old')
  DO
      read(10,'(A2)',end=12)  c
      SELECT CASE (c)
          CASE('v') ! Vertex
              sol%nb_vert = sol%nb_vert + 1 ! Nombre de vertex
          CASE('f','l') ! Face
              sol%nb_face = sol%nb_face + 1 ! Nombre de faces
          CASE DEFAULT

      END SELECT
  END DO
  
  12 continue
  
  ! Allocation des tableaux de coordonnees et de connectivite
  allocate(sol%list_facette(sol%nb_face))
  allocate(sol%list_vertex(sol%nb_vert))
  
  rewind(10)
  
  DO ! Lecture du fichier OBJ
      read(10,'(A2)', ADVANCE='NO',end=11)  c ! On lit les deux premiers caracteres de chaque ligne sans retour chariot
      
      SELECT CASE (c)
      
          ! Lecture de la table de connectivite
      
          CASE('v') ! Vertex
              i=i+1
              read(10,*) x,y,z ! On lit 3 flottants, il s agit des coordonnees de chaque vertex
              sol%list_vertex(i)%x=x
              sol%list_vertex(i)%y=y
              sol%list_vertex(i)%z=z
              IF (x.lt.sol%xmin_s)sol%xmin_s=x
              IF (x.gt.sol%xmax_s)sol%xmax_s=x
              IF (y.lt.sol%ymin_s)sol%ymin_s=y
              IF (y.gt.sol%ymax_s)sol%ymax_s=y
              IF (z.lt.sol%zmin_s)sol%zmin_s=z
              IF (z.gt.sol%zmax_s)sol%zmax_s=z
              
          CASE('f') ! Face
              j=j+1
              read(10,*) i1,i2,i3 ! On lit 3 entiers, il s agit des numeros des vertex qui composent la face
              sol%list_facette(j)%vertex(1)=i1
              sol%list_facette(j)%vertex(2)=i2
              sol%list_facette(j)%vertex(3)=i3
          CASE('l') ! Line/Edge
              j=j+1
              read(10,*) i1,i2 ! On lit 2 entiers, il s agit des numeros des vertex qui composent le segment
              sol%list_facette(j)%vertex(1)=i1
              sol%list_facette(j)%vertex(2)=i2
              sol%list_facette(j)%vertex(3)=i2

          CASE DEFAULT
              read(10,*) ! On saute toute autre ligne
      
      END SELECT
      
  END DO
  
  11 continue
  
  write(*,*) 'OBST-INFO == End reading the mesh defining the obstacle ', file,sol%nb_vert,sol%nb_face
  ! Fin de lecture du fichier OBJ
  CLOSE(10)

  ! Creation de la bounding box
  sol%xmin_s = sol%xmin_s-0.02d0*dabs(sol%xmin_s)
  sol%xmax_s = sol%xmax_s+0.02d0*dabs(sol%xmax_s)
  sol%ymin_s = sol%ymin_s-0.02d0*dabs(sol%ymin_s)
  sol%ymax_s = sol%ymax_s+0.02d0*dabs(sol%ymax_s)
  sol%zmin_s = sol%zmin_s-0.02d0*dabs(sol%zmin_s)
  sol%zmax_s = sol%zmax_s+0.02d0*dabs(sol%zmax_s)

  sol%id = isol
  
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_obj

!DOCFIN 

  PROGRAM cerf_amr
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/cerf_amr  *
!
!    NOM
! convert_mai
!
!    DESCRIPTION  
!*
! Programme permettant la lecture de fichiers binaires au format CERF
! puis de calculer un critere afin de raffiner ou deraffiner eventuellement
!
! Program for reading binary files in CERF format
! then calculates a criterion for refining or coarsening the mesh if necessary
!*
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use uti
  IMPLICIT NONE
!.2-----  Declaration
  type(bloc),allocatable,dimension(:)             :: bl_ini,bl_out
  type(bloc)                                      :: blv(6),bl_null
  type(list_vec),allocatable,dimension(:)         :: list_w_bloc
  type(calcul)                                    :: calc_ini,calc_out,cb
  integer                                         :: nbdom,nrafmax,i,iv,idv,j,k,nvi,bcl,bclj,ios
  integer                                         :: itest, idom, nbtotcelli,nbtotcinti,nbtotcello,nbtotcinto,nb_bloc
  integer                                         :: nb_cell_bloc,ib,ibloc,ic1,icb,itemp,nx,ny,nz
  real(kind=kind(0.d0))                           :: crit_raf,crit_deraf,critmoy,voltot
  real(kind=kind(0.d0))                           :: delta,d
  real(kind=kind(0.d0)), dimension(:),allocatable :: critere,dtb
  integer, dimension(:),allocatable               :: im
  integer                                         :: imac(6),imav(6),imaf(6)
  type(list_int), allocatable,dimension(:)        :: interdom
  integer, allocatable,dimension(:)               :: nbl,isb
  character(len=256)                              :: iomsg
!=========================== DEBUT DU CODE EXECUTABLE ==================

  bl_null%idom=0
! lecture de l objet calcul d ou on va extraire des blocs
  CALL empty_mesh(cb%msh,1,0)
  CALL get_calc(cb)
  nrafmax   =cb%nrma ! Niveau maximal de raffinement
  crit_raf  =cb%vcra ! critere a partir duquel on raffine
  crit_deraf=cb%vcde ! critere en dessous duquel on deraffine
  write( *,1051)nrafmax
  write( *,1052)crit_raf
  write( *,1053)crit_deraf
 1051 format('CERF_AMR-Info  Maximal refinement level :',i5)
 1052 format('CERF_AMR-Info Mesh refinement parameter :',e13.5)
 1053 format('CERF_AMR-Info Mesh coarsening parameter :',e13.5)

! On normalise les coordonnees des sommet des blocs a 1/1000 de hpetit
  hpetit=1.d20
  DO i=1,cb%msh%nb_cell
      IF (cb%msh%list_cell(i)%h.lt.hpetit)hpetit=cb%msh%list_cell(i)%h
  END DO
  OPEN(11,file='cerfbin_000',status='old',form='unformatted',iostat=ios,iomsg=iomsg)
  if (ios /= 0) call print_err('CERF_AMR','Cannot open cerfbin_000: '//trim(iomsg))
  read(11,iostat=ios,iomsg=iomsg) nb_bloc,nbdom
  if (ios /= 0) call print_err('CERF_AMR','Cannot read header from cerfbin_000: '//trim(iomsg))


  CLOSE(11)
  allocate(list_w_bloc(nb_bloc))
  allocate(bl_ini(nb_bloc))
  allocate(bl_out(nb_bloc))
  allocate(critere(nb_bloc))
  allocate(dtb(nb_bloc))
  allocate(im(nb_bloc))
  allocate(isb(nb_bloc)) ! Indice de solide par bloc
  isb=0

  im=0
  dtb=1.d20
  critere=0.d0

!-----------------------------------------------------------------------------------
! Boucle sur les domaines et les blocs pour determiner le critere de raffinement
!-----------------------------------------------------------------------------------
  critmoy=0.d0   ! valeur moyenne du critere sur tous les domaines
  voltot=0.d0    ! voulume total 
  nbtotcelli=0   !n ombre total (sur tous les domaines) de cellules interieures et aux interfaces
  nbtotcinti=0   ! nombre total (sur tous les domaines) de cellules interieures 
  hpetit=1.d20     ! dimension du plus petit bloc
  DO idom=1,nbdom
      CALL empty_mesh(calc_ini%msh,nbdom,idom)
      CALL empty_sol(calc_ini%list_sol)
      calc_ini%msh%nb_dom=nbdom
      calc_ini%ipas=cb%ipas
! Recuperation du calcul et sauvegarde des variables primitives internes au bloc
      CALL get_calc(calc_ini)
 !!!!!!!!!!!!!
 ! on met a jour les objets "solide" dans cb a partir du domaine 1
  if(idom.eq.1.and.cb%nb_sol.ne.0)then
    do i=1,cb%nb_sol
        cb%list_sol(i)%imv    =calc_ini%list_sol(i)%imv
        cb%list_sol(i)%rho    =calc_ini%list_sol(i)%rho
        cb%list_sol(i)%xmin_s =calc_ini%list_sol(i)%xmin_s
        cb%list_sol(i)%xmax_s =calc_ini%list_sol(i)%xmax_s
        cb%list_sol(i)%ymin_s =calc_ini%list_sol(i)%ymin_s
        cb%list_sol(i)%ymax_s =calc_ini%list_sol(i)%ymax_s
        cb%list_sol(i)%zmin_s =calc_ini%list_sol(i)%zmin_s
        cb%list_sol(i)%zmax_s =calc_ini%list_sol(i)%zmax_s
        cb%list_sol(i)%xg     =calc_ini%list_sol(i)%xg
        cb%list_sol(i)%theta  =calc_ini%list_sol(i)%theta
        cb%list_sol(i)%list_vertex  =calc_ini%list_sol(i)%list_vertex
    enddo
  endif
 !!!!!!!!!!!!!
! Boucle sur les blocs du domaine
      DO ib=1,calc_ini%nb_bloc
          ibloc=calc_ini%list_bloc(ib)%numbl
          bl_ini(ibloc)=calc_ini%list_bloc(ib)
! determination du nombre de cellules du bloc et hpetit, dimension du plus petit bloc
          SELECT CASE (calc_ini%msh%ndim)
             CASE (1) ! Cas 1D
              nb_cell_bloc=bl_ini(ibloc)%nx*2**bl_ini(ibloc)%nrb
              IF (abs(bl_ini(ibloc)%s(1)%x-bl_ini(ibloc)%s(2)%x).lt.hpetit)&
              hpetit=abs(bl_ini(ibloc)%s(1)%x-bl_ini(ibloc)%s(2)%x)
             CASE (2) ! Cas 2D
              nb_cell_bloc=bl_ini(ibloc)%nx*2**bl_ini(ibloc)%nrb* &
                           bl_ini(ibloc)%ny*2**bl_ini(ibloc)%nrb
              IF (abs(bl_ini(ibloc)%s(1)%y-bl_ini(ibloc)%s(4)%y).lt.hpetit)&
              hpetit=abs(bl_ini(ibloc)%s(1)%y-bl_ini(ibloc)%s(4)%y)
             CASE (3) ! Cas 3D
              nb_cell_bloc=bl_ini(ibloc)%nx*2**bl_ini(ibloc)%nrb* &
                           bl_ini(ibloc)%ny*2**bl_ini(ibloc)%nrb* &
                           bl_ini(ibloc)%nz*2**bl_ini(ibloc)%nrb
              IF (abs(bl_ini(ibloc)%s(1)%z-bl_ini(ibloc)%s(5)%z).lt.hpetit)&
              hpetit=abs(bl_ini(ibloc)%s(1)%z-bl_ini(ibloc)%s(5)%z)
          END SELECT
! Sauvegarde des variables primitives internes au bloc
          nullify(list_w_bloc(ibloc)%vec)
          allocate(list_w_bloc(ibloc)%vec(nb_cell_bloc))
          DO i=1,nb_cell_bloc
              list_w_bloc(ibloc)%vec(i)=calc_ini%msh%list_cell(bl_ini(ibloc)%first_cell+i)%w%vprim
              if(calc_ini%msh%list_cell(bl_ini(ibloc)%first_cell+i)%w%chi.ne.0.d0)isb(ibloc)=1 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          END DO
! Calcul du critere
          CALL critraf(calc_ini,critere,ib,nb_cell_bloc)
          critmoy=critmoy+critere(ibloc)
          voltot=voltot+volbloc(bl_ini(ibloc))
          nbtotcinti=nbtotcinti+nb_cell_bloc  
      END DO
      nbtotcelli=nbtotcelli+calc_ini%msh%nb_cell
      
! Reecriture sur fichier solbin
      delta = calc_ini%tmax-calc_ini%tmin
      calc_ini%tmin  =calc_ini%tmin-delta
      calc_ini%tmax  =calc_ini%tmax-delta           
      CALL save_calc(calc_ini)
      CALL empty_mesh(calc_ini%msh,0,0)  ! liberation de la mémoire
      CALL empty_sol(calc_ini%list_sol)
  END DO
!------------------------------------------------------------------------------------------
! FIN de la boucle sur les domaines et les blocs pour determiner le critere de raffinement
!-------------------------------------------------------------------------------------------
  do ib=1,nb_bloc
    critere(ib)=critere(ib)/volbloc(bl_ini(ib))
  enddo
  if(voltot.eq.0.d0)then
      call print_err('CERF_AMR','Total volume is zero, cannot compute average criterion')
  else
      critmoy=critmoy/voltot
  endif
  if(critmoy.eq.0.d0)then
      call print_err('CERF_AMR','Average criterion is zero, cannot normalize criterion')
  else
      critere=critere/critmoy
      write(*,*)'CERF_AMR-INFO Average criterion : ',critmoy
  endif

! Normalisation du critere
  CALL amr2tec(bl_ini,critere,nb_bloc) 
  bl_out=bl_ini
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  DO ib=1,nb_bloc
    if(isb(ib).eq.1)critere(ib)=2*crit_raf
  enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Determination des niveaux de raffinement des blocs
  DO ib=1,nb_bloc
      IF (dabs(critere(ib)).gt.crit_raf.and.bl_out(ib)%nrb.lt.nrafmax) THEN
          im(ib)=1
          bl_out(ib)%nrb=bl_out(ib)%nrb+1
          DO i=1,6
              IF (bl_out(ib)%cl(i).gt.0)im(bl_out(ib)%cl(i))=1
          END DO
      END IF
      IF (dabs(critere(ib)).lt.crit_deraf.and.bl_out(ib)%nrb.gt.0) THEN
          im(ib)=-1
          bl_out(ib)%nrb=bl_out(ib)%nrb-1
          DO i=1,6
              IF (bl_out(ib)%cl(i).gt.0)im(bl_out(ib)%cl(i))=1
          END DO
      END IF
  END DO
! on verifie que 2 blocs voisins n aient pas une difference d indice de raffinement >2      
 10  itest=0
  DO ib=1,nb_bloc
      DO i=1,6
          bcl=bl_out(ib)%cl(i)
          if(bcl.lt.-100000)bcl=-bcl-100000
          IF (bcl.gt.0) THEN
              IF ((bl_out(ib)%nrb-bl_out(bl_out(ib)%cl(i))%nrb).ge.2) THEN
                  itest=1
                  bl_out(bcl)%nrb=bl_out(bcl)%nrb+1
                  im(bcl)=1
                  idv=bcl
                  DO j=1,6
                      bclj=bl_out(idv)%cl(j)
                      if(bclj.lt.-100000)bclj=-bclj-100000
                      IF (bclj.gt.0) im(bclj)=1
                  END DO
              END IF
          END IF
      END DO
  END DO        
  IF(itest.ne.0) goto 10
        
! liste des voisins: -1/ le voisin est + grossier
!                     0/ le voisin est identique
!                     1/ le voisin est + fin
  DO ib=1,nb_bloc
      bl_out(ib)%nrf=0
      DO i=1,6
          bcl=bl_out(ib)%cl(i)
          if(bcl.lt.-100000)bcl=-bcl-100000
          IF (bcl.gt.0) THEN
              IF (bl_out(bcl)%nrb.gt.bl_out(ib)%nrb)bl_out(ib)%nrf(i)=1
              IF (bl_out(bcl)%nrb.lt.bl_out(ib)%nrb)bl_out(ib)%nrf(i)=-1
          END IF
      END DO
  END DO
         
! On refait la repartition des blocs dans chaque domaine
  DO ib=1,nb_bloc
       bl_out(ib)%idom=0
  END DO
  write( *,1011)nb_bloc,nbdom
 1011 format('Aggregation of ',i6,' blocks into',i3,' sub-domains')
  CALL splitdom_Z(bl_out,nb_bloc,nbdom, cb%msh%ndim) !!!!!!! DECOUPAGE PAR Z-ORDER

! Remaillage eventuel des blocs et projection des donnees
! Determination de la taille des tableaux du bloc
  DO ib=1,nb_bloc
      bl_out(ib)%dom=0
      DO i=1,6
          bcl=bl_out(ib)%cl(i)
          if(bcl.lt.-100000)bcl=-bcl-100000
          IF (bcl.gt.0) bl_out(ib)%dom(i)=bl_out(bcl)%idom
      END DO
      imac=1
      imav=1
      imaf=1
      DO i=1,6 ! ima: indice de maillage de l interface entre 2 blocs voisins
          bcl=bl_out(ib)%cl(i)
          if(bcl.lt.-100000)bcl=-bcl-100000
          IF (bl_out(ib)%idom.eq.bl_out(ib)%dom(i).and.ib.lt.bcl)imaf(i)=0
          IF (bl_out(ib)%idom.eq.bl_out(ib)%dom(i).and.ib.lt.bcl)imav(i)=0
          IF (bl_out(ib)%idom.eq.bl_out(ib)%dom(i).or.bcl.le.0)imac(i)=0
      END DO
      
      SELECT CASE (cb%msh%ndim)
        CASE (1) ! Cas 1D
          nx=bl_out(ib)%nx*2**(bl_out(ib)%nrb)
          ny=1
          nz=1
          bl_out(ib)%nb_cell   = nx+imac(1)+imac(2)
          bl_out(ib)%nb_vertex = (nx+1)*(ny+1)*2 
          bl_out(ib)%nb_face   = (nx-1)+nx*2*2 + imaf(1)+imaf(2) 

        CASE (2) ! Cas 2D
          nx=bl_out(ib)%nx*2**(bl_out(ib)%nrb)
          ny=bl_out(ib)%ny*2**(bl_out(ib)%nrb)
          nz=1
          bl_out(ib)%nb_cell = nx*ny + int(ny*2.**bl_out(ib)%nrf(1)*imac(1)) &
                                     + int(ny*2.**bl_out(ib)%nrf(2)*imac(2)) &
                                     + int(nx*2.**bl_out(ib)%nrf(3)*imac(3)) &
                                     + int(nx*2.**bl_out(ib)%nrf(4)*imac(4))
          bl_out(ib)%nb_vertex = (nx+1)*(ny+1)*2 &
                                     + bl_out(ib)%nrf(1)*(bl_out(ib)%nrf(1)+1)*ny*imav(1) &
                                     + bl_out(ib)%nrf(2)*(bl_out(ib)%nrf(2)+1)*ny*imav(2) &
                                     + bl_out(ib)%nrf(3)*(bl_out(ib)%nrf(3)+1)*nx*imav(3) &
                                     + bl_out(ib)%nrf(4)*(bl_out(ib)%nrf(4)+1)*nx*imav(4)
          bl_out(ib)%nb_face   = (nx-1)*ny+nx*(ny-1)+nx*ny*2 &
                                     + ny*imaf(1)+ny*imaf(2)+nx*imaf(3)+nx*imaf(4)  &
                                     + bl_out(ib)%nrf(1)*(bl_out(ib)%nrf(1)+1)*ny/2*imaf(1) &
                                     + bl_out(ib)%nrf(2)*(bl_out(ib)%nrf(2)+1)*ny/2*imaf(2) &
                                     + bl_out(ib)%nrf(3)*(bl_out(ib)%nrf(3)+1)*nx/2*imaf(3) &
                                     + bl_out(ib)%nrf(4)*(bl_out(ib)%nrf(4)+1)*nx/2*imaf(4)        
        CASE (3) ! Cas 3D
          nx=bl_out(ib)%nx*2**(bl_out(ib)%nrb)
          ny=bl_out(ib)%ny*2**(bl_out(ib)%nrb)
          nz=bl_out(ib)%nz*2**(bl_out(ib)%nrb)
          bl_out(ib)%nb_cell   = nx*ny*nz &
                                     + int(ny*nz*4.**bl_out(ib)%nrf(1)*imac(1)) &
                                     + int(ny*nz*4.**bl_out(ib)%nrf(2)*imac(2)) &
                                     + int(nx*nz*4.**bl_out(ib)%nrf(3)*imac(3)) &
                                     + int(nx*nz*4.**bl_out(ib)%nrf(4)*imac(4)) &
                                     + int(nx*ny*4.**bl_out(ib)%nrf(5)*imac(5)) &
                                     + int(nx*ny*4.**bl_out(ib)%nrf(6)*imac(6)) 
          bl_out(ib)%nb_vertex = (nx+1)*(ny+1)*(nz+1) &
                                     + bl_out(ib)%nrf(1)*(bl_out(ib)%nrf(1)+1)/2*(3*ny*nz+ny+nz)*imav(1) &
                                     + bl_out(ib)%nrf(2)*(bl_out(ib)%nrf(2)+1)/2*(3*ny*nz+ny+nz)*imav(2) &
                                     + bl_out(ib)%nrf(3)*(bl_out(ib)%nrf(3)+1)/2*(3*nx*nz+nx+nz)*imav(3) &
                                     + bl_out(ib)%nrf(4)*(bl_out(ib)%nrf(4)+1)/2*(3*nx*nz+nx+nz)*imav(4) &
                                     + bl_out(ib)%nrf(5)*(bl_out(ib)%nrf(5)+1)/2*(3*nx*ny+nx+ny)*imav(5) &
                                     + bl_out(ib)%nrf(6)*(bl_out(ib)%nrf(6)+1)/2*(3*nx*ny+nx+ny)*imav(6) 
          bl_out(ib)%nb_face   = (nx-1)*ny*nz+nx*(ny-1)*nz+nx*ny*(nz-1) &
                                     + ny*nz*imaf(1)+ny*nz*imaf(2)+nx*nz*imaf(3)+nx*nz*imaf(4) &
                                     + nx*ny*imaf(5)+nx*ny*imaf(6) &
                                     + bl_out(ib)%nrf(1)*(bl_out(ib)%nrf(1)+1)/2*3*ny*nz*imaf(1) &
                                     + bl_out(ib)%nrf(2)*(bl_out(ib)%nrf(2)+1)/2*3*ny*nz*imaf(2) &
                                     + bl_out(ib)%nrf(3)*(bl_out(ib)%nrf(3)+1)/2*3*nx*nz*imaf(3) &
                                     + bl_out(ib)%nrf(4)*(bl_out(ib)%nrf(4)+1)/2*3*nx*nz*imaf(4) &  
                                     + bl_out(ib)%nrf(5)*(bl_out(ib)%nrf(5)+1)/2*3*nx*ny*imaf(5) &  
                                     + bl_out(ib)%nrf(6)*(bl_out(ib)%nrf(6)+1)/2*3*nx*ny*imaf(6)   
                                                
      END SELECT
  END DO

! Creation de la liste des interfaces
  allocate(interdom(nbdom*(nbdom-1)/2))
  allocate(nbl(nbdom*(nbdom-1)/2))
  CALL inter(bl_out,nb_bloc,nbdom,interdom,nbl,cb%msh%ndim)

! Determination de petit
  petit=1.d-4
  DO ib=1,nb_bloc
      IF (hpetit/(bl_out(ib)%nx*2**bl_out(ib)%nrb).lt.petit) petit=hpetit/(bl_out(ib)%nx*2**bl_out(ib)%nrb)
      IF (hpetit/(bl_out(ib)%ny*2**bl_out(ib)%nrb).lt.petit.and.cb%msh%ndim.ne.1)&
      petit=hpetit/(bl_out(ib)%ny*2**bl_out(ib)%nrb)
      IF (hpetit/(bl_out(ib)%nz*2**bl_out(ib)%nrb).lt.petit.and.cb%msh%ndim.eq.3)&
      petit=hpetit/(bl_out(ib)%nz*2**bl_out(ib)%nrb)
  END DO
  petit=petit*0.1d0
  write( *,1818)petit,hpetit
  1818     format('CERF_AMR-INFO Small dimensions :',2e13.5)

! Boucle sur les domaines
  DO idom=1,nbdom
      ! Initialisations
      calc_out%msh%ndim  =cb%msh%ndim
      calc_out%msh%nb_dom=nbdom
      nullify(calc_out%msh%list_vertex)
      nullify(calc_out%msh%list_face)
      nullify(calc_out%msh%list_cell)
      nullify(calc_out%msh%list_send)
      nullify(calc_out%msh%list_recv)
      CALL empty_mesh(calc_out%msh,calc_out%msh%nb_dom,idom)
      CALL copy_sol(cb,calc_out)
      IF (associated(calc_out%list_bloc)) THEN
          deallocate(calc_out%list_bloc)
          nullify(calc_out%list_bloc)
      END IF
      nullify(calc_out%list_bloc)

      ! Determination de la taille des tableaux du domaine
      calc_out%msh%nb_cell  = 0
      calc_out%msh%nb_vertex= 0
      calc_out%msh%nb_face  = 0
      calc_out%nb_bloc=0
         
      DO ib=1,nb_bloc
          IF (bl_out(ib)%idom.eq.idom) THEN
              calc_out%nb_bloc=calc_out%nb_bloc+1
              bl_out(ib)%first_cell=calc_out%msh%nb_cell
              calc_out%msh%nb_cell  = calc_out%msh%nb_cell  +bl_out(ib)%nb_cell
              bl_out(ib)%first_face=calc_out%msh%nb_face
              calc_out%msh%nb_face  = calc_out%msh%nb_face  +bl_out(ib)%nb_face
              bl_out(ib)%first_vertex=calc_out%msh%nb_vertex
              calc_out%msh%nb_vertex= calc_out%msh%nb_vertex+bl_out(ib)%nb_vertex
          END IF
      END DO
         
      allocate(calc_out%list_bloc(calc_out%nb_bloc))
      allocate(calc_out%msh%list_cell(calc_out%msh%nb_cell))
      allocate(calc_out%msh%list_vertex(calc_out%msh%nb_vertex))
      allocate(calc_out%msh%list_face(calc_out%msh%nb_face))
      allocate(calc_out%msh%list_send(calc_out%msh%nb_dom))
      allocate(calc_out%msh%list_recv(calc_out%msh%nb_dom))
      DO i=1,idom-1
          k=idom-i+(i-1)*(2*nbdom-i)/2 
          IF (nbl(k).ne.0) allocate(calc_out%msh%list_recv(i)%L(interdom(k)%L(4*nbl(k)-1)))
          IF (nbl(k).ne.0) allocate(calc_out%msh%list_send(i)%L(interdom(k)%L(4*nbl(k)-0)))
      END DO
      DO i=idom+1,nbdom
          k=i-idom+(idom-1)*(2*nbdom-idom)/2
          IF (nbl(k).ne.0) allocate(calc_out%msh%list_recv(i)%L(interdom(k)%L(4*nbl(k)-0)))
          IF (nbl(k).ne.0) allocate(calc_out%msh%list_send(i)%L(interdom(k)%L(4*nbl(k)-1)))
      END DO

! Maillage des blocs du domaine
      icb=0
      DO ib=1,nb_bloc
          IF (bl_out(ib)%idom.eq.idom) THEN
              icb=icb+1
              calc_out%list_bloc(icb)=bl_out(ib)
              DO i=1,6
                  blv(i)=bl_null
                  bcl=bl_out(ib)%cl(i)
                  if(bcl.lt.-100000)bcl=-bcl-100000
                  IF (bcl.gt.0)blv(i)=bl_out(bcl)
              END DO
              SELECT CASE (cb%msh%ndim)
                 CASE (1)
                   CALL mesh1d(bl_out(ib),calc_out%msh,ib,nbdom,blv,interdom)
                 CASE (2)
                  CALL mesh2d(bl_out(ib),calc_out%msh,ib,nbdom,blv,interdom)
                 CASE (3)
                  CALL mesh3d(bl_out(ib),calc_out%msh,ib,nbdom,blv,interdom)
              END SELECT
          END IF
      END DO ! Fin boucle sur les blocs
      CALL init_mesh(calc_out%msh) 
      
! On verifie les orientations de face
      iv=0
      DO i=1,calc_out%msh%nb_face
          ic1=calc_out%msh%list_face(i)%ic1
          d=(calc_out%msh%list_face(i)%center%x-calc_out%msh%list_cell(ic1)%center%x)*&
             calc_out%msh%list_face(i)%vnorm%v(1)+&
            (calc_out%msh%list_face(i)%center%y-calc_out%msh%list_cell(ic1)%center%y)*&
             calc_out%msh%list_face(i)%vnorm%v(2)+&
            (calc_out%msh%list_face(i)%center%z-calc_out%msh%list_cell(ic1)%center%z)*&
            calc_out%msh%list_face(i)%vnorm%v(3)         
          IF (d.le.0.) THEN
              calc_out%msh%list_face(i)%vnorm%v=-calc_out%msh%list_face(i)%vnorm%v
              itemp=calc_out%msh%list_face(i)%vertex(2)
              calc_out%msh%list_face(i)%vertex(2)=calc_out%msh%list_face(i)%vertex(calc_out%msh%list_face(i)%nbvertex)
              calc_out%msh%list_face(i)%vertex(calc_out%msh%list_face(i)%nbvertex)=itemp
              iv=iv+1
          END IF
      END DO
      IF (iv.ne.0) CALL init_mesh(calc_out%msh)

! On elimine les sommets surabondants
      nvi=calc_out%msh%nb_vertex
      CALL trivertex(calc_out%msh)
      write( *,1111)idom,nvi-calc_out%msh%nb_vertex,nvi,calc_out%msh%nb_vertex
 1111 format('CERF_AMR-INFO Domain',i3,' elimination of ',i7,' vertexes out of',i7,', i.e.',i7,' vertexes.')
        
! Initialisation sur tout le domaine
      nbtotcello=0
      nbtotcinto=0
      CALL empty_mesh(calc_ini%msh,nbdom,idom)
      CALL empty_sol(calc_ini%list_sol)
      CALL get_calc(calc_ini)
     
! Copie de l objet calcul              
      calc_out%tmin           = calc_ini%tmin
      calc_out%tmax           = calc_ini%tmax
      calc_out%dt             = calc_ini%dt
      calc_out%pdtp           = calc_ini%pdtp
      calc_out%cfl            = calc_ini%cfl
      calc_out%vmax           = calc_ini%vmax
      calc_out%isauv          = calc_ini%isauv
      calc_out%istart         = calc_ini%istart
      calc_out%ipas           = calc_ini%ipas
      calc_out%iordre_e       = calc_ini%iordre_e
      calc_out%iordre_t       = calc_ini%iordre_t
      calc_out%imeth_int_temps= calc_ini%imeth_int_temps
      calc_out%point_sondes   = calc_ini%point_sondes
      calc_out%nb_sondes      = calc_ini%nb_sondes
      calc_out%num_point_min  = calc_ini%num_point_min
      calc_out%ityp_flux      = calc_ini%ityp_flux
      calc_out%ilimiteur      = calc_ini%ilimiteur
      calc_out%nbds           = calc_ini%nbds
      calc_out%nrma           = calc_ini%nrma
      calc_out%vcde           = calc_ini%vcde
      calc_out%vcra           = calc_ini%vcra
      calc_out%nb_sol         = calc_ini%nb_sol
      calc_out%list_sol       = calc_ini%list_sol
            
           
      DO ib=1,calc_out%nb_bloc
          ibloc=calc_out%list_bloc(ib)%numbl
          CALL proddl(list_w_bloc(ibloc),bl_ini(ibloc),bl_out(ibloc),calc_out,cb%msh%ndim)
      END DO
!---------------------------
! Si presence de solides
      IF (calc_out%nb_sol .NE. 0) THEN
          DO i = 1,calc_out%msh%nb_cell
            calc_out%msh%list_cell(i)%w%chi=0.d0
          enddo
          DO j = 1,calc_out%nb_sol
               k=0
               DO i = 1,calc_out%msh%nb_cell
                    IF (          &
                    calc_out%msh%list_cell(i)%center%x<calc_out%list_sol(j)%xmax_s  &
                    .AND. calc_out%msh%list_cell(i)%center%x>calc_out%list_sol(j)%xmin_s  &
                    .AND. calc_out%msh%list_cell(i)%center%y<calc_out%list_sol(j)%ymax_s  &
                    .AND. calc_out%msh%list_cell(i)%center%y>calc_out%list_sol(j)%ymin_s  &
                    .AND. calc_out%msh%list_cell(i)%center%z<calc_out%list_sol(j)%zmax_s  &
                    .AND. calc_out%msh%list_cell(i)%center%z>calc_out%list_sol(j)%zmin_s) &
                    CALL raycasting(calc_out%list_sol(j),calc_out%msh%list_cell(i)%center%x,&
                                                     calc_out%msh%list_cell(i)%center%y,&
                                                     calc_out%msh%list_cell(i)%center%z,&
                                                     calc_out%msh%list_cell(i)%w%chi)
                    IF (calc_out%msh%list_cell(i)%w%chi .EQ. calc_out%list_sol(j)%id) k=k+1
               END DO
               calc_out%list_sol(j)%nb_cell = k
          END DO

          DO j = 1,calc_out%nb_sol
               k=0
               DO i = 1,calc_out%msh%nb_cell
                    IF (   calc_out%msh%list_cell(i)%idom .EQ. calc_out%msh%numdom         &
                    .AND.  calc_out%msh%list_cell(i)%center%x<calc_out%list_sol(j)%xmax_s  &
                    .AND.  calc_out%msh%list_cell(i)%center%x>calc_out%list_sol(j)%xmin_s  &
                    .AND.  calc_out%msh%list_cell(i)%center%y<calc_out%list_sol(j)%ymax_s  &
                    .AND.  calc_out%msh%list_cell(i)%center%y>calc_out%list_sol(j)%ymin_s  &
                    .AND.  calc_out%msh%list_cell(i)%center%z<calc_out%list_sol(j)%zmax_s  &
                    .AND.  calc_out%msh%list_cell(i)%center%z>calc_out%list_sol(j)%zmin_s  &
                    .AND. (calc_out%msh%list_cell(i)%w%chi .EQ. calc_out%list_sol(j)%id)) THEN
                         k=k+1
                         !calc_out%list_sol(j)%list_cells(k) = i
                         calc_out%msh%list_cell(i)%w%chi = calc_out%list_sol(j)%id
                         calc_out%msh%list_cell(i)%w%vprim%v(1)=calc_out%list_sol(j)%rho
                         CALL prim2bal(calc_out%msh%list_cell(i)%w)
                    END IF
               END DO
          END DO
          if(idom.eq.1)call save_obj(calc_out)
      END IF     
      

! Sauvegarde
      calc_out%msh%numdom=idom
      DO i=1,calc_out%msh%nb_cell
          calc_out%msh%list_cell(i)%w%vbal%v=0.d0
          calc_out%msh%list_cell(i)%balance%v=0.d0
          calc_out%msh%list_cell(i)%fp%v=0.d0
          calc_out%msh%list_cell(i)%w%gprim(1)%v=0.d0
          calc_out%msh%list_cell(i)%w%gprim(2)%v=0.d0
          calc_out%msh%list_cell(i)%w%gprim(3)%v=0.d0
          calc_out%msh%list_cell(i)%w%enti=0.d0
          calc_out%msh%list_cell(i)%w%entf=0.d0
          calc_out%msh%list_cell(i)%w%pe  =0.d0
          CALL prim2bal(calc_out%msh%list_cell(i)%w)
      END DO

      delta  =calc_out%tmax-calc_out%tmin
      calc_out%tmin  =calc_out%tmin-delta
      calc_out%tmax  =calc_out%tmax-delta     
 
      CALL save_calc(calc_out)
      CALL empty_mesh(calc_out%msh,0,0)  ! liberation de la mémoire
      CALL empty_mesh(calc_ini%msh,0,0)  ! liberation de la mémoire
      CALL empty_sol(calc_ini%list_sol)
      CALL empty_sol(calc_out%list_sol)
    
  END DO
  
  
  nbtotcinti=0
  nbtotcinto=0
  nbtotcelli=0   
  nbtotcello=0   
  DO ib=1,nb_bloc
      SELECT CASE (cb%msh%ndim)
        CASE (1)
          nb_cell_bloc=bl_ini(ib)%nx*2**bl_ini(ib)%nrb
        CASE (2)
          nb_cell_bloc=bl_ini(ib)%nx*2**bl_ini(ib)%nrb*bl_ini(ib)%ny*2**bl_ini(ib)%nrb
        CASE (3)
          nb_cell_bloc=bl_ini(ib)%nx*2**bl_ini(ib)%nrb* &
                       bl_ini(ib)%ny*2**bl_ini(ib)%nrb* &
                       bl_ini(ib)%nz*2**bl_ini(ib)%nrb
      END SELECT
      nbtotcinti=nbtotcinti+nb_cell_bloc
      nbtotcelli=nbtotcinti+bl_ini(ib)%nb_cell
      SELECT CASE (cb%msh%ndim)
        CASE (1)
          nb_cell_bloc=bl_out(ib)%nx*2**bl_out(ib)%nrb
        CASE (2)
          nb_cell_bloc=bl_out(ib)%nx*2**bl_out(ib)%nrb* &
                       bl_out(ib)%ny*2**bl_out(ib)%nrb
        CASE (3)
         nb_cell_bloc=bl_out(ib)%nx*2**bl_out(ib)%nrb* &
                      bl_out(ib)%ny*2**bl_out(ib)%nrb* &
                      bl_out(ib)%nz*2**bl_out(ib)%nrb
      END SELECT
      nbtotcinto=nbtotcinto+nb_cell_bloc
      nbtotcello=nbtotcinto+bl_ini(ib)%nb_cell
  END DO
  write(*,*)'Total number of cells,    before', nbtotcelli, '  after', nbtotcello
  write(*,*)'Number of interior cells, before', nbtotcinti, '  after', nbtotcinto
!===========================   FIN DE LA ROUTINE    ====================

  END PROGRAM cerf_amr
!DOCFIN

 SUBROUTINE mame2bloc(xmin,xmax,ymin,ymax,zmin,zmax,nx,ny,nz,lst_bloc,ndim)
!=========================== DOCUMENTATION =============================
!DOCDEBh*    UTI/PRE/mame2bloc  * 
!
!    NOM
! mame2bloc(xmin,xmax,ymin,ymax,zmin,zmax,nx,ny,nz,lst_bloc,ndim)
!
!    DESCRIPTION
!*
! Maillage regulier de blocs d un cube 3d en hexaedres (xmin,ymin,xmax,ymax,zmin,zmax)
! nx, ny, nz sont les nombres de blocs suivant x, y, z
!
! Regular mesh of blocks of a 3d cube in hexaedres (xmin,ymin,xmax,ymax,zmin,zmax)
! nx, ny, nz are the number of blocks following x, y, z
!*
! 
!    ENTREES
! xmin,xmax,ymin,ymax,zmin,zmax,nx,ny,nz
!
!    SORTIES
! lst_bloc  : liste des blocs / list of blocks
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ====================
!.1-----  Implicit, Use
 use num
 use zorder
 implicit none
!.2-----  Declaration
 real(kind=kind(0.d0)), intent(inout)             :: xmin,xmax,ymin,ymax,zmin,zmax !! Definition du domaine a mailler / Definition of the area to be meshed 
 integer, intent(in)                              :: nx,ny,nz !! Discretisation suivant x,y,z / Discretisation according to x,y,z
 integer, intent(in)                              :: ndim !! Dimension du probleme / Problem dimensionb
 type(bloc), pointer, dimension(:), intent(inout) :: lst_bloc !! Liste des blocs / Block list

 real(kind=kind(0.d0)) :: x,y,z,hx,hy,hz
 integer               :: i,j,k,ia,mortonx,mortony,mortonz

 integer(kind=16)      :: nmorton
 integer(kind=16) ,allocatable,dimension(:)     :: lm
!=========================== DEBUT DU CODE EXECUTABLE ==================
!-------  Initialisations
! Dimensions caracteristiques de morton
hx=(xmax-xmin)/(nx)
hy=(ymax-ymin)/(ny)
hz=(zmax-zmin)/(nz)
petit_morton=min(hx,hy,hz)*0.1d0
x_min_morton=xmin
y_min_morton=ymin
z_min_morton=zmin
allocate (lm(nx*ny*nz))

! Creation des blocs
do i=1,nx
    do j=1,ny
        do k=1,nz
            ia=i+(j-1)*nx+nx*ny*(k-1)
            lst_bloc(ia)%numbl     = ia
            lst_bloc(ia)%idom      = 1
            lst_bloc(ia)%nrb       = 0
            lst_bloc(ia)%nx        = 1
            lst_bloc(ia)%ny        = 1
            lst_bloc(ia)%nz        = 1
            lst_bloc(ia)%s(:)%x    = 0.d0
            lst_bloc(ia)%s(:)%y    = 0.d0
            lst_bloc(ia)%s(:)%z    = 0.d0
            lst_bloc(ia)%s(1)%x    = xmin+(i-1)*hx ; lst_bloc(ia)%s(1)%y    = ymin+(j-1)*hy ; lst_bloc(ia)%s(1)%z    = zmin+(k-1)*hz  
            lst_bloc(ia)%s(2)%x    = xmin+(i-0)*hx ; lst_bloc(ia)%s(2)%y    = ymin+(j-1)*hy ; lst_bloc(ia)%s(2)%z    = zmin+(k-1)*hz  
            lst_bloc(ia)%s(3)%x    = xmin+(i-0)*hx ; lst_bloc(ia)%s(3)%y    = ymin+(j-0)*hy ; lst_bloc(ia)%s(3)%z    = zmin+(k-1)*hz  
            lst_bloc(ia)%s(4)%x    = xmin+(i-1)*hx ; lst_bloc(ia)%s(4)%y    = ymin+(j-0)*hy ; lst_bloc(ia)%s(4)%z    = zmin+(k-1)*hz  
            lst_bloc(ia)%s(5)%x    = xmin+(i-1)*hx ; lst_bloc(ia)%s(5)%y    = ymin+(j-1)*hy ; lst_bloc(ia)%s(5)%z    = zmin+(k-0)*hz  
            lst_bloc(ia)%s(6)%x    = xmin+(i-0)*hx ; lst_bloc(ia)%s(6)%y    = ymin+(j-1)*hy ; lst_bloc(ia)%s(6)%z    = zmin+(k-0)*hz  
            lst_bloc(ia)%s(7)%x    = xmin+(i-0)*hx ; lst_bloc(ia)%s(7)%y    = ymin+(j-0)*hy ; lst_bloc(ia)%s(7)%z    = zmin+(k-0)*hz  
            lst_bloc(ia)%s(8)%x    = xmin+(i-1)*hx ; lst_bloc(ia)%s(8)%y    = ymin+(j-0)*hy ; lst_bloc(ia)%s(8)%z    = zmin+(k-0)*hz  
            lst_bloc(ia)%cl(:)     = 0
            lst_bloc(ia)%cl(1)     = i-1+(j-1)*nx+nx*ny*(k-1)
            lst_bloc(ia)%cl(2)     = i+1+(j-1)*nx+nx*ny*(k-1)
            lst_bloc(ia)%cl(3)     = i+0+(j-2)*nx+nx*ny*(k-1)
            lst_bloc(ia)%cl(4)     = i+0+(j-0)*nx+nx*ny*(k-1)
            lst_bloc(ia)%cl(5)     = i+0+(j-1)*nx+nx*ny*(k-2)
            lst_bloc(ia)%cl(6)     = i+0+(j-1)*nx+nx*ny*(k-0)
              lst_bloc(ia)%dom(:)= 1
            if (i==1 )then
              lst_bloc(ia)%cl(1) = -111
            endif
            if (j==1 )then
              lst_bloc(ia)%cl(3) = -333
              if(ndim.eq.1)lst_bloc(ia)%cl(3) = -999
            endif
            if (k==1 )then
              lst_bloc(ia)%cl(5) = -555
              if(ndim.le.2)lst_bloc(ia)%cl(5) = -999
            endif
            if (i==nx)then
              lst_bloc(ia)%cl(2) = -222
            endif
            if (j==ny)then
              lst_bloc(ia)%cl(4) = -444
              if(ndim.eq.1)lst_bloc(ia)%cl(4) = -999
            endif
            if (k==nz)then
              lst_bloc(ia)%cl(6) = -666
              if(ndim.le.2)lst_bloc(ia)%cl(6) = -999
            endif
            lst_bloc(ia)%nrf(:)      = 0
            lst_bloc(ia)%first_cell  = 0
            lst_bloc(ia)%nb_cell     = 0
            lst_bloc(ia)%first_face  = 0
            lst_bloc(ia)%nb_face     = 0
            lst_bloc(ia)%first_vertex= 0
            lst_bloc(ia)%nb_vertex   = 0
            lst_bloc(ia)%volc        = volbloc(lst_bloc(ia))
             x=xmin+(2*i-1)*hx*.5d0
             y=ymin+(2*j-1)*hy*.5d0
             z=zmin+(2*k-1)*hz*.5d0
             mortonx=coord_real2int(x,x_min_morton,petit_morton)
             mortony=coord_real2int(y,y_min_morton,petit_morton)
             mortonz=coord_real2int(z,z_min_morton,petit_morton)
             call zordercurve3d(mortonx,mortony,mortonz,nmorton)
             !lst_bloc(ia)%morton    = nmorton
             lm(ia)    = nmorton
        enddo
    enddo
enddo

! on ordonne les numeros (locaux) des blocs selon le code de morton (lm)
k=0
do ia=1,nx*ny*nz
    j=int(minloc(lm,1,mask=lm.ne.0))
    k=k+1
    lst_bloc(ia)%morton    = k
    lm(j)=0
enddo
deallocate(lm)
return
!===========================   FIN DE LA ROUTINE    ====================

END SUBROUTINE mame2bloc
!DOCFIN

 MODULE phy
!=========================== DOCUMENTATION ============================= 
!DOCDEBm*    PHY/phy  *
!
!    NOM
! phy
!    DESCRIPTION  
!*
! Interface des routines du Module PHYsique
!
! Interface of routines from PHYsic Module 
!*
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
! tableaux de variables utilisé pour les conditions aux limites et les conditions initiales constantes
  type(state),dimension(phy_nb_cl) :: phy_state
! type du flux numérique
!  =0   --> rusanov
! =1 --> godunov
! integer                          :: phy_typflux = 0
! variable de debuguage des cas test
! istep=0/1   --> cas test de la rampe inactif ou actif
! (sert à appliquer des profils de vitesse)
 ! integer                          :: phy_istep=0
 !=========================== DEBUT DU CODE EXECUTABLE ==================

!~ 
!~!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE bal2prim(w)
        use phy_typ
        type(state),intent(inout) :: w 
      END SUBROUTINE Bal2Prim
  END INTERFACE
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE critphy(w,c)
        use phy_typ
        type(state), intent(inout) :: w 
        real(kind=kind(0.d0)), intent(out) :: c
      END SUBROUTINE critphy
  END INTERFACE
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE entropie(w,e)
        use phy_typ
        type(state), intent(inout) :: w 
        real(kind=kind(0.d0)), intent(out) :: e
      END SUBROUTINE entropie
  END INTERFACE
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
    interface
        SUBROUTINE  fct_bathy(x,y,z,zb,zbx,zby,cf)
            use phy_typ
            real(kind=kind(0.d0)), intent(in)                :: x,y,z
            real(kind=kind(0.d0)), intent(out)               :: zb,cf,zbx,zby
        END SUBROUTINE fct_bathy
    end interface
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
    interface
        SUBROUTINE  fct_cond(vi,vp,fctnum,x,y,z,vn)
            use phy_typ
           integer, intent(in)              :: fctnum
           real(kind=kind(0.d0)),intent(in) :: x,y,z
           type(vect_nvar), intent(in)      :: vi
           type(vect_nvar), intent(out)     :: vp
           type(vect_3),intent(in)          :: vn
        END SUBROUTINE fct_cond
    end interface
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
    interface
        SUBROUTINE  fct_iniw(x,y,z,vprim,ifct)
            use phy_typ
            real(kind=kind(0.d0)), intent(in)    :: x,y,z
            type(vect_nvar) , intent(out)        :: vprim
            integer                              :: ifct
        END SUBROUTINE fct_iniw
    end interface
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
    interface
        SUBROUTINE fct_mvsol(v1,v2,v3,o1,o2,o3,num)
          use phy_typ
          real(kind=kind(0.d0)) :: v1,v2,v3,o1,o2,o3
          integer               :: num
        END SUBROUTINE fct_mvsol
    end interface
!----- Fin Interface --------------------------------------------------


!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE fluxnum(wL,wR,vn,flux,itypflux)
        use phy_typ
        integer                    :: itypflux
        type(state), intent(in)    :: wL , wR
        type(vect_3),intent(in)    :: vn
        type(vect_nvar),intent(out):: flux
      END SUBROUTINE fluxnum
  END INTERFACE
!----- Fin Interface --------------------------------------------------


!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE fluxnumnoncons(wL,wR,vn,fluxnc,itypflux)
        use phy_typ
        integer                    :: itypflux
        type(state), intent(in) :: wL , wR
        type(vect_3),intent(in):: vn
        type(vect_nvar),intent(out):: fluxnc
      END SUBROUTINE fluxnumnoncons
  END INTERFACE
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE prim2bal(w)
        use phy_typ
        type(state),intent(inout) :: w 
      END SUBROUTINE Prim2Bal
  END INTERFACE
!~!----- Fin Interface --------------------------------------------------


!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE riemisot(rg,ug,phig,alfg,rd,ud,phid,alfd,xi,r,u,p,phi,alf)
        real(kind=kind(0.d0)),intent(in):: rg,ug,phig,alfg,rd,ud,phid,alfd,xi
        real(kind=kind(0.d0)),intent(out):: r,u,p,phi,alf
      END SUBROUTINE riemisot
  END INTERFACE
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE sources(w,s,iordre)
        use phy_typ
        type(state), intent(in) :: w 
        type(vect_nvar),intent(out):: s
        integer,intent(in) :: iordre
      END SUBROUTINE sources
  END INTERFACE
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
    interface
        subroutine svriemann(hg,ug,hd,ud,xi,h,u)
          real(kind=kind(0.d0)),intent(in):: hg,ug,hd,ud,xi
          real(kind=kind(0.d0)),intent(out):: h,u
        end subroutine svriemann
    end interface
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE VelCFL(w,vloc,h)
        use phy_typ
        type(state),intent(in) :: w 
        real(kind=kind(0.d0)),intent(in) :: h
        real(kind=kind(0.d0)),intent(out) :: vloc
      END SUBROUTINE VelCFL
  END INTERFACE
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE vitson(w,cson)
        use phy_typ
        type(state),intent(in) :: w
        real(kind=kind(0.d0)),intent(out) :: cson
      END SUBROUTINE Vitson
  END INTERFACE
!----- Fin Interface --------------------------------------------------

!----- Debut Interface ------------------------------------------------
  INTERFACE
      SUBROUTINE Wext(win,wout,vn,ityp,x,y,z,xm,ym,zm)
        use phy_typ
        integer,intent(in) ::  ityp
        type(state),intent(in) :: win
        type(vect_3),intent(in) :: vn
        real(kind=kind(0.d0)),optional,intent(in) :: x,y,z
        real(kind=kind(0.d0)),optional,intent(in) :: xm,ym,zm
        type(state),intent(out) :: wout
      END SUBROUTINE Wext
  END INTERFACE
!----- Fin Interface --------------------------------------------------

!===========================   FIN DU MODULE   =========================
 END MODULE phy
!DOCFIN

  PROGRAM cerf2tec
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/cerf2tec  *
!
!    NOM
! cerf2tec
!    DESCRIPTION  
!*
! Programme permettant la lecture de fichiers binaires au format CERF
! puis de les transformer en un fichier au format tecplot en version multibloc
! Program for reading binary files in CERF format
! then transform them into a file in tecplot format in a multiblock version
!*
!
!    AUTEUR 
! GOLAY
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use uti
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul)                                    :: calc 
  type(point)                                     :: p 
  integer                                         :: idom,i,j,k,ii,ib,nx,ny,nz,ivar,np,i2d,icell
  integer                                         :: ibloc,ifc,nb_bloc,nbdom,is,nxtot
  real(kind=kind(0.d0)) ,allocatable,dimension(:) :: x,y,z
!=========================== DEBUT DU CODE EXECUTABLE ==================

 write(*,*)achar(27)//'[34m**********************************************************'
 write(*,*) fdate()
 write(*,*)'CERF 2 Tecplot format output '
 write(*,*)'**********************************************************' //achar(27)//'[0m'

 nx=1;ny=1;nz=1;nxtot=0

! lecture des informations necessaires a la transformation
  OPEN(11,file='cerfbin_000',status='old',form='unformatted')
  read(11) nb_bloc,nbdom
  CLOSE(11)

! Boucle sur les domaines et les blocs 
  OPEN(12,file='cerfout.dat',status='unknown')
  !~OPEN(13,file='blocamr.dat',status='unknown')
  !~write(13,*)'Number of blocks',nb_bloc
  DO idom=1,nbdom
      CALL empty_mesh(calc%msh,nbdom,idom)
      CALL empty_sol(calc%list_sol)
! Recuperation du calcul
      CALL get_calc(calc)
      IF (idom.eq.1) THEN
          write(12,*)' TITLE="',calc%tmin,'"'
          if(imodel_phy.ne.1)then  
            write(12,*)' VARIABLES="X","Y","Z","R","U","V","W","P","Prod"'
          else   !Cas particulier du modele de SaintVenant
            write(12,*)' VARIABLES="X","Y","Z","eta","U","V","P_S","Zbottom"'
          endif
      endif
      if(imodel_phy.eq.1)then  
        do i=1,calc%msh%nb_cell
          if(calc%msh%list_cell(i)%w%vprim%v(1)<hzero_phy)then
            calc%msh%list_cell(i)%w%vprim%v(1)=0.d0
          else
            calc%msh%list_cell(i)%w%vprim%v(1)=calc%msh%list_cell(i)%w%vprim%v(1)+&
                                               calc%msh%list_cell(i)%w%vprim%v(5)
          endif
        enddo
      endif
      
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  DEBUG SOLIDE !!!!!!!!!!!!!!!!!!!
       !~do i=1,calc%msh%nb_cell
       !~     calc%msh%list_cell(i)%w%vprim%v(4)=calc%msh%list_cell(i)%w%chi
       !~ enddo
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  DEBUG SOLIDE !!!!!!!!!!!!!!!!!!!

      DO ib=1,calc%nb_bloc
          !~CALL ecrit_bloc(calc%list_bloc(ib))
          ibloc=calc%list_bloc(ib)%numbl
          SELECT CASE (calc%msh%ndim)
            CASE (1) ! Cas 1D
              nx=calc%list_bloc(ib)%nx*2**(calc%list_bloc(ib)%nrb)
              ny=1
              nz=1
              i2d=-1
              nxtot=nxtot+nx
            CASE (2) ! Cas 2D
              nx=calc%list_bloc(ib)%nx*2**(calc%list_bloc(ib)%nrb)
              ny=calc%list_bloc(ib)%ny*2**(calc%list_bloc(ib)%nrb)
              nz=1
              i2d=1
            CASE (3) ! Cas 3D
              nx=calc%list_bloc(ib)%nx*2**(calc%list_bloc(ib)%nrb)
              ny=calc%list_bloc(ib)%ny*2**(calc%list_bloc(ib)%nrb)
              nz=calc%list_bloc(ib)%nz*2**(calc%list_bloc(ib)%nrb)
              i2d=0
          END SELECT

          write(12,1000)nx+1,ny+1,nz+1
1000 format('ZONE I=',i5,' J=',i5,' K=',i5,&
            ', DATAPACKING=BLOCK, VARLOCATION=([4,5,6,7,8,9]=CELLCENTERED)')
                  
          ii=0
          np=(nx+1)*(ny+1)*(nz+1)
          allocate(x(np))
          allocate(y(np))
          allocate(z(np))

! construction de la liste des sommets
          DO i=1,nx+1
              DO j=1,ny+1
                  DO k=1,nz+1
                      is=i+(nx+1)*(j-1)+(nx+1)*(ny+1)*(k-1)
                      p=pni(calc%list_bloc(ib),i*1.d0,j*1.d0,k*1.d0,i2d)
                      x(is)=p%x
                      y(is)=p%y
                      z(is)=p%z
                  END DO
              END DO
          END DO
! Cas particulier du modele de SaintVenant
          if(imodel_phy.eq.1)then
            do i=1,nx
              do j=1,ny
                icell=calc%list_bloc(ib)%first_cell+i+(j-1)*nx
                z(i+(j-1)*(nx+1))  =calc%msh%list_cell(icell)%w%vprim%v(1)
                z(i+1+(j-1)*(nx+1))=calc%msh%list_cell(icell)%w%vprim%v(1)
                z(i+(j)*(nx+1))    =calc%msh%list_cell(icell)%w%vprim%v(1)
                z(i+1+(j)*(nx+1))  =calc%msh%list_cell(icell)%w%vprim%v(1)
                z(i+(j-1)*(nx+1)+(nx+1)*(ny+1))  =calc%msh%list_cell(icell)%w%vprim%v(5)
                z(i+1+(j-1)*(nx+1)+(nx+1)*(ny+1))=calc%msh%list_cell(icell)%w%vprim%v(5)
                z(i+(j)*(nx+1)+(nx+1)*(ny+1))    =calc%msh%list_cell(icell)%w%vprim%v(5)
                z(i+1+(j)*(nx+1)+(nx+1)*(ny+1))  =calc%msh%list_cell(icell)%w%vprim%v(5)
              enddo
           enddo
          endif

          write(12,'(10e13.5)')x
          write(12,'(10e13.5)')y
          write(12,'(10e13.5)')z
          deallocate(x)
          deallocate(y)
          deallocate(z)
                 
          ifc=calc%list_bloc(ib)%first_cell
          DO ivar=1,nvar
           write(12,'(10e13.5)')(calc%msh%list_cell(ii)%w%vprim%v(ivar),ii=ifc+1,ifc+nx*ny*nz)
          END DO
          if(imodel_phy.eq.1)write(12,'(10e13.5)')(calc%msh%list_cell(ii)%w%vprim%v(4),ii=ifc+1,ifc+nx*ny*nz) ! production entropie
          if(imodel_phy.eq.1)write(12,'(10e13.5)')(calc%msh%list_cell(ii)%w%vprim%v(5),ii=ifc+1,ifc+nx*ny*nz) ! bathy
          if(imodel_phy.eq.2)write(12,'(10e13.5)')(calc%msh%list_cell(ii)%w%vprim%v(6),ii=ifc+1,ifc+nx*ny*nz) ! production entropie
      END DO
  END DO
  
  close(12)
  
  
  
  
  if(calc%msh%ndim.ne.1) return
  !=========================== SAUVEGARDE EN 1D SI NECESSAIRE  ======================================
  ! Boucle sur les domaines et les blocs 
  OPEN(12,file='cerfout1d.dat',status='unknown')

  DO idom=1,nbdom
      CALL empty_mesh(calc%msh,nbdom,idom)
      CALL empty_sol(calc%list_sol)
! Recuperation du calcul
      CALL get_calc(calc)
      IF (idom.eq.1) THEN
          write(12,*)' TITLE="',calc%tmin,'"'
          if(imodel_phy.ne.1)then  
            write(12,*)' VARIABLES="X","R","U","P"'
          else   !Cas particulier du modele de SaintVenant
            write(12,*)' VARIABLES="X","h","U","eta","q","Zbottom"'
          endif
          write(12,1001)nxtot
1001 format('ZONE T="", I=',i9,' F=POINT')
     endif

      DO ib=1,calc%nb_bloc
          ibloc=calc%list_bloc(ib)%numbl
          nx=calc%list_bloc(ib)%nx*2**(calc%list_bloc(ib)%nrb)

! Cas du modele de SaintVenant
          if(imodel_phy.eq.1)then
            do i=1,nx
                icell=calc%list_bloc(ib)%first_cell+i
                write(12,'(6e14.6)')calc%msh%list_cell(icell)%center%x, &
                                     calc%msh%list_cell(icell)%w%vprim%v(1), &
                                     calc%msh%list_cell(icell)%w%vprim%v(2), &
                                     calc%msh%list_cell(icell)%w%vprim%v(1)+calc%msh%list_cell(icell)%w%vprim%v(5), &
                                     calc%msh%list_cell(icell)%w%vprim%v(1)*calc%msh%list_cell(icell)%w%vprim%v(2), &
                                     calc%msh%list_cell(icell)%w%vprim%v(5)
            enddo
          endif
          if(imodel_phy.eq.2)then
            do i=1,nx
                icell=calc%list_bloc(ib)%first_cell+i
                write(12,'(6e14.6)')calc%msh%list_cell(icell)%center%x, &
                                     calc%msh%list_cell(icell)%w%vprim%v(1), &
                                     calc%msh%list_cell(icell)%w%vprim%v(2), &
                                     calc%msh%list_cell(icell)%w%vprim%v(5)
            enddo
          endif

      END DO
  END DO
  
  close(12)
  
  
  

!===========================   FIN DE LA ROUTINE    ====================

CONTAINS

 SUBROUTINE ecrit_bloc(b)
  use geo
  IMPLICIT NONE
  type(bloc),intent(in) :: b
  integer in
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(13,'(6i10)')b%numbl, b%idom,b%nx,b%ny,b%nz,b%nrb
  DO in=1,8
      write(13,'(3e16.8)') b%s(in)%x,b%s(in)%y,b%s(in)%z
  END DO
  write(13,'(6i10)') b%cl
  write(13,'(6i10)') b%nrf
  write(13,'(6i10)') b%dom
  write(13,'(6i10)') b%first_cell, b%nb_cell, b%first_face, b%nb_face, b%first_vertex, b%nb_vertex
 END SUBROUTINE ecrit_bloc

   END PROGRAM cerf2tec
!DOCFIN

 SUBROUTINE triangle(x1,y1,z1,x2,y2,z2,x3,y3,z3,xn,yn,zn,surf,xm,ym,zm)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/triangle  *
!
!    NOM
! triangle(x1,y1,z1,x2,y2,z2,x3,y3,z3,xn,yn,zn,surf,xm,ym,zm)
!    DESCRIPTION  
!*
! Calcul du vecteur normal, de la surface et du barycentre d un triangle
!
! Calculate the normal vector, area and barycentre of a triangle
!*
!
!    ENTREES / INPUT
!    x1,y1,z1,x2,y2,z2,x3,y3,z3 : 3 sommets du triangle / 3 vertices of the triangle
!
!    SORTIES / OUTPUT
!    xn,yn,zn,surf,xm,ym,zm: vecteur normal, surface et barycentre du triangle 
!                          / normal vector, area and barycentre of the triangle
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  IMPLICIT NONE
!.2-----  Declaration
  real(kind=kind(0.d0)), intent(in)   :: x1,y1,z1,x2,y2,z2,x3,y3,z3
!! coordonnees des sommets du triangle / coordinates of the vertices of the triangle
  real(kind=kind(0.d0)), intent(out)   :: xn,yn,zn 
!! vecteur normal du triangle / normal vector of the triangle
  real(kind=kind(0.d0)), intent(out)   :: surf !! Surface du triangle / Surface of the triangle
  real(kind=kind(0.d0)), intent(out)   :: xm,ym,zm
!! coordonnees du barycentre du triangle / coordinates of the barycentre of the triangle

  real(kind=kind(0.d0))   :: x12,y12,z12,x13,y13,z13
!=========================== DEBUT DU CODE EXECUTABLE ==================

  x12=x2-x1
  y12=y2-y1
  z12=z2-z1
  
  x13=x3-x1
  y13=y3-y1
  z13=z3-z1
  
  ! normale et surface du triangle 
  xn=y12*z13-z12*y13
  yn=-x12*z13+z12*x13
  zn=x12*y13-y12*x13
  
  xn=-xn
  yn=-yn
  zn=-zn
  
  surf=dsqrt(xn*xn+yn*yn+zn*zn)
  
  xm=1.d0/3.d0*(x1+x2+x3)
  ym=1.d0/3.d0*(y1+y2+y3)
  zm=1.d0/3.d0*(z1+z2+z3)
            
  IF (surf.ne.0) THEN
      xn=xn/surf
      yn=yn/surf
      zn=zn/surf
  ELSE
      xn=-1
      yn=0
      zn=0
  END IF
  
  surf=surf*0.5d0
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE TRIANGLE
!DOCFIN

 SUBROUTINE calc_flux(calc,lev)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/calc_flux  *
!
!    NOM
!   calc_flux(calc,lev)
!    DESCRIPTION  
!*
! Calcul des bilan des flux sur les faces 
! Le terme de bilan est stocke dans la variable "balance" de chaque cellule
!
! Calculation of flow balances on faces 
! The balance term is stored in the ‘balance’ variable in each cell.
!*
! 
!    ENTREES / INPUT
!   calc : objet calcul / Calcul object
!   lev  :  niveau maximal de raffinement a considerer / maximum level of refinement to be considered
!    SORTIES / OUTPUT
!   calc : objet calcul avec les bilans de flux mis a jour / Calcul object with updated flow balances
!   lev  : niveau maximal de raffinement a considerer / maximum level of refinement to be considered
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul),intent(inout)  :: calc !! Objet calcul / Calcul object
  integer, intent(inout)      :: lev  !! niveau maximal de raffinement a considerer / maximum level of refinement to be considered
  
  type(state)                 :: wL,wR
  integer                     :: i,ic1,ic2,iv,ii
  real(kind=kind(0.d0))       :: surf,xa,ya,za
  type(vect_nvar)             :: flux, fluxnc 
  type(vect_3)                :: vnmoins ! oppose du vecteur normal (pour les flux non conservatifs)
  type(vect_3)                :: vcf     ! vecteur centre cellule - centre face
!=========================== DEBUT DU CODE EXECUTABLE ==================
  

!--- boucle sur les faces pour calculer les flux convectifs
  
  DO i=1,calc%msh%nb_face
      IF (calc%msh%list_face(i)%flevel.gt.lev) GOTO 200

      ic1=calc%msh%list_face(i)%ic1
      ic2=calc%msh%list_face(i)%ic2

      IF (ic2.eq.-999) GOTO 200
      surf=calc%msh%list_face(i)%surf
      IF (ic1.le.0) STOP
  
      ! recuperation de l etat Left
      wL=calc%msh%list_cell(ic1)%w
  
      ! si ordre 2, correction de l etat Left par la methode MUSCL
      IF (calc%iordre_e.ge.2) THEN
          ! determination du vecteur centre de la cellule - centre de la face
          xa=calc%msh%list_face(i)%center%x
          ya=calc%msh%list_face(i)%center%y
          za=calc%msh%list_face(i)%center%z
  
          vcf%v(1)=xa-calc%msh%list_cell(ic1)%center%x
          vcf%v(2)=ya-calc%msh%list_cell(ic1)%center%y
          vcf%v(3)=za-calc%msh%list_cell(ic1)%center%z
      
          DO iv=1,nvarmax
              DO ii=1,calc%msh%ndim
                  wL%vprim%v(iv)=wL%vprim%v(iv)+wL%gprim(ii)%v(iv)*vcf%v(ii) 
              END DO
          END DO
      
      END IF
   
      ! si il existe, recuperation de l etat Right
      IF (ic2.ge.1) THEN
          wR=calc%msh%list_cell(ic2)%w
           
         ! si ordre 2, correction de l etat Right par la methode MUSCL
          IF (calc%iordre_e.ge.2) THEN
              ! determination du vecteur centre de la cellule - centre de la face
              xa=calc%msh%list_face(i)%center%x
              ya=calc%msh%list_face(i)%center%y
              za=calc%msh%list_face(i)%center%z
        
              vcf%v(1)=xa-calc%msh%list_cell(ic2)%center%x
              vcf%v(2)=ya-calc%msh%list_cell(ic2)%center%y
              vcf%v(3)=za-calc%msh%list_cell(ic2)%center%z
              
              DO iv=1,nvarmax
                  DO ii=1,calc%msh%ndim
                    wR%vprim%v(iv)=wR%vprim%v(iv)+wR%gprim(ii)%v(iv)*vcf%v(ii)  
                  END DO
              END DO             
          END IF
      ELSE
          ! en cas de condition aux limites on extrapole l etat
          ! Right a partir du type de la condition aux limites
          ! de l etat connu et du vecteur normal
          xa=calc%msh%list_face(i)%center%x
          ya=calc%msh%list_face(i)%center%y
          za=calc%msh%list_face(i)%center%z
          CALL wext(wL,wR,calc%msh%list_face(i)%vnorm,ic2,xa,ya,za,&
                    calc%msh%list_cell(ic1)%center%x, &
                    calc%msh%list_cell(ic1)%center%y, &
                    calc%msh%list_cell(ic1)%center%z )
      END IF
  
      ! calcul du flux numerique convectif conservatif
      icell_phy=ic1

      CALL prim2bal(wR)
      CALL prim2bal(wL)
      CALL fluxnum(wL,wR,calc%msh%list_face(i)%vnorm,flux,calc%ityp_flux)

      ! ajout dans le bilan de la cellule de gauche si elle est dans le
      ! bon domaine
      IF (calc%msh%list_cell(ic1)%idom.eq.calc%msh%numdom.and.calc%msh%list_cell(ic1)%isolid.ne.1) &
             calc%msh%list_cell(ic1)%balance%v=calc%msh%list_cell(ic1)%balance%v+flux%v * surf
                   
      ! ajout dans le bilan de la cellule de droite si elle existe et est dans le
      ! bon domaine (signe oppose car f(-vn)=-f(vn) )
      IF (ic2.gt.0) THEN
          IF (calc%msh%list_cell(ic2)%idom.eq.calc%msh%numdom.and.calc%msh%list_cell(ic2)%isolid.ne.1) &
                 calc%msh%list_cell(ic2)%balance%v=calc%msh%list_cell(ic2)%balance%v-flux%v *surf
      END IF
      ! le cas echant, calcul du flux numerique non conservatif

          CALL fluxnumnoncons(wL,wR,calc%msh%list_face(i)%vnorm,fluxnc,calc%ityp_flux)
          
          ! ajout dans le bilan de la cellule de gauche si elle est dans le
          ! bon domaine
          IF (calc%msh%list_cell(ic1)%idom.eq.calc%msh%numdom) &
              calc%msh%list_cell(ic1)%balance%v=calc%msh%list_cell(ic1)%balance%v+fluxnc%v * surf
  
          vnmoins%v=-calc%msh%list_face(i)%vnorm%v
          vi_phy=-vi_phy
          call fluxnumnoncons(wR,wL,vnmoins,fluxnc,calc%ityp_flux)
          ! ajout dans le bilan de la cellule de droite si elle existe et est dans le
          ! bon domaine (ici en general, f(-vn) est different de -f(vn))
          IF (ic2.gt.0) THEN
             IF (calc%msh%list_cell(ic2)%idom.eq.calc%msh%numdom) &
                  calc%msh%list_cell(ic2)%balance%v=calc%msh%list_cell(ic2)%balance%v+fluxnc%v *surf
          END IF

200 continue
  END DO
  
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE calc_flux
!DOCFIN

 SUBROUTINE read_phys()
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_phys *
!
!    NOM
! read_phys(calc)
!    DESCRIPTION  
!*
! Lecture du Bloc PHYS du fichier de donnees *.inp
! Reading thePHYS block from the *.inp data file
!*
! 
!    ENTREES / INPUT
!    
!    SORTIES / OUTPUT
!    
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  real(kind=kind(0.d0))  :: arg
  character(4)           :: para
!=========================== DEBUT DU CODE EXECUTABLE ==================

  write(*,*)
  write(*,*)achar(27)//'[34m================================================'
  write(*,*)'Reading physical parameters: block PHYS'
  write(*,*)'================================================'//achar(27)//'[0m'

599 read(33,'(a4,f20.0)',err=600,end=600)para,arg
  SELECT CASE (para)
      CASE('GPES')
          pes_xyz=idint(arg)
          write(*,*)'PHYS-Info  New value for gravity  orientation :', pes_xyz
      CASE('MODE')
          imodel_phy=idint(arg)
          write(*,*)'PHYS-Info  New physical model     :',imodel_phy
          IF (imodel_phy.eq.1) THEN
            nvar=3
            inoncons_phy=1
          ENDIF
      CASE('PREF')
          p0_phy=arg
          write(*,*)'PHYS-Info  New reference pressure :',p0_phy
      CASE('REFA')
          rho0A_phy=arg
          write(*,*)'PHYS-Info  New air density :',rho0A_phy
      CASE('REFW')
          rho0W_phy=arg
          write(*,*)'PHYS-Info  New water density:',rho0W_phy
      CASE('CSSM')
          c_phy=arg
          write(*,*)'PHYS-Info  New mixture sound speed :',c_phy
      CASE('SHAR')
          sharp_phy=arg
          write(*,*)'PHYS-Info  New sharpening parameter:',sharp_phy
      CASE('WLTR')
          hzero_phy=arg
          write(*,*)'PHYS-Info   New water level truncation value :',hzero_phy
      CASE('FRMO')
          ifrict=int(arg)
          write(*,*)'PHYS-Info Friction Model 0/none, 1/Manning-Strickler, 2/Darcy-Weisbach:',ifrict
      CASE('BAGR')
          ngrad_bathy=int(arg)
          write(*,*)'PHYS-Info Bathymetry gradient 0/given, 1/approximated :',ngrad_bathy
          
      CASE DEFAULT
          goto 600
  END SELECT
  
  ! petite verification
  IF (nvar.gt.nvarmax)call print_err('READ_PHYS','nvar is bigger than nvarmax ')
  goto 599
600 continue
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_phys
!DOCFIN

  PROGRAM cerf_input 
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/cerf_input  *
!
!    NOM
! cerf_input
!    DESCRIPTION  
!*
! Programme permettant la lecture d un fichier de donnees  
! pour le convertir en (un ou plusieurs) fichier binaire au format CERF
!
! Program for reading a data file  
! to convert it into (one or more) binary files in CERF format
!*
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use uti
  use, intrinsic :: iso_fortran_env, only: real64
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul)                                     :: calc 
  character(30)                                    :: fichinp
  character(4)                                     :: entete
  integer                                          :: icode,iarg
  integer                                          :: nzonei
  real(kind=kind(0.d0)),allocatable,dimension(:,:) :: zone,zonei
  real(kind=kind(0.d0)),allocatable,dimension(:)   :: crit
  integer,allocatable,dimension(:,:)               :: nzone  
  logical                                          :: fichexist
  integer                                          :: argc, ios=0,ios2, i,j
  character(len=256)                               :: iomsg,ligne
!=========================== DEBUT DU CODE EXECUTABLE ==================

! Recupuration et ouverture du fichier de donnees
 argc = command_argument_count()
 if (argc < 1) call print_err('CERF_INPUT','No data file specified !!!')
 call get_command_argument(1,fichinp)
 fichinp = trim(fichinp)
 inquire(file=fichinp,exist=fichexist)

 if (.not. fichexist) call print_err('CERF_INPUT','Data file does not exist at the specified location !')

 write(*,*)achar(27)//'[34m**********************************************************'
 write(*,*) fdate()
 write(*,*)'CERF_INPUT Data file :'// fichinp 
 write(*,*)'**********************************************************' //achar(27)//'[0m'

! Ouverture du fichier de donnees
  OPEN(33,file=fichinp,status='old',action='read',iostat=ios,iomsg=iomsg)
  if (ios /= 0) call print_err('CERF_INPUT','Could not open file: '//trim(iomsg))
  CALL empty_mesh(calc%msh,1,0)
 10 continue

! Recherche de l entete
  !read(33,'(a4,2i5)',iostat=ios)entete,icode,iarg
  entete='bbbb'
  read(33,'(A)',iostat=ios) ligne
  if (ios == 0) then
    read(ligne,*,iostat=ios2) entete, icode, iarg
  end if
  
  if(ios .gt.0) goto 10
  if(ios .lt.0) goto 800
  
  SELECT CASE (entete)
!-----------------------------------------------------------------------
! Lecture des parametres physiques
!-----------------------------------------------------------------------
      CASE('PHYS')
          CALL read_phys()
!-----------------------------------------------------------------------
! Lecture des conditions aux limites
!-----------------------------------------------------------------------
      CASE('COND')
          CALL read_cond(calc%list_bloc,icode,iarg,calc%nb_bloc)
 
!-----------------------------------------------------------------------
! Lecture de l Initialisation
!-----------------------------------------------------------------------
      CASE('INIT')
          CALL read_init(icode,iarg,zonei,nzonei)
          
 !-----------------------------------------------------------------------
! Lecture de la bathymetrie
!-----------------------------------------------------------------------
      CASE('BATH')
          CALL read_bath(icode,iarg)
         
          if(ibathy.eq.-2)then ! on cree le fichier des sommet de la base des blocs
            open(17,file=fich_bathy,status='new')
            do i=1,calc%nb_bloc
              do j=1,4
                 write(17,'(2e13.5)')calc%list_bloc(i)%s(j)%x,calc%list_bloc(i)%s(j)%y
               enddo
            enddo
            close(17)
            write(*,*)'Bottom of the Blocks written in file:',fich_bathy
            stop
          endif
    
!-----------------------------------------------------------------------
! Lecture des obstacles
!-----------------------------------------------------------------------
      CASE('OBST')
          CALL read_obst(calc,iarg)

!-----------------------------------------------------------------------
! Lecture ou creation du maillage maitre
!-----------------------------------------------------------------------
      CASE('MAME')
         CALL read_mame(calc,icode,iarg)

!-----------------------------------------------------------------------
! Lecture des parametres numeriques
!-----------------------------------------------------------------------
      CASE('NUME')
         CALL read_nume(calc)

!-----------------------------------------------------------------------
! Lecture des parametres de maillage AMR
!-----------------------------------------------------------------------
      CASE('MESH')
         CALL read_mesh(calc,nzone,zone)

  END SELECT
  GOTO 10
!-----------------------------------------------------------------------
! Fin de lecture, constitution des calculs et sauvegarde sur fichier binaire
!-----------------------------------------------------------------------

 800   continue

!-----------------------------------------------------------------------
! Sauvegarde et extraction des domaines

  calc%msh%numdom=0
  close(33,iostat=ios)
  CALL block2mesh(calc,nzone,zone,nzonei,zonei)
  call print_avert('CERF_INPUT','Save the blocks ')
  CALL save_calc(calc)
  allocate(crit(calc%nb_bloc))
  crit=0.d0
  CALL amr2tec(calc%list_bloc,crit,calc%nb_bloc) 
  deallocate(crit)


  if(allocated(nzone))deallocate(nzone)
  if(allocated(zone)) deallocate(zone)
  if(allocated(zonei))deallocate(zonei)
!===========================   FIN DE LA ROUTINE    ====================

  END PROGRAM cerf_input
!DOCFIN

 SUBROUTINE gradlimxy(msh)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    GEO/gradlimxy.f90  *
!
!    NOM
! gradlimxy(msh)
!    DESCRIPTION  
!*
! Limite le gradient des variables primitives par la méthode de Barth
! La limitation est faite dans chaque direction x y indépendamment
! Suppose donc que le maillage est régulier en x y et 2D 
! Suppose donc que le gradient  a deja ete calcule (appel a gradprim)
! Attention: le gradient des cellules frontiere n est pas limite
! Il faut donc un appel à MPI pour mettre à jours TOUS les limiteurs
!
! Limit the gradient of primitive variables using Barth s method
! Limitation is done in each x y direction independently
! Assumes that the mesh is regular in x y and 2D. 
! Assumes that the gradient has already been calculated (call gradprim).
! Warning: the gradient of the border cells is not limited
! A call to MPI is therefore required to update ALL the limiters.
!*
! 
!    ENTREES / INPUT
!    msh : maillage / mesh
!
!    SORTIES / OUTPUT
!    msh : maillage / mesh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(mesh), intent(inout) :: msh !! Maillage / Mesh
  real(kind=kind(0.d0)),dimension(:,:),allocatable :: dlimx , dlimy ! tableau des limiteurs de pente dans chaque cellule
  real(kind=kind(0.d0)),dimension(nvarmax)         :: odg
  integer                                          :: i,iv,ic1,ic2,idom1,idom2,idom
  real(kind=kind(0.d0))                            :: g,r,dlim2
  type(vect_3)                                     :: vcf
  type(state)                                      :: w1,w2

!=========================== DEBUT DU CODE EXECUTABLE ==================

  allocate(dlimx(nvar,msh%nb_cell))
  allocate(dlimy(nvar,msh%nb_cell))

  dlimx=1
  dlimy=1

! vecteur des ordres de grandeur (permet d avoir un limiteur adimensionne)
  DO iv=1,nvar
      odg(iv)=1.d0
  END DO

  odg(5)=1.d5
!  odg(1)=1.d0
  
  ! boucle sur les faces du maillage
  DO i=1,msh%nb_face
      
      ! repérage des voisins
      ic1=msh%list_face(i)%ic1
      ic2=msh%list_face(i)%ic2
      
      w1=msh%list_cell(ic1)%w
      IF (ic2.gt.0) THEN
          w2=msh%list_cell(ic2)%w
      ELSE
          CALL wext(w1,w2,msh%list_face(i)%vnorm,ic2, &
               msh%list_face(i)%center%x , &
               msh%list_face(i)%center%y , &
               msh%list_face(i)%center%z , &
               msh%list_cell(ic1)%center%x, &
               msh%list_cell(ic1)%center%y, &
               msh%list_cell(ic1)%center%z )
      END IF
     
      ! numero de domaine à gauche
      idom1=msh%list_cell(ic1)%idom
      IF (idom1.ne.msh%numdom) THEN
          write(*,*) 'erreur maillage domaine'
          STOP
      END IF
     
      IF (ic2.ne.-999) THEN ! ne pas boucler sur les faces fictives
        
          ! numero de domaine à droite
          idom2=0
          IF (ic2.gt.0) idom2=msh%list_cell(ic2)%idom
          IF (idom2.ne.msh%numdom) idom2=0
          
          
          ! limitation cellule de gauche
          
          ! détermination du vecteur centre de la cellule - centre de la face
          vcf%v(1)=msh%list_face(i)%center%x-msh%list_cell(ic1)%center%x
          vcf%v(2)=msh%list_face(i)%center%y-msh%list_cell(ic1)%center%y
          vcf%v(3)=msh%list_face(i)%center%z-msh%list_cell(ic1)%center%z
       
          DO iv=1,nvar
              
              dlim2=1.d0
              g=w1%gprim(1)%v(iv)*vcf%v(1)+&
              & w1%gprim(2)%v(iv)*vcf%v(2)+&
              & w1%gprim(3)%v(iv)*vcf%v(3)
              
              !IF (dabs(g/odg(iv)).gt.1.d-6) THEN
              IF (g.ne.0.d0) THEN   ! moins compliqué et plus stable
                  r=(w2%vprim%v(iv)-w1%vprim%v(iv))/g
                  IF (r.lt.0.d0) THEN
                      dlim2=0.d0
                  ELSE IF (r.gt.1.d0) THEN
                      dlim2=1.d0
                  ELSE
                      dlim2=r
                  END IF
              ELSE
              dlim2=1.d0
              END IF
              
              IF (dabs(msh%list_face(i)%vnorm%v(2)).lt.1.d-10) THEN         ! direction x
                  IF (dlimx(iv,ic1).gt.dlim2) dlimx(iv,ic1)=dlim2
              END IF
              
              IF (dabs(msh%list_face(i)%vnorm%v(1)).lt.1.d-10) THEN         ! direction y
                  IF (dlimy(iv,ic1).gt.dlim2) dlimy(iv,ic1)=dlim2
              END IF
              
          END DO
        
          ! limitation cellule de droite
        
          IF (idom2.ne.0) THEN
           
              ! détermination du vecteur centre de la cellule - centre de la face
              vcf%v(1)=msh%list_face(i)%center%x-msh%list_cell(ic2)%center%x
              vcf%v(2)=msh%list_face(i)%center%y-msh%list_cell(ic2)%center%y
              vcf%v(3)=msh%list_face(i)%center%z-msh%list_cell(ic2)%center%z
               
              DO iv=1,nvar
                  
                  dlim2=1.d0
                  
                  g=w2%gprim(1)%v(iv)*vcf%v(1)+&
                  & w2%gprim(2)%v(iv)*vcf%v(2)+&
                  & w2%gprim(3)%v(iv)*vcf%v(3)
                  
                  IF (g.ne.0.d0) THEN   ! moins compliqué et plus stable
!                  if (dabs(g/odg(iv)).gt.1.d-6) then   ! si trop limité
                      r=(w1%vprim%v(iv)-w2%vprim%v(iv))/g
                      IF (r.lt.0.d0) THEN
                          dlim2=0.d0
                      ELSE IF (r.gt.1.d0) THEN
                          dlim2=1.d0
                      ELSE
                          dlim2=r
                      END IF
                  ELSE
                     dlim2=1.d0
                  END IF
                  
                  IF (dabs(msh%list_face(i)%vnorm%v(2)).lt.1.d-10) THEN         ! direction x
                     IF (dlimx(iv,ic2).gt.dlim2) dlimx(iv,ic2)=dlim2
                  END IF
                  
                  IF (dabs(msh%list_face(i)%vnorm%v(1)).lt.1.d-10) THEN         ! direction y
                     IF (dlimy(iv,ic2).gt.dlim2) dlimy(iv,ic2)=dlim2
                  END IF
                  
              END DO

          END IF
        
      END IF
     
  END DO


  ! mise à jour du gradient dans les cellules

  DO i=1,msh%nb_cell
      idom=msh%list_cell(i)%idom
      IF (idom.eq.msh%numdom) THEN
          DO iv=1,nvar
              msh%list_cell(i)%w%gprim(1)%v(iv)=0.95*dlimx(iv,i)*msh%list_cell(i)%w%gprim(1)%v(iv) 
              msh%list_cell(i)%w%gprim(2)%v(iv)=0.95*dlimy(iv,i)*msh%list_cell(i)%w%gprim(2)%v(iv) 
          END DO
      END IF  
  END DO

  deallocate(dlimx)
  deallocate(dlimy)
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE gradlimxy
!DOCFIN

  SUBROUTINE trivertex(msh)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/trivertex  *
!
!    NOM
! trivertex(msh)
!    DESCRIPTION  
!*
! Elimination des sommets surabondants et corrige en consequence
! Eliminate overabundant peaks and correct accordingly
!*
!
!    ENTREES / INPUT
!    msh : maillage / mesh
!
!    SORTIES / OUTPUT
!    msh : maillage corrige / corrected mesh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  use zorder
  IMPLICIT NONE
!.2-----  Declaration       
  type(mesh), intent(inout)             :: msh !! Maillage / Mesh
  type(chaineR3), pointer               :: R3    
  type (chaineR2), Pointer              :: R2    
  type (chaineR1), Pointer              :: R1    
  integer                               :: taille,interieur,i,j
  integer, dimension(:),allocatable     :: temp
  type(point), dimension(:),allocatable :: tempvertex         
!=========================== DEBUT DU CODE EXECUTABLE ==================
! Initialisations
  taille=0
  allocate(R1,R2,R3)
  R1%z=0.d0
  Nullify(R1%suiv) ; Nullify(R1%prec)
  R2%y=0.d0
  R2%cr1=>R1
  nullify(R2%suiv) ; Nullify(R2%prec)
  R3%x=-1.d20
  R3%cr2=>R2
  nullify(R3%suiv) ; Nullify(R3%prec)
  allocate(temp(msh%nb_vertex))
  temp=0

! Rangement des sommets
  j=0
  DO i=1,msh%nb_vertex
      CALL rangeR3 (msh%list_vertex(i)%x,msh%list_vertex(i)%y,msh%list_vertex(i)%z, R3,taille)
      j=taille
  END DO
  
! Numerotation des sommets
  CALL parcoursR3(R3)
  DO i=1,msh%nb_vertex
      CALL donne_num (msh%list_vertex(i)%x,msh%list_vertex(i)%y,msh%list_vertex(i)%z, R3,temp(i),interieur)
      IF(temp(i).le.0.or.temp(i).gt.msh%nb_vertex) THEN
          write( *,1010)msh%list_vertex(i)%x, msh%list_vertex(i)%y, msh%list_vertex(i)%z, temp(i)
1010 format('Err_Donne_num ',3e15.8,i8)
          STOP
      END IF
  END DO
  
! Modification des numeros des vertex des faces
  DO i=1,msh%nb_face
      DO j=1,msh%list_face(i)%nbvertex
          msh%list_face(i)%vertex(j)=temp(msh%list_face(i)%vertex(j))
      END DO
  END DO
  
! Remplacement des vertex
  allocate(tempvertex(taille))
  DO i=1,msh%nb_vertex
      tempvertex(temp(i))=msh%list_vertex(i)
  END DO
  deallocate(msh%list_vertex)
  msh%nb_vertex=taille
  allocate(msh%list_vertex(taille))
  msh%list_vertex=tempvertex
  deallocate(tempvertex)
  deallocate(temp)
  
! IL FAUT DESALLOUER R3,R2,R1
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE trivertex
!DOCFIN

!!*!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! Ptim.f90 --- Timing MPI or mixed MPI/OpenMP Fortran programs
!! 
!! Auteur          : Jalel Chergui (CNRS/IDRIS) <Jalel.Chergui@idris.fr>
!! Créé le         : Thu Nov 18 15:44:01 2004
!! Dern. mod. par  : Jalel Chergui (CNRS/IDRIS) <Jalel.Chergui@idris.fr>
!! Dern. mod. le   : Tue Dec  7 11:34:46 2004
!!*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifdef _MPI


MODULE PTIM
  IMPLICIT NONE

  PRIVATE

  !... Shared private variables
  INTEGER, PARAMETER         :: ROOT_RANK=0, d=SELECTED_REAL_KIND(12)
  REAL(kind=d)               :: ELA_overhead, CPU_overhead
  REAL(kind=d), DIMENSION(2) :: ELA_tim, CPU_tim
  LOGICAL                    :: mpi=.FALSE.

  !$ INTEGER, PARAMETER                           :: MAX_NUM_THRDS=128
  !$ REAL(kind=d), DIMENSION(0:MAX_NUM_THRDS-1,2) :: ELA_omp_tim=0.0_d
  !$ INTEGER                                      :: num_thrds=1
  !$ LOGICAL                                      :: omp=.FALSE.

  INTEGER, DIMENSION(8)           :: values
  CHARACTER(LEN=8), DIMENSION(2)  :: date
  CHARACTER(LEN=10), DIMENSION(2) :: time
  CHARACTER(LEN=5)                :: zone
  CHARACTER(LEN=80)               :: user_label="My Program"
  INTEGER                         :: label_length=10

  !... Public interfaces
  PUBLIC :: PTIM_start, PTIM_stop
  !$ PUBLIC :: PTIM_omp_start, PTIM_omp_stop

  CONTAINS

  SUBROUTINE PTIM_start(label)
    IMPLICIT NONE

    !... MPI Header file
    INCLUDE "mpif.h"

    !... Input dummy argument
    CHARACTER(LEN=*), OPTIONAL, INTENT(in) :: label

    !... Local variables
    INTEGER      :: rank, ierr
    REAL(kind=d) :: dummy

    !... Compute clock overhead
    ELA_overhead = MPI_WTIME()
    ELA_overhead = MPI_WTIME() - ELA_overhead
    CALL CPU_TIME(dummy)
    CALL CPU_TIME(CPU_overhead)
    IF (dummy < 0.0_d) PRINT *,"Warning, PTIM_start: CPU user time is not available on this machine."
    CPU_overhead = CPU_overhead - dummy

    Call MPI_INITIALIZED(mpi, ierr)
    if (.not. mpi) PRINT *,"Warning, PTIM_start: MPI_init must be invoked prior to PTIM_start."
    CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

    !... Start timings on "date & time"
    IF ( rank == ROOT_RANK ) THEN
       CALL DATE_AND_TIME(date(1),time(1),zone,values)
       IF(PRESENT(label)) THEN
         label_length=LEN_TRIM(label)
         user_label(1:label_length) = TRIM(label)
       END IF
    END IF
    !... Start elapsed and CPU time counters
    ELA_tim(1) = MPI_WTIME()
    CALL CPU_TIME(CPU_tim(1))
  END SUBROUTINE PTIM_start

  !$ SUBROUTINE PTIM_omp_start()
    !$ USE OMP_LIB
    !$ IMPLICIT NONE

    !... Local variables
    !$ INTEGER :: rank, nt

    !$ omp=OMP_IN_PARALLEL()
    !$ IF (.NOT. omp) PRINT *,"Warning, PTIM_omp_start must be called in an OpenMP PARALLEL scope."

    !$ nt = OMP_GET_NUM_THREADS()
    !$ num_thrds=MAX(num_thrds, nt)
    !$ IF (num_thrds > MAX_NUM_THRDS) THEN
    !$   PRINT *,"Warning, PTIM_omp_start: Number of threads greater than MAX_NUM_THDS=128."
    !$   PRINT *,"Please, reduce the number of threads in the PARALLEL scope or set MAX_NUM_THDS"
    !$   PRINT *,"to a greater value in PTIM module."
    !$ END IF

    ! Start thread time counter.
    !$ rank = OMP_GET_THREAD_NUM()
    !$ ELA_omp_tim(rank,1)=OMP_GET_WTIME()
  !$ END SUBROUTINE PTIM_omp_start

  !$ SUBROUTINE PTIM_omp_stop()
    !$ USE OMP_LIB
    !$ IMPLICIT NONE

    !... Local variables
    !$ INTEGER      :: rank
    !$ REAL(KIND=d) :: omp_fin_elapse

    ! Store final private time counter.
    !$ omp_fin_elapse=OMP_GET_WTIME()

    !$ omp=OMP_IN_PARALLEL()
    !$ IF (.NOT. omp) PRINT *,"Warning, PTIM_omp_stop must be called in an OpenMP PARALLEL scope."

    ! Which thread I am ?
    !$ rank=OMP_GET_THREAD_NUM()

    ! Collecting each private elapsed time into a global array.
    !$ ELA_omp_tim(rank,2) = ELA_omp_tim(rank,2) + omp_fin_elapse - ELA_omp_tim(rank,1)
  !$ END SUBROUTINE PTIM_omp_stop

  SUBROUTINE PTIM_stop(label, file)
    IMPLICIT NONE

    !... MPI Header file
    INCLUDE "mpif.h"

    !... Input dummy arguments
    CHARACTER(LEN=*), OPTIONAL, INTENT(in) :: label, file

    !... Local variables
    INTEGER                                 :: rank, nb_procs, ierr, length, i, u=6
    LOGICAL                                 :: file_opened
    REAL(kind=d), ALLOCATABLE, DIMENSION(:) :: all_ELA_tim, all_CPU_tim, all_ratio
    REAL(kind=d)                            :: tot_ELA_tim, tot_CPU_tim, tot_ratio,&
                                               max_ELA_tim, max_CPU_tim, max_ratio,&
                                               min_ELA_tim, min_CPU_tim, min_ratio,&
                                               avg_ELA_tim, avg_CPU_tim, avg_ratio

    !$ INTEGER, ALLOCATABLE, DIMENSION(:)        :: all_num_thrds
    !$ LOGICAL, ALLOCATABLE, DIMENSION(:)        :: all_omp
    !$ REAL(kind=d), ALLOCATABLE, DIMENSION(:,:) :: all_ELA_omp_tim
    !$ INTEGER                                   :: j, proc_max_num_thrds
    

    CHARACTER(LEN=256) :: prologue,epilogue,proc_tab_label,proc_tab_2hline,&
                          proc_tab_fmt
    !$ CHARACTER(LEN=256) :: omp_tab_label,omp_tab_hline,omp_tab_fmt, omp_tab_longhline
    CHARACTER(LEN=512)  :: others

    !... Final CPU and elapsed times
    CALL CPU_TIME(CPU_tim(2))
    ELA_tim(2) = MPI_WTIME() - ELA_tim(1) - ELA_overhead - CPU_overhead
    CPU_tim(2) = CPU_tim(2) - CPU_tim(1) - CPU_overhead

    !... Gather all timings
    CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, nb_procs, ierr)

    IF ( rank == ROOT_RANK ) THEN
      IF (PRESENT(label)) THEN
        length=LEN_TRIM(label)
        IF (VERIFY(label(1:length), user_label(1:label_length)) /= 0) &
           PRINT *,"Warning, PTIM_stop: Input label argument doesn't match the one of PTIM_start argument."
      END IF
      IF (PRESENT(file)) THEN
        !... Looking for a none connected logical file unit.
        u=99
        INQUIRE(UNIT=u, OPENED=file_opened)
        DO WHILE (file_opened .AND. u /= 0)
          u = u - 1
          INQUIRE(UNIT=u, OPENED=file_opened)
        END DO
        IF(u == 0 .AND. file_opened) THEN
          PRINT *,"Warning, PTIM_stop: All file units from 0 to 99 are already connected. Output has been redirected to STDOUT."
          u=6
        ELSE
          OPEN(UNIT=u, FILE=TRIM(file), FORM="formatted", STATUS="unknown", ACTION="write")
        END IF
      END IF        

!      ALLOCATE(all_ELA_tim(0:nb_procs-1), all_CPU_tim(0:nb_procs-1), all_ratio(0:nb_procs-1))
      !$ ALLOCATE(all_omp(0:nb_procs-1))
    END IF
      ALLOCATE(all_ELA_tim(0:nb_procs-1), all_CPU_tim(0:nb_procs-1), all_ratio(0:nb_procs-1))

    CALL MPI_GATHER(ELA_tim(2), 1, MPI_DOUBLE_PRECISION,  &
                    all_ELA_tim, 1, MPI_DOUBLE_PRECISION, &
                    0, MPI_COMM_WORLD, ierr)
    CALL MPI_GATHER(CPU_tim(2), 1, MPI_DOUBLE_PRECISION,  &
                    all_CPU_tim, 1, MPI_DOUBLE_PRECISION, &
                    0, MPI_COMM_WORLD, ierr)
    !$ CALL MPI_GATHER(omp, 1, MPI_LOGICAL, all_omp, 1, MPI_LOGICAL, &
    !$               & 0, MPI_COMM_WORLD, ierr)

    !$ ALLOCATE(all_num_thrds(0:nb_procs-1))
    !$ CALL MPI_ALLGATHER(num_thrds, 1, MPI_INTEGER, all_num_thrds, 1, MPI_INTEGER, &
    !$                  & MPI_COMM_WORLD, ierr)
    !$ proc_max_num_thrds=MAXVAL(all_num_thrds(0:))

    !$ IF (rank == ROOT_RANK ) ALLOCATE(all_ELA_omp_tim(0:proc_max_num_thrds-1,0:nb_procs-1))
    !$ CALL MPI_GATHER(ELA_omp_tim(0,2), proc_max_num_thrds, MPI_DOUBLE_PRECISION, &
    !$               & all_ELA_omp_tim, proc_max_num_thrds, MPI_DOUBLE_PRECISION,  &
    !$               & 0, MPI_COMM_WORLD, ierr)

    IF ( rank == ROOT_RANK) THEN
      !... Compute elapsed user time
       tot_ELA_tim = SUM(all_ELA_tim(0:))
       avg_ELA_tim = tot_ELA_tim/REAL(nb_procs,kind=d)
       max_ELA_tim = MAXVAL(all_ELA_tim(0:))
       min_ELA_tim = MINVAL(all_ELA_tim(0:))
       IF ( min_ELA_tim <= 0.0_d ) THEN
          PRINT *,"Warning, PTIM_stop: Measured elapsed user time seems to be too short"
          PRINT *,"compared to the clock precision. Timings could be erroneous."
       END IF

       !... Compute CPU user time
       tot_CPU_tim = SUM(all_CPU_tim(0:))
       avg_CPU_tim = tot_CPU_tim/REAL(nb_procs,kind=d)
       max_CPU_tim = MAXVAL(all_CPU_tim(0:))
       min_CPU_tim = MINVAL(all_CPU_tim(0:))
       IF ( min_CPU_tim <= 0.0_d ) THEN
          PRINT *,"Warning, PTIM_stop: Measured CPU user time seems to be too short"
          PRINT *,"compared to the clock precision. Timings could be erroneous."
       END IF

       !... Compute cpu/elapsed ratio
       all_ratio(0:) = all_CPU_tim(0:) / all_ELA_tim(0:)
       tot_ratio     = SUM(all_ratio(0:))
       min_ratio     = MINVAL(all_ratio(0:))
       max_ratio     = MAXVAL(all_ratio(0:))
       avg_ratio     = tot_ratio/REAL(nb_procs,kind=d)

       !... End of timings at "date & time"
       CALL DATE_AND_TIME(date(2),time(2),zone,values)

       !... Output Format
       prologue       ='(//,5X,"Copyright (C) 2004, Jalel CHERGUI, IDRIS-CNRS FRANCE.",/,&
                                         &5X,"TIM (release 3.1) summary report of *** ",A," ***",/)'
       proc_tab_label ='(5X,"Process Rank",(" "),"|",(" "),"Process CPU Time (s)",(" "),"|",&
                                      &(" "),"Process Elapsed Time (s)",(" "),"|",(" "),"CPU/Elapsed")'
       !$ omp_tab_label   ='(5X,13(" "),"|",22(" "),"|",(" "),"Thread Elapsed Time (s)",2(" "),"|")'
       proc_tab_2hline='(5X,13("="),"|",22("="),"|",26("="),"|",12("="))'
       !$ omp_tab_longhline ='(5X,13("-"),"|",22("-"),"|",26("-"),"|",12("-"))'
       !$ omp_tab_hline   ='(5X,13(" "),"|",22(" "),"|",26("-"),"|")'
       proc_tab_fmt   ='(5X,I4,9(" "),"|",3(" "),F12.3,7(" "),"|",4(" "),F12.3,10(" "),"|",5(" "),F7.3)'
       !$ omp_tab_fmt     ='(5X,13(" "),"|",22(" "),"|",(" "),I4,":",4(" "),F12.3,4(" "),"|")'
       others         ='(5X,"Total",  8(" "),"|",3(" "),F12.3,7(" "),"|",4(" "),F12.3,10(" "),"|",5(" "),F7.3,/,&
                                      &5X,"Minimum",6(" "),"|",3(" "),F12.3,7(" "),"|",4(" "),F12.3,10(" "),"|",5(" "),F7.3,/,&
                                      &5X,"Maximum",6(" "),"|",3(" "),F12.3,7(" "),"|",4(" "),F12.3,10(" "),"|",5(" "),F7.3,/,&
                                      &5X,"Average",6(" "),"|",3(" "),F12.3,7(" "),"|",4(" "),F12.3,10(" "),"|",5(" "),F7.3)'
       epilogue       ='(/,5X,"TIM started on ",2(A2,"/"),A4," at ",2(A2,":"),A2," MET ",A3,":",A2," from GMT",/,&
                                      &5X,  "TIM stopped on ",2(A2,"/"),A4," at ",2(A2,":"),A2," MET ",A3,":",A2," from GMT",/)'
       WRITE(UNIT=u,FMT=TRIM(prologue)) user_label(1:label_length)
       WRITE(UNIT=u,FMT=TRIM(proc_tab_label))
       WRITE(UNIT=u,FMT=TRIM(proc_tab_2hline))
       DO i = 0, nb_procs-1
         !$ IF (all_omp(i) .AND. all_num_thrds(i) > 1) THEN
         !$   WRITE(UNIT=u,FMT=TRIM(proc_tab_fmt)) i, all_CPU_tim(i), &
         !$                                        all_ELA_tim(i), all_ratio(i)
         !$   WRITE(UNIT=u,FMT=TRIM(omp_tab_hline))
         !$   WRITE(UNIT=u,FMT=TRIM(omp_tab_label))
         !$   WRITE(UNIT=u,FMT=TRIM(omp_tab_hline))
         !$   DO j = 0, all_num_thrds(i)-1
         !$     WRITE(UNIT=u,FMT=TRIM(omp_tab_fmt)) j, all_ELA_omp_tim(j,i)
         !$   END DO
         !$     IF ( i < nb_procs-1) WRITE(UNIT=u,FMT=TRIM(omp_tab_longhline))
         !$ ELSE IF (.not.all_omp(i)) THEN
           WRITE(UNIT=u,FMT=TRIM(proc_tab_fmt)) i, all_CPU_tim(i), &
                                                all_ELA_tim(i), all_ratio(i)
         !$ END IF
       END DO
       WRITE(UNIT=u,FMT=TRIM(proc_tab_2hline))
       WRITE(UNIT=u,FMT=TRIM(others)) tot_CPU_tim, tot_ELA_tim, tot_ratio, &
                                      min_CPU_tim, min_ELA_tim, min_ratio, &
                                      max_CPU_tim, max_ELA_tim, max_ratio, &
                                      avg_CPU_tim, avg_ELA_tim, avg_ratio
       WRITE(UNIT=u,FMT=TRIM(proc_tab_2hline))
       WRITE(UNIT=u,FMT=TRIM(epilogue)) date(1)(7:8), date(1)(5:6), date(1)(1:4), &
                                        time(1)(1:2), time(1)(3:4), time(1)(5:6), &
                                        zone(1:3),    zone(4:5),                  &
                                        date(2)(7:8), date(2)(5:6), date(2)(1:4), &
                                        time(2)(1:2), time(2)(3:4), time(2)(5:6), &
                                        zone(1:3),    zone(4:5)
       IF(PRESENT(file) .AND. u /= 6) CLOSE(UNIT=u)
       !$ DEALLOCATE(all_ELA_omp_tim, all_omp)
       DEALLOCATE(all_ELA_tim, all_CPU_tim, all_ratio)
     END IF
     !$ DEALLOCATE(all_num_thrds)

     !... RAZ
     !$ ELA_omp_tim(:,:)=0.0_d ; num_thrds=1 ; omp=.false.
  END SUBROUTINE PTIM_stop
END MODULE PTIM

#else

MODULE PTIM
end MODULE PTIM
#endif

  MODULE geo_typ
!=========================== DOCUMENTATION ============================= 
!DOCDEBm*    GEO/geo_typ  *
!
!    NOM 
! geo_typ
!    DESCRIPTION  
!*
! Descrition des types de structures GEOmetrie/maillage
!
! Description of GEOmetry/mesh structure types
!*
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy
  IMPLICIT NONE
!=========================== DEBUT DU CODE EXECUTABLE ==================
!----- Grandeurs communes necessaires a la description de la geometrie
!----- Common variables necessary for the description of the geometry
! distance minimale de recollement / minimal distance for merging
  real(kind=kind(0.d0)) :: petit = 1.d-6, hpetit 
! distance minimale pour la numerotation de morton / minimal distance for morton numbering
  real(kind=kind(0.d0)) :: petit_morton = 1.d-6 
! decalage pour la numerotation de morton suivant x,y,z / offset for morton numbering in x,y,z
  real(kind=kind(0.d0)) :: x_min_morton = 0.d0    
  real(kind=kind(0.d0)) :: y_min_morton = 0.d0    
  real(kind=kind(0.d0)) :: z_min_morton = 0.d0    

! nombre maximum de solides dans le calcul / maximum number of solids in the calculation
    integer, parameter              :: nb_sol_max=10      

!----- Debut Type ------------------------------------------------------
  TYPE point
      real(kind=kind(0.d0)):: x,y,z
  END TYPE point
!----- Fin Type --------------------------------------------------------

!----- Debut Type ------------------------------------------------------
  TYPE face
    integer,dimension(4)    :: vertex    ! tableau des points (au plus 4) : numero LOCAL au domaine des sommets
    integer                 :: nbvertex  ! nombre effectif de points (3 ou 4)
    integer                 :: ic1,ic2   ! numero LOCAL des deux cellules voisines si ic2 <=0  ---> condition aux limites
    real(kind=kind(0.d0))   :: surf      ! surface
    integer                 :: flevel
    type(vect_3)            :: vnorm     ! vecteur normal, orienté de ic1 vers ic2 (obligatoire)
    type(point)             :: center    ! barycentre
  END TYPE face
!----- Fin Type --------------------------------------------------------

!----- Debut Type ------------------------------------------------------
  TYPE cell
      type(point)             :: center           ! barycentre
      real(kind=kind(0.d0))   :: vol              ! volume
      real(kind=kind(0.d0))   :: h                ! Rapport Volume sur surface du bord : homogene à une distance: soit le "diametre" de la cellule
      integer                 :: clevel           ! dans le cas de la turbulence distance a la paroi et yplus et indicateur solide
      !real(kind=kind(0.d0))   :: dip              
      !real(kind=kind(0.d0))   :: yplus            
      integer                 :: isolid=0           
      !type(vect_3)            :: vnpa             ! vecteur normal a la paroi
      type(state)             :: w                ! vecteur d etat au centre de la maille
      type(vect_nvar)         :: balance          ! bilan des flux et des sources sur la maille
      type(vect_nvar)         :: fp               ! flux precedent
      integer                 :: num,idom,numloc  ! numero de la maille, numero de sous-domaine, numero local 
  END TYPE cell
!----- Fin Type --------------------------------------------------------

!----- Debut Type ------------------------------------------------------
! type liste d entier allouable
  TYPE list_int
      integer,pointer,dimension(:):: L => null()
  END TYPE list_int
!----- Fin Type --------------------------------------------------------
 
!----- Debut Type ------------------------------------------------------
! type liste vect-nvar allouable
  TYPE list_vec
     type(vect_nvar),pointer,dimension(:):: vec => null()
  END TYPE list_vec
!----- Fin Type --------------------------------------------------------

!----- Debut Type ------------------------------------------------------
! type maillage
  TYPE mesh
     integer                             :: numdom,nb_cell,nb_face        ! numero du sous-domaine, nombre de cellules et de faces
     integer                             :: nb_dom,nb_vertex              ! nombre de sous-domaines, nombre de sommets
     integer                             :: nb_level_face,nb_level_cell   ! nombre de niveaux par faces et par cellules
     integer                             :: ndim                          ! dimension du maillage 0/ Axi, 1/1D, 2/2D , 3/3D 
     real(kind=kind(0.d0))               :: small,big                     ! dimensions de la plus petite et plus grosse cellule 
     type(face),pointer,dimension(:)     :: list_face => null()           ! tableaux des cellules
     type(cell),pointer,dimension(:)     :: list_cell => null()           ! tableaux des faces
     type(point),pointer,dimension(:)    :: list_vertex => null()         ! tableaux des vertex
     type(list_int),pointer,dimension(:) :: list_send => null()           ! tableau des listes de numeros de cellules à envoyer pour domaines voisins
     type(list_int),pointer,dimension(:) :: list_recv => null()           ! tableau des listes de numeros de cellules à recevoir des domaines voisins
  END TYPE mesh
!----- Fin Type --------------------------------------------------------

!----- Debut Type ------------------------------------------------------
! type Bloc
  TYPE bloc
     integer                            :: numbl,idom              ! numero de bloc et de domaine
     integer                            :: morton                  !  Numero issu du Z-order (code de morton)
     integer                            :: nrb,nx,ny,nz            ! nbre de cellules suivant x,y,z et niveau de raffinement (puissance de 2), 
     type(point),dimension(8)           :: s                       ! Definition geometrique de la boite par ces 8 sommets
     real(kind=kind(0.d0))              :: volc                    ! volume du bloc
     integer,dimension(6)               :: cl(6)                   ! Cl ou numero du bloc voisin: clxmin,clxmax,clymin,clymax,clzmin,clzmax
     integer,dimension(6)               :: nrf(6)                  ! Niveau de raffinement de la frontiere du bloc : nrxmin,nrxmax,nrymin,nrymax,nrzmin,nrzmax
     integer,dimension(6)               :: dom(6)                  ! Numero de domaine du bloc voisin:
     integer                            :: first_cell, nb_cell     ! Numero de la premiere cellule, nombre de cellules
     integer                            :: first_face, nb_face     ! Numero de la premiere face, nombre de faces
     integer                            :: first_vertex, nb_vertex ! Numero du premier sommet, nombre de sommet
     logical                            :: isol                    ! Indicatrice de presence du solide
     real(kind=kind(0.d0)),dimension(8) :: vb            ! valeurs stockees par bloc pour SV: bathymetrie aux 4 premiers sommets 
                                                         ! et coefficient de friction aux 4 premiers sommets
  END TYPE bloc
!----- Fin Type --------------------------------------------------------

!----- Debut Type ------------------------------------------------------
! type chaineR1
  TYPE chaineR1
     integer                  :: num, interieur
     real*8                   :: z,phi
     Type(chaineR1), pointer  :: prec,suiv
  END TYPE chaineR1
!----- Fin Type --------------------------------------------------------

!----- Debut Type ------------------------------------------------------
! type chaineR2
  TYPE chaineR2
     real*8                   :: y
     type(chaineR1), pointer  :: cr1
     type(chaineR2), pointer  :: prec,suiv
  END TYPE chaineR2
!----- Fin Type --------------------------------------------------------

!----- Debut Type ------------------------------------------------------
! type chaineR3
  TYPE chaineR3
      real*8                  :: x
      type(chaineR2), pointer :: cr2
      type(chaineR3), pointer :: prec,suiv
  END TYPE chaineR3
!----- Fin Type --------------------------------------------------------

!----- Debut Type ------------------------------------------------------
  TYPE facette
! tableau des points (au plus 3)
     integer,dimension(3)    :: vertex
  END TYPE facette
!----- Fin Type --------------------------------------------------------


!----- Debut Type ------------------------------------------------------
! --  TYPE solide
  TYPE solide
      integer                                   :: id=0                                                                    
! Identifiant (numero) du solide
      integer                                   :: imv=0                                                                    
! mouvement du solide: =-1 fixe ; =0 libre ; >0 prescrit par la fonction numero imv
      integer                                   :: nb_vert=0,nb_face=0                                                     
! Nbre de sommets, facettes ou aretes definissant le solide
      real(kind=kind(0.d0))                     :: xmin_s=0.d0,xmax_s=0.d0,ymin_s=0.d0,ymax_s=0.d0,zmin_s=0.d0,zmax_s=0.d0 
! Bounding Box du solide
      real(kind=kind(0.d0))                     :: rho=0.d0                                                                
! Masse volumique du solide
      type(vect_3)                              :: xg,theta                                                                
! Position du centre de gravite du solide, angle de rotation par rapport au referentiel global
      type(facette), dimension(:), allocatable  :: list_facette                                                            
! Liste des facettes constituant l'enveloppe du solide
      type(point), dimension(:), allocatable    :: list_vertex                                                             
! Liste des vertex sur l enveloppe du solide
      integer                                   :: nb_cell=0                                                               
! Nbre de cellules contenues dans le solide
!      integer, dimension(:), allocatable        :: list_cells
  END TYPE solide
!----- Fin Type --------------------------------------------------------
!===========================   FIN DU MODULE   =========================

  END MODULE geo_typ
!DOCFIN

 SUBROUTINE ini_w(calc,nzonei,zonei)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/ini_w  *
!
!    NOM
! ini_w(calc,nzonei,zonei)
!    DESCRIPTION  
!*
! Initialisation des ddls
!
! Dof initialization
!*
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul)                                      :: calc   !! Objet calcul / Calcul object
  real(kind=kind(0.d0)),allocatable,dimension(:,:)  :: zonei  !! parametres d initialisation / Initialization parameters
  integer                                           :: nzonei !! parametres d initialisation / Initialization parameters

  integer                                           :: i,j,k
!=========================== DEBUT DU CODE EXECUTABLE ==================
 
! Initialisation sur tout le domaine
      DO i=1,calc%msh%nb_cell
          calc%msh%list_cell(i)%w%vprim%v   =0.d0
          calc%msh%list_cell(i)%w%vbal%v    =0.d0
          calc%msh%list_cell(i)%balance%v   =0.d0
          calc%msh%list_cell(i)%fp%v        =0.d0
          calc%msh%list_cell(i)%w%gprim(1)%v=0.d0
          calc%msh%list_cell(i)%w%gprim(2)%v=0.d0
          calc%msh%list_cell(i)%w%gprim(3)%v=0.d0
          calc%msh%list_cell(i)%w%enti      =0.d0
          calc%msh%list_cell(i)%w%entf      =0.d0
          calc%msh%list_cell(i)%w%pe        =0.d0
          calc%msh%list_cell(i)%w%chi       =0.d0
          !CALL prim2bal(calc%msh%list_cell(i)%w)
      END DO


! Initialisation tube a choc
    if(nzonei.eq.0)then
      DO i=1,calc%msh%nb_cell
        IF (calc%msh%list_cell(i)%center%x.le.0.d0) THEN
            calc%msh%list_cell(i)%w%vprim%v=phy_state(1)%vprim%v
        ELSE
            calc%msh%list_cell(i)%w%vprim%v=phy_state(2)%vprim%v
        END IF
          CALL prim2bal(calc%msh%list_cell(i)%w)
      END DO  
    endif

! Initialisation par zone
    if(nzonei.gt.0)then
      DO i=1,calc%msh%nb_cell
        DO j=1,nzonei
             IF (calc%msh%list_cell(i)%center%x.ge.zonei(1,j).and. &
                 calc%msh%list_cell(i)%center%x.le.zonei(2,j).and. &
                 calc%msh%list_cell(i)%center%y.ge.zonei(3,j).and. &
                 calc%msh%list_cell(i)%center%y.le.zonei(4,j).and. &
                 calc%msh%list_cell(i)%center%z.ge.zonei(5,j).and. &
                 calc%msh%list_cell(i)%center%z.le.zonei(6,j)) THEN
                 do k=1,nvar
                   calc%msh%list_cell(i)%w%vprim%v(k)  = zonei(6+k,j)
                 enddo
                 IF(imodel_phy.eq.2.and.pes_xyz.eq.1)calc%msh%list_cell(i)%w%vprim%v(5)= &
                                                     calc%msh%list_cell(i)%w%vprim%v(5)+ &
                                                     calc%msh%list_cell(i)%w%vprim%v(1)*gpes_phy*&
                                                     (zonei(2,j)-calc%msh%list_cell(i)%center%x)
                 IF(imodel_phy.eq.2.and.pes_xyz.eq.2)calc%msh%list_cell(i)%w%vprim%v(5)=&
                                                     calc%msh%list_cell(i)%w%vprim%v(5)+ &
                                                     calc%msh%list_cell(i)%w%vprim%v(1)*gpes_phy*&
                                                     (zonei(4,j)-calc%msh%list_cell(i)%center%y)
                 IF(imodel_phy.eq.2.and.pes_xyz.eq.3)calc%msh%list_cell(i)%w%vprim%v(5)=&
                                                     calc%msh%list_cell(i)%w%vprim%v(5)+ &
                                                     calc%msh%list_cell(i)%w%vprim%v(1)*gpes_phy*&
                                                     (zonei(6,j)-calc%msh%list_cell(i)%center%z)
              END IF
        ENDDO
        CALL prim2bal(calc%msh%list_cell(i)%w)
      END DO  
    endif

! Initialisation par une fonction utilisateur
    if(nzonei.lt.0)then
      DO i=1,calc%msh%nb_cell
          CALL fct_iniw(calc%msh%list_cell(i)%center%x, &
                    calc%msh%list_cell(i)%center%y, &
                    calc%msh%list_cell(i)%center%z, &
                    calc%msh%list_cell(i)%w%vprim, &
                    -nzonei)
          CALL prim2bal(calc%msh%list_cell(i)%w)        
      END DO  
    endif

!----------------------------------------------------------------
! Si presence de solides
!----------------------------------------------------------------
      IF (calc%nb_sol .NE. 0) THEN
          DO j = 1,calc%nb_sol
               k=0
               DO i = 1,calc%msh%nb_cell
                    IF (         &
                    calc%msh%list_cell(i)%center%x<calc%list_sol(j)%xmax_s  &
                    .AND. calc%msh%list_cell(i)%center%x>calc%list_sol(j)%xmin_s  &
                    .AND. calc%msh%list_cell(i)%center%y<calc%list_sol(j)%ymax_s  &
                    .AND. calc%msh%list_cell(i)%center%y>calc%list_sol(j)%ymin_s  &
                    .AND. calc%msh%list_cell(i)%center%z<calc%list_sol(j)%zmax_s  &
                    .AND. calc%msh%list_cell(i)%center%z>calc%list_sol(j)%zmin_s) &
                    CALL raycasting(calc%list_sol(j),calc%msh%list_cell(i)%center%x,&
                                                     calc%msh%list_cell(i)%center%y,&
                                                     calc%msh%list_cell(i)%center%z,&
                                                     calc%msh%list_cell(i)%w%chi)
                    IF (calc%msh%list_cell(i)%w%chi .EQ. calc%list_sol(j)%id) then
                      k=k+1
                      calc%msh%list_cell(i)%w%vprim%v(1)=calc%list_sol(j)%rho
                      CALL prim2bal(calc%msh%list_cell(i)%w)
                    endif
               END DO
               calc%list_sol(j)%nb_cell = k
               write( *,1010)j,calc%msh%numdom,calc%list_sol(j)%nb_cell
1010           format('Solide ',i3,'  from domain',i3,'  number of cells affected',i9)
          END DO
      END IF
!----------------------------------------------------------------
! Cas particulier du modele de SaintVenant
!----------------------------------------------------------------
   IF(imodel_phy.ne.1)RETURN
   SELECT CASE (ibathy)
      CASE(0) ! Fond plat
          write(*,*)'INI_W-Info Flat Bottom and no friction'

      CASE(1) ! Initialisation de la bathymetrie par fonction utilisateur
          write(*,*)'INI_W-Info Bathymetry and friction  defined by user fonction number:',num_bathy
          DO i=1,calc%msh%nb_cell
              CALL fct_bathy(calc%msh%list_cell(i)%center%x, &
                             calc%msh%list_cell(i)%center%y, &
                             calc%msh%list_cell(i)%center%z, &
                             calc%msh%list_cell(i)%w%vprim%v(5), & 
                             calc%msh%list_cell(i)%w%gprim(1)%v(5),calc%msh%list_cell(i)%w%gprim(1)%v(5),&
                             calc%msh%list_cell(i)%w%vprim%v(6))
          END DO  

!----------------------------------------
      CASE (2) ! Initialisation de la bathymetrie par interpolation lineaire par bloc
          write(*,*)'INI_W-Info Bathymetry and friction defined linearly per block on file:',fich_bathy
          call calc_bathy(calc)

!------------------------------------------------------
      !~CASE (3) ! Initialisation de la bathymetrie par bloc sur le raffinement max
      !~    write(*,*)'INI_W-Info Bathymetry and friction defined per block at the highest mesh refinement level on file:',fich_bathy
      !~    
      CASE DEFAULT
         call print_err('READ_BATH','Unforeseen case')
          
  END SELECT
  ! if(ngrad_bathy.eq.1) call grad_bathy(calc)  !!!!!!!!!!!!!! A FAIRE  !!!!!!!!!!!!!!!!!!!!!!!!!
      
      


!===========================   FIN DE LA ROUTINE    ====================

END SUBROUTINE ini_w
!DOCFIN 

 SUBROUTINE init_mesh (msh)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/init_mesh  *
!
!    NOM
! init_mesh (msh)
!    DESCRIPTION
!*
!     Calcul les donnees geometriques (surfaces, volumes, normales)
!     a partir de donnees elementaires (liste des points et connectivite faces-cellules)  
!     Calculate geometric data (surfaces, volumes, normals)
!     from basic data (list of points and face-cell connectivity)  
!*
! 
! 
!    ENTREES / INPUT
!    msh: le maillage / the mesh
!
!    SORTIES / OUTPUT
!    msh: le maillage / the mesh
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use geo_typ
  use geo, only : triangle
  IMPLICIT NONE
!.2-----  Declaration
  type(mesh), intent(inout) :: msh !! Maillage / Mesh
  real(kind=kind(0.d0))     :: x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4
  real(kind=kind(0.d0))     :: xn1,yn1,zn1,surf1,xm1,ym1,zm1,xn2,yn2,zn2,surf2,xm2,ym2,zm2
  real(kind=kind(0.d0))     :: xn,yn,zn,surf,xm,ym,zm,d13,d24
  integer                   :: i1,i2,i3,i4,nf,iv,iv1,iv2
!=========================== DEBUT DU CODE EXECUTABLE ==================

  DO nf=1,msh%nb_face
  ! on decoupe chaque face en 2 triangles
  ! coplanaires !!!!!
      i1=msh%list_face(nf)%vertex(1) ! n° du sommet 1
      i2=msh%list_face(nf)%vertex(2)
      i3=msh%list_face(nf)%vertex(3)
      
      x1=msh%list_vertex(i1)%x
      y1=msh%list_vertex(i1)%y
      z1=msh%list_vertex(i1)%z
      
      x2=msh%list_vertex(i2)%x
      y2=msh%list_vertex(i2)%y
      z2=msh%list_vertex(i2)%z
      
      x3=msh%list_vertex(i3)%x
      y3=msh%list_vertex(i3)%y
      z3=msh%list_vertex(i3)%z
      
      IF (msh%list_face(nf)%nbvertex.eq.4) THEN
          i4=msh%list_face(nf)%vertex(4)
          
          x4=msh%list_vertex(i4)%x
          y4=msh%list_vertex(i4)%y
          z4=msh%list_vertex(i4)%z
          
          d13=(x3-x1)**2+(y3-y1)**2+(z3-z1)**2
          d24=(x4-x2)**2+(y4-y2)**2+(z4-z2)**2
          
          IF (d13.le.d24) THEN
              CALL triangle(x1,y1,z1,x2,y2,z2,x3,y3,z3,xn1,yn1,zn1,surf1,xm1,ym1,zm1)
              CALL triangle(x1,y1,z1,x3,y3,z3,x4,y4,z4,xn2,yn2,zn2,surf2,xm2,ym2,zm2)
          ELSE
              CALL triangle(x1,y1,z1,x2,y2,z2,x4,y4,z4,xn1,yn1,zn1,surf1,xm1,ym1,zm1)
              CALL triangle(x2,y2,z2,x3,y3,z3,x4,y4,z4,xn2,yn2,zn2,surf2,xm2,ym2,zm2)
          END IF
          
          surf=surf1+surf2
          
          IF (surf.ne.0) THEN
              xn=(surf1*xn1+surf2*xn2)/surf
              yn=(surf1*yn1+surf2*yn2)/surf
              zn=(surf1*zn1+surf2*zn2)/surf
              xm=(surf1*xm1+surf2*xm2)/surf
              ym=(surf1*ym1+surf2*ym2)/surf
              zm=(surf1*zm1+surf2*zm2)/surf
          ELSE
              xn=-1
              yn=0
              zn=0
              xm=0
              ym=0
              zm=0
          END IF

      ELSE
          CALL triangle(x1,y1,z1,x2,y2,z2,x3,y3,z3,xn,yn,zn,surf,xm,ym,zm)
      END IF

      msh%list_face(nf)%center%x=xm
      msh%list_face(nf)%center%y=ym
      msh%list_face(nf)%center%z=zm
      
      msh%list_face(nf)%surf=surf
      
      msh%list_face(nf)%vnorm%v(1)=xn
      msh%list_face(nf)%vnorm%v(2)=yn
      msh%list_face(nf)%vnorm%v(3)=zn

  END DO

! Calcul des rapports Volume/surface
   DO iv=1,msh%nb_cell
     IF(msh%list_cell(iv)%idom.eq.msh%numdom)msh%list_cell(iv)%h=0.d0
    end DO

  DO nf=1,msh%nb_face
      iv1=msh%list_face(nf)%ic1
      iv2=msh%list_face(nf)%ic2
      IF (iv1.gt.0.and.iv2.ne.-999) THEN   !!!!!!!!!!!!! ON ESSAYE !!!!!!!!!!!
          IF(msh%list_cell(iv1)%idom.eq.msh%numdom)msh%list_cell(iv1)%h=msh%list_cell(iv1)%h+msh%list_face(nf)%surf
      END IF
      IF (iv2.gt.0) THEN
          IF(msh%list_cell(iv2)%idom.eq.msh%numdom)msh%list_cell(iv2)%h=msh%list_cell(iv2)%h+msh%list_face(nf)%surf
      END IF
  END DO

  msh%small=1.d20
  msh%big  =0.d0
  DO iv=1,msh%nb_cell
    IF(msh%list_cell(iv)%idom.eq.msh%numdom)then
        msh%list_cell(iv)%h=msh%list_cell(iv)%vol/msh%list_cell(iv)%h
        if(msh%list_cell(iv)%h.gt.msh%big)  msh%big  =msh%list_cell(iv)%h
        if(msh%list_cell(iv)%h.lt.msh%small)msh%small=msh%list_cell(iv)%h
     endif
  END DO
  write( *,1000)msh%numdom,msh%small
  write( *,1010)msh%numdom,msh%small
1000    format('INIT_MESH-INFO Domain ',i3,' size of smallest cell  :',e13.5)
1010    format('INIT_MESH-INFO Domain ',i3,' size of largest cell   :',e13.5)
  msh%list_face(:)%flevel=0
  msh%list_cell(:)%clevel=0
  msh%nb_level_cell=int(dlog(msh%big*1.05/msh%small)/dlog(2.0d0))
  msh%nb_level_face=msh%nb_level_cell

!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE INIT_MESH
!DOCFIN 

 SUBROUTINE VelCFL(w,vloc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/VelCFL  *
!
!    NOM
! velcfl(w,vloc)
!    DESCRIPTION  
!*
! Calcul de la vitesse d onde Max
!
! Calculation of Max wave velocity
!*
! 
!    ENTREES / INPUT
! w    : objet de type "state" contenant les variables conservatives
!      / object of type "state" containing the conservative variables
!
!    SORTIES / OUTPUT
! vloc : vitesse d onde  /  wave velocity
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  use phy ,only:  vitson
  IMPLICIT NONE
!.2-----  Declaration
  type(state),intent(in)            :: w !! Variables d etat / State variables
  real(kind=kind(0.d0)),intent(out) :: vloc !! Vitesse d onde : Wave speed
  
  real(kind=kind(0.d0))             :: cson,vconv
  real(kind=kind(0.d0))             :: r,u1,u2,u3,p,u

!=========================== DEBUT DU CODE EXECUTABLE ==================
  SELECT CASE (imodel_phy)
      CASE (1)
          u1=w%vprim%v(2)
          u2=w%vprim%v(3)
          u=dsqrt(u1*u1+u2*u2)  
          CALL vitson(w,cson)
          vconv=u+cson !     vitesse des ondes convectives
      CASE DEFAULT
          r=w%vprim%v(1)
          u1=w%vprim%v(2)
          u2=w%vprim%v(3)
          u3=w%vprim%v(4)
          p=w%vprim%v(5)
          u=dsqrt(u1*u1+u2*u2+u3*u3)  
          CALL vitson(w,cson)
          vconv=u+cson !     vitesse des ondes convectives
  END SELECT
  
  vloc=vconv

!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE VelCFL
!DOCFIN

 SUBROUTINE read_bath(icode,iarg)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_bath *
!
!    NOM
! read_bath(icode,iarg)
!    DESCRIPTION  
!*
! Lecture du Bloc BATH du fichier de donnees
! Read the BATH block of the data file
!*
! 
!    ENTREES / INPUT
!    icode  : 0/ Initialisation de la bathymetrie par fonction utilisateur
!               / Initialization of bathymetry by user function
!             1/ Initialisation de la bathymetrie par interpolation lineaire par bloc
!               / Initialization of bathymetry by linear interpolation per block
!             2/ Initialisation de la bathymetrie par bloc sur le raffinement max
!               / Initialization of bathymetry per block on the highest mesh refinement level
!    iarg   : argument for the selected case
!
!    SORTIES / OUTPUT
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  integer, intent(inout)                           :: icode,iarg !! Code, argument
  
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(*,*)
  write(*,*)achar(27)//'[34m================================================'
  write(*,*)'Reading bathymetry and friction: block BATH'
  write(*,*)'================================================'//achar(27)//'[0m'
  write(*,*)

  SELECT CASE (icode)
      CASE(0) ! Fond plat
          write(*,*)'BATH-Info Bathymetry : Flat Bottom and no friction'
          ibathy=icode

      CASE(1) ! Initialisation de la bathymetrie par fonction utilisateur
          num_bathy=iarg
          write(*,*)'BATH-Info Bathymetry and friction defined by user fonction number:',num_bathy
          ibathy=icode

!----------------------------------------
      CASE (2) ! Initialisation de la bathymetrie par interpolation lineaire par bloc
          num_bathy=iarg
          read(33,*)fich_bathy
          write(*,*)'BATH-Info Bathymetry and friction defined linearly per block on file:',fich_bathy
          ibathy=icode
          if(iarg.eq.-1)ibathy=-2

!~!------------------------------------------------------
!~      CASE (3) ! Initialisation de la bathymetrie par bloc sur le raffinement max
!~          read(*,*)fich_bathy
!~          write(*,*)'BATH-Info Bathymetry and friction defined per block at the highest mesh refinement level on file:',fich_bathy
!~          ibathy=icode
!~         call print_err('READ_BATH','This feature has not yet been implemented')

          
      CASE DEFAULT
         call print_err('READ_BATH','Unforeseen case')
          
  END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_bath
!DOCFIN

 SUBROUTINE save_obj (calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/save_obj  *
!
!    NOM
! save_obj  (calc)
!    DESCRIPTION  
!*
! Sauvegarde au format OBJ des objets solides
! Save solid objects in OBJ format
!*
! 
!    ENTREES / INPUT
! calc : objet calcul / calculation object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul),intent(in) :: calc !! Objet calcul / Calcul object
  character               :: fsol*14,cn*10
  integer                 :: i,ic,id,iu,isol
!=========================== DEBUT DU CODE EXECUTABLE ==================
  cn='0123456789'
  do isol=1,calc%nb_sol
    ic=int(isol/100.)
    id=int((isol-ic*100.)/10.)
    iu=isol-id*10-ic*100
    
    fsol( 1: 6)='solide' 
    fsol( 7: 7)='_'
    fsol( 8: 8)=cn(ic+1:ic+1)
    fsol( 9: 9)=cn(id+1:id+1)
    fsol(10:10)=cn(iu+1:iu+1)
    fsol(11:14)='.obj'
    open(11,file=fsol,status='unknown')

    write(11,1020)calc%list_sol(isol)%xg%v
    write(11,1021)calc%list_sol(isol)%theta%v
1020  format('# Position of the center of gravity of the solid           :',3e13.5)
1021  format('# Angle of rotation relative to the global reference frame :',3e13.5)
	
    do i=1,calc%list_sol(isol)%nb_vert
      write(11,1000)calc%list_sol(isol)%list_vertex(i)%x,&
                    calc%list_sol(isol)%list_vertex(i)%y,&
                    calc%list_sol(isol)%list_vertex(i)%z
    enddo
    do i=1,calc%list_sol(isol)%nb_face
      write(11,1010)calc%list_sol(isol)%list_facette(i)%vertex(1),&
                    calc%list_sol(isol)%list_facette(i)%vertex(2),&
                    calc%list_sol(isol)%list_facette(i)%vertex(3)
    enddo
    close(11)

  enddo
 1000   format('v ',3e13.5)    
 1010   format('f ',3i9)    

!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE save_obj
!DOCFIN

 SUBROUTINE init_def_bloc(cb,nzone,zone)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/ini_def_bloc  *
!
!    NOM
! ini_def_bloc(cb,nzone,zone)
!    DESCRIPTION  
!*
! Definition de la discretisation des blocs 
! Definition of block discretisation 
!*
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  use UTI,only: fct_mesh
  IMPLICIT NONE
!.2-----  Declaration
  type(calcul)                                      :: cb    !! Objet calcul / Calcul object
  real(kind=kind(0.d0)),allocatable,dimension(:,:)  :: zone  !! parametres de maillage / Mesh parameters
  integer,allocatable,dimension(:,:)                :: nzone !! parametres de maillage / Mesh parameters

  integer                                           :: i,j
  type( point)                                      :: center

!=========================== DEBUT DU CODE EXECUTABLE ==================


!----------------------------------------------------------------------------------
! on definit la discretisation des blocs 
!
! Premier cas on utilise les zones definies dans cerf.inp

  IF (nzone(1,1).ge.0) THEN
      DO i=1,cb%nb_bloc
          cb%list_bloc(i)%nrb =0
          cb%list_bloc(i)%idom=0
          center%x=0.d0; center%y=0.d0; center%z=0.d0
          do j=1,8
            center%x=center%x+cb%list_bloc(i)%s(j)%x/8.d0
            center%y=center%y+cb%list_bloc(i)%s(j)%y/8.d0
            center%z=center%z+cb%list_bloc(i)%s(j)%z/8.d0
          enddo
          DO j=1,size(nzone,2)
              IF (center%x.ge.zone(1,j).and. &
                  center%x.le.zone(2,j).and. &
                  center%y.ge.zone(3,j).and. &
                  center%y.le.zone(4,j).and. &
                  center%z.ge.zone(5,j).and. &
                  center%z.le.zone(6,j))then
                  cb%list_bloc(i)%nrb =nzone(1,j)
              END IF
          END DO
      END DO
  ELSE
! Deuxieme cas on utilise les fonctions utilisateur
  DO i=1,cb%nb_bloc
          cb%list_bloc(i)%nrb =0
          cb%list_bloc(i)%idom=0
          center%x=0.d0; center%y=0.d0; center%z=0.d0
          do j=1,8
            center%x=center%x+cb%list_bloc(i)%s(j)%x/8.d0
            center%y=center%y+cb%list_bloc(i)%s(j)%y/8.d0
            center%z=center%z+cb%list_bloc(i)%s(j)%z/8.d0
          enddo
          call fct_mesh(center%x,center%y,center%z,-nzone(1,1),cb%list_bloc(i)%nrb)
      END DO
  END IF
  

!===========================   FIN DE LA ROUTINE    ====================

END SUBROUTINE init_def_bloc
!DOCFIN 

 SUBROUTINE read_gmsh(fichmsh,calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_gmsh  *
!
!    NOM
! read_gmsh(ficmsh,msh)
!    DESCRIPTION  
!*
! Lecture d un fichier de maillage au format Gmsh et affectation dans les blocs au format CERF
!
! Read a mesh file in Gmsh format and assign it to blocks in CERF format
!*
! 
!    ENTREES / INPUT
! fichmsh: nom de fichier de maillage au format Gmsh v2.2 / Mesh file name in Gmsh v2.2 format
!
!    SORTIES / OUTPUT
! calc: objet calcul modifie / modified calculation object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  use zorder
  use msh
  implicit none
!.2-----  Declaration
  type(calcul), intent(inout) :: calc !! Objet calcul / Calcul object
  character( *), intent(in)   :: fichmsh !! Nom du fichier de maillage / Mesh file name
  
  integer, dimension(:,:), allocatable :: iconnec
  integer, dimension(15)               :: nbn=(/2,3,4,4,8,1,1,1,1,1,1,1,1,1,1/) ! nbre de noeud en fct du type d elt
  real(kind=kind(0.d0))                :: x,y,z,d
  integer                              :: in,mortonx,mortony,mortonz,ie,ier,nb_elem,jn,itemp,iphys,ityp,j,nbelem,nbf,ii
  integer                              :: if1,if2,ic1,ic2,k
  integer(kind=16)                     :: nmorton
  integer(kind=16) ,allocatable,dimension(:)     :: lm
  character*80                         :: ligne
  type(chaine_MF), pointer             :: lcf,dblechf,totof
  type(vertex)                         :: v
  type(mface)                          :: f
  type(noe), dimension(:), allocatable :: lst_noe
  integer                              :: nb_noe
  type(noe),dimension(8)               :: ln,lnf
  type(noe)                            :: noe_null
  type(bloc)                           :: b_null
!=========================== DEBUT DU CODE EXECUTABLE ==================
!
!-------  Initialisations
!

noe_null%coord%x= 0.d0 ; noe_null%coord%y= 0.d0 ; noe_null%coord%z= 0.d0
noe_null%morton= 0 ; noe_null%num= 0
b_null%numbl= 0 ; b_null%idom= 0 ;b_null%morton= 0 ;b_null%nrb= 0 ;b_null%nx= 1 ;b_null%ny= 1 ;b_null%nz= 1
b_null%s(:)%x= 0.d0 ; b_null%s(:)%y= 0.d0 ; b_null%s(:)%z= 0.d0 ; b_null%volc= 0.d0
b_null%cl(:)= 0 ; b_null%nrf(:)= 0 ; b_null%dom(:)= 0
b_null%first_cell= 0 ; b_null%nb_cell= 0
b_null%first_face= 0 ; b_null%nb_face= 0
b_null%first_vertex= 0 ; b_null%nb_vertex= 0 ; b_null%isol= .false.
    allocate(iconnec(1,1))
    iconnec = 0
    allocate(lst_noe(1))
    lst_noe(:)=noe_null


open(11,file=fichmsh,status='old')
10    continue 
read(11,'(a)', end=99) ligne 
! lecture des noeuds
if (ligne(1:6) == '$Nodes') then
    read(11,*) nb_noe
    write(*,*)'read_gmsh-INFO Reading ',nb_noe,' vertexes'
    deallocate(lst_noe)
    allocate(lst_noe(nb_noe))
    lst_noe(:)=noe_null
    x_min_morton=1.d20
    y_min_morton=1.d20
    z_min_morton=1.d20
    do in = 1,nb_noe
        read(11,*) jn,x,y,z
        lst_noe(in)%coord%x = x
        lst_noe(in)%coord%y = y
        lst_noe(in)%coord%z = z
        lst_noe(in)%num = in
        if (x < x_min_morton) x_min_morton = x
        if (y < y_min_morton) y_min_morton = y
        if (z < z_min_morton) z_min_morton = z
    enddo
endif

! lecture de la connectivite des elements
if (ligne(1:9) == '$Elements') then
    read(11,*) nbelem
    write(*,*)'read_gmsh-INFO Reading ',nbelem,' elements'
    deallocate(iconnec)
    allocate(iconnec(nbelem,11))
    iconnec = 0
    do ie = 1,nbelem
        read(11,*) jn,ityp,in,iphys,(itemp,ii=1,in-1),(iconnec(ie,ii+2),ii=1,nbn(ityp))
        iconnec(ie,1) = ityp !ityp=1,2,3,4,5,6 -> l2,t3,q4,th4,h8,point
        iconnec(ie,2) = iphys  !propriete physique
    enddo
endif

goto 10 

99    continue 
close(11)

! Estimation de petit_morton et du nombre d elements
petit_morton=1.d20
nb_elem = 0
do ie=1,nbelem
    ! nbn(iconnec(ie,1)) : ityp
    if (iconnec(ie,1) == 2 ) cycle ! t3
    if (iconnec(ie,1) == 3 ) cycle ! q4
    if (iconnec(ie,1) == 4 ) cycle ! th4
    if (iconnec(ie,1) == 5)then
        nb_elem = nb_elem + 1 ! h8
        iconnec(ie,11)=nb_elem
    endif
    if (iconnec(ie,1) >= 6) cycle ! on boucle
    do j=1,nbn(iconnec(ie,1))
        do k=1,nbn(iconnec(ie,1))
            if (k /= j) then
                d=sqrt((lst_noe(iconnec(ie,k+2))%coord%x-lst_noe(iconnec(ie,j+2))%coord%x)**2 + &
                       (lst_noe(iconnec(ie,k+2))%coord%y-lst_noe(iconnec(ie,j+2))%coord%y)**2 + &
                       (lst_noe(iconnec(ie,k+2))%coord%z-lst_noe(iconnec(ie,j+2))%coord%z)**2)
                if (d < petit_morton) petit_morton = d
            endif
        enddo
    enddo
enddo
petit_morton = petit_morton/20.d0
write(*,*)'read_gmsh-INFO Small_Morton:',petit_morton


 ! Determination du code Morton des noeuds
do in=1,nb_noe
    mortonx = coord_real2int(lst_noe(in)%coord%x,x_min_morton,petit_morton)
    mortony = coord_real2int(lst_noe(in)%coord%y,y_min_morton,petit_morton)
    !if (calc%msh%ndim == 2) then
    !    call zordercurve2d(mortonx,mortony,nmorton)
    !else
        mortonz = coord_real2int(lst_noe(in)%coord%z,z_min_morton,petit_morton)
        call zordercurve3d(mortonx,mortony,mortonz,nmorton)
    !endif
    lst_noe(in)%morton = nmorton
enddo

! Initialisations de la liste chainee des faces
allocate(lcf)
nullify(lcf%suiv); nullify(lcf%prec)
lcf%f%morton = 0
lcf%f%num = 0

! On range les faces  dans la liste chainee  et on range les blocs
calc%nb_bloc=nb_elem
allocate(calc%list_bloc(calc%nb_bloc))
allocate(lm(calc%nb_bloc))
nb_elem = 0
do ie = 1,nbelem
    select case (iconnec(ie,1))
        case(1,15)
        !~case(1) ! l2 pour conserver le numero de propriete des frontieres  --------------------
        !~    if (calc%msh%ndim == 2) then
        !~        call ini_mface(f)
        !~        lnf(1)=lst_noe(iconnec(ie,3))
        !~        lnf(2)=lst_noe(iconnec(ie,4)) 
        !~        call mortonface(f,lnf,2,calc%msh%ndim)
        !~        f%be2=-iconnec(ie,2)
        !~        call range_mface(f,lcf,ier)
        !~    endif

        case(3) ! q4 ---------------------------------------------------------------------
            !~if (calc%msh%ndim == 2) then ! alors c est un element
                !~nb_elem=nb_elem+1
                !~calc%list_bloc(nb_elem)=b_null
                !~ln(:)=noe_null
                !~do j=1,nbn(iconnec(ie,1))
                !~    ln(j)=lst_noe(iconnec(ie,j+2))
                !~enddo
                !~call permnoe(ln,nbn(iconnec(ie,1))) ! on permute les noe pour demarrer du plus petit morton
                !~call noe2bloc(ln,calc%list_bloc(nb_elem),nbn(iconnec(ie,1)),2)
                !~do j=1,nbn(iconnec(ie,1))
                !~    lnf(:)=noe_null
                !~    lnf(2)=ln(j)
                !~    if (j /= nbn(iconnec(ie,1))) then
                !~        lnf(1)=ln(j+1)
                !~    else
                !~        lnf(1)=ln(1)
                !~    endif
                !~    call ini_mface(f)
                !~    call mortonface(f,lnf,2,2)
                !~    f%be1=nb_elem
                !~    f%fac_loc(1)=j
                !~    call perm4(f%mv,nbn(iconnec(ie,1)))
                !~    call range_mface(f,lcf,ier)
                !~enddo
                !~calc%list_bloc(nb_elem)%numbl   = nb_elem
            !~else ! sinon c est une face
                v%x = 0.d0; v%y = 0.d0; v%z = 0.d0
                call ini_mface(f) 
                lnf(:) = noe_null
                do j = 1,nbn(iconnec(ie,1))
                    lnf(j) = lst_noe(iconnec(ie,j+2))
                enddo
                call permnoe(lnf,nbn(iconnec(ie,1))) ! on permute les noe pour demarrer du plus petit morton
                call mortonface(f,lnf,nbn(iconnec(ie,1)),3)
                f%be2 = -iconnec(ie,2)
                !call affiche_mface(f)
                call range_mface(f,lcf,ier)
            !~endif
            
        case(5) ! h8 -------------------------------------------------------------------------------
            nb_elem=nb_elem+1
            ! bloc
            calc%list_bloc(nb_elem)=b_null
            ln(:)=noe_null
            do j=1,nbn(iconnec(ie,1))
                ln(j)=lst_noe(iconnec(ie,j+2))
            enddo
            !call permnoe(ln,8) ! on permute les noe pour demarrer du plus petit morton
            call noe2bloc(ln,calc%list_bloc(nb_elem),nbn(iconnec(ie,1)),3,lm(nb_elem))
            calc%list_bloc(nb_elem)%numbl   = nb_elem

            ! face 1 5 8 4
            call ini_mface(f)
            lnf(:)=noe_null ; lnf(1)=ln(1) ; lnf(2)=ln(5) ; lnf(3)=ln(8) ; lnf(4)=ln(4)
            call mortonface(f,lnf,4,3)
            f%be1=nb_elem
            f%fac_loc(1)=1
            call perm4(f%mv,4)
            call range_mface(f,lcf,ier)
            ! face 2 3 7 6
            call ini_mface(f)
            lnf(:)=noe_null ; lnf(1)=ln(2) ; lnf(2)=ln(3) ; lnf(3)=ln(7) ; lnf(4)=ln(6)
            call mortonface(f,lnf,4,3)
            f%be1=nb_elem
            f%fac_loc(1)=2
            call perm4(f%mv,4)
            call range_mface(f,lcf,ier)
            ! face 1 2 6 5
            call ini_mface(f)
            lnf(:)=noe_null ; lnf(1)=ln(1) ; lnf(2)=ln(2) ; lnf(3)=ln(6) ; lnf(4)=ln(5)
            call mortonface(f,lnf,4,3)
            f%be1=nb_elem
            f%fac_loc(1)=3
            call perm4(f%mv,4)
            call range_mface(f,lcf,ier)
            ! face 3 4 8 7
            call ini_mface(f)
            lnf(:)=noe_null ; lnf(1)=ln(3) ; lnf(2)=ln(4) ; lnf(3)=ln(8) ; lnf(4)=ln(7)
            call mortonface(f,lnf,4,3)
            f%be1=nb_elem
            f%fac_loc(1)=4
            call perm4(f%mv,4)
            call range_mface(f,lcf,ier)
            ! face 1 4 3 2
            call ini_mface(f)
            lnf(:)=noe_null ; lnf(1)=ln(1) ; lnf(2)=ln(4) ; lnf(3)=ln(3) ; lnf(4)=ln(2)
            call mortonface(f,lnf,4,3)
            f%be1=nb_elem
            f%fac_loc(1)=5
            call perm4(f%mv,4)
            call range_mface(f,lcf,ier)
            ! face 5 6 7 8
            call ini_mface(f)
            lnf(:)=noe_null ; lnf(1)=ln(5) ; lnf(2)=ln(6) ; lnf(3)=ln(7) ; lnf(4)=ln(8)
            call mortonface(f,lnf,4,3)
            f%be1=nb_elem
            f%fac_loc(1)=6
            call perm4(f%mv,4)
            call range_mface(f,lcf,ier)
            calc%list_bloc(nb_elem)%volc=volbloc(calc%list_bloc(nb_elem))
            
        case default
            write(*,*)' INFO-read_gmsh, type element',iconnec(ie,1),' non prevu!'
    end select
enddo

!---------------------------------------------------------
! On parcourt les faces pour determiner les voisins des blocs
!
nbf = 0
dblechf=>lcf
do while (associated(dblechf%prec))
    dblechf=>dblechf%prec
enddo
dblechf=>dblechf%suiv  ! on saute le premier qui est nul
do while (associated(dblechf))
    nbf=nbf+1
    dblechf%f%num=nbf
    dblechf=>dblechf%suiv
enddo
 
nbf= 0
dblechf=>lcf
do while (associated(dblechf%prec))
    dblechf=>dblechf%prec
enddo
dblechf=>dblechf%suiv  ! on saute le premier qui est nul
do while (associated(dblechf))
    if (dblechf%f%num > 0) then
        nbf=nbf+1   
        ic1 = dblechf%f%be1
        ic2 = dblechf%f%be2
        if1 = dblechf%f%fac_loc(1)
        if2 = dblechf%f%fac_loc(2)
        calc%list_bloc(ic1)%cl(if1)  =ic2
        if (ic2 > 0) then
            calc%list_bloc(ic2)%cl(if2)  =ic1
        endif
    endif
    dblechf=>dblechf%suiv
enddo
    write(*,*)'read_gmsh-INFO creation of ',nbf,' faces'

! on ordonne les numeros (locaux) des blocs selon le code de morton (lm)
k=0
do ii=1,calc%nb_bloc
    j=int(minloc(lm,1,mask=lm.ne.0))
    k=k+1
    calc%list_bloc(ii)%morton    = k
    lm(j)=0
enddo
deallocate(lm)
    write(*,*)'read_gmsh-INFO creation of ',calc%nb_bloc,' master elements'

!----------------------------------------------------------------------------
! LIBERATION DE LA MEMOIRE
!----------------------------------------------------------------------------
dblechf=>lcf
do while (associated(dblechf%prec))
    dblechf => dblechf%prec
enddo
do while (associated(dblechf))
    totof => dblechf
    dblechf => dblechf%suiv
    deallocate(totof)
enddo
!
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_gmsh
!DOCFIN 

 SUBROUTINE psr(interdom,nb_dom,idomI,idomJ,ibI,ibJ,ipos_send,ipos_recv)
!=========================== DOCUMENTATION =============================
!DOCDEBh*    GEO/psr  *
!
!    NOM
!  psr (interdom,nb_bloc,nb_dom,idomI,idomJ,ibI,ibJ,ipos_send,ipos_recv)
!    DESCRIPTION  
!*
! Lecture de la liste des blocs de chaque cote de l interface entre les domaines
! pour chaque couple de domaine Di, Dj  i<j
! cree en position j-i+(i-1)*(2nb_dom-i)/2 
! une liste de 4 entiers:
! - numero du bloc du domaine Di
! - numero du bloc du domaine Dj
! - position cumule de la liste send pour les 2 blocs
! - position cumule de la liste recv 
!
! Reading the list of blocks on each side of the interface between domains
! for each pair of domains Di, Dj i<j
! create at position j-i+(i-1)*(2nb_dom-i)/2 
! a list of 4 integers:
! - domain Di block number
! - number of the block in the Dj domain
! - cumulative position of the send list for the 2 blocks
! - cumulative position of the recv list 
!*
!
!    ENTREES / INPUT
! interdom        : liste des blocs de chaque cote de l interface entre les domaines 
!                 / list of blocks on each side of the interface between domains
! nb_dom          : Nombre de domaines / Number of domains
! idomI           : Numero du domaine I considere / Number of domain I considered
! idomJ           : Numero du domaine J voisin / Number of neighbouring domain J
! ibI             : Numero du bloc du domaine idomI / Block number of domain idomI
! ibJ             : Numero du bloc du domaine idomJ / Block number of domain idomJ
!
!    SORTIES / OUTPUT
! ipos_send : position dans la liste list_send des cellules de idomI a envoyer a idomJ 
!           / position in the list_send list of idomI cells to send to idomJ
! ipos_recv : position dans la liste list_recv des cellules de idomI a recevoir de idomJ 
!           / position in the list_recv list of cells from idomI to be received from idomJ
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DECLARATIONS ==============================
!.1-----  Implicit, Use
  use geo_typ
  IMPLICIT NONE
!.2-----  Declaration
  integer, intent(in)                     :: nb_dom   !! Nombre de domaines / Number of domains
  integer, intent(in)                     :: idomI    !! Numero du domaine I considere / Number of domain I considered
  integer, intent(in)                     :: idomJ    !! Numero du domaine J voisin / Number of neighbouring domain J
  integer, intent(in)                     :: ibI      !! Numero du bloc du domaine idomI / Block number of domain idomI
  integer, intent(in)                     :: ibJ      !! Numero du bloc du domaine idomJ / Block number of domain idomJ
  integer, intent(out)                    :: ipos_send
! position dans la liste list_send des cellules de idomI a envoyer a idomJ 
! position in the list_send list of idomI cells to send to idomJ
  integer, intent(out)                    :: ipos_recv
!  position dans la liste list_recv des cellules de idomI a recevoir de idomJ 
!  position in the list_recv list of cells from idomI to be received from idomJ
  type(list_int),dimension(:), intent(in) :: interdom
! liste des blocs de chaque cote de l interface entre les domaines 
! list of blocks on each side of the interface between domains
  
  integer     ::   i,k
!====================== START OF THE EXECUTABLE CODE  ==================

!.1-----  Initialisation
  ipos_send=0
  ipos_recv=0

  IF (idomI.lt.idomJ) THEN
      k=idomJ-idomI+(idomI-1)*(2*nb_dom-idomI)/2 
      DO i=2,size(interdom(k)%L)/4
          IF (ibI.eq.interdom(k)%L((i-1)*4+1).and.ibJ.eq.interdom(k)%L((i-1)*4+2)) THEN
              ipos_send=interdom(k)%L(4*(i-1)-1)
              ipos_recv=interdom(k)%L(4*(i-1)-0)
          END IF
      END DO
  ELSE
      k=idomI-idomJ+(idomJ-1)*(2*nb_dom-idomJ)/2 
      DO i=2,size(interdom(k)%L)/4
          IF (ibJ.eq.interdom(k)%L((i-1)*4+1).and.ibI.eq.interdom(k)%L((i-1)*4+2)) THEN
              ipos_send=interdom(k)%L(4*(i-1)-0)
              ipos_recv=interdom(k)%L(4*(i-1)-1)
          END IF
      END DO
  END IF
  return
 !===========================   END OF THE SUBROUTINE    ====================
END SUBROUTINE psr
!DOCFIN

 SUBROUTINE fluxnumnoncons(wL,wR,vn,fluxnc,itypflux)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/fluxnumnoncons  *
!
!    NOM
! fluxnumnoncons(wL,wR,vn,fluxnc,itypflux)
!
!    DESCRIPTION 
!*
! Calcul du flux numerique non conservatif
! Calculation of non-conservative numerical flux
!*
! 
!    ENTREES / INPUT
! wL   : objet de type "state" Etat de la partie gauche / left state
! wR   : objet de type "state" Etat de la partie droite / right state
! vn   : objet de type "vect_3", normale a la face / normal vector to the face
! itypflux   : type de flux / type of flux
!
!    SORTIES / OUTPUT
! fluxnc : objet de type "vect_nvar", flux non conservatif
! c est a dire que fluxnc(-vn) n est pas egal a -fluxnc(vn)
! / non-conservative flux, i.e. fluxnc(-vn) is not equal to -fluxnc(vn)
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  type(state), intent(in)            :: wL,wR !! Etat gauche et droit / left and right state 
  type(vect_3),intent(in)            :: vn !! Vecteur normal a la face / Normal vector to the face
  type(vect_nvar),intent(out)        :: fluxnc !! flux non conservatif / non-conservative flux
  integer                            :: itypflux !! type de flux / type of flux
  
  type(vect_3)                       :: uL,uR
  real(kind=kind(0.d0))              :: unL,unR,hL,zL,zR,hL_reco
  integer                            :: iphi
!=========================== DEBUT DU CODE EXECUTABLE ==================
!-------  Initialisations
  fluxnc%v=0

  IF (imodel_phy.eq.2) iphi=5 ! isotherme bifluide  6 variables
  IF (imodel_phy.eq.2) THEN
      SELECT CASE (itypflux)
      
          CASE (0) ! rusanov
              uL%v(1)=wL%vprim%v(2)
              uL%v(2)=wL%vprim%v(3)
              uL%v(3)=wL%vprim%v(4)
              unL=uL%v(1)*vn%v(1)+uL%v(2)*vn%v(2)+uL%v(3)*vn%v(3)
            
              uR%v(1)=wR%vprim%v(2)
              uR%v(2)=wR%vprim%v(3)
              uR%v(3)=wR%vprim%v(4)
              unR=uR%v(1)*vn%v(1)+uR%v(2)*vn%v(2)+uR%v(3)*vn%v(3)
            
              fluxnc%v(iphi)=unL*0.5d0*(wR%vbal%v(iphi)-wL%vbal%v(iphi))
            
          CASE (1) !godunov
            fluxnc%v(iphi) =min(0.d0,vi_phy) *(wR%vbal%v(iphi)-wL%vbal%v(iphi))
      
      END SELECT
  END IF

! Cas du modele de Saint Venant : on rajoute les termes necessaires a la reconstruction hydrostatique
! si la bathymetrie est nulle le flux non conservatif est nul
  IF (imodel_phy.eq.1) THEN
     hL=wL%vprim%v(1)
     zL=wL%vprim%v(5)
     zR=wR%vprim%v(5)

     IF(hL.LE.hzero_phy)hL=0.d0
     hL_reco=max(0.d0,hL+zL-max(zL,zR))
     IF(hL_reco.LE.hzero_phy)hL_reco=0.d0
     
     fluxnc%v(1)=0.d0
     fluxnc%v(2)= gpes_phy*vn%v(1)*(hL**2-hL_reco**2)/2.d0
     fluxnc%v(3)= gpes_phy*vn%v(2)*(hL**2-hL_reco**2)/2.d0
     fluxnc%v(4)=0.d0
     fluxnc%v(5)=0.d0
  ENDIF
  
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE fluxnumnoncons
!DOCFIN

 SUBROUTINE proddl(w,bli,blo,co,ndim)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/proddl  *
!
!    NOM
! proddl(w,bli,blo,co,ndim)
!    DESCRIPTION  
!*
! Initialise les ddls d un bloc du calcul co a partir des ddls du bloc du calcul ci
! les maillages des calculs sont eventuellement (de)raffine par 2.
!
! Initialise the dof of a co calculation block from the dof of the ci calculation block
! calculation meshes are eventually refined or coarsen 
!*
! 
! 
!    ENTREES / INPUT
!    w   variable primitives  du bloc initial / primitive variable of the initial block
!    bli  objet bloc initial / initial block object
!    blo  objet bloc final / final block object
!    ndim  dimension du maillage 1,2 ou3 / mesh dimension 1,2 or 3
!
!    SORTIES / OUTPUT
!    co  objet calcul de sortie (out) / output calcul object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  type(bloc), intent(in)      :: bli,blo !! Bloc initial et final / Initial and final block
  type(list_vec), intent(inout)  :: w !! Variables primitives du bloc initial / Primitive variables of the initial block
  integer,intent(in)          :: ndim !! dimension du probleme / Problem dimension
  type(calcul), intent(inout) :: co  !! Objet calcul modifie / Modified calcul object
  
  integer                     :: i,j,k,nxi,nyi,nzi,nxo,nyo,nzo,nci,nco,ici,ico,ierr
!=========================== DEBUT DU CODE EXECUTABLE ==================
nxi=1;nyi=1;nzi=1;nxo=1;nyo=1;nzo=1

  SELECT CASE (ndim)
     CASE (1) ! Cas 1D
       nxi=bli%nx*2**(bli%nrb)
       nyi=1
       nzi=1
       nxo=blo%nx*2**(blo%nrb)
       nyo=1
       nzo=1
     CASE (2) ! Cas 2D
       nxi=bli%nx*2**(bli%nrb)
       nyi=bli%ny*2**(bli%nrb)
       nzi=1
       nxo=blo%nx*2**(blo%nrb)
       nyo=blo%ny*2**(blo%nrb)
       nzo=1
     CASE (3) ! Cas 3D
       nxi=bli%nx*2**(bli%nrb)
       nyi=bli%ny*2**(bli%nrb)
       nzi=bli%nz*2**(bli%nrb)
       nxo=blo%nx*2**(blo%nrb)
       nyo=blo%ny*2**(blo%nrb)
       nzo=blo%nz*2**(blo%nrb)
  END SELECT

  nci=nxi*nyi*nzi
  nco=nxo*nyo*nzo
  ierr=0
  DO i=1,nco
      co%msh%list_cell(i+blo%first_cell)%w%chi    =0.d0
      co%msh%list_cell(i+blo%first_cell)%w%vprim%v=0.d0
      co%msh%list_cell(i+blo%first_cell)%w%vbal%v =0.d0
      co%msh%list_cell(i+blo%first_cell)%w%gprim(1)%v=0.d0
      co%msh%list_cell(i+blo%first_cell)%w%gprim(2)%v=0.d0
      co%msh%list_cell(i+blo%first_cell)%w%gprim(3)%v=0.d0
  END DO

  
!======================================================================
! projection des ddl dans le bloc
!======================================================================
  IF (nci.eq.nco) THEN  ! le maillage interieur est identique
      ierr=1
      DO i=1,nco
          co%msh%list_cell(i+blo%first_cell)%w%vprim%v= w%vec(i)%v
          if(imodel_phy.eq.1.and. ngrad_bathy.eq.0)then ! on recupere le gradient de bathy si besoin
           SELECT CASE (ibathy)
              CASE(0)
              CASE(1) ! Initialisation de la bathymetrie par fonction utilisateur
                      CALL fct_bathy(co%msh%list_cell(i+blo%first_cell)%center%x, &
                                     co%msh%list_cell(i+blo%first_cell)%center%y, &
                                     co%msh%list_cell(i+blo%first_cell)%center%z, &
                                     co%msh%list_cell(i+blo%first_cell)%w%vprim%v(5), &
                                     co%msh%list_cell(i+blo%first_cell)%w%gprim(1)%v(5),&
                                     co%msh%list_cell(i+blo%first_cell)%w%gprim(2)%v(5), &
                                     co%msh%list_cell(i+blo%first_cell)%w%vprim%v(6))
              !~CASE (2) ! Initialisation de la bathymetrie par interpolation lineaire par bloc
              !~CASE (3) ! Initialisation de la bathymetrie par bloc sur le raffinement max
              CASE DEFAULT
                 call print_err('PRODDL','Unforeseen case')
           END SELECT
          endif
      END DO
  END IF
!----------------------
  IF (nci.eq.(nco*(2**ndim)))then ! le maillage est plus grossier
      ierr=1
      if(imodel_phy.eq.1)then
!methode qui conserve eta et pas h !!
        do i=1,nxi
          do j=1,nyi
            do k=1,nzi
              ici=i+(j-1)*nxi+(k-1)*nxi*nyi
              ico=int((i+1)/2)+(int((j+1)/2)-1)*nxo+(int((k+1)/2)-1)*nxo*nyo+blo%first_cell
!changement de repere h=eta
              if(w%vec(ici)%v(1)>hzero_phy)then
                w%vec(ici)%v(1)=w%vec(ici)%v(1)+w%vec(ici)%v(5)
              else
                w%vec(ici)%v(1:3)=0.d0
              endif

              co%msh%list_cell(ico)%w%vprim%v=co%msh%list_cell(ico)%w%vprim%v+w%vec(ici)%v
            enddo
          enddo
        enddo
        do i=1,nxo*nyo*nzo
          co%msh%list_cell(i+blo%first_cell)%w%vprim%v=co%msh%list_cell(i+blo%first_cell)%w%vprim%v/(2.d0**ndim)
!changement de repere h=h
! on met a jour la bathymetrie
           SELECT CASE (ibathy)
              CASE(0)
              CASE(1) ! Initialisation de la bathymetrie par fonction utilisateur
                      CALL fct_bathy(co%msh%list_cell(i+blo%first_cell)%center%x, &
                                     co%msh%list_cell(i+blo%first_cell)%center%y, &
                                     co%msh%list_cell(i+blo%first_cell)%center%z, &
                                     co%msh%list_cell(i+blo%first_cell)%w%vprim%v(5), &
                                     co%msh%list_cell(i+blo%first_cell)%w%gprim(1)%v(5),&
                                     co%msh%list_cell(i+blo%first_cell)%w%gprim(2)%v(5), &
                                     co%msh%list_cell(i+blo%first_cell)%w%vprim%v(6))
              !~CASE (2) ! Initialisation de la bathymetrie par interpolation lineaire par bloc
              !~CASE (3) ! Initialisation de la bathymetrie par bloc sur le raffinement max
              CASE DEFAULT
                 call print_err('PRODDL','Unforeseen case')
           END SELECT

          co%msh%list_cell(i+blo%first_cell)%w%vprim%v(1)=max(0.d0,&
          co%msh%list_cell(i+blo%first_cell)%w%vprim%v(1)-co%msh%list_cell(i+blo%first_cell)%w%vprim%v(5))   
          call Prim2Bal(co%msh%list_cell(i+blo%first_cell)%w)
        enddo

      else

        DO i=1,nxi
          DO j=1,nyi
              DO k=1,nzi
                  ici=i+(j-1)*nxi+(k-1)*nxi*nyi
                  ico=int((i+1)/2)+(int((j+1)/2)-1)*nxo+(int((k+1)/2)-1)*nxo*nyo+blo%first_cell
                  co%msh%list_cell(ico)%w%vprim%v=co%msh%list_cell(ico)%w%vprim%v+w%vec(ici)%v
              END DO
          END DO
        END DO
        DO i=1,nxo*nyo*nzo
          co%msh%list_cell(i+blo%first_cell)%w%vprim%v=co%msh%list_cell(i+blo%first_cell)%w%vprim%v/(2.d0**ndim)
          CALL prim2bal(co%msh%list_cell(i+blo%first_cell)%w)
        END DO
      endif
  END IF   
!----------------------
  IF (nci.eq.(nco/(2**ndim))) THEN ! le maillage est plus fin
      ierr=1
      if(imodel_phy.eq.1)then !methode qui conserve eta et pas h !!
            DO i=1,nxo
              DO j=1,nyo
                  DO k=1,nzo
                      ico=i+(j-1)*nxo+(k-1)*nxo*nyo+blo%first_cell
                      ici=int((i+1)/2)+(int((j+1)/2)-1)*nxi+(int((k+1)/2)-1)*nxi*nyi
                      co%msh%list_cell(ico)%w%vprim%v=w%vec(ici)%v
                      ! on met a jour la bathymetrie
                       SELECT CASE (ibathy)
                          CASE(0)
                          CASE(1) ! Initialisation de la bathymetrie par fonction utilisateur
                                  CALL fct_bathy(co%msh%list_cell(ico)%center%x, &
                                                 co%msh%list_cell(ico)%center%y, &
                                                 co%msh%list_cell(ico)%center%z, &
                                                 co%msh%list_cell(ico)%w%vprim%v(5), &
                                                 co%msh%list_cell(ico)%w%gprim(1)%v(5),&
                                                 co%msh%list_cell(ico)%w%gprim(2)%v(5), &
                                                 co%msh%list_cell(ico)%w%vprim%v(6))
                          !~CASE (2) ! Initialisation de la bathymetrie par interpolation lineaire par bloc
                          !~CASE (3) ! Initialisation de la bathymetrie par bloc sur le raffinement max
                          CASE DEFAULT
                             call print_err('PRODDL','Unforeseen case')
                       END SELECT
                       co%msh%list_cell(ico)%w%vprim%v(1)=max(0.d0,w%vec(ici)%v(1)+&
                       w%vec(ici)%v(5)-co%msh%list_cell(ico)%w%vprim%v(5))
                  END DO
              END DO
          END DO
      else
          DO i=1,nxo
              DO j=1,nyo
                  DO k=1,nzo
                      ico=i+(j-1)*nxo+(k-1)*nxo*nyo+blo%first_cell
                      ici=int((i+1)/2)+(int((j+1)/2)-1)*nxi+(int((k+1)/2)-1)*nxi*nyi
                      co%msh%list_cell(ico)%w%vprim%v=w%vec(ici)%v
                  END DO
              END DO
          END DO
      endif
  END IF   
!----------------------
  IF (ierr.eq.0) THEN ! Impossible
      write(*,*)nci,nco
      call print_err('PRODDL',' ERROR : Incompatible cell numbers')
  END IF
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE proddl
!DOCFIN

 SUBROUTINE splitdom_Z (bl,nb_bloc,nbdv,ndim)
!=========================== DOCUMENTATION =============================
!DOCDEBh*    UTI/PRE/splitdom_curve  *
!
!    NOM
!  splitdom_curve (bl,nb_bloc,nbdv,ndim)
!    DESCRIPTION  
!*
!  Affectation de numeros de domaines pour les courbes (Zorder, Hilbert,...)
!  Assign domain numbers for curves (Zorder, Hilbert,...)
!*
! 
! 
! 
!    ENTREES / INPUT
! bl      : liste des blocs a repartir / list of blocks to distribute
! nb_bloc : nombre de blocs / number of blocks
! nbdv    : nombre de domaines desires / number of domains required
! ndim    : dimension du maillage 1/1D, 2/2D , 3/3D  / mesh dimension 1/1D, 2/2D, 3/3D
!
!    SORTIES / OUTPUT
! bl      : liste des blocs avec un numero de domaine attribue / list of blocks with assigned domain number
! 
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DECLARATIONS ==============================
!.1-----  Implicit, Use
  use num
  !USE uti
  IMPLICIT NONE
!.2-----  Declaration

  integer, intent(in)                   :: nb_bloc !! Nombre de blocs / Number of blocks
  integer, intent(in)                   :: nbdv  !! Nombre de domaines desires / Number of domains required
  integer, intent(in)                   :: ndim !! Dimension du probleme / Problem dimension
  type(bloc),dimension(:),intent(inout) :: bl !! Liste des blocs / list of blocks
  
  integer,allocatable,dimension(:,:)      :: inum
  integer                               :: ib, nbcell_obj,nbd_obj,numdom,nbcell_deb
!====================== START OF THE EXECUTABLE CODE  ==================
IF (nbdv.gt.nb_bloc)  call print_err('SPLITDOM_Z', 'Oupsss ....')

  allocate(inum(nb_bloc,3))
  DO ib=1,nb_bloc
        inum(bl(ib)%morton,1)=ib ! position du bloc dans la liste z-order
        IF (ndim.eq.1) inum(bl(ib)%morton,2)=bl(ib)%nx*2**(bl(ib)%nrb) ! nbre de cellules du bloc
        IF (ndim.eq.2) inum(bl(ib)%morton,2)=bl(ib)%nx*2**(bl(ib)%nrb)*bl(ib)%ny*2**(bl(ib)%nrb)
        IF (ndim.eq.3) inum(bl(ib)%morton,2)=bl(ib)%nx*2**(bl(ib)%nrb)*bl(ib)%ny*2**(bl(ib)%nrb)*bl(ib)%nz*2**(bl(ib)%nrb)
  END DO
   inum(1,3)=inum(1,2)
  DO ib=2,nb_bloc
        inum(ib,3)=inum(ib,2)+inum(ib-1,3) ! nombre de cellules cumule  en suivant le z-order   
  END DO
  
  nbcell_obj=int(inum(nb_bloc,3)/nbdv) ! Objectif Nbre de cellule par domaine
  numdom=1
  nbd_obj=nbdv ! nbre de domaines restant a traiter
  nbcell_deb=0
  do ib=1,nb_bloc
      bl(inum(ib,1))%idom=numdom
      if(inum(ib,3)-nbcell_deb.ge.nbcell_obj)then
          numdom=numdom+1
          nbd_obj=nbd_obj-1
          nbcell_deb=inum(ib,3)
          if(nbd_obj.eq.1)nbcell_obj=inum(nb_bloc,3)-nbcell_deb+1
          !nbcell_obj=nbcell_obj+inum(ib,3) !int((inum(nb_bloc,3)-inum(ib,3))/nbd_obj)
      endif
  enddo
deallocate(inum)

!===========================   END OF THE SUBROUTINE    ====================
END SUBROUTINE splitdom_Z
!DOCFIN

 SUBROUTINE amr2tec(bl,critere,nb_bloc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/amr2tec  *
!
!    NOM
! amr2tec
!    DESCRIPTION  
!*
! Creation d un fichier cerfamr.dat permettant l affichage des critreres des blocs
!
! Creation of cerfamr.dat file for displaying block criteria
!*
! 
!    ENTREES / INPUT
!    bl : liste des blocs / blocks list
!    critere : valeur moyenne du critere par bloc / average criterion value per block
!    nb-bloc : nombre de blocs / block number
!
!    SORTIES / OUTPUT
!    
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  type(bloc),dimension(:), intent(in)            :: bl !! Liste des blocs / Blocks list
  real(kind=kind(0.d0)), dimension(:),intent(in) :: critere !! Valeur moyenne du critere par bloc / Average criterion value per block
  integer, intent(in)                            :: nb_bloc !! Nombre de blocs / Block number
  
  integer                                        :: i,ic,j
!=========================== DEBUT DU CODE EXECUTABLE ==================
  OPEN(12,file='cerfamr.dat',status='unknown')
  write(12,*)' TITLE="',0,'"'
  write(12,*)' VARIABLES="X","Y","Z","Niv","Crit","Dom"'
  write(12,*)' ZONE T=" Domaine',0,'" N=',nb_bloc*8,' E=',nb_bloc,' F=FEPOINT, ET=BRICK'
  DO i=1,nb_bloc
      DO j=1,8
          write(12,'(10e14.6)')bl(i)%s(j)%x,bl(i)%s(j)%y,bl(i)%s(j)%z,bl(i)%nrb*1.d0,critere(i),bl(i)%idom*1.d0
      END DO
  END DO
  DO i=1,nb_bloc
      ic=(i-1)*8
      write(12,'(8i9)')ic+1,ic+2,ic+3,ic+4,ic+5,ic+6,ic+7,ic+8
  END DO
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE amr2tec
!DOCFIN

  MODULE phy_typ
!=========================== DOCUMENTATION ============================= 
!DOCDEBm*    PHY/phy_typ  *
!
!    NOM
! phy_typ
!    DESCRIPTION  
!*
! Descrition des types de structures PHYsiques
!
! Description of PHYsical structure types
!*!
! Type:
!     vect_nvar  -> vecteur de taille nvarmax (seules les nvar premieres sont utiles)
!     vect_3     -> vecteur de taille 3
!     state      -> objet "etat": variables conservatives, variables primitives, gradient des variables primitives
!                   modele Saint-Venant: h,u,v,entropie,z_b
!                   modele Bifluide    : rho,u,v,w, p, entropie
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use, intrinsic :: iso_fortran_env, only : output_unit, error_unit
  IMPLICIT NONE
!.2-----  Declaration
! ----- nbre de variables de bilan
  integer,parameter               :: nvarmax=6 , phy_nb_cl=10 
  integer                         :: nvar=5    
! Indice de variable reserve pour l entropie
! A DEFINIR DANS LA ROUTINE ENTROPIE
  integer                         :: ive_phy=0 
  integer :: imodel_phy=2  ! type de modele physique
! =2   --> bifluide isotherme (loi de pression isobare ou non)
! =1   --> Saint Venant

  real(kind=kind(0.D0)) ::etac_phy=0.D0 ! constante eta
  integer :: inoncons_phy=0 ! indicateur de modele non-conservatif
                            !=0 : pas de termes non conservatifs
                            !=1 : possede des termes non-conservatifs
  real(kind=kind(0.d0)) :: vi_phy   ! vitesse d interface du modele non conservatif
  integer               :: icell_phy   ! no de cellule (debogage)

!----- quelques constantes physiques
  real(kind=kind(0.D0)) :: gpes_phy=9.81d0 !pesanteur

! modele bi-fluide isotherme
  real(kind=kind(0.D0)) :: c_phy=20.d0                       ! vitesses du son dans le melange air / eau (en m/s)
  real(kind=kind(0.D0)) :: p0_phy=1.d5                       ! pression de reference (en Pa)
  real(kind=kind(0.D0)) :: rho0A_phy=1.d0, rho0W_phy=1000.d0 ! masses volumiques de reference pour l air et l eau (en kg/m^3)
  real(kind=kind(0.D0)) :: sharp_phy=0.d0                    ! parametre de compression de l interface
  integer               :: pes_xyz=2                         ! orientation de la pesanteur 0/aucune, 1/suivant x, 2/suivant y, 3/suivant z

! modele de Saint Venant
  real(kind=kind(0.D0)) :: tc
  real(kind=kind(0.D0)) :: hzero_phy=1.d-4

  integer               :: ibathy=0 ! 0/ fond plat
                                    ! 1/ bathy et friction definies par fonction de numero num_bathy
                                    ! 2/ bathy et friction definies lineairement par bloc aux sommets
                                    ! 3/ bathy et friction definies par bloc sur le niveau de raffinement max
  character(30)         :: fich_bathy
  integer               :: num_bathy=0   ! numero de la fonction utilisateur definissant la bathymetrie, son gradient et la friction
  integer               :: ngrad_bathy=0 ! gradient de bathymetrie numerique 0/non , 1/oui
  integer               :: ifrict=0 ! 0/ Pas de Fiction
                                    ! 1/ Friction Manning-Sticker Cf u u /h**4/3
                                    ! 2/ Friction Darcy-Weisbach Cf u u /h
                                    
!=========================== DEBUT DU CODE EXECUTABLE ==================
!----- Debut Type ------------------------------------------------------
!  vecteur de taille nvar (surdimensionne à nvarmax)
  TYPE vect_nvar
     real(kind=kind(0.d0)),dimension(nvarmax):: v
  END TYPE vect_nvar
!----- Fin Type -------------------------------------------------------

!----- Debut Type -----------------------------------------------------
! vecteur de taille 3
  TYPE vect_3
     real(kind=kind(0.d0)),dimension(3):: v
  END TYPE vect_3
!----- Fin Type -------------------------------------------------------
  
!----- Debut Type -----------------------------------------------------
! etat physique: variables de bilan et primitives
! gradient des variables primitives
  TYPE state
     type(vect_nvar)             :: vbal,vprim
     type(vect_nvar),dimension(3):: gprim
     real(kind=kind(0.d0))       :: enti,entf,pe,chi
  END TYPE state
!----- Fin Type -------------------------------------------------------



 CONTAINS
 
 SUBROUTINE print_err(fich,msg)
  implicit none
  character(len=*), intent(in)       :: msg, fich
 write(output_unit,*)achar(27)//'[31mX ERR-'//fich//' : '//msg  ! en rouge
 write(output_unit,*)'X ERR-'//fich//' : end program.'//achar(27)//'[0m'
 stop
 END SUBROUTINE print_err

 SUBROUTINE print_avert(fich,msg)
  implicit none
  character(len=*), intent(in)       :: msg, fich
  write(output_unit,*)achar(27)//'[34m! AVERT-'//fich//' : '//msg//achar(27)//'[0m' ! en bleu
 END SUBROUTINE print_avert

 SUBROUTINE print_info(fich,msg)
  implicit none
  character(len=*), intent(in)       :: msg, fich
  write(output_unit,*)achar(27)//'[32m> INFO-'//fich//' : '//msg//achar(27)//'[0m' ! en vert
 END SUBROUTINE print_info

!===========================   FIN DU MODULE   =========================
  END MODULE phy_typ
!DOCFIN

 SUBROUTINE riemisot(rg,ug,phig,alfg,rd,ud,phid,alfd,xi,r,u,p,phi,alf)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    PHY/riemisot  *
!
!    NOM
! riemisot(rg,ug,phig,alfg,rd,ud,phid,alfd,xi,r,u,p,phi,alf)
!
!    DESCRIPTION  
!*
! Routine de resolution du probleme de Riemann isotherme
! avec toutes les routines necessaires 
! Routine for solving the isothermal Riemann problem
!*
! issu de V3D (code recherche F77 Helluy/Golay) / from V3D (F77 research code Helluy/Golay)
! la loi de pression est de la forme / the pressure law is of the form
! p=alf p1 + (1-alf) p2
! p1=p0_phy + c_phy**2 (   alf /   phi *rho-rho0A_phy)
! p2=p0_phy + c_phy**2 ((1-alf)/(1-phi)*rho-rho0W_phy)
! alf et phi sont convectes a la vitesse u / alf and phi are convected at velocity u
! 
!    ENTREES / INPUT
!  rg    : masse volumique a gauche / density left
!  ug    : vitesse a gauche / velocity left
!  phig  : fraction de masse de fluide a gauche / mass fraction of fluid at left
!  alfg  : fraction de volume de fluide a gauche / volume fraction of fluid at left
!  rd    : masse volumique a droite / density right
!  ud    : vitesse a droite / velocity right
!  phid  : fraction de masse de fluide a droite / mass fraction of fluid at right
!  alfd  : fraction de volume de fluide  a droite / volume fraction of fluid at right
!  xi    : x/t   (x/t=0 pour godunov)
!
!    SORTIES / OUTPUT
!   r   : masse volumique / density
!   u   : vitesse / velocity
!   p   : pression / pressure
!   phi : fraction de masse de fluide / mass fraction of fluid
!   alf : fraction de volume de fluide / volume fraction of fluid
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use phy_typ
  IMPLICIT NONE
!.2-----  Declaration
  real(kind=kind(0.d0)),intent(in)  ::  rg    !! masse volumique a gauche / left density
  real(kind=kind(0.d0)),intent(in)  ::  ug    !! vitesse a gauche / velocity left
  real(kind=kind(0.d0)),intent(in)  ::  phig  !! fraction de masse de fluide a gauche / fraction of fluid mass on left
  real(kind=kind(0.d0)),intent(in)  ::  alfg  !! fraction de volume de fluide a gauche / fraction of fluid volume at left
  real(kind=kind(0.d0)),intent(in)  ::  rd    !! masse volumique a droite / density right
  real(kind=kind(0.d0)),intent(in)  ::  ud    !! vitesse a droite / velocity right
  real(kind=kind(0.d0)),intent(in)  ::  phid  !! fraction de masse de fluide a droite / mass fraction of fluid at right
  real(kind=kind(0.d0)),intent(in)  ::  alfd  !! fraction de volume de fluide  a droite / volume fraction of fluid at right
  real(kind=kind(0.d0)),intent(in)  ::  xi    !! x/t   (x/t=0 pour godunov) / (x/t=0 for godunov)
  real(kind=kind(0.d0)),intent(out) ::  r     !! masse volumique / density
  real(kind=kind(0.d0)),intent(out) ::  u     !! vitesse / velocity
  real(kind=kind(0.d0)),intent(out) ::  p     !! pression / pressure
  real(kind=kind(0.d0)),intent(out) ::  phi   !! fraction de masse de fluide / mass fraction of fluid
  real(kind=kind(0.d0)),intent(out) ::  alf   !! fraction de volume de fluide / volume fraction of fluid 
  
  real(kind=kind(0.d0))             :: r0g,r0d,s1m,s1p,s2m,s2p
  real(kind=kind(0.d0))             :: ugini,udini,um,ui,pmin,pming,pmind
  real(kind=kind(0.d0))             :: pg,pd,pdini,pgini,pm,cd,cg
  real(kind=kind(0.d0))             :: rdini,rgini,r1,r2
  real(kind=kind(0.d0))             :: dp,drg,drd,ff,df
  integer                           :: itermax,iter
  real(kind=kind(0.d0))             :: eps=1.d-10

!=========================== DEBUT DU CODE EXECUTABLE ==================
!-------  Initialisations
  IF (rd.le.0.d0) write(*,*)'rd',rd
  IF (rg.le.0.d0) write(*,*)'rg',rg

  ! vitesses du son à droite et à gauche
  cg=dsqrt(phig*c_phy**2+(1.d0-phig)*c_phy**2)
  cd=dsqrt(phid*c_phy**2+(1.d0-phid)*c_phy**2)

  r0g=(alfg*c_phy**2*rho0A_phy+(1.d0-alfg)*c_phy**2*rho0W_phy)/cg**2
  r0d=(alfd*c_phy**2*rho0A_phy+(1.d0-alfd)*c_phy**2*rho0W_phy)/cd**2

  pming=p0_phy-cg**2*r0g
  pmind=p0_phy-cd**2*r0d
  IF (pming.le.pmind) THEN
     pmin=pmind
  ELSE
     pmin=pming
  END IF

  drg=rg-r0g
  drd=rd-r0d

  pg=p0_phy+cg**2*(rg-r0g)
  pd=p0_phy+cd**2*(rd-r0d)

  p=0.5d0*(pg+pd)

  dp=1
  ff=1
  iter=1
  itermax=100
  
  eps=1.d-6
  
  rgini=rg
  ugini=ug
  pgini=pg
  rdini=rd
  udini=ud
  pdini=pd

  DO WHILE (dabs(dp).gt.eps.and.iter.lt.itermax)

      IF (p.lt.pmin) p=pmin+eps
      iter=iter+1
      r2=(p-p0_phy)/cd**2+r0d
      r1=(p-p0_phy)/cg**2+r0g 
      if(r1.le.0.d0)write(*,*)r1,p,phig
      if(r2.le.0.d0)write(*,*)r2,p,phid
      ff=ud-ug-h(rd,r2,cd)-h(rg,r1,cg)
      df=-dhdr(rd,r2,cd)/cd**2-dhdr(rg,r1,cg)/cg**2
      dp=-ff/df
      p=p+dp

  END DO

  IF (iter.eq.itermax) THEN
      write(*,*) 'Riemiso pas de convergence',dabs(dp/p0_phy)
      write(*,*) 'rg ug phig alfg pg',rg,ug,phig,alfg,pg
      write(*,*) 'rd ud phid alfd pd',rd,ud,phid,alfd,pd
      STOP
  END IF

  ! intermediate densities and velocity
  r2=(p-p0_phy)/cd**2+r0d
  r1=(p-p0_phy)/cg**2+r0g

  um=ug+h(rg,r1,cg)
  um=ud-h(rd,r2,cd)

  ! vitesse d interface
  ui=um
  pm=p

  ! wave velocities

  ! 1-shock or 1-rarefaction
  IF (r1.gt.rg) THEN
      s1m=ug-cg*dsqrt(r1/rg)
      s1p=um-cg*dsqrt(rg/r1)
  ELSE
      s1m=ug-cg
      s1p=um-cg
  END IF

  ! 2-shock or 2-rarefaction
  IF (r2.gt.rd) THEN
      s2m=ud+cd*dsqrt(r2/rd)
      s2p=um+cd*dsqrt(rd/r2)
  ELSE
      s2m=um+cd
      s2p=ud+cd
  END IF

  ! computation of the solution at xi=x/t

  IF (xi.lt.s1m) THEN
      r=rg
      u=ug
      phi=phig
      alf=alfg
      p=pg
  ELSE IF (xi.lt.s1p) THEN
      u=xi+cg
      r=rg*exp((ug-u)/cg)
      phi=phig
      alf=alfg
      p=p0_phy+cg**2*(r-r0g)
  ELSE IF (xi.lt.um) then
      r=r1
      u=um
      phi=phig
      alf=alfg
      p=p0_phy+cg**2*(r-r0g)
  ELSE IF (xi.lt.s2m) then
      r=r2
      u=um
      phi=phid
      alf=alfd
      p=p0_phy+cd**2*(r-r0d)
  ELSE if (xi.lt.s2p) then
      u=xi-cd
      r=rd*exp((u-ud)/cd)
      phi=phid
      alf=alfd
      p=p0_phy+cd**2*(r-r0d)
  ELSE
      r=rd
      u=ud
      phi=phid
      alf=alfd
      p=p0_phy+cd**2*(r-r0d)
  END IF

CONTAINS

!=======================================================================
FUNCTION h(rL,rLocal,c)
!------------------
  use phy
  IMPLICIT NONE

  real(kind=kind(0.d0)), intent(in) :: rL,rLocal,c
  real(kind=kind(0.d0))             :: h

  IF (rLocal*rL.le.0.d0) THEN
      write(*,*)'pb function h: r=',rLocal,' rL=',rL
      STOP
  END IF
  IF (rLocal.gt.rL) THEN
      h=c*(rL-rLocal)/dsqrt(rL*rLocal)
  ELSE
      h=c*log(rL/rLocal)
  END IF
  
END FUNCTION h
!=======================================================================
FUNCTION dhdr(rL,rLocal,c)
!------------------
  use phy
  IMPLICIT NONE

  real(kind=kind(0.d0)), intent(in) :: rL,rLocal,c
  real(kind=kind(0.d0))             :: dhdr,t2,t7
  
  IF(rLocal*rL.le.0.d0) THEN
      write(*,*)'pb function dh'
      STOP
  END IF
  
  IF (rLocal.gt.rL) THEN
      t2 = dsqrt(rL*rLocal)
      t7 = t2*t2
      dhdr = -c/t2-c*(rL-rLocal)/t7/t2*rL/2.D0
  ELSE
      dhdr=-c/rLocal
  END IF
  
END FUNCTION dhdr

END SUBROUTINE riemisot

!===========================   FIN DE LA ROUTINE    ====================
!DOCFIN

 SUBROUTINE get_calc  (calc)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    NUM/get_calc  *
!
!    NOM 
! get_calc  (calc)
!    DESCRIPTION  
!*
! Recuperation binaire du domaine en cours
! Binary recovery of the current domain
!*
! 
!    ENTREES / INPUT
! calc : objet calcul / calcul object
!    SORTIES / OUTPUT
! calc : objet calcul / calcul object
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
      use num_typ
      IMPLICIT NONE
!.2-----  Declaration
 type(calcul),intent(inout) :: calc !! Objet calcul / Calcul object
 
 character                  :: fsol*11,cn*10
 integer                    :: i,ic,id,iu,is,ios
 character(len=256)         :: iomsg
 !type(param_ini_s) :: param
!=========================== DEBUT DU CODE EXECUTABLE ==================
!
!-------  Initialisations
!
      cn='0123456789'
      ic=int(calc%msh%numdom/100.)
      id=int((calc%msh%numdom-ic*100.)/10.)
      iu=calc%msh%numdom-id*10-ic*100

      if (calc%msh%numdom.gt.999) call print_err('GET_CALC','Domain index > 999 is not supported')

      fsol( 1: 7)='cerfbin'
      fsol( 8: 8)='_'
      fsol( 9: 9)=cn(ic+1:ic+1)
      fsol(10:10)=cn(id+1:id+1)
      fsol(11:11)=cn(iu+1:iu+1)
      open(11,file=fsol,status='old',form='unformatted',iostat=ios,iomsg=iomsg)
      if (ios /= 0) call print_err('GET_CALC','Cannot open '//trim(fsol)//' : '//trim(iomsg))
      !write(*,*)'Reading File ',fsol
      read(11,iostat=ios,iomsg=iomsg) calc%nb_bloc,calc%nbds
      if (ios /= 0) call print_err('GET_CALC','Error reading header (nb_bloc,nbds): '//trim(iomsg))

      
! Lecture des parametres numeriques
      read(11,iostat=ios,iomsg=iomsg) nvar
      if (ios /= 0) call print_err('GET_CALC','Error reading nvar: '//trim(iomsg))
      read(11,iostat=ios,iomsg=iomsg) calc%tmin,     calc%tmax,   calc%cfl 
      if (ios /= 0) call print_err('GET_CALC','Error reading time/cfl: '//trim(iomsg))
      read(11,iostat=ios,iomsg=iomsg) calc%isauv,    calc%istart, calc%ipas, &
               calc%ityp_flux, calc%iordre_t, calc%iordre_e, calc%imeth_int_temps, calc%ilimiteur
      if (ios /= 0) call print_err('GET_CALC','Error reading numerics: '//trim(iomsg))
      read(11,iostat=ios,iomsg=iomsg) calc%msh%numdom, calc%msh%nb_cell, &
               calc%msh%nb_face, calc%msh%nb_dom, calc%msh%nb_vertex, calc%msh%ndim, &
               calc%msh%nb_level_face,calc%msh%nb_level_cell
      if (ios /= 0) call print_err('GET_CALC','Error reading mesh dimensions: '//trim(iomsg))
      read(11,iostat=ios,iomsg=iomsg) calc%msh%small, calc%msh%big
      if (ios /= 0) call print_err('GET_CALC','Error reading mesh scales: '//trim(iomsg))
      read(11,iostat=ios,iomsg=iomsg) calc%pdtp, calc%nb_sondes, calc%point_sondes, calc%num_point_min
      if (ios /= 0) call print_err('GET_CALC','Error reading probes: '//trim(iomsg))
               


! Lecture des parametres physiques
      read(11,iostat=ios,iomsg=iomsg) gpes_phy , imodel_phy,pes_xyz
      if (ios /= 0) call print_err('GET_CALC','Error reading physical params #1: '//trim(iomsg))
      read(11,iostat=ios,iomsg=iomsg) rho0A_phy,c_phy, rho0W_phy, p0_phy, sharp_phy
      if (ios /= 0) call print_err('GET_CALC','Error reading physical params #2: '//trim(iomsg))
      read(11,iostat=ios,iomsg=iomsg) hzero_phy,ibathy,num_bathy,ngrad_bathy,ifrict
      if (ios /= 0) call print_err('GET_CALC','Error reading physical params #3: '//trim(iomsg))
      read(11,iostat=ios,iomsg=iomsg) fich_bathy
      if (ios /= 0) call print_err('GET_CALC','Error reading bathy filename: '//trim(iomsg))
      
!
! Lecture des sommets, des faces, des cellules
      if(calc%msh%nb_vertex.ne.0)allocate(calc%msh%list_vertex(calc%msh%nb_vertex))
      if(calc%msh%nb_face.ne.0)  allocate(calc%msh%list_face(calc%msh%nb_face))
      if(calc%msh%nb_cell.ne.0)  allocate(calc%msh%list_cell(calc%msh%nb_cell))
     
            if(calc%msh%nb_vertex.ne.0) then
                  read(11,iostat=ios,iomsg=iomsg) (calc%msh%list_vertex(i),i=1,calc%msh%nb_vertex)
                  if (ios /= 0) call print_err('GET_CALC','Error reading vertices: '//trim(iomsg))
            end if
            if(calc%msh%nb_face.ne.0) then
                  read(11,iostat=ios,iomsg=iomsg) (calc%msh%list_face(i)  ,i=1,calc%msh%nb_face)
                  if (ios /= 0) call print_err('GET_CALC','Error reading faces: '//trim(iomsg))
            end if
            if(calc%msh%nb_cell.ne.0) then
                  read(11,iostat=ios,iomsg=iomsg) (calc%msh%list_cell(i)  ,i=1,calc%msh%nb_cell)
                  if (ios /= 0) call print_err('GET_CALC','Error reading cells: '//trim(iomsg))
            end if

 !~!
! Lecture des conditions aux limites imposees
      read(11,iostat=ios,iomsg=iomsg) phy_state
      if (ios /= 0) call print_err('GET_CALC','Error reading boundary states: '//trim(iomsg))
! Lecture des blocs
      read(11,iostat=ios,iomsg=iomsg) calc%nrma
      if (ios /= 0) call print_err('GET_CALC','Error reading nrma: '//trim(iomsg))
      read(11,iostat=ios,iomsg=iomsg) calc%vcde,calc%vcra
      if (ios /= 0) call print_err('GET_CALC','Error reading vcde/vcra: '//trim(iomsg))

      if(calc%nb_bloc.ne.0)allocate(calc%list_bloc(calc%nb_bloc))
      if(calc%nb_bloc.ne.0) then
         read(11,iostat=ios,iomsg=iomsg) calc%list_bloc
         if (ios /= 0) call print_err('GET_CALC','Error reading block list: '//trim(iomsg))
      end if
                
! Lecture des solides
      read(11,iostat=ios,iomsg=iomsg)calc%nb_sol      ! Nombre de solides <5
      if (ios /= 0) call print_err('GET_CALC','Error reading number of solids: '//trim(iomsg))
      IF (calc%nb_sol .NE. 0 ) THEN
        do i=1,calc%nb_sol 
!Identifiant du solide, Nbre de sommets, facettes, Nbre de cellules
           read(11,iostat=ios,iomsg=iomsg)calc%list_sol(i)%id,calc%list_sol(i)%imv, &
           calc%list_sol(i)%nb_vert,calc%list_sol(i)%nb_face, calc%list_sol(i)%nb_cell
           if (ios /= 0) call print_err('GET_CALC','Error reading solid header: '//trim(iomsg))
! Bounding Box du solide et rho
           read(11,iostat=ios,iomsg=iomsg) calc%list_sol(i)%xmin_s,calc%list_sol(i)%xmax_s,&
                    calc%list_sol(i)%ymin_s,calc%list_sol(i)%ymax_s,&
                    calc%list_sol(i)%zmin_s,calc%list_sol(i)%zmax_s,calc%list_sol(i)%rho
           if (ios /= 0) call print_err('GET_CALC','Error reading solid bounds/rho: '//trim(iomsg))
! Postion du centre de gravite du solide, angle de rotation par rapport au referentiel global
           read(11,iostat=ios,iomsg=iomsg)  calc%list_sol(i)%xg,calc%list_sol(i)%theta
           if (ios /= 0) call print_err('GET_CALC','Error reading solid state: '//trim(iomsg))
! Liste des facettes constituant l enveloppe du solide
           allocate(calc%list_sol(i)%list_facette(calc%list_sol(i)%nb_face))
           read(11,iostat=ios,iomsg=iomsg) calc%list_sol(i)%list_facette
           if (ios /= 0) call print_err('GET_CALC','Error reading solid facets: '//trim(iomsg))
! Liste des vertex sur l enveloppe du solide
           allocate(calc%list_sol(i)%list_vertex(calc%list_sol(i)%nb_vert))
           read(11,iostat=ios,iomsg=iomsg) calc%list_sol(i)%list_vertex
           if (ios /= 0) call print_err('GET_CALC','Error reading solid vertices: '//trim(iomsg))
! Nbre de cellules contenues dans le solide
!           if(calc%list_sol(i)%nb_cell.ne.0)allocate(calc%list_sol(i)%list_cells(calc%list_sol(i)%nb_cell))
!           if(calc%list_sol(i)%nb_cell.ne.0)read(11) calc%list_sol(i)%list_cells
        enddo
      endif
!
! Lecture de la liste des cellules a echanger/recevoir
     allocate(calc%msh%list_send(calc%msh%nb_dom))
     do i=1,calc%msh%nb_dom
        nullify(calc%msh%list_send(i)%L)
        read(11,iostat=ios,iomsg=iomsg)is
        if (ios /= 0) call print_err('GET_CALC','Error reading send size: '//trim(iomsg))

        if(is.ne.0)then
          allocate(calc%msh%list_send(i)%L(is))
          read(11,iostat=ios,iomsg=iomsg)calc%msh%list_send(i)%L
          if (ios /= 0) call print_err('GET_CALC','Error reading send list: '//trim(iomsg))
        endif
      end do
      
     allocate(calc%msh%list_recv(calc%msh%nb_dom))
      do i=1,calc%msh%nb_dom
        nullify(calc%msh%list_recv(i)%L)
        read(11,iostat=ios,iomsg=iomsg)is
        if (ios /= 0) call print_err('GET_CALC','Error reading recv size: '//trim(iomsg))
        if(is.ne.0)then
          allocate(calc%msh%list_recv(i)%L(is))
          read(11,iostat=ios,iomsg=iomsg)calc%msh%list_recv(i)%L
          if (ios /= 0) call print_err('GET_CALC','Error reading recv list: '//trim(iomsg))
        endif
     end do

     close(11)

!
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE GET_CALC
!DOCFIN 

 SUBROUTINE  fct_mesh(x,y,z,ifct,nrb)
!=========================== DOCUMENTATION =============================
!DOCDEBh*    UTI/USER/fct_mesh  *
!
!    NOM
! fct_mesh(x,y,z,ifct,nrb)
!
!    DESCRIPTION
!*
! Initialisation du niveau de raffinement d un bloc par une fonction utilisateur
!
! Initialise the refinement level of a block using a user function
!*
! 
!    ENTREES / INPUT
!    x,y,z : coordonnees / coordinates
!    ifct  : numero de la fonction definissant le niveau de raffinement / number of the function defining the refinement level
!    
!    SORTIES / OUTPUT 
!    nrb    : niveau de raffinement / refinement level
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ====================
!.1-----  Implicit, Use
   use phy_typ
   IMPLICIT NONE
!.2-----  Declaration
   real(kind=kind(0.d0)), intent(in)                :: x,y,z !! Centre du bloc / Block center
   integer, intent(in)                              :: ifct !! Numero de la fonction / Function number
   integer, intent(out)                             :: nrb  !! Niveau de raffinement du bloc / Mesh refinement level

!=========================== DEBUT DU CODE EXECUTABLE ==================

nrb=0*int(x*y*z)
  
   SELECT CASE (ifct)

!------ Cas de Montfaucon
    CASE (1)
      nrb=0
      IF(x.gt.0.D0 .and. x.le.2.d0 .and. y.le.6.4d0)nrb=2
      IF(x.gt.2.D0 .and. x.le.16.d0 .and. y.le. (6.4d0-(x-2.d0)*3.5d0/14.d0))nrb=2
      IF(x.gt.16.D0 .and. x.le.22.d0 .and. y.le.2.9d0)nrb=0
      IF(x.gt.22.D0 .and. x.le.30.d0 .and. y.le. (2.9d0-(x-22.d0)*2.7d0/8.d0))nrb=0

    CASE DEFAULT
      call print_err('fct_mesh', 'No user function defined')

   END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE fct_mesh
!DOCFIN

 SUBROUTINE read_init(icode,iarg,zonei,nzonei)
!=========================== DOCUMENTATION ============================= 
!DOCDEBh*    UTI/PRE/read_init *
!
!    NOM
! read_init(msh,icode,iarg)
!    DESCRIPTION  
!*
! Lecture du Bloc init du fichier de donnees *.inp
! Read the init block of the *.inp data file
!*
! 
! 
!    ENTREES / INPUT
!    icode  : 0/ tube a choc / shock tube
!             1/ initialisation par fonction utilisateur / initialization by user function
!             2/ initialisation par zones / initialization by zones
!    iarg   : argument de l'initialisation / initialization argument
!
!    SORTIES / OUTPUT
!    zonei : tableau de parametres d'initialisation / initialization parameters array
!    nzonei: nombre de zones a initialiser / number of zones to initialize
!
!    SOURCE
! Ce logiciel est regi par la licence [CeCILL-B]
! This software is governed by the [CeCILL-B] license
!=========================== DEBUT DES DECLARATIONS ==================== 
!.1-----  Implicit, Use
  use num
  IMPLICIT NONE
!.2-----  Declaration
  integer, intent(inout)                           :: icode,iarg !! Code, argument
  integer, intent(inout)                           :: nzonei !! parametres /  parameters
  real(kind=kind(0.d0)),allocatable,dimension(:,:) :: zonei !! parametres /  parameters
  
  real(kind=kind(0.d0))                            :: rl,ul,pl
  real(kind=kind(0.d0))                            :: rr,ur,pr
  integer                                          :: i,j
!=========================== DEBUT DU CODE EXECUTABLE ==================
  write(*,*)
  write(*,*)achar(27)//'[34m================================================'
  write(*,*)'Reading initial condition: block INIT'
  write(*,*)'================================================'//achar(27)//'[0m'
  write(*,*)
 
 nzonei=0

!------------------------------------------------------
  SELECT CASE (icode)
      CASE(0) ! Initialisation dans le cas du tube a choc
          write(*,*)'INIT-Info Initialisation defined for shock tube'
          SELECT CASE (imodel_phy)
              CASE (2)
                  read(33,*)rl,ul,pl ! si x<0
                  read(33,*)rr,ur,pr ! si x>0
                  write( *,1060)rl,ul,pl ! si x<0
                  write( *,1061)rr,ur,pr ! si x>0
1060              format(' INIT-Info Initialisation left for Shock tube  :',3e13.5)
1061              format(' INIT-Info Initialisation right for Shock tube :',3e13.5)
                  phy_state(1)%vprim%v(1)=rL
                  phy_state(1)%vprim%v(2)=uL
                  phy_state(1)%vprim%v(3)=0.d0
                  phy_state(1)%vprim%v(4)=0.d0
                  phy_state(1)%vprim%v(5)=pL
                  phy_state(2)%vprim%v(1)=rR
                  phy_state(2)%vprim%v(2)=uR
                  phy_state(2)%vprim%v(3)=0.d0
                  phy_state(2)%vprim%v(4)=0.d0
                  phy_state(2)%vprim%v(5)=pR
              !----------------------------------------
              CASE(1)
                  read(33,*)rl,ul ! si x<0
                  read(33,*)rr,ur ! si x>0
                  phy_state(1)%vprim%v(1)=rL
                  phy_state(1)%vprim%v(2)=uL
                  phy_state(1)%vprim%v(3)=0.d0
                  phy_state(1)%vprim%v(4)=0.d0
                  phy_state(1)%vprim%v(5)=0.d0
                  phy_state(2)%vprim%v(1)=rR
                  phy_state(2)%vprim%v(2)=uR
                  phy_state(2)%vprim%v(3)=0.d0
                  phy_state(2)%vprim%v(4)=0.d0
                  phy_state(2)%vprim%v(5)=0.d0
                  write( *,1010)rL
                  write( *,1011)uL
                  write( *,1012)rR
                  write( *,1013)uR
1010              format(' INIT-Info Initialisation for shallow water model hL:',e13.5)
1011              format(' INIT-Info Initialisation for shallow water model uL:',e13.5)
1012              format(' INIT-Info Initialisation for shallow water model hR:',e13.5)
1013              format(' INIT-Info Initialisation for shallow water model uR:',e13.5)

              !----------------------------------------
              CASE DEFAULT
                  call print_err('READ_INIT','unknown physical model')
         END SELECT
           
         CALL Prim2Bal(phy_state(1))
         CALL Prim2Bal(phy_state(2))
            

!----------------------------------------
      CASE (1) ! Initialisation par fonction utilisateur
          write(*,*)'INIT-Info Initialisation defined by user fonction number:',iarg
          allocate(zonei(1,1))
          zonei=0.d0
          nzonei=-iarg

!------------------------------------------------------
      CASE (2) ! Initialisation par zones
          write(*,*)'INIT-Info  Number of zone to be initialized  :',iarg
          nzonei=iarg
          allocate(zonei(nvar+6,nzonei))
          zonei=0.d0
          DO i=1,nzonei
              read(33,*)(zonei(j,i),j=1,6)
              read(33,*)(zonei(j,i),j=7,6+nvar)
          END DO
          
!------------------------------------------------------
      CASE DEFAULT
         call print_err('READ_INI','Unforeseen case')
          
  END SELECT
!===========================   FIN DE LA ROUTINE    ====================
END SUBROUTINE read_init
!DOCFIN

robodoc --src ../sources --doc ./doccerf --rc ./cerf.rc --singledoc --nosource --html
robodoc --src ../sources --doc ./doccerf --rc ./cerf.rc --singledoc --html
robodoc --src ../sources --doc ./doccerf --rc ./cerf.rc --singledoc --rtf
robodoc --src ../sources --doc ./doccerf --rc ./cerf.rc --multidoc --html

cp eolens.css doceolens.css
